/***********************************************************

******************************************************************/

/* 
 * LevelP.h - Private definitions for Level widget
 * 
 */

#ifndef _XawLevelP_h
#define _XawLevelP_h

#include "Level.h"
#ifdef	USE_Xaw3d
# include <X11/Xaw3d/LabelP.h>
#endif	/*USE_Xaw3d*/
#ifdef	USE_neXtaw
# include <X11/neXtaw/LabelP.h>
#endif	/*USE_neXtaw*/
#ifdef	USE_Xaw95
# include <X11/Xaw95/LabelP.h>
#endif	/*USE_Xaw95*/
#if !(defined(USE_Xaw3d) || defined(USE_Xaw95) || defined(USE_neXtaw))
# include <X11/Xaw/LabelP.h>
#endif /* !(defined(USE_Xaw3d) || defined(USE_Xaw95) || defined(USE_neXtaw)) */

/***********************************************************************
 *
 * Level Widget Private Data
 *
 ***********************************************************************/
typedef enum {
  HighlightNone,			/* Do not highlight. */
  HighlightWhenUnset,		/* Highlight only when unset, this is
				   			   to preserve current level widget 
							   functionality. */
  HighlightAlways			/* Always highlight, lets the toggle widget
				   				and other subclasses do the right thing. */
} XtLevelHighlight;

/************************************
 *
 *  Class structure
 *
 ***********************************/
/* New fields for the Level widget class record */
typedef struct _LevelClass 
{
	int makes_compiler_happy;  /* not used */
} LevelClassPart;

/* Full class record declaration */
typedef struct _LevelClassRec {
	CoreClassPart		core_class;
	SimpleClassPart		simple_class;
#ifdef _ThreeDP_h
	ThreeDClassPart		threeD_class;
#endif /*_ThreeDP_h*/
	LabelClassPart		label_class;
	LevelClassPart    	level_class;
} LevelClassRec;

extern LevelClassRec levelClassRec;

/***************************************
 *
 *  Instance (widget) structure 
 *
 **************************************/
/* New fields for the Level widget record */
typedef struct {
	/* resources */
	Dimension   		highlight_thickness;
	XtCallbackList 		callbacks;

	/* private state */
	Pixmap      		gray_pixmap;
	GC          		normal_GC;
	GC          		inverse_GC;
	Boolean     		set;
	XtLevelHighlight	highlighted;
	/* more resources */
	int					shape_style;
	Dimension			corner_round;
	/* VKǉ̃\[X */
	int					levelValue;
	int					maxValue;
} LevelPart;


/*    XtEventsPtr eventTable;*/


/* Full widget declaration */
typedef struct _LevelRec {
	CorePart	core;
	SimplePart	simple;
#ifdef _ThreeDP_h
	ThreeDPart	threeD;
#endif /*_ThreeDP_h*/
	LabelPart	label;
	LevelPart	level;
} LevelRec;

#endif /* _XawLevelP_h */


