/***************************************************************************
 *	cd_data.c: ãģ̥եΥ饤֥
 *			
 *			Version 0.01		1994/06/20 (Tues.) --
 *			Version 1.00		1997/09/13 (Sat.) --
 *			
 *			Programed by Nobuyuki Maruichi
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <sys/dir.h>

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "cd_data.h"
#include "cdda_ext.h"
#include "mwxcd.h"
#include "luty.h"

#define	FALSE	0
#define	TRUE	1

char *DefaultTiffFile = "";
enum _cdlErrorCode {
	OutOfData, IllegalFormat, 
};
static int cdlSysErrorCode = 0;

/***************************************************************************
 *	TrackDataAlloc: ȥåѤΥݤ
 *	
 *		TrackData *TrackDataAlloc(int tracks);
 *	
 *		int tracks;			ȥå
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		ΥǥѤΥȥåݤ롣ȥå
 *		ջ֤ȥȥϡ00:00.00ɤȡȡɤ˽롣
 ***************************************************************************/
TrackData *TrackDataAlloc(int tracks)
{
	int counter;
	TrackData *alloc_ptr = NULL;
	static const struct cd_time zero_time = {0,0,0};
	
	if(tracks > 0) {
		alloc_ptr = (TrackData *)malloc(sizeof(TrackData) * tracks);
		if(alloc_ptr != NULL) {
			for(counter = 0;counter < tracks;++counter) {
				alloc_ptr->trackTime = zero_time;
				alloc_ptr->trackTitle[0] = '\0';
			}
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	DiscDataAlloc: ʬΥǥѤΥƤ
 *	
 *		CddaDataForm *DiscDataAlloc(int tracks);
 *	
 *		int tracks;		ǥΥȥå
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		
 ***************************************************************************/
CddaDataForm *DiscDataAlloc(int tracks)
{
	CddaDataForm *alloc_ptr = NULL;
	
	alloc_ptr = (CddaDataForm *)malloc(sizeof(CddaDataForm) * tracks);
	if(alloc_ptr != NULL) {
		alloc_ptr->track_ptr = TrackDataAlloc(tracks);
		if(alloc_ptr->track_ptr != NULL) {
			alloc_ptr->cdTitle[0] = '\0';
			alloc_ptr->artist[0] = '\0';
			alloc_ptr->label[0] = '\0';
			alloc_ptr->releaseDate[0] = '\0';
			alloc_ptr->tracks = tracks;
			alloc_ptr->tiffFile[0] = '\0';
			alloc_ptr->lyricsFile[0] = '\0';
			alloc_ptr->next_ptr = NULL;
		} else {
			free(alloc_ptr);
			alloc_ptr = NULL;
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	isdelete ޥ: ڤͤʸ륳ɤɤȽꤹ
 *	
 *		isdelete(c, flag)
 *	
 *		c			Ƚꤹ륳
 *		flag		ڡʶˤ򼨤ե饰
 *	֤
 *				ʤ
 *				ڤͤ륳
 *	
 *		
 ***************************************************************************/
#define isdelete(c, flag)	\
	(((((int)c) & 0x00ff) < 0x80)?(iscntrl((c)) || ((flag)?(isspace((c))):(0))):(0))

/***************************************************************************
 *	get_string_length: 
 *	
 *		int get_string(char *string_ptr, 
 *						const char *buffer_ptr, int max_length, int flag);
 *	
 *		char *string_ptr;			ʸ뤿ΥХåե
 *		const char *buffer_ptr;		ʸФȤΥХåե
 *		int max_length;				ǽʸХåեΥХȿ
 *		int flag;					뤫ɤ򼨤ե饰
 *									ʿʤʤ餽Τޤޡ
 *	֤
 *		ʸ
 *	
 *		
 ***************************************************************************/
int get_string(char *string_ptr, 
					const char *buffer_ptr, int max_length, int flag)
{
	int last_character, s_length;
	int length;
	int test_length;
	
	s_length = test_length = strlen(buffer_ptr);
	last_character = ((s_length > 0)?(s_length - 1):(s_length));
	while(isdelete(*(buffer_ptr + last_character), flag) && 
				last_character > 0) {
		--last_character;
	}
	s_length = last_character + 
					(!isdelete(*(buffer_ptr + last_character), flag));
	length = sprintf(string_ptr, "%.*s", s_length, buffer_ptr);
	/*printf("***%s*(%d/%d)***%s", string_ptr, s_length, test_length, buffer_ptr);*/
	return(length);
}

/***************************************************************************
 *	getTrack: ȥå
 *	
 *		char *getTrack(TrackData *track_ptr, FILE *stream, int flag);
 *	
 *		TrackData *track_ptr;	
 *		FILE *stream;			եݥ
 *		int flag;				뤫ɤ򼨤ե饰
 *	֤
 *		NULL		ե롦顼ޤϡե뽪λΤȤ
 *		NULLʳ	ʤΥȥ
 *	
 *		
 ***************************************************************************/
char *getTrack(TrackData *track_ptr, FILE *stream, int flag)
{
	int minute, second;
	char buffer[1024], separator;
	static const struct cd_time zero_time = {0,0,0};
	char *status_ptr;
	
	status_ptr = fgets(buffer, sizeof(buffer), stream);
	if(status_ptr != NULL) {
		sscanf(buffer, "%d%c%d", &minute, &separator, &second);
		track_ptr->trackTime = zero_time;
		track_ptr->trackTime.minute = minute;
		track_ptr->trackTime.second = second;
		status_ptr = fgets(buffer, sizeof(buffer), stream);
		if(status_ptr != NULL) {
			get_string(&track_ptr->trackTitle[0], buffer, 42, flag);
		}
	}
	return(status_ptr);
}

/***************************************************************************
 *	getTrackData: ãĤΥȥåʬ
 *	
 *		int getTrackData(TrackData *track_ptr, 
 *							int tracks, FILE *stream, int flag);
 *	
 *		TrackData *track_ptr;
 *		int tracks;
 *		FILE *stream;	
 *		int flag;
 *	֤
 *		ȥå
 *	
 *		
 ***************************************************************************/
int getTrackData(TrackData *track_ptr, int tracks, FILE *stream, int flag)
{
	int counter;
	char *status_ptr = (char*)track_ptr;	/* NULL ݥ󥿤ǤʤФ褤 */
	
	for(counter = 0;counter < tracks && status_ptr != NULL;
							counter += (status_ptr != NULL)) {
		status_ptr = getTrack(track_ptr + counter, stream, flag);
	}
	return(counter);
}

/***************************************************************************
 *	MakeDiscData: Υǥ
 *	
 *		CddaDataForm *MakeDiscData(FILE *stream, int flag);
 *	
 *		FILE *stream;
 *		int flag;
 *	֤
 *		NULL		顼ʥ­եϥ顼
 *		NULLʳ	ģʳƤ줿ؤ
 *	
 *		
 *	Х
 *		
 ***************************************************************************/
CddaDataForm *MakeDiscData(FILE *stream, int flag)
{
	int counter;
	int reciveTracks;
	char works[8][256];
	char *string_ptr = works[0];	/* 礨NULLݥ󥿰ʳ */
	CddaDataForm disc_data;
	CddaDataForm *alloc_ptr = NULL;
	
	/***************************************
	 *	ΥǥƬ֤碌
	 ***************************************/
	do {
		string_ptr = fgets(works[0], sizeof(works[0]), stream);
	} while(strncmp(works[0], "##", 2) != 0 && string_ptr != NULL);

	/*********************************************
	 *	ΥǥΥإåʬɤ߹
	 *********************************************/
	for(counter = 1;counter < 8 && string_ptr != NULL;++counter) {
		string_ptr = fgets(works[counter], sizeof(works[counter]), stream);
	}
	if(counter == 8 && strncmp(works[0], "##", 2) == 0) {
		get_string(&disc_data.cdTitle[0], works[1], 42, flag);
		get_string(&disc_data.artist[0], works[2], 42, flag);
		get_string(&disc_data.label[0], works[3], 42, flag);
		get_string(&disc_data.releaseDate[0], works[4], 10, flag);
		sscanf(works[5], "%d", &disc_data.tracks);
		get_string(&disc_data.tiffFile[0], works[6], 8, flag);
		get_string(&disc_data.lyricsFile[0], works[7], 6, flag);
		
		alloc_ptr = DiscDataAlloc(disc_data.tracks);
		if(alloc_ptr != NULL) {
			disc_data.track_ptr = alloc_ptr->track_ptr;
			disc_data.next_ptr = alloc_ptr->next_ptr;
			*alloc_ptr = disc_data;
			reciveTracks = getTrackData(alloc_ptr->track_ptr, 
							alloc_ptr->tracks, stream, flag);
		} else {
			cdlSysErrorCode = errno;
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	fmakeDiscsData: ǥ
 *	
 *		CddaDataForm *fmakeDiscsData(FILE *stream, int flag);
 *	
 *		FILE *stream;
 *		int flag;
 *	֤
 *		NULL		­
 *		NULLʳ	ģƬʳƤ줿ؤ
 *	
 *		
 ***************************************************************************/
CddaDataForm *fmakeDiscsData(FILE *stream, int flag)
{
	int counter;
	int disc_num;
	char buffer[256];
	CddaDataForm preTopDiscData;	/* ľΥǡ */
	CddaDataForm *connect_ptr = &preTopDiscData;
	
	fgets(buffer, sizeof(buffer), stream);
	sscanf(buffer, "%d", &disc_num);
	connect_ptr->next_ptr = NULL;
	for(counter = 0;counter < disc_num && connect_ptr != NULL;
				connect_ptr = connect_ptr->next_ptr, ++counter) {
		connect_ptr->next_ptr = MakeDiscData(stream, flag);
	}
	if(counter < disc_num) {
		if(cdlSysErrorCode == 0)
			cdlSysErrorCode = EOF;
	}
	return(preTopDiscData.next_ptr);
}

/***************************************************************************
 *	MakeDiscsData: ǥ
 *	
 *		CddaDataForm *MakeDiscsData(const char *filename);
 *	
 *		const char *filename;
 *	֤
 *		NULL		­
 *		NULLʳ	ģƬʳƤ줿ؤ
 *	
 *		
 ***************************************************************************/
CddaDataForm *MakeDiscsData(const char *filename, int flag)
{
	FILE *stream;
	static char errorMessage[4096];
	CddaDataForm *topDiscData = NULL;	/* Υǡ */
	const char *cdlErrorMessage = NULL;
	
	cdlSysErrorCode = 0;
	stream = fopen(filename, "r");
	if(stream != NULL) {
		topDiscData = fmakeDiscsData(stream, flag);
		if(cdlSysErrorCode) {
			if(feof(stream) && !ferror(stream)) {
				cdlSysErrorCode = EOF;
				/*cdlErrorMessage = cdlErrorMessages[OutOfData];*/
				cdlErrorMessage = keyword2mes("DiscInfoImperfction");
			}
			switch(cdlSysErrorCode) {
			case EOF:
				PopupMessage(cdlErrorMessage);
				break;
			default:
				if(cdlErrorMessage == NULL) {
					/*sprintf(errorMessage, "ǥɤ߹: %s", filename);*/
					sprintf(errorMessage, "%s: %s", 
									keyword2mes("CdlReading"), filename);
					cdlErrorMessage = errorMessage;
				}
				PopupSyserrMessage(cdlErrorMessage);
				break;
			}
		}
		fclose(stream);
	}
	return(topDiscData);
}

/***************************************************************************
 *	TrackFrames: ԣϣäȥåαջ֤
 *	
 *		long int TrackFrames(int track_no, const struct cd_toc *toc);
 *	
 *		int track;					ȥå
 *		const struct cd_toc *toc	ãľTOCTable of contents
 *	֤
 *		ȥåΥե졼ʥȥåαջ֡
 *	
 *		
 ***************************************************************************/
long int TrackFrames(int track_no, const struct cd_toc *toc)
{
	long int start_frame, end_frame;
	
	start_frame = time2frame(&toc->track[track_no - toc->s_track]);
	switch(track_no >= toc->e_track) {
	case FALSE:
		end_frame = time2frame(&toc->track[track_no - toc->s_track + 1]);
		break;
	default:
		end_frame = time2frame(&toc->total);
		end_frame -= (end_frame % 75);
		break;
	}
	return(end_frame - start_frame);
}

/***************************************************************************
 *	cmp_Toc_DiscData: ãľTOCˤȣãģ̥ǡӤ
 *	
 *		int cmp_Toc_DiscData(const CddaDataForm *disc_data, 
 *						const struct cd_toc *toc2_ptr);
 *	
 *		const struct cd_toc *toc1_ptr;	
 *		const struct cd_toc *toc2_ptr;	
 *	֤
 *		EOF: 	顼Ӥݥ󥿤Τ NULL ݥ󥿡
 *		0: 		פ
 *		1: 		ۤʤ
 *	
 *		
 ***************************************************************************/
int cmp_Toc_DiscData(const CddaDataForm *disc_data_ptr, 
								const struct cd_toc *toc_ptr)
{
	int counter;
	int status = EOF;
	int number_of_track;
	long int cdl_frame, toc_frame;
	
	if(disc_data_ptr != NULL && toc_ptr != NULL) {
		number_of_track = NumberOfTrack(toc_ptr);
		if(number_of_track == disc_data_ptr->tracks) {
			for(counter = 0, status = 0;
					status == 0 && counter < number_of_track;++counter) {
				cdl_frame = time2frame(&(disc_data_ptr->track_ptr + counter)->trackTime);
				toc_frame = TrackFrames(counter + toc_ptr->s_track, toc_ptr);
				status = ((cdl_frame / 75) != (toc_frame / 75));
			}
		} else {
			status = 1;
		}
	}
	return(status);
}

/***************************************************************************
 *	dispDiscInfomation: 
 *	
 *		void dispDiscInfomation(CddaDataForm *disc_data, struct cd_toc *toc);
 *	
 *		CddaDataForm *disc_data;
 *		struct cd_toc *toc;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void dispDiscInfomation(CddaDataForm *disc_data, struct cd_toc *toc)
{
	int counter;
	TrackData *track_ptr;
	long int toc_frame;
	long int trackstart;
	long int trackend;
	
	if(disc_data != NULL) {
		printf(	"Title:   %s\n""Artist:  %s\n""Label:   %s\n"
				"Release: %s\n""Tracks:  %d\n""Jacket:  %s\n"
				"Lyrics:  %s\n", disc_data->cdTitle, disc_data->artist,
				disc_data->label, disc_data->releaseDate, disc_data->tracks, 
				disc_data->tiffFile, disc_data->lyricsFile);
		track_ptr = disc_data->track_ptr;
		for(counter = 0;counter < disc_data->tracks;++counter, ++track_ptr) {
			printf("%2d: ", counter + 1); fflush(stdout);
			toc_frame = TrackFrames(counter + toc->s_track, toc);
			trackstart = time2frame(TrackStartTime(counter + toc->s_track, toc));
			trackend = time2frame(TrackEndTime(counter + toc->s_track, toc));
			printf("%2d'%02d/%2d:%02d.%02d:%s\n", 
					track_ptr->trackTime.minute, track_ptr->trackTime.second, 
					(int)toc_frame / 4500, ((int)toc_frame / 75) % 60, 
					(int)toc_frame % 75, track_ptr->trackTitle);
		}
	}
}

/***************************************************************************
 *	SearchDiscData: ꤵ줿ԣϣäб롢ãģ̤򸡺
 *	
 *		CddaDataForm *SearchDiscData(int disc_num, 
 *						CddaDataForm *disc_data_ptr, 
 *								const struct cd_toc *toc_ptr);
 *	
 *		int disc_num;
 *		CddaDataForm *disc_data_ptr;
 *		const struct cd_toc *toc_ptr;
 *	֤
 *		NULL		Ĥʤä
 *		NULLʳ	Ĥä
 *	
 *		
 ***************************************************************************/
CddaDataForm *SearchDiscData(int disc_num, 
		CddaDataForm *disc_data_ptr, const struct cd_toc *toc_ptr)
{
	int counter;
	int status = 1;
	CddaDataForm *current_disc = NULL;
	
	for(counter = 0;disc_data_ptr != NULL && status != 0 && 
			((disc_num == EOF)?(TRUE):(counter < disc_num));
			++counter, disc_data_ptr = disc_data_ptr->next_ptr) {
		status = cmp_Toc_DiscData(disc_data_ptr, toc_ptr);
		current_disc = disc_data_ptr;
	}
	return((status == 0)?(current_disc):(NULL));
}

/***************************************************************************
 *	releaseDiscData: ãģ̾ΤΥ
 *	
 *		void releaseDiscData(CddaDataForm *disc_info);
 *	
 *		CddaDataForm *disc_info;	ãģ̾Ƭ
 *	
 *		
 ***************************************************************************/
void releaseDiscData(CddaDataForm *disc_info)
{
	CddaDataForm *releaseDisc_ptr;
	CddaDataForm *nextDisc_ptr;

	for(releaseDisc_ptr = disc_info;
			releaseDisc_ptr != NULL;releaseDisc_ptr = nextDisc_ptr) {
		nextDisc_ptr = releaseDisc_ptr->next_ptr;
		free(releaseDisc_ptr->track_ptr);	/* ȥåʬβ */
		free(releaseDisc_ptr);			/* ¾Υǥʬβ */
	}
}

/***************************************************************************
 *	numberOfDiscData: ãģ̾Υǥ
 *	
 *		int numberOfDiscData(const CddaDataForm *disc_info);
 *	
 *		const CddaDataForm *disc_info;	ãģ̾Ƭ
 *	֤
 *		ǥ
 *	
 *		󥯥ݥ󥿤const 뤳ȤʤᡢŪ˥
 *		ȤƤ롣
 ***************************************************************************/
int numberOfDiscData(const CddaDataForm *disc_info)
{
	int disc_num = 0;
	const CddaDataForm *currentDisc_ptr;

	currentDisc_ptr = disc_info;
	while(currentDisc_ptr != NULL) {
		++disc_num;
		currentDisc_ptr = (const CddaDataForm*)currentDisc_ptr->next_ptr;
	}
	return(disc_num);
}

/***************************************************************************
 *	putTrack: ȥåϤ
 *	
 *		int putTrack(const TrackData *track_ptr, FILE *stream);
 *	
 *		const TrackData *track_ptr;	
 *		FILE *stream;			
 *	֤
 *		EOF:	顼
 *				ȥå̵NULLݥ󥿡
 *				ｪλ
 *	
 *		
 ***************************************************************************/
int putTrack(const TrackData *track_ptr, FILE *stream)
{
	int status = 0;

	if(track_ptr != NULL) {
		fprintf(stream, "%02d'%02d\r\n", 
					track_ptr->trackTime.minute, track_ptr->trackTime.second);
		fprintf(stream, "%-42.42s\r\n", track_ptr->trackTitle);
		status = (ferror(stream)?(EOF):(1));
	}
	return(status);
}

/***************************************************************************
 *	fputTrackData: ꤵ줿ȥåϤ
 *	
 *		int fputTrackData(int tracks, 
 *							const TrackData *track_ptr, FILE *stream);
 *	
 *		int tracks;
 *		const TrackData *track_ptr;
 *		FILE *stream;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int fputTrackData(int tracks, const TrackData *track_ptr, FILE *stream)
{
	int counter;
	int track_count;
	int status = 0;
	
	for(counter = 0, track_count = 0;
			counter < tracks && status >= 0;++track_ptr, ++counter) {
		status = putTrack(track_ptr, stream);
		track_count += ((status > 0)?(status):(0));
	}
	return(track_count);
}

/***************************************************************************
 *	fputDiscData: ΥǥϤ
 *	
 *		CddaDataForm *fputDiscData(const CddaDataForm *disc_info, 
 *															FILE *stream);
 *	
 *		const CddaDataForm *disc_info;
 *		FILE *stream;
 *	֤
 *		NULL		­
 *		NULLʳ	ģʳƤ줿ؤ
 *	
 *		
 ***************************************************************************/
int fputDiscData(const CddaDataForm *disc_info, FILE *stream)
{
	int tracks;
	
	fprintf(stream, "##\r\n");
	fprintf(stream, "%-*.*s\r\n", 42, 42, disc_info->cdTitle);
	fprintf(stream, "%-*.*s\r\n", 42, 42, disc_info->artist);
	fprintf(stream, "%-*.*s\r\n", 42, 42, disc_info->label);
	fprintf(stream, "%-*.*s\r\n", 10, 10, disc_info->releaseDate);
	fprintf(stream, "%2d\r\n", disc_info->tracks);
	fprintf(stream, "%-*.*s\r\n", 8, 8, disc_info->tiffFile);
	fprintf(stream, "%-*.*s\r\n", 6, 6, disc_info->lyricsFile);
	
	tracks = fputTrackData(disc_info->tracks, disc_info->track_ptr, stream);

	return(tracks);
}

/***************************************************************************
 *	fputDiscsData: ãģ̾Ϥ
 *	
 *		void fputDiscsData(const CddaDataForm *disc_info, FILE stream);
 *	
 *		const CddaDataForm *disc_info;	ãģ̾Ƭ
 *		FILE stream;				Υեݥ
 *	
 *		󥯥ݥ󥿤const 뤳ȤʤᡢŪ˥
 *		ȤƤ롣
 ***************************************************************************/
void fputDiscsData(const CddaDataForm *disc_info, FILE *stream)
{
	int tracks;
	int disc_num;
	int status;
	const CddaDataForm *currentDisc_ptr;

	disc_num = numberOfDiscData(disc_info);
	fprintf(stream, "%05d\r\n", disc_num);
	for(currentDisc_ptr = disc_info, status = 0;
			currentDisc_ptr != NULL && status == 0;
			currentDisc_ptr = 
						(const CddaDataForm*)currentDisc_ptr->next_ptr) {
		tracks = fputDiscData(currentDisc_ptr, stream);
		status = (tracks != currentDisc_ptr->tracks);
	}
}

/***************************************************************************
 *	SaveDiscsData: 
 *	
 *		void SaveDiscsData(const char *filename, 
 *								const CddaDataForm *disc_info);
 *	
 *		const char *filename;
 *		const CddaDataForm *disc_info;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void SaveDiscsData(const char *filename, const CddaDataForm *disc_info)
{
	FILE *stream;
	
	stream = fopen(filename, "w");
	if(stream != NULL) {
		fputDiscsData(disc_info, stream);
		fclose(stream);
	}
}

/***************************************************************************
 *	MakeNewDiscData: Υǥ
 *	
 *		CddaDataForm *MakeNewDiscData(const struct cd_toc *toc)
 *	
 *		FILE *stream;
 *	֤
 *		NULL		­
 *		NULLʳ	ģʳƤ줿ؤ
 *	
 *		
 ***************************************************************************/
CddaDataForm *MakeNewDiscData(const struct cd_toc *toc, int flag)
{
	int counter;
	long int toc_frame;
	time_t gmt;
	struct tm *jst_ptr;
	CddaDataForm *alloc_ptr = NULL;
	extern AppData app_data;
	
	time(&gmt);
	jst_ptr = localtime(&gmt);
	alloc_ptr = DiscDataAlloc(NumberOfTrack(toc));
	if(alloc_ptr != NULL) {
		sprintf(alloc_ptr->cdTitle, "%-42s", "----- CD TITLE -----");
		get_string(alloc_ptr->cdTitle, alloc_ptr->cdTitle, 42, flag);
		sprintf(alloc_ptr->artist, "%-42s", "----- ARTIST -----");
		get_string(alloc_ptr->artist, alloc_ptr->artist, 42, flag);
		sprintf(alloc_ptr->label, "%-42s", "-- LABEL --");
		get_string(alloc_ptr->label, alloc_ptr->label, 42, flag);
		sprintf(alloc_ptr->releaseDate, "%04d.%02d.%02d", 
			jst_ptr->tm_year + 1900, jst_ptr->tm_mon + 1, jst_ptr->tm_mday);
		get_string(alloc_ptr->releaseDate, alloc_ptr->releaseDate, 10, flag);
		sprintf(alloc_ptr->tiffFile, "%-8.8s", DefaultTiffFile);
		get_string(alloc_ptr->tiffFile, alloc_ptr->tiffFile, 8, flag);
		sprintf(alloc_ptr->lyricsFile, "%-6.6s", "");
		get_string(alloc_ptr->lyricsFile, alloc_ptr->lyricsFile, 6, flag);
		for(counter = 0;counter < alloc_ptr->tracks;++counter) {
			toc_frame = (TrackFrames(counter + toc->s_track, toc) / 75) * 75;
			frame2time(toc_frame, 
						&(alloc_ptr->track_ptr + counter)->trackTime);
			if(isDataTrack(&toc->track[counter]))
				sprintf((alloc_ptr->track_ptr + counter)->trackTitle,
					app_data.data_track_title);
			else
				sprintf((alloc_ptr->track_ptr + counter)->trackTitle, 
					".. Music No.%2d ..                        ", 
									counter + toc->s_track);
			get_string((alloc_ptr->track_ptr + counter)->trackTitle, 
					(alloc_ptr->track_ptr + counter)->trackTitle, 42, flag);
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	DiscDataMerge: ǥǡޡ
 *	
 *		CddaDataForm *DiscDataMerge(CddaDataForm *prevDiscData,
 *										CddaDataForm *connectDiscData);
 *	
 *		CddaDataForm *prevDiscData;
 *		CddaDataForm *connectDiscData;
 *	֤
 *		NULL		Ĥΰ NULL ݥ
 *		NULLʳ	ޡƥǡƬ	
 *	
 *		
 ***************************************************************************/
CddaDataForm *DiscDataMerge(CddaDataForm *prevDiscData, 
									CddaDataForm *connectDiscData)
{
	CddaDataForm *topDiscData = prevDiscData;

	if(topDiscData == NULL) {
		topDiscData = connectDiscData;
	} else {
		while(prevDiscData->next_ptr != NULL)
			prevDiscData = prevDiscData->next_ptr;
		prevDiscData->next_ptr = connectDiscData;
	}
	return(topDiscData);
}

/***************************************************************************
 *	asciiNameCmp: ѻʸȾʸƱ뤷Ӥ
 *	
 *		int asciiNameCmp(const char *s1, const char *s2, size_t n);
 *	
 *		const char *s1;
 *		const char *s2;
 *		size_t n;
 *	֤
 *		FALSE:	ѻʸȾʸƱ뤷Ȥ
 *		TRUE:		ѻʸȾʸƱ뤷Ȥ԰
 *	
 *		
 ***************************************************************************/
int asciiNameCmp(const char *s1, const char *s2, size_t n)
{
	int flag = 0;
	int counter;

	for(counter = 0;*(s1 + counter) != '\0' && 
			*(s2 + counter) != '\0' && counter < n && flag == 0;++counter) {
		flag = (toupper(*(s1 + counter)) != toupper(*(s2 + counter)));
	}
	if(counter < n) {
		flag = flag || (toupper(*(s1 + counter)) != toupper(*(s2 + counter)));
	}
	return(flag);
}

/***************************************************************************
 *	searchFileName0: ե̾򸡺
 *	
 *		char *searchFileName0(const char *dirName, const char *fileName)
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	֤
 *		NULL:		ե뤬ĤޤǤ
 *		NULLʳ:	פե̾
 *	
 ***************************************************************************/
char *searchFileName0(const char *dirName, const char *fileName)
{
	int end;
	DIR *dp;
	char *result = NULL;
	Boolean flag = False;
	struct direct *dir;

	/***************************
	 *	ǥ쥯ȥ򥪡ץ
	 ***************************/
	if ((dp = opendir(dirName)) == NULL) {
		return(NULL);
	}
	/************************
	 *	
	 ************************/
	while ((dir = readdir(dp)) != NULL && flag == False) {
		flag = (asciiNameCmp(fileName, dir->d_name, strlen(fileName)) == 0);
		if(flag != False) {
			end = *(dir->d_name + strlen(fileName));
			if(end != '.' && end != '\0')
				flag = False;
			else
				break;
		}
	}
	if(flag != False) {
		result = (char*)malloc(strlen(dir->d_name) + 1);
		strcpy(result, dir->d_name);
	}
	closedir(dp);
	return(result);
}

/***************************************************************************
 *	searchFileName: ե̾򸡺
 *	
 *		char *searchFileName(const char *dirName, const char *fileName)
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 ***************************************************************************/
char *searchFileName(const char *dirName, 
						const char *fileName, const char **suffixList)
{
	int end;
	int counter;
	DIR *dp;
	char *result = NULL;
	Boolean flag = False;
	Boolean suffixFlag = False;
	struct direct *dir;

	/***************************
	 *	ǥ쥯ȥ򥪡ץ
	 ***************************/
	if ((dp = opendir(dirName)) == NULL) {
		return(NULL);
	}
	/************************
	 *	
	 ************************/
	while ((dir = readdir(dp)) != NULL && flag == False) {
		flag = (asciiNameCmp(fileName, dir->d_name, strlen(fileName)) == 0);
		if(flag != False) {
			end = *(dir->d_name + strlen(fileName));
			if(end != '.' && end != '\0')
				flag = False;
			else {
				if(suffixList != NULL) {
					if(strlen(dir->d_name) >= strlen(fileName)) {
						for(counter = 0;*(suffixList+counter) != NULL && 
										suffixFlag == False;++counter) {
							suffixFlag = 
								(asciiNameCmp(dir->d_name + strlen(fileName), 
										*(suffixList+counter), 
										strlen(*(suffixList+counter))) == 0);
						}
					} else {
						suffixFlag = False;
					}
				} else {
					suffixFlag = True;
				}
				if(suffixFlag != False) {
					break;				/* ޥå */
				} else {
					flag = False;
				}
			}
		}
	}
	if(flag != False) {
		result = (char*)malloc(strlen(dir->d_name) + 1);
		if(result != NULL) {
			strcpy(result, dir->d_name);
		}
	}
	closedir(dp);
	return(result);
}

/***************************************************************************
 *	cdlStringOut: ãİξʸ󲽤ޤ
 *	
 *		unsigned const char *cdlStringOut(const void *stringInfo);
 *	
 *		const void *stringInfo;
 *	֤
 *		NULL:		Ǥ˥󥯤äƤ
 *		NULLʳ:	ʸƬؤݥ
 *	
 *		ʸƬ
 *	
 *	 stringInfo λؤɥ쥹
 *		
 *		
 *		㥹ȤѴ롡
 *		
 *		CDΥȥ먭ȥåջ֨
 *		
 *		ƥȨ ʤΥȥ 
 *		
 *		졼٥롡ȥåջ֨
 *		
 *		ȯ ʤΥȥ 
 *		
 *		ȥå
 *		
 *		ե̾
 *		
 *		λե̾ȥåջ֨
 *		
 *		 ȥå  ʤΥȥ 
 *		
 *		󥯥ݥ󥿨
 *	ء
 *	
 *	ãĤΥȥ먭
 *	
 *	 ƥ 
 *	嵭ϰϤΡآ٥ޡ
 *	ΤȤʸ󲽤롣
 *	
 *		
 ***************************************************************************/
unsigned const char *cdlStringOut(const void *stringInfo)
{
	int counter;
	static char buffer[5120], *write_ptr;
	const CddaDataForm *cdl_ptr = stringInfo;
	const TrackData *track_ptr;

	/* ãĤΥȥ/ƥ/졼٥ʸ */
	sprintf(buffer, "%s %s %s ", 
			cdl_ptr->cdTitle, cdl_ptr->artist, cdl_ptr->label);
	/* ȥåζʤΥȥʸ */
	for(write_ptr = buffer + strlen(buffer), 
				track_ptr = cdl_ptr->track_ptr, counter = 0;
						counter < cdl_ptr->tracks;++counter, ++track_ptr) {
		write_ptr += sprintf(write_ptr, "%s ", track_ptr->trackTitle);
	}
	return(buffer);
}

/***************************************************************************
 *	cdlNextString: ʸ򼨤ݥ󥿤֤
 *	
 *		const void *cdlNextString(const void *stringInfo);
 *	
 *		const void *stringInfo;
 *	֤
 *		NULL:		ãľνü
 *		NULLʳ:	Υȥå
 *	
 *	 stringInfo λؤɥ쥹
 *		
 *		㥹
 *		Ѵ
 *		
 *		
 *		ãĤΥȥ먭ȥåջ֨
 *		
 *		 ƥ ʤΥȥ롡
 *		
 *		 졼٥ 
 *		
 *		ȯ
 *		
 *		ȥåȥåջ֨
 *		ǽ
 *		ե̾ʤΥȥ롡
 *		
 *		λե̾
 *		
 *		 ȥå 
 *		
 *		󥯥ݥ󥿨
 *		ءãĤΥȥ먭
 *		
 *		 ƥ 
 *		嵭Ѥ˼򡡡
 *		ݥ󥿤򡡡 졼٥ 
 *		Ф
 *		ʤ顡ȯ
 *		
 *		NULLݥ󥿡
 *		
 ***************************************************************************/
const void *cdlNextString(const void *stringInfo)
{
	const CddaDataForm *cdl_ptr = (const CddaDataForm*)stringInfo;

	return((const void*)cdl_ptr->next_ptr);
}

/***************************************************************************
 *	isCdlCodeset: ãľ󤬤ɤʸ狼֤
 *	
 *		int isCdlcodeset(const CddaDataForm *cdl_ptr);
 *	
 *		const CddaDataForm *cdl_ptr;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int isCdlCodeset(const CddaDataForm *cdl_ptr)
{
	int result;

	result = checkEncode(cdl_ptr, cdlStringOut, cdlNextString);

	return(result);
}

