/***************************************************************************
 *	cdda_ext.c: ãıյǽ
 *	
 *		Programmed by Nobuyuki Maruichi
 *	
 *				Date 1994/03/17 --
 *	
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#ifdef	TOWNS
# include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */

#include "cdda_ioc.h"
#include "cdda_ext.h"
#include "cd_data.h"
#include "mwxcd.h"

#define	FALSE	0
#define	TRUE	1

/*extern int programTitle;*/
extern CddaDataForm *CurrentDisc_ptr;
extern int CurrentDiscFlag;
extern int ProgramSongTitle;

/***************************************************************************
 *	Cd_Order_alloc: Cd_Order Хåեݤ
 *	
 *		Cd_Order *Cd_Order_alloc(void);
 *	
 *		
 *	֤
 *		NULL: 		­
 *		NULLʳ: 	Ƥ줿 Cd_Order ХåեؤΥݥ
 *	
 *		
 ***************************************************************************/
Cd_Order *Cd_Order_alloc(void)
{
	Cd_Order *alloc_ptr;
	
	alloc_ptr = (Cd_Order *)malloc(sizeof(Cd_Order));
	if(alloc_ptr) {
		alloc_ptr->prev_order_ptr = NULL;
		alloc_ptr->next_order_ptr = NULL;
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	search_audio_track: ȥå饪ǥȥåõ
 *	
 *		int search_audio_track(int start_track, 
 *				struct cd_time *cd_time_ptr, const struct cd_toc *toc);
 *	
 *		int start_track;				ϰ֡ʣʤƬȥå
 *		struct cd_time *cd_time_ptr;	ȥåαճϻ֤֤
 *		const struct cd_toc *toc;		CD TOC:Table of Contents-CD
 *	֤
 *		EOF:		顼ǥȥåĤʤ
 *		ʾ:		ǽΥǥȥåݡϥȥåֹ
 *	
 *		ãľTOCˤ顢ȥåʹߤǺǽΥǥȥå
 *		õȥåαճϻ֤֤裲 cd_time_ptr 
 *		 NULL ݥ󥿤ΤȤϡջ֤֤ʤ
 *		
 ***************************************************************************/
int search_audio_track(int start_track, 
				struct cd_time *cd_time_ptr, const struct cd_toc *toc)
{
	int track;					/* ȥå򼨤 */
	int audio_track = EOF;		/* ǽΥǥȥå */
	int total_track;			/* ȥå */
	
	total_track = toc->e_track - toc->s_track + 1;
	
	for(track = start_track;track < total_track;++track) {
		if(isAudioTrack(&toc->track[track])) {
			audio_track = track;
			break;
		}
	}
	if(audio_track != EOF) {
		if(cd_time_ptr != NULL) {
			cd_time_ptr->minute = toc->track[track].minute;
			cd_time_ptr->second = toc->track[track].second;
			cd_time_ptr->frame  = toc->track[track].frame;
		}
	}
	return(audio_track);
}

/***************************************************************************
 *	get_TrackPlay: ꤵ줿ȥåγϻ֡λ֤
 *	
 *		int get_TrackPlay(int track, 
 *					struct cdda_play *cd_play, struct cd_toc *toc);
 *	
 *		int track;					ȥåƬȥåֹ
 *		struct cdda_play *cd_play;	CD Τι¤
 *		struct cd_toc *toc;			CD TOC:Table of Contents-CD
 *	֤
 *		EOF:		顼ǥȥåĤʤ
 *		ʾ:		ճϥȥåֹ桡ݡϥȥåֹ
 *	
 *		ꤵ줿ȥåǥȥåǤСΥȥå
 *		뤿ξ롣
 *		
 *		cd_play
 *		
 *		
 *		 ʬ 
 *		
 *		ճϻ֨  λꤵ줿
 *		ȥåγϻ֡
 *		ե졼ਭ
 *		
 *		 ʬ 
 *		
 *		սλ֨  λꤵ줿Υȥå
 *		ϻ֡ϡݡΣե졼
 *		ե졼ਭ
 *		
 *		ԡȲġġģ
 *		
 *		
 *		
 ***************************************************************************/
int get_TrackPlay(int track, struct cdda_play *cd_play, struct cd_toc *toc)
{
	int audio_track = EOF;		/* ǽΥǥȥå */
	int total_track;			/* ȥå */
	struct cd_time *cdTime_ptr;	
	
	total_track = toc->e_track - toc->s_track + 1;
	
	if(track < total_track) {
		if(isAudioTrack(&toc->track[track])) {
			audio_track = track;
			cd_play->start.minute = toc->track[track].minute;
			cd_play->start.second = toc->track[track].second;
			cd_play->start.frame  = toc->track[track].frame;
			if(track + 1 < total_track) {
				cdTime_ptr = &toc->track[track + 1];
			} else {
				cdTime_ptr = &toc->total;
			}
			frame2time(time2frame(cdTime_ptr) - 1, &cd_play->end);
			cd_play->count = 1;
		}
	}
	return(audio_track);
}

/***************************************************************************
 *	MakeNormalPlayOrders: Normal ⡼ɤǤαեʿǡ
 *	
 *		Cd_Order *MakeNormalPlayOrder(int track, const struct cd_toc *toc);
 *	
 *		int track;					ȥåֹݣ
 *		const struct cd_toc *toc;	ãľTable of contents
 *	֤
 *		NULL:		顼⤷ϡ³륪ǥȥå̵
 *		NULLʳ:	ƬؤΥݥ
 *	
 *		ȥå顢Ϣ³ȥåϢ뤷ʤ顢ץʡ
 *		ꥹȡˤ롣
 *		ǡƵƤӽФʥꥫ֡˹ԤäƤΤǡԣϣ
 *		Table Of ContentsˤƤȥХˤʤΤդ뤳ȡ
 *		
 *		MakeNormalPlayOrder() 
 *		ǽθƤӽФǺʬ
 *		
 *		Ƭ
 *		
 *		ϥȥåġġİ track ʹߤǺǽ
 *		ǥȥå
 *		λȥåġġľ嵭γϥȥåʹߤǷ³
 *		ǥȥå
 *		ãıվ󨭡
 *		ꥫ֥
 *		¦󥯨äʬ
 *		
 *		¦󥯨
 *		ϥȥå
 *		NULLݥ󥿡
 *		λȥå
 *		
 *		ãıվ
 *		
 *		¦󥯨
 *		
 *		¦󥯨ġ
 *		
 *		
 *	
 *		ãıվʬξܺ
 *		
 *		 ʬ 
 *		
 *		ճϻ֨  Υγϥȥå
 *		ϻ֡
 *		ե졼ਭ
 *		
 *		 ʬ 
 *		
 *		սλ֨  Υνλȥåμ
 *		ݡΣե졼
 *		ե졼ਭ
 *		
 *		ԡȲġġģ
 *		
 *		
 *		̾β CD/ƬȥåΤߤǡȥå CD-ROM Ǥϡ
 *		륪ϡĤΤߤǤ
 *		˥ǡȥåäƤʹߤˤ⥪ǥȥå
 *		褦ʣãĤǤϡ륪ϡʣĤˤʤޤ
 *	
 ***************************************************************************/
Cd_Order *MakeNormalPlayOrders(int track, const struct cd_toc *toc)
{
	int number_of_track;
	struct cd_time cd_time;	
	Cd_Order *nowOrder_ptr = NULL;
	
	number_of_track = NumberOfTrack(toc);
	
	track = search_audio_track(track, &cd_time, toc);
	if(track != EOF) {
		nowOrder_ptr = Cd_Order_alloc();
#ifdef	DEBUG
		printf("nowOrder_ptr == %p\n", nowOrder_ptr);
#endif	/*DEBUG*/
		if(nowOrder_ptr != NULL) {
			/************************************
			 *	
			 ************************************/
			nowOrder_ptr->start_track = track + toc->s_track;
			nowOrder_ptr->play_info.start = cd_time;
			while(isAudioTrack(&toc->track[track + 1]) && 
							(track + 1) < number_of_track) {
				++track;
			}
			nowOrder_ptr->end_track = track + toc->s_track;
			frame2time(time2frame(TrackEndTime(track + toc->s_track, toc)) - 1, 
									&nowOrder_ptr->play_info.end);
			nowOrder_ptr->play_info.count = 1;
#ifdef	DEBUG
			printf("MakeNormalPlayOrders: Track %d -- %d\n", 
						nowOrder_ptr->start_track, nowOrder_ptr->end_track);
			printf("\t(%2d:%02d.%02d -- %2d:%02d.%02d)\n", 
				nowOrder_ptr->play_info.start.minute, 
				nowOrder_ptr->play_info.start.second,
				nowOrder_ptr->play_info.start.frame,
				nowOrder_ptr->play_info.end.minute,
				nowOrder_ptr->play_info.end.second,
				nowOrder_ptr->play_info.end.frame);
#endif	/*DEBUG*/
			nowOrder_ptr->next_order_ptr = 
							MakeNormalPlayOrders(track + 1, toc);
			if(nowOrder_ptr->next_order_ptr != NULL) {
				nowOrder_ptr->next_order_ptr->prev_order_ptr = nowOrder_ptr;
			}
		}
	} else {
#ifdef	DEBUG
		printf("Audio Track: Not found (from Track %d)\n", track + toc->s_track);
#endif	/*DEBUG*/
	}
	return(nowOrder_ptr);
}

#define track_order_test(track, order)\
	((track) >= (order).start_track && (track) <= (order).end_track)
	
/***************************************************************************
 *	track_order_search: ȥåޤ४õ
 *	
 *		int track_order_search(int track_no, Cd_Order *order_ptr);
 *	
 *		int track_no;					ȥåֹ
 *		Cd_Order *order_ptr;			Ρޥ롦⡼ɡƬ
 *	֤
 *		NULL: 		顼ȥåޤ४ʤ
 *		NULLʳ: 	ȥåޤ४ؤΥݥ
 *	
 *		ꥹȤƬ顢ȥåޤ४õơ
 *		֤
 ***************************************************************************/
Cd_Order *track_order_search(int track_no, Cd_Order *order_ptr)
{
	if(order_ptr != NULL) {
		while(order_ptr != NULL && !track_order_test(track_no, *order_ptr)) {
			order_ptr = order_ptr->next_order_ptr;
		}
	}
	return(order_ptr);
}

/***************************************************************************
 *	time_order_search: ֤ޤ४õ
 *	
 *		Cd_Order *time_order_search(const struct cd_time *cd_time_ptr, 
 *											Cd_Order *order_ptr);
 *	
 *		const struct cd_time *cd_time_ptr;	ջ
 *		Cd_Order *order_ptr;				Ρޥ롦⡼ɡƬ
 *	֤
 *		NULL: 		顼ȥåޤ४ʤ
 *		NULLʳ: 	ȥåޤ४ؤΥݥ
 *	
 *		ꥹȤƬ顢ȥåޤ४õơ
 *		֤
 ***************************************************************************/
Cd_Order *time_order_search(const struct cd_time *cd_time_ptr, 
 											Cd_Order *order_ptr)
{
 	Cd_Order *search_ptr = NULL;

	if(order_ptr != NULL) {
		search_ptr = order_ptr;
		while(search_ptr != NULL && 
					CmpCdTime(cd_time_ptr, &search_ptr->play_info)) {
			search_ptr = search_ptr->next_order_ptr;
		}
	}
	if(search_ptr == NULL && order_ptr != NULL) {
		search_ptr = (Cd_Order *)LinkLast(order_ptr, Cd_Order_Prev);
		while(search_ptr != NULL && 
					CmpCdTime(cd_time_ptr, &search_ptr->play_info)) {
			search_ptr = search_ptr->next_order_ptr;
		}
	}
	return(search_ptr);
}

/***************************************************************************
 *	nearest_track_order_search: ȥåޤ४õ
 *	
 *		int nearest_track_order_search(int track_no, Cd_Order *order_ptr);
 *	
 *		int track_no;					ȥåֹ
 *		Cd_Order *order_ptr;			Ρޥ롦⡼ɡƬ
 *	֤
 *		NULL: 		顼ȥåޤ४ʤ
 *		NULLʳ: 	ȥåޤ४ؤΥݥ
 *	
 *		ꥹȤƬ顢ȥåޤ४õơ
 *		֤
 ***************************************************************************/
Cd_Order *nearest_track_order_search(int track_no, Cd_Order *order_ptr)
{
	Cd_Order *bak_order_ptr;

	if(order_ptr != NULL) {
		bak_order_ptr = order_ptr;
		while(order_ptr != NULL && track_no < order_ptr->start_track) {
			bak_order_ptr = order_ptr;
			order_ptr = order_ptr->next_order_ptr;
		}
		order_ptr = bak_order_ptr;
	}
	return(order_ptr);
}

/***************************************************************************
 *	getTrackEndTime: ȥåνλ֤
 *	
 *		int getTrackEndTime(struct cd_time *cd_time_ptr, 
 *								int track, const struct cd_toc *toc);
 *	
 *		struct cd_time *cd_time_ptr;	ȥåνλ֤Хåե
 *		int track;						ȥåֹ
 *		const struct cd_toc *toc;		ԣϣ
 *	֤
 *		EOF:		ȥå¸ߤʤ
 *		:			
 *	
 *		
 ***************************************************************************/
int getTrackEndTime(struct cd_time *cd_time_ptr, int track, const struct cd_toc *toc)
{
	int status = EOF;
	int tracks;
	unsigned long int time;
	
	tracks = NumberOfTrack(toc);
	if(track >= toc->s_track && track <= toc->e_track) {
		status = 0;
		time = time2frame(TrackEndTime(track, toc));
		frame2time(time - 1, cd_time_ptr);
	}
	return(status);
}

/***************************************************************************
 *	CmpDiscTime: Ǥ錄줿֤ǥκϰ⤫Ƚꤹ
 *	
 *		int CmpDiscTime(const struct cd_time *cd_time_ptr, 
 *								const struct cd_toc *toc);
 *	
 *		struct cd_time *cd_time_ptr;		Ӥ
 *		const struct cd_toc *toc;			ԣϣ
 *	֤
 *		ݣ:		ϻ֤
 *		:			ϻ֡λ֤ϰ
 *		ܣ:		λ֤
 *	
 ***************************************************************************/
int CmpDiscTime(const struct cd_time *cd_time_ptr, const struct cd_toc *toc)
{
	int status = 1;
	int tracks;
	unsigned long int start, end, time;
	
	time  = time2frame(cd_time_ptr);
	tracks = NumberOfTrack(toc);
	if(tracks > 0) {
		start = time2frame(&toc->track[0]);
		end   = time2frame(&toc->total) - 1;
		status = -(time < start) + (time > end);
	}
	return(status);
}

/***************************************************************************
 *	CmpCdTimes: Ǥ錄줿֤γϻ֡λ֤ϰ⤫Ƚꤹ
 *	
 *		int CmpCdTimes(const struct cd_time *cd_time_ptr, 
 *							const struct cd_time *start_time, 
 *							const struct cd_time *end_time);
 *	
 *		struct cd_time *cd_time_ptr;		Ӥ
 *		const struct cd_time *start_time;	ãıդγϻ
 *		const struct cd_time *end_time;		ãıդνλ
 *	֤
 *		ݣ:		ϻ֤
 *		:			ϻ֡λ֤ϰ
 *		ܣ:		λ֤
 *	
 ***************************************************************************/
int CmpCdTimes(const struct cd_time *cd_time_ptr, 
		const struct cd_time *start_time, const struct cd_time *end_time)
{
	int status;
	unsigned long int start, end, time;
	
	time  = time2frame(cd_time_ptr);
	start = time2frame(start_time);
	end   = time2frame(end_time);
	status = -(time < start) + (time > end);
	
	return(status);
}

/***************************************************************************
 *	CmpCdTime: Ǥ錄줿֤γϻ֡λ֤ϰ⤫Ƚꤹ
 *	
 *		int CmpCdTime(const struct cd_time *cd_time_ptr, 
 *							const struct cdda_play *cd_play);
 *	
 *		struct cd_time *cd_time_ptr;		Ӥ
 *		const struct  cdda_play *cd_play;	ãıդγϻ֡λ
 *	֤
 *		ݣ:		ϻ֤
 *		:			ϻ֡λ֤ϰ
 *		ܣ:		λ֤
 *	
 ***************************************************************************/
int CmpCdTime(const struct cd_time *cd_time_ptr, 
					const struct cdda_play *cd_play)
{
	int status;
	unsigned long int start, end, time;
	
	time  = time2frame(cd_time_ptr);
	start = time2frame(&cd_play->start);
	end   = time2frame(&cd_play->end);
	status = -(time < start) + (time > end);
	
	return(status);
}

/***************************************************************************
 *	cd_status2: ӣգ£Ѥμ
 *	
 *		int cd_status2(struct cd_subq *subq_ptr);
 *	
 *		struct cd_subq *subq_ptr;
 *	֤
 *		EOF: 	顼ʸߤαվμ˼ԡ
 *		: 	
 *	
 *		
 ***************************************************************************/
int cd_status2(struct cd_subq *subq_ptr)
{
	int status = FALSE;

	if(cd_status(subq_ptr) == 0) {
		if(subq_ptr->playing) {
			status = TRUE;
		}
	}
	return((status)?(0):(EOF));
}

/***************************************************************************
 *	searching: ꤫饵ʬեȤãĤαվ
 *	
 *		Cd_Order *searching(struct cd_play *playing, 
 *						const struct cd_time *time_ptr, long int step);
 *	
 *		const Cd_Order *cd_order_ptr;		ʸߤΡ˥
 *		struct cd_play *playing;			ãĤαվ
 *		const struct cd_time *time_ptr;		ߤαջ
 *		long int step;						ǥեȤե졼
 *	֤
 *		NULL:		˱ϰϤˤʤ
 *		NULLʳ:	η̤Υΰ֤ؤ
 *	
 *		time_ptr
 *		
 *		 ʬ 
 *		
 *		ߤαջ֨  
 *		
 *		ե졼ਭ
 *		
 *		Υե졼ñ̤Ǥαջ֡ϡᡡ
 *		ʡʬϡ60ܡáϡˡ75Υե졼Ϩ
 *		cd_play եȤ
 *		ե졼
 *		û
 *		 ʬ 
 *		
 *		ճϻ֨  
 *		
 *		ե졼ਭ
 *		
 *		 ʬ 
 *		
 *		սλ֨  αսλ֡
 *		
 *		ե졼ਭ
 *		
 *		ԡȲ
 *		
 *		
 *		
 *		ճϻ֤ߤΥϰϤؼޤ뤫
 *		ɤȽꤷơϰϳʤ饪С
 *		ʬΥإåפ롣
 *		
 *		
 *		ϰϤꡡϰϤ
 *		cd_order_ptrإե
 *		إեȡθߤΥϡ
 *		
 *		 ϥȥå 	
 *		
 *		 λȥå  ϥȥå 
 *		
 *		ϻ֨ λȥå  ϥȥå 
 *		ãĨ
 *		ըλ֨ϻ֨ λȥå 
 *		󨧨ãĨ
 *		ԡȨըλ֨ϻ֨
 *		󨧨ãĨ
 *		 ¦ ԡȨըλ֨
 *		󨧨
 *		 ¦  ¦ ԡȨ
 *		
 *		Σգ̣̥ݥ󥿡 ¦  ¦ 
 *		
 *		 ¦ 
 *		Σգ̣̥ݥ󥿨
 *		
 *	bugs
 *		Backward search -- overflow
 ***************************************************************************/
Cd_Order *searching(Cd_Order *cd_order_ptr, struct cdda_play *playing, 
							const struct cd_time *time_ptr, long int step)
{
	int status;								/* ϰϤΥå */
	unsigned long int start, end;			/* CD αվ */
	unsigned long int top, bottom;			/* ߤΥϰ */
	
	/**********************
	 *	CD վμ
	 **********************/
	playing->start = *time_ptr;
	start  = time2frame(&playing->start);
	end    = time2frame(&playing->end);
	
	start += step;				/* ֤ */
	
	do {
		/***************************
		 *	ߤΥϰϤμ
		 ***************************/
		top    = time2frame(&cd_order_ptr->play_info.start);
		bottom = time2frame(&cd_order_ptr->play_info.end);
		/*************************
		 *	ϰϤΥå
		 *************************/
		status = (-(start < top) + (start > bottom));
		switch(status) {
		case -1:		/* ˤդ줿 */
			cd_order_ptr = cd_order_ptr->prev_order_ptr;
			if(cd_order_ptr != NULL) {
				/*********************
				 *	˷³
				 *********************/
				start -= top;
				start += time2frame(&cd_order_ptr->play_info.end);
			}
			break;
		case 0:			/* ϰ */
			break;
		case 1:			/* ˤդ줿 */
			cd_order_ptr = cd_order_ptr->next_order_ptr;
			if(cd_order_ptr != NULL) {
				/***********************
				 *	˷³
				 ***********************/
				start -= bottom;
				start += time2frame(&cd_order_ptr->play_info.start);
			}
			break;
		}
	} while((status)?(cd_order_ptr != NULL):(FALSE));
	if(cd_order_ptr != NULL) {
		frame2time( start, &playing->start);
		frame2time(bottom, &playing->end);
	}
	return(cd_order_ptr);
}

/***************************************************************************
 *	get_track_no: ջ֤ȥåֹ֤
 *	
 *		int get_track_no(const struct cd_time *cd_time_ptr, 
 *									const struct cd_toc *toc);
 *	
 *		const struct cd_time *cd_time_ptr;	ջ
 *		const struct cd_toc *toc;			ԣϣáTable Of Contents
 *	֤
 *		EOF		ջ֤ãĤΤϰϤǼޤʤ
 *		ʾ塧	ȥåֹ
 *	
 *		
 ***************************************************************************/
int get_track_no(const struct cd_time *cd_time_ptr, const struct cd_toc *toc)
{
	int track = EOF;
	int number_of_track;
	unsigned long int cd_frame;
	
	number_of_track = NumberOfTrack(toc);
	cd_frame = time2frame(cd_time_ptr);
	if(cd_frame < time2frame(&toc->total)) {
		for(track = 0;track < number_of_track;++track) {
			if(cd_frame < time2frame(&toc->track[track]))
				break;
		}
		--track;
		track += toc->s_track;
	}
	return(track);
}

/***************************************************************************
 *	InnerTop: ȥåʤޤϡˤƬλ֤μ
 *	
 *		static struct cd_time *InnerTop(int track, 
 *				const Cd_Order *cd_order_ptr, const struct cd_toc *toc);
 *	
 *		int track;							ߤΥȥåֹ
 *		const Cd_Order *cd_order_ptr;		ߤΥ
 *		const struct cd_toc *toc;			ԣϣáTable Of Contents
 *	֤
 *		ȥåޤϡƬλ
 *	
 *		
 ***************************************************************************/
static const struct cd_time *InnerTop(int track, 
			const Cd_Order *cd_order_ptr, const struct cd_toc *toc)
{
	const struct cd_time *cd_time_ptr;	/*  */
	
	if(cd_order_ptr->start_track == EOF || 
					track == cd_order_ptr->start_track) {
		cd_time_ptr = &cd_order_ptr->play_info.start;
	} else {
		cd_time_ptr = &toc->track[track - toc->s_track];
	}
	return(cd_time_ptr);
}

/***************************************************************************
 *	SubCdTime: cd_time ¤ΤɤͤӤԤ
 *	
 *		long int SubCdTime(const struct cd_time *time1, 
 *							const struct cd_time *time2);
 *	
 *		const struct cd_time *time1;	
 *		const struct cd_time *time2;	
 *	֤
 *		 time1 顢 time2 ʥե졼ˤǤ롣
 *		衡ͤʲΰ̣
 *			:		time2 礭
 *			:		time1  time2 
 *			:		time1 礭
 *	
 *		
 ***************************************************************************/
long int SubCdTime(const struct cd_time *time1, 
							const struct cd_time *time2)
{
	long int time_frame;
	
	time_frame = time2frame(time1);
	time_frame -= time2frame(time2);
	
	return(time_frame);
}

/***************************************************************************
 *	SkipTop: ȥåʥˤƬؤΥåפΤ˱ճϻ֤
 *	
 *		int SkipTop(struct cdda_play *play, const Cd_Order *cd_order_ptr, 
 *				const struct cd_toc *toc, const struct cd_subq *now_subq);
 *	
 *		struct cdda_play *play;
 *		const Cd_Order *cd_order_ptr;		ߤΥ
 *		const struct cd_toc *toc;			ԣϣáTable Of Contents
 *		const struct cd_subq *now_subq;		ãıվ
 *	֤
 *		(FALSE): 	ޤϡȥåƬ75ե졼
 *		(TRUE): 	ޤϡȥåƬ75ե졼ʤǤ
 *	
 *		
 ***************************************************************************/
int SkipTop(struct cdda_play *play, const Cd_Order *cd_order_ptr, 
 				const struct cd_toc *toc, const struct cd_subq *now_subq)
{
	int status = FALSE;
	const struct cd_time *cd_time_ptr;
	
	cd_time_ptr = InnerTop(now_subq->track, cd_order_ptr, toc);
	if(SubCdTime(&now_subq->time, cd_time_ptr) > 75) {
		status = TRUE;
		play->start = *cd_time_ptr;
	}
	return(status);
}

/***************************************************************************
 *	PreviousSkip: ΥȥåʥˤؤΥåѾμ
 *	
 *		const Cd_Order *PreviousSkip(struct cdda_play *play, 
 *				const Cd_Order *cd_order_ptr, 
 *				const struct cd_toc *toc, const struct cd_subq *now_subq);
 *	
 *		struct cdda_play *play;			åΣãıեǡ
 *		int track;						եȥå
 *		const Cd_Order *cd_order_ptr;	ߤΥ
 *		const struct cd_toc *toc;		ԣϣáTable Of Contents
 *	֤
 *		NULL		Υȥåʥˤ¸ߤʤ
 *					եǡǤʤä
 *		NULLʳ	եǡʱեǡμ
 *	
 *		
 ***************************************************************************/
Cd_Order *PreviousSkip(struct cdda_play *play, int track, 
			Cd_Order *cd_order_ptr, const struct cd_toc *toc)
{
	const struct cd_time *cd_time_ptr = NULL;
	
	if(cd_order_ptr != NULL) {
		if(cd_order_ptr->start_track == EOF || 
						track <= cd_order_ptr->start_track) {
			cd_order_ptr = cd_order_ptr->prev_order_ptr;
			if(cd_order_ptr != NULL) {
				cd_time_ptr = &cd_order_ptr->play_info.start;
			}
		} else {
			--track;
			cd_time_ptr = &toc->track[track - toc->s_track];
		}
		if(cd_time_ptr != NULL) {
			play->start = *cd_time_ptr;
			play->end   = cd_order_ptr->play_info.end;
		}
	}
	return(cd_order_ptr);
}

/***************************************************************************
 *	NextSkip: ΥȥåʥˤؤΥåѾμ
 *	
 *		const Cd_Order *NextSkip(struct cdda_play *play, int track, 
 *				const Cd_Order *cd_order_ptr, const struct cd_toc *toc);
 *	
 *		struct cdda_play *play;			åΣãıեǡ
 *		int track;						եȥå
 *		const Cd_Order *cd_order_ptr;	ߤΥ
 *		const struct cd_toc *toc;		ԣϣáTable Of Contents
 *	֤
 *		NULL		Υȥåʥˤ¸ߤʤ
 *					եǡǤʤä
 *		NULLʳ	եǡʱեǡμ
 *	
 *		
 ***************************************************************************/
Cd_Order *NextSkip(struct cdda_play *play, int track, 
					Cd_Order *cd_order_ptr, const struct cd_toc *toc)
{
	const struct cd_time *cd_time_ptr = NULL;
	
	if(cd_order_ptr != NULL) {
		if(cd_order_ptr->end_track == EOF || 
						track >= cd_order_ptr->end_track) {
			cd_order_ptr = cd_order_ptr->next_order_ptr;
			if(cd_order_ptr != NULL) {
				cd_time_ptr = &cd_order_ptr->play_info.start;
			}
		} else {
			++track;
			cd_time_ptr = &toc->track[track - toc->s_track];
		}
		if(cd_time_ptr != NULL) {
			play->start = *cd_time_ptr;
			play->end   = cd_order_ptr->play_info.end;
		}
	}
	return(cd_order_ptr);
}

/***************************************************************************
 *	track_list: ȥåꥹȤɽʥǥХåѴؿ
 *	
 *		void track_list(const struct cd_toc *toc);
 *	
 *		const struct cd_toc *toc;			ԣϣáTable Of Contents
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void track_list(const struct cd_toc *toc)
{
	int track;
	unsigned long int cd_frame;
	struct cd_time cd_time;
	const struct cd_time *start_time, *end_time;
	
	for(track = toc->s_track;track <= toc->e_track;++track) {
		start_time = TrackStartTime(track, toc);
		end_time   = TrackEndTime(track, toc);
		cd_frame = SubCdTime(end_time, start_time);
		frame2time(cd_frame, &cd_time);
		printf("Track %2d : %2d:%02d.%02d -- %2d:%02d.%02d (%2d:%02d.%02d)\n", 
			track, start_time->minute, start_time->second, start_time->frame,
				end_time->minute, end_time->second, end_time->frame, 
					cd_time.minute, cd_time.second, cd_time.frame);
	}
}

/***************************************************************************
 *	ProgramIndexMember: ץࡦꥹȤ
 *	
 *		void ProgramIndexMember(char *buffer, Cd_Order *order);
 *	
 *		chat *buffer;			ꥹȹʸХåե
 *		Cd_Order *order;		
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ProgramIndexMember(char *buffer, Cd_Order *order)
{
	int selector;
	struct cd_time cd_time;

	if(order->start_track == order->end_track) {
		selector = 2*(order->start_track == EOF) | 
				((CurrentDiscFlag != FALSE) && ProgramSongTitle);
		frame2time(SubCdTime(&order->play_info.end, 
						&order->play_info.start), &cd_time);
		switch(selector) {
		case 0:		/* ꡼ʳǥʤ */
			sprintf(buffer, "Track %d: (%2d:%02d -- %2d:%02d)",
				order->start_track, 
				order->play_info.start.minute, order->play_info.start.second,
				order->play_info.end.minute, order->play_info.end.second);
			break;
		case 1:		/* ꡼ʳǥ󤢤 */
			sprintf(buffer, "Track%2d: %2d'%02d  %s",
				order->start_track, cd_time.minute, cd_time.second, 
				(CurrentDisc_ptr->track_ptr + 
								order->start_track - 1)->trackTitle);
			break;
		case 2:		/* ꡼ǥʤ */
			/* to be continued */
		case 3:		/* ꡼ǥ󤢤 */
			sprintf(buffer, "Memory %2d'%02d (%2d:%02d -- %2d:%02d)",
				cd_time.minute, cd_time.second, 
				order->play_info.start.minute, 
				order->play_info.start.second,
				order->play_info.end.minute, 
				order->play_info.end.second) ;
			break;
		}
	} else {
		sprintf(buffer, "Track %d - %d: (%2d:%02d -- %2d:%02d)",
			order->start_track, order->end_track,
			order->play_info.start.minute, order->play_info.start.second,
			order->play_info.end.minute, order->play_info.end.second);	
	}
}

/***************************************************************************
 *	ProgramOrderList: ץࡦꥹȤ
 *	
 *		int ProgramOrderList(Cd_Order *program_order, 
 *								chat **list_ptr, int length, int max_num);
 *	
 *		Cd_Order *program_order;	ץࡦ
 *		chat **list_ptr;			ꥹ
 *		int length;					ĤΥꥹȺĹ
 *		int max_num;				ꥹȤκĿ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int ProgramOrderList(Cd_Order *program_order, char **list_ptr, int length, int max_num)
{
	int counter;
	char buffer[256];
	Cd_Order *order;

	for(counter = 0, order = program_order;
				order != NULL && counter < max_num;
				++counter, order = order->next_order_ptr, ++list_ptr) {
		ProgramIndexMember(buffer, order);
		sprintf(*list_ptr, "%.*s", length - 1, cdljc(buffer));
	}
	return(counter);
}

/***************************************************************************
 *	track_time: ȥåαջ֤֤
 *	
 *		long int track_time(int track, const struct cd_toc *toc);
 *	
 *		int track;							ȥå
 *		const struct cd_toc *toc;			ԣϣáTable Of Contents
 *	֤
 *		EOF		ȥåֹ椬۾
 *		ʾ塧	ȥåΥե졼
 *	
 *		
 ***************************************************************************/
long int track_time(int track, const struct cd_toc *toc)
{
	long int cd_frame = EOF;
	const struct cd_time *start_time, *end_time;
	
	if(track >= toc->s_track && track <= toc->e_track) {
		start_time = TrackStartTime(track, toc);
		end_time   = TrackEndTime(track, toc);
		cd_frame = SubCdTime(end_time, start_time);
	}
	return(cd_frame);
}

/***************************************************************************
 *	release_order_list: ꥹȤΥ꤫
 *	
 *		void release_order_list(Cd_Order *cd_order_ptr);
 *	
 *		Cd_Order *cd_order_ptr;
 *	֤
 *		
 *	
 *		
 *		Cd_Order: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *		
 *		Ƭõ塢ꥹΤ
 *		
 *		Ƭ
 *		
 *		ϥȥå	
 *		
 *		λȥåϥȥå	
 *		
 *		ãıվ󨭨λȥåϥȥå
 *		
 *		¦󥯨ãıվ󨭨λȥå
 *		
 *		¦󥯨¦󥯨ãıվ
 *		
 *		Σգ̣̥ݥ󥿡¦󥯨¦󥯨
 *		
 *		¦󥯨
 *		Σգ̣̥ݥ󥿨
 *		
 ***************************************************************************/
void release_order_list(Cd_Order *cd_order_ptr)
{
	Cd_Order *next_ptr, *release_ptr;

	if(cd_order_ptr != NULL) {
		next_ptr = (Cd_Order *)LinkLast(cd_order_ptr, Cd_Order_Prev);
		for(release_ptr = next_ptr;
					release_ptr != NULL;release_ptr = next_ptr) {
			next_ptr = release_ptr->next_order_ptr;
			free(release_ptr);
		}
	}
}

/***************************************************************************
 *	delete_order: ꤵ줿򥪡ꥹȤ椫
 *	
 *		int delete_order(Cd_Order *cd_order_ptr);
 *	
 *		Cd_Order *cd_order_ptr;
 *	֤
 *		bit0 åȤʤ顧		¦󥯤ƹ줿
 *		bit1 åȤʤ顧		¦󥯤ƹ줿
 *	
 *		Cd_Order: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *		
 *		ꤷ򥪡ꥹȤ鳰
 *		
 *		ľΥ
 *		
 *		ϥȥå	
 *		
 *		λȥå	ľΥ
 *		
 *		ãıվ󨭨ϥȥå
 *		ϥȥå
 *		¦󥯨λȥå
 *		λȥå
 *		¦󥯨ãıվ
 *		ãıվ󨭡
 *		¦󥯨
 *		¦󥯨
 *		¦󥯨
 *		 NULL ¦󥯨
 *		
 *		 NULL
 *		
 ***************************************************************************/
int delete_order(Cd_Order *cd_order_ptr)
{
	int status = 0x00;
	Cd_Order *prev_ptr, *next_ptr;
	
	if(cd_order_ptr != NULL) {
		prev_ptr = cd_order_ptr->prev_order_ptr;
		next_ptr = cd_order_ptr->next_order_ptr;
		if(cd_order_ptr->prev_order_ptr != NULL) {
			/* 󥯤ΤĤʤؤ */
			prev_ptr->next_order_ptr = next_ptr;
			cd_order_ptr->prev_order_ptr = NULL;
			status |= 0x01;
		}
		if(cd_order_ptr->next_order_ptr != NULL) {
			/* 󥯤ΤĤʤؤ */
			next_ptr->prev_order_ptr = prev_ptr;
			cd_order_ptr->next_order_ptr = NULL;
			status |= 0x02;
		}
	}
	return(status);
}

/***************************************************************************
 *	release_order: ꤵ줿򥪡ꥹȤ椫
 *	
 *		int release_order(Cd_Order *cd_order_ptr);
 *	
 *		Cd_Order *cd_order_ptr;
 *	֤
 *		
 *	
 *		Cd_Order: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *		
 *		ꤷ򥪡ꥹȤ鳰롣
 *		
 *		ľΥ
 *		
 *		ϥȥå
 *		
 *		λȥå	ľΥ
 *		
 *		ãıվ󨭨ϥȥå
 *		ϥȥå
 *		¦󥯨λȥå
 *		λȥå
 *		¦󥯨ãıվ
 *		ãıվ󨭡
 *		¦󥯨
 *		¦󥯨
 *		¦󥯨
 *		 NULL ¦󥯨
 *		
 *		 NULL
 *		
 *		
 ***************************************************************************/
int release_order(Cd_Order *cd_order_ptr)
{
	int status = 0x00;
	
	status = delete_order(cd_order_ptr);
	if(cd_order_ptr != NULL) {		/*  if ɬפʤ */
		free(cd_order_ptr);
	}
	return(status);
}

/***************************************************************************
 *	insert_order: 򥤥󥵡Ȥ
 *	
 *		void insert_order(Cd_Order *cd_order_ptr, 
 *							Cd_Order *prev_order, Cd_Order *next_order);
 *	
 *		Cd_Order *cd_order_ptr;
 *		Cd_Order *prev_order;
 *		Cd_Order *next_order;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void insert_order(Cd_Order *cd_order_ptr, 
						Cd_Order *prev_order, Cd_Order *next_order)
{
	if(prev_order != NULL) {
		prev_order->next_order_ptr = cd_order_ptr;
	}
	if(next_order != NULL) {
		next_order->prev_order_ptr = cd_order_ptr;
	}
	cd_order_ptr->prev_order_ptr = prev_order;
	cd_order_ptr->next_order_ptr = next_order;
}

/***************************************************************************
 *	Cd_Order_Prev: Cd_OrderΣΥ󥯤֤
 *	
 *		void *Cd_Order_Prev(void *data_ptr);
 *	
 *		void *data_ptr;
 *	֤
 *		NULL:		󥯤ü
 *		NULLʳ:	Υ
 *	
 *		֤ͤˤϤˤϡѤΥݥ󥿷Ǥvoid *ɤѤ롣
 *		ᡢٻѤ뤿ˤϡCd_Order˥㥹ȤʤƤϤ
 *		ʤ
 *		
 ***************************************************************************/
void *Cd_Order_Prev(void *data_ptr)
{
	Cd_Order *cd_order_ptr = (Cd_Order*)data_ptr;
	
	return(cd_order_ptr->prev_order_ptr);
}

/***************************************************************************
 *	Cd_Order_Next: Cd_OrderΣĸΥ󥯤֤
 *	
 *		void *Cd_Order_Next(void *data_ptr);
 *	
 *		void *data_ptr;
 *	֤
 *		NULL:		󥯤ü
 *		NULLʳ:	ĸΥ
 *	
 *		֤ͤˤϤˤϡѤΥݥ󥿷Ǥvoid *ɤѤ롣
 *		ᡢٻѤ뤿ˤϡCd_Order˥㥹ȤʤƤϤ
 *		ʤ
 *		
 ***************************************************************************/
void *Cd_Order_Next(void *data_ptr)
{
	Cd_Order *cd_order_ptr = (Cd_Order*)data_ptr;
	
	return(cd_order_ptr->next_order_ptr);
}

/***************************************************************************
 *	LinkLast: ѤΥ󥯥ȥꥹȷΥꥹȤü򥵡ؿ
 *	
 *		void *LinkLast(void *linked_data_ptr, 
 *						void (*next_link_ptr)(void *now_ptr));
 *	
 *		void *linked_data_ptr;		ѤΥ󥯥ȥꥹȤؤΥݥ
 *		void (*next_link_ptr)(void *now_ptr);	ΥꥹȤ֤ؿ
 *	֤
 *		NULL		ꥹȤˤʤäƤʤ
 *					裱linked_data_ptrˤ NULL ݥ
 *		NULLʳ	ꥹȤü
 *	
 *		ѤΥ󥯥ȥꥹȷΥꥹȤü򥵡롣Ѥˤ뤿
 *		֤ͤȤѤΥݥ󥿡void *ˤѤƤ롣Υ
 *		󥯤ؤΥ󥯥ݥ󥿤ΥСϹ¤Τɤˤ뤫狼ʤ
 *		鼡إ󥯥ݥ󥿤뤿ˡ裲 next_link_ptr ؤ
 *		ؿѤ롣֤ͤǤꥹȤüѤΥݥ󥿡void *ˤ
 *		֤Τǥ㥹ȤƼʤȥǡ򰷤Ȥʤ
 *	ջ
 *		ѤΥݥ󥿡void *ˤѤƤΤǥץȥѤ
 *		ΣӣɡäΥ顼åǤϡóݤʤȤ¿Τ
 *		դ뤳ȡ
 *		
 ***************************************************************************/
void *LinkLast(void *linked_data_ptr, void *(*next_link_ptr)(void *now_ptr))
{
	void *data_ptr = NULL;
	
	while(linked_data_ptr != NULL) {
		data_ptr = linked_data_ptr;
		linked_data_ptr = next_link_ptr(linked_data_ptr);
	}
	return(data_ptr);
}

/***************************************************************************
 *	NumberOfLink: ѤΥ󥯥ȥꥹȷΥꥹȤθĿؿ
 *	
 *		int NumberOfLink(void *linked_data_ptr, 
 *					void *(*next_link_ptr)(void *now_ptr));
 *	
 *		void *linked_data_ptr;		ѤΥ󥯥ȥꥹȤؤΥݥ
 *		void (*next_link_ptr)(void *now_ptr);	ΥꥹȤ֤ؿ
 *	֤
 *		0		ꥹȤˤʤäƤʤ
 *					裱linked_data_ptrˤ NULL ݥ
 *		1ʾ塧	ꥹȤüޤǤΥꥹȿ
 *	
 *		ѤΥ󥯥ȥꥹȷΥꥹȤü򥵡롣Ѥˤ뤿
 *		֤ͤȤѤΥݥ󥿡void *ˤѤƤ롣Υ
 *		󥯤ؤΥ󥯥ݥ󥿤ΥСϹ¤Τɤˤ뤫狼ʤ
 *		鼡إ󥯥ݥ󥿤뤿ˡ裲 next_link_ptr ؤ
 *		ؿѤ롣֤ͤǤꥹȤüѤΥݥ󥿡void *ˤ
 *		֤Τǥ㥹ȤƼʤȥǡ򰷤Ȥʤ
 *	ջ
 *		ѤΥݥ󥿡void *ˤѤƤΤǥץȥѤ
 *		ΣӣɡäΥ顼åǤϡóݤʤȤ¿Τ
 *		դ뤳ȡ
 *		
 ***************************************************************************/
int NumberOfLink(void *linked_data_ptr, 
					void *(*next_link_ptr)(void *now_ptr))
{
	int counter;
	
	for(counter = 0;linked_data_ptr != NULL;++counter) {
		linked_data_ptr = next_link_ptr(linked_data_ptr);
	}
	return(counter);
}

/***************************************************************************
 *	LinkSearch: ѤΥ󥯥ȥꥹȷΥꥹȤΤĤ򥵡ؿ
 *	
 *		void *LinkSearch(int num, 
 *				void *linked_data_ptr, void (*next_link_ptr)(void *now_ptr));
 *	
 *		int num;					
 *		void *linked_data_ptr;		ѤΥ󥯥ȥꥹȤؤΥݥ
 *		void (*next_link_ptr)(void *now_ptr);	ΥꥹȤ֤ؿ
 *	֤
 *		NULL		ꥹȤ
 *		NULLʳ	
 *	
 *		ѤΥ󥯥ȥꥹȷΥꥹȤ򥵡롣Ѥˤ뤿
 *		֤ͤȤѤΥݥ󥿡void *ˤѤƤ롣Υ󥯤
 *		Υ󥯥ݥ󥿤ΥСϹ¤Τɤˤ뤫狼ʤ鼡
 *		إ󥯥ݥ󥿤뤿ˡ裲 next_link_ptr ؤؿ
 *		Ѥ롣֤ͤǤꥹȤüѤΥݥ󥿡void *ˤ֤
 *		Τǥ㥹ȤƼʤȥǡ򰷤Ȥʤ
 *	ջ
 *		ѤΥݥ󥿡void *ˤѤƤΤǥץȥѤ
 *		ΣӣɡäΥ顼åǤϡóݤʤȤ¿Τ
 *		դ뤳ȡ
 *		
 ***************************************************************************/
void *LinkSearch(int num, 
		void *linked_data_ptr, void *(*next_link_ptr)(void *now_ptr))
{
	int counter;
	
	for(counter = 0;linked_data_ptr != NULL && counter < num;++counter) {
		linked_data_ptr = next_link_ptr(linked_data_ptr);
	}
	return((counter <= num)?(linked_data_ptr):(NULL));
}

/***************************************************************************
 *	add_program: ȥåץɲä
 *	
 *		int add_program(int track, Cd_Order *cd_order_ptr);
 *	
 *		int track;
 *		Cd_Order *cd_order_ptr;
 *	֤
 *		NULL			顼ʥγԡ
 *		NULLʳ		ɲä줿Υݥ
 *	
 *		
 ***************************************************************************/
Cd_Order *add_program(int track, Cd_Order *cd_order_ptr, struct cd_toc *toc)
{
	int status;
	Cd_Order *track_order, *next_order;
	
	track_order = Cd_Order_alloc();
	if(track_order != NULL) {
		track_order->start_track = track_order->end_track = track;
		status = 
			 get_TrackPlay(track - toc->s_track, &track_order->play_info, toc);
		if(status >= 0) {
			next_order = ((cd_order_ptr == NULL)?
						(cd_order_ptr):(cd_order_ptr->next_order_ptr));
			insert_order(track_order, cd_order_ptr, next_order);
		} else {
			free(track_order);
			track_order = NULL;
		}
	}
	return(track_order);
}

/***************************************************************************
 *	PlayContinue: αդäȤκȽꤹ
 *	
 *		const Cd_Order *PlayContinue(int repeat_mode, 
 *									const Cd_Order *cd_order_ptr);
 *	
 *		int repeat_mode;
 *		const Cd_Order *cd_order_ptr;	ߤΥ
 *	֤
 *		NULL		Υȥåʥˤ¸ߤʤ
 *					եǡǤʤä
 *		NULLʳ	եǡʱեǡμ
 *	
 *		
 ***************************************************************************/
Cd_Order *PlayContinue(int repeat_mode, Cd_Order *cd_order_ptr)
{
	Cd_Order *new_cd_order_ptr = NULL;
	
	if(cd_order_ptr != NULL) {
		switch(repeat_mode) {
		case RepeatOff:
			new_cd_order_ptr = cd_order_ptr->next_order_ptr;
			break;
		default:
			new_cd_order_ptr = cd_order_ptr->next_order_ptr;
			if(new_cd_order_ptr == NULL) {
				new_cd_order_ptr = 
					(Cd_Order *)LinkLast(cd_order_ptr, Cd_Order_Prev);
			}
			break;
		}
	}
	return(new_cd_order_ptr);
}

/***************************************************************************
 *	NeighborOrder: ᤯Υõ
 *	
 *		Cd_Order *NeighborOrder(Cd_Order *cd_order_ptr);
 *	
 *		Cd_Order *cd_order_ptr;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
Cd_Order *NeighborOrder(Cd_Order *cd_order_ptr)
{
	Cd_Order *neighbor_order_ptr = NULL;
	
	if(cd_order_ptr != NULL) {
		neighbor_order_ptr = cd_order_ptr->next_order_ptr;
		if(neighbor_order_ptr == NULL) {
			neighbor_order_ptr = cd_order_ptr->prev_order_ptr;
		}
	}
	return(neighbor_order_ptr);
}

/***************************************************************************
 *	remakeProgram: ץࡦꥹȤǽȥåΤߤǺƹ
 *	
 *		Cd_Order *remakeProgram(Cd_Order *cd_order_ptr, 
 *												const struct cd_toc *toc);
 *	
 *		Cd_Order *cd_order_ptr;		ץࡦꥹȡʤβ褫
 *		const struct cd_toc *toc;	Table of contents
 *	֤
 *		NULL:		ͭʺ̵äȤ
 *		NULLʳ:	ƹ
 *	
 *		ץʥˡꥹȤǽȥåƹ
 *		ãıվ󡾳ϡλϿޤ
 *		
 *			Ƭ
 *		
 *		ϥȥå	
 *		
 *		λȥåϥȥå	
 *		
 *		ãıվ󨭨λȥåϥȥå
 *		
 *		¦󥯨ãıվ󨭨λȥå
 *		
 *		¦󥯨¦󥯨ãıվ
 *		
 *		Σգ̣̥ݥ󥿡¦󥯨¦󥯨
 *		
 *		¦󥯨
 *		Σգ̣̥ݥ󥿨
 *		
 *		̵ʺڤΥ
 *		
 *		̵ʺȤϡ
 *			ϰ˥ǡȥåޤ४
 *		
 ***************************************************************************/
Cd_Order *remakeProgram(Cd_Order *cd_order_ptr, const struct cd_toc *toc)
{
	Cd_Order *next_ptr, *remake_ptr;	/* Υ / ƹս */
	Cd_Order *newTop_ptr = NULL;		/* ƬΥ */
	Cd_Order *prev_ptr = NULL;			/* ľΥ */

	if(cd_order_ptr != NULL) {
		/* ץࡦꥹȤƬ */
		next_ptr = (Cd_Order *)LinkLast(cd_order_ptr, Cd_Order_Prev);
		for(remake_ptr = next_ptr, prev_ptr = NULL;
					remake_ptr != NULL;remake_ptr = next_ptr) {
			next_ptr = remake_ptr->next_order_ptr;
			if(isPlayable(remake_ptr->start_track, 
							remake_ptr->end_track, toc) != FALSE) {
				/*******************
				 *	ǽξ
				 *******************/
				if(newTop_ptr == NULL)
					newTop_ptr = remake_ptr;	/* Ƭ */
				/* ճϡϿ */
				frame2time(time2frame(
						TrackStartTime(remake_ptr->start_track, toc)),
						&remake_ptr->play_info.start);
				/* սλϿ */
				frame2time(time2frame(
						TrackEndTime(remake_ptr->end_track, toc)) - 1,
						&remake_ptr->play_info.end);
				prev_ptr = remake_ptr;
			} else {
				/*********************
				 *	Բǽξ
				 *********************/
				if(prev_ptr != NULL)
					prev_ptr->next_order_ptr = next_ptr;
				free(remake_ptr);
			}
		}
	}
	return(newTop_ptr);
}

/***************************************************************************
 *	test_track: ãġңϣͤΥƥȡüʣãġңϣͤ
 *	
 *		int test_track(const struct cd_toc *toc);
 *	
 *		const struct cd_toc *toc;		CD TOC:Table of Contents-CD
 *	֤
 *		EOF:		顼Ρޥ⡼ɤбԲǽüʣãġңϣ
 *		ʾ:		Ρޥ롦⡼бĤΣãġңϣ͡ãġģ
 *	
 *		
 ***************************************************************************/
int test_track(const struct cd_toc *toc)
{
	int status = 0;
	int track;					/* ȥå򼨤 */
	int number_of_track;
	
	number_of_track = NumberOfTrack(toc);
	track = 0;
	while(track < number_of_track && isDataTrack(&toc->track[track])) {
		++track;
	}
	for(;track < number_of_track && status == 0;++track) {
		if(isDataTrack(&toc->track[track])) {
			status = EOF;
		}
	}
	return(status);
}

/***************************************************************************
 *	isPlayable: ǽƥȤ
 *	
 *		int isPlayable(int start_track, int end_track, 
 *											const struct cd_toc *toc);
 *	
 *		int start_track;		ϥȥå
 *		int end_track;			λȥå
 *		const struct cd_toc *toc;		CD TOC:Table of Contents-CD
 *	֤
 *		ʣ:			Բ
 *		ʣʳ:		ǽ
 *	
 *		ϡλȥåդɤȽꤷޤϰϤ
 *		ǡȥåäꡢϡλȥå¸ߤʤ
 *		ԲĤˤʤ롣
 *		
 ***************************************************************************/
int isPlayable(int start_track, int end_track, const struct cd_toc *toc)
{
	int status = 0;
	int track;					/* ȥå򼨤 */
	int number_of_track;

	number_of_track = NumberOfTrack(toc);
	if(start_track >= 1 && end_track <= number_of_track) {
		for(track = start_track - 1, status = 1;
							track < end_track && status;++track) {
			status = isAudioTrack(&toc->track[track]);
		}
	}
	return(status);
}

/***************************************************************************
 *	programCount: ꤵ줿ץΰ֤ץֹ֤ǵ
 *	
 *		int ProgramCount(Cd_Order *traceOrder);
 *	
 *		Cd_Order *traceOrder;
 *	֤
 *		ꤵ줿ץΰ֤饪ƬޤǤΥ
 *	
 *		ꤵ줿Υץΰ֤ץֹ֤֤
 *		
 ***************************************************************************/
/*ARGSUSED*/
int ProgramCount(Cd_Order *traceOrder)
{
	int counter=0;
	
	while(traceOrder != NULL) {
	 	++counter;
		traceOrder = traceOrder->prev_order_ptr;
	}
	return(counter);
}

/***************************************************************************
 *	cmp_toc: ãľTOCˤӤ
 *	
 *		int cmp_toc(const struct cd_toc *toc1_ptr, 
 *						const struct cd_toc *toc2_ptr);
 *	
 *		const struct cd_toc *toc1_ptr;	
 *		const struct cd_toc *toc2_ptr;	
 *	֤
 *		EOF: 	顼Ӥݥ󥿤Τ NULL ݥ󥿡
 *		0: 		פ
 *		1: 		ۤʤ
 *	
 *		
 ***************************************************************************/
int cmp_toc(const struct cd_toc *toc1_ptr, const struct cd_toc *toc2_ptr)
{
	int counter;
	int status = EOF;
	int number_of_track;
	
	if(toc1_ptr != NULL && toc2_ptr != NULL) {
		number_of_track = NumberOfTrack(toc1_ptr);
		if(number_of_track == NumberOfTrack(toc2_ptr)) {
			for(counter = 0, status = 0;
					status == 0 && counter < number_of_track;++counter) {
				status = SubCdTime(&toc1_ptr->track[counter], 
										&toc2_ptr->track[counter]);
			}
			status = ((status == 0)?(0):(1));
		} else {
			status = 1;
		}
	}
	return(status);
}

