/***************************************************************************
 *	cdda_ext.h: ãıյǽ
 *		
 *		Version 0.61 1994/03/31 -- 
 *		
 *			Programmed by Nobuyuki Maruichi
 *	
 ***************************************************************************/

#ifndef _CDDA_EXT_H
#define _CDDA_EXT_H
#ifdef	TOWNS
# include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */
#include "cdda_ioc.h"

enum _RepeatMode {RepeatOff, RepeatOn};
enum _OrderMode {NormalOrder, ProgramOrder};
/****************************************************************************
 *	Cd_Order: ֥롦󥯥ȡꥹȷʻȹ¤
 *	С
 *		int start_track;					ճϥȥå
 *		int end_track;						սλȥå
 *		struct cdda_play play_info;			ճϡλ֤ʤ
 *		struct _Cd_Order *prev_order_ptr;	Υؤ󥯥ݥ
 *		struct _Cd_Order *next_order_ptr;	Υؤ󥯥ݥ
 *	
 *		ճϥȥåսλȥå EOF ΤȤϥåס
 *		Ԥʤ
 *		󥯡ݥ󥿤ϡNULL ΤȤü򼨤
 *		
 *		Cd_Order: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *		
 *		Ƭ
 *		
 *		ϥȥå	
 *		
 *		λȥåϥȥå	
 *		
 *		ãıվ󨭨λȥåϥȥå
 *		
 *		¦󥯨ãıվ󨭨λȥå
 *		
 *		¦󥯨¦󥯨ãıվ
 *		
 *		Σգ̣̥ݥ󥿡¦󥯨¦󥯨
 *		
 *		¦󥯨
 *		Σգ̣̥ݥ󥿨
 *	
 ***************************************************************************/
typedef struct _Cd_Order {
	int start_track, end_track;
	struct cdda_play play_info;
	struct _Cd_Order *prev_order_ptr;
	struct _Cd_Order *next_order_ptr;
} Cd_Order;

/***************************************************************************
 *	NumberOfTrack() ޥ: TOCTable of contentsˤȥå
 *	
 *		toc		ãľTOCTable of contents
 *	֤
 *		ȥå
 *	
 *	ǡ
 *		ãľΥǡ
 *		
 *		 ãļ 
 *		
 *		ϥȥå
 *		
 *		λȥå  
 *		
 *		 ʬ 
 *		
 *		ãļϿ֨  
 *		
 *		ե졼ਭ
 *		
 *		DF ʬ 
 *		Ƭȥå
 *		ϻ֨  
 *		
 *		ե졼ਭ
 *		
 *		
 *		
 *		
 *		
 *		DF ʬ 
 *		ǽȥå
 *		ϻ֨  
 *		
 *		ե졼ਭ
 *		
 *		
 *		DF:ǡǥμ̤򼨤ե饰
 *		
 ***************************************************************************/
#define NumberOfTrack(toc)	((toc)->e_track - (toc)->s_track + 1)

/***************************************************************************
 *	TrackStartTime() ޥ: ԣϣäȥåαճϻ֤
 *	
 *		track	ȥå
 *		toc		ãľTOCTable of contents
 *	֤
 *		ȥåαճϻ
 ***************************************************************************/
#define TrackStartTime(track_no, toc)	\
			(&((toc)->track[(track_no) - (toc)->s_track]))

/***************************************************************************
 *	TrackEndTime() ޥ: ԣϣäȥåαսλ֤
 *	
 *		track	ȥå
 *		toc		ãľTOCTable of contents
 *	֤
 *		ȥåαսλ
 ***************************************************************************/
#define TrackEndTime(track_no, toc)	\
			(((track_no) >= (toc)->e_track)?(&(toc)->total):\
				(&(toc)->track[(track_no) - (toc)->s_track] + 1))

/*********************
 *	ץȥ
 *********************/
Cd_Order *Cd_Order_alloc(void);
int search_audio_track(int start_track, struct cd_time *cd_time_ptr, 
						const struct cd_toc *toc);
int get_TotalPlay(int track, 
		struct cdda_play *cd_play, const struct cd_toc *toc);
int get_TrackPlay(int track, 
		struct cdda_play *cd_play, struct cd_toc *toc);
Cd_Order *track_order_search(int track_no, Cd_Order *order_ptr);
Cd_Order *time_order_search(const struct cd_time *cd_time_ptr, 
 											Cd_Order *order_ptr);
Cd_Order *nearest_track_order_search(int track_no, Cd_Order *order_ptr);
Cd_Order *MakeNormalPlayOrders(int track, const struct cd_toc *toc);
int CmpDiscTime(const struct cd_time *cd_time_ptr, const struct cd_toc *toc);
int CmpCdTimes(const struct cd_time *cd_time_ptr, 
		const struct cd_time *start_time, const struct cd_time *end_time);
int CmpCdTime(const struct cd_time *cd_time_ptr, 
					const struct cdda_play *cd_play);
int cd_status2(struct cd_subq *subq_ptr);
Cd_Order *searching(Cd_Order *cd_order_ptr, 
	struct cdda_play *playing, const struct cd_time *time_ptr, long int step);
int SkipTop(struct cdda_play *play, const Cd_Order *cd_order_ptr, 
			const struct cd_toc *toc, const struct cd_subq *now_subq);
Cd_Order *PreviousSkip(struct cdda_play *play, int track, 
			Cd_Order *cd_order_ptr, const struct cd_toc *toc);
Cd_Order *NextSkip(struct cdda_play *play, int track, 
					Cd_Order *cd_order_ptr, const struct cd_toc *toc);
int MakeNormalPlayOrder(Cd_Order *order_ptr, const struct cd_toc *toc);
void track_list(const struct cd_toc *toc);
Cd_Order *add_program(int track, Cd_Order *cd_order_ptr, struct cd_toc *toc);
Cd_Order *PlayContinue(int repeat_mode, Cd_Order *cd_order_ptr);
void *Cd_Order_Prev(void *data_ptr);
void *Cd_Order_Next(void *data_ptr);
void *LinkLast(void *linked_data_ptr, void *(*next_link_ptr)(void *now_ptr));
long int SubCdTime(const struct cd_time *time1, const struct cd_time *time2);
Cd_Order *NeighborOrder(Cd_Order *cd_order_ptr);
int test_track(const struct cd_toc *toc);
void set_cd_volume(int volume_level, char *volume_string);
int shift_cd_volume(int d_volume, char *volume_string);
void set_line_volume(int volume_level, char *volume_string);
int shift_line_volume(int d_volume, char *volume_string);
int cmp_toc(const struct cd_toc *toc1_ptr, const struct cd_toc *toc2_ptr);
int ProgramCount(Cd_Order *traceOrder);
void ProgramIndexMember(char *buffer, Cd_Order *order);
int get_track_no(const struct cd_time *cd_time_ptr, const struct cd_toc *toc);
int getTrackEndTime(struct cd_time *cd_time_ptr, int track, const struct cd_toc *toc);
int NumberOfLink(void *linked_data_ptr, void *(*next_link_ptr)(void *now_ptr));
int release_order(Cd_Order *cd_order_ptr);
void insert_order(Cd_Order *cd_order_ptr, Cd_Order *prev_order, Cd_Order *next_order);
void release_order_list(Cd_Order *cd_order_ptr);
void *LinkSearch(int num, void *linked_data_ptr, void *(*next_link_ptr)(void *now_ptr));
int ProgramOrderList(Cd_Order *program_order, char **list_ptr, int length, int max_num);
int delete_order(Cd_Order *cd_order_ptr);
int isPlayable(int start_track, int end_track, const struct cd_toc *toc);
Cd_Order *remakeProgram(Cd_Order *cd_order_ptr, const struct cd_toc *toc);
/* void PlayingChange(MultiPlay *playing); */
#endif /*_CDDA_EXT_H*/

