/***************************************************************************
 *	cdda_ioc.h: CD-DA Ϣ I/O ˴ؤ
 *
 *			1994/03/20 --
 *	
 *				Programmed by Nobuyuki Maruichi
 *	
 ***************************************************************************/

#ifdef	TOWNS
#include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */
#ifdef GENERAL
# include <linux/cdrom.h>
#endif /*GENERAL*/

#ifndef COMPLEX_CDIOC_H
#define COMPLEX_CDIOC_H

/***************************************************************************
 *	ioType: CD-DA  I/O μ̤򼨤
 *		TownsIO: Towns  ioctl
 *		GENERAL_IO: PC/AT  ioctl
 *		
 ***************************************************************************/
typedef enum {
	TownsIO = 0,
	TownsExtIO = 1, 
	GeneralIO
} ioType;

/***************************************************************************
 *	ioType: CD-DA  I/O μ̤򼨤
 *		TownsIO: Towns  ioctl
 *		GENERAL_IO: PC/AT  ioctl
 *		
 ***************************************************************************/
typedef enum {
	NotMounted = 0,
	NowMounted = 1, 
} mountedCheck;

/***************************************************************************
 *	cdDigitalAudio CD-DA  I/O Ū˹Ԥʤι¤
 *	Сѿؿ
 *		
 *		 С     TOWNS      Generaḷ
 *		
 *		  ioTypeName    "TOWNS I/O" "General I/O" I/O ̾Ψ
 *		
 *		    ioType      TownsExtIO       GeneralIO    I/O ̨̼
 *		
 *		  unlocked()   TrayUnlocked        NULL        å 
 *		
 *		    play()      townsPlay2     generalPlay2   
 *		
 *		   pause()      townsPause     generalPause   ߡ
 *		
 *		   resume()     townsResume   generalResume   ߲
 *		
 *		    stop()       townsStop      generalStop   ߡ
 *		
 *		   status()     townsStatus generalTownsStatus ֤μ 
 *		
 *		  status2()    generalStatus   generalStatus   ֤μ 
 *		
 *		    toc()        townsToc       generalToc    
 *		
 *		 doorControl()  townsDoor       generalDoor    ȥ쥤 
 *		
 *		  doorCheck()  NULL  NULL  ̤ 
 *		
 *		
 *	
 *		Linux Ѥ I/O ϡTOWNS ¦ I/O Ѥδؿ˻ˤ
 *		ƥߥ졼󤷤Ƥ롣
 *		
 *		ǡstatus2() ϡ֤μãĥȥ쥤ĤȽԤ
 *		TOWNS Ѥ I/O ˤϡãĥȥ쥤ľ֤ȽԤΤ̵
 *		ǡTOWNS Linux ɲü줿Linux Ѥ I/O ˤȽꤷ
 *		롣ϡTOWNS Linux  CD-ROM driver V1.0 Ǽޤ
 *		
 ***************************************************************************/
typedef struct cdda_device {
	const char *ioTypeName;
	ioType ioType;
	int (*unlocked)(void);
	int (*play)(struct cdda_play *info);
	int (*pause)(void);
	int (*resume)(void);
	int (*stop)(void);
	int (*status)(struct cd_subq *subq);
	int (*status2)(struct cd_subq *subq);
	int (*toc)(struct cd_toc *toc);
	int (*doorControl)(int cmd);
	int (*doorCheck)(struct cd_subq *subq);
} cdDigitalAudio;

/***************************************************************************
 *	MACHINE_ID: ＱѤ I/O Address for FM TOWNS
 *		MACHINE_ID1: 0x30
 *		MACHINE_ID2: 0x31
 ***************************************************************************/
#define MACHINE_ID1		0x30
#define MACHINE_ID2		0x31

/***************************************************************************
 *	 TownsID: ＱѤμ̻(for FM TOWNS)
 *	
 *		
 ***************************************************************************/
enum _machine {
	TOWNS_1st   = 0x01, 
	TOWNS_2nd   = 0x02, 
	TOWNS_3rd   = 0x04, 
	TOWNS_II_UX = 0X03, 
	TOWNS_II_CX = 0x05, 
	TOWNS_II_UG = 0x06, 
	TOWNS_II_HG = 0x08, 
	TOWNS_II_HR = 0x07, 
	TOWNS_II_UR = 0x09, 
	TOWNS_II_MA = 0x0b, 
	TOWNS_II_MX = 0x0c, 
	TOWNS_II_ME = 0x0d, 
	TOWNS_II_MF = 0x0f
} TownsID;

/***************************************************************************
 *	 cdStatus: CD ץ졼ξ֤򼨤(PC/AT)
 *	
 *		
 ***************************************************************************/
typedef enum {
	CS_ERROR = EOF, 
	CS_STOP = 0,
	CS_PLAYING, 
	CS_PAUSE, 
	CS_EJECTED,
	CS_WAITING, 
	CS_UNKNOWN
} cdStatus;

/***************************************************************************
 *	 cdMediaType: CD μ̤򼨤
 *	
 *		
 ***************************************************************************/
typedef enum {
	CD_TypeUnknown            = 0x00,
	CD_DigitalAudio           = 0x01, 
	CD_ROM_Data               = 0x02,
	CD_ROM_DataWithAudioTrack = 0x03
} cdMediaType;

/***************************************************************************
 *	 ץȥ
 ***************************************************************************/
int CdDriveOpen(void);
int CdDriveClose(void);
int track_check(struct cd_toc *toc, int track, int endtrack);
int cd_play(struct cdda_play *info, int track, int endtrack, 
				int count, int *min_track, int *max_track);
int cd_play2(struct cdda_play *info);
u_int time2frame(const struct cd_time *msf);
void frame2time(u_int t, struct cd_time *msf);
int isAudioTrack(const struct cd_time *track_ptr);
int isDataTrack(const struct cd_time *track_ptr);
int cd_pause(void);
int cd_resume(void);
int cd_stop(void);
int cd_status(struct cd_subq *subq);
int cddaStatus2(struct cd_subq *subq);
int get_toc(struct cd_toc *toc);
int cd_door_cntrl(int cmd);

#ifdef	TOWNS
int townsPlay2(struct cdda_play *info);
int townsPause(void);
int townsResume(void);
int townsStop(void);
int townsStatus(struct cd_subq *subq);
int townsToc(struct cd_toc *toc);
# ifdef	CDIOCDOOR
int townsDoor(int cmd);
# endif	/*CDIOCDOOR*/
#endif	/*TOWNS*/
#ifdef GENERAL
int generalPlay2(struct cdda_play *info);
int generalPause(void);
int generalResume(void);
int generalStop(void);
int generalStatus(struct cd_subq *subq);
int generalTownsStatus(struct cd_subq *subq);
int generalToc(struct cd_toc *toc);
int generalDoor(int cmd);
#endif /*GENERAL*/

#endif /*COMPLEX_CDIOC_H*/

