/***************************************************************************
 *	env_util.c - mwxcd δĶ桼ƥƥ
 *	
 *			1995/ 8/28 (Mon.)  -- 1995/07/28
 *			1997/10/ 7 (Tues.) -- 1999/08/18
 *
 *					Programmed by Nobuyuki Maruichi
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1983 or 1990
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <signal.h>
#include <limits.h>
#include <errno.h>

/***********************************************
 *	POSIX Υ󥯥롼ɡե
 ***********************************************/
#include <pwd.h>
#include <regex.h>
#include <unistd.h>
#include <sys/types.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

/**************************************************************
 * Atena Widgetݲ Atena Widget Υ󥯥롼ɡե
 **************************************************************/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/MultiSrc.h>
#include <X11/Xaw/MultiSink.h>
#ifdef	X11R5
# include <X11/Xaw/XawIm.h>
# include <X11/Xaw/Xawi18n.h>
#endif	/*X11R5*/

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "mwxcd.h"
#include "cdda_ext.h"
#include "cd_data.h"
#include "file_sel.h"
#include "stringuty.h"
#include "luty.h"
#include "message.h"

/*****************************************
 *	Хѿ
 *
 *
 *****************************************/
extern AppData app_data;
extern Pixmap diskMark;

static String ApplicationName;
static String ApplicationClass;
static LineLink *ResorceFileTop = NULL;
static Widget cdlFileEnviroment, tiffFileEnviroment, wrdFileEnviroment;

static const LineLink *discDataFile_line_ptr;
static const LineLink *tiffDirpath_line_ptr;
static const LineLink *wordsDirpath_line_ptr;
	
/***************************************************************************
 *	cdlSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void cdlSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void cdlEnvSelectFinish(const char *dirName, const char *fileName)
{
	char filepath[4096];

	sprintf(filepath, "%s/%s", dirName, fileName);
#ifdef	XAW_BUG
	XtVaSetValues(cdlFileEnviroment, XtNstring, XtNewString(filepath), NULL);
#else
	XtVaSetValues(cdlFileEnviroment, XtNstring, filepath, NULL);
#endif	/*XAW_BUG*/
}

/***************************************************************************
 *	cdlFileSelector: ե롦쥯ƤӽФ
 *	
 *		void cdlFileSelector(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void cdlEnvSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	String filepath;
	extern selectorPanes filePickupPaneInfo[];
	extern selectorPanes fileSortPaneInfo[];
	static selectorPanes *defPickup = &filePickupPaneInfo[1];
	static selectorPanes *defSort = &fileSortPaneInfo[1];

	XtVaGetValues(cdlFileEnviroment, XtNstring, &filepath, NULL);
	dirName[0] = '\0';
	fileName[0] = '\0';
	fileCheck(filepath, sizeof(dirName), dirName, sizeof(fileName), fileName);
	fileSelectorCall(w, dirName, defPickup, defSort, cdlEnvSelectFinish);
}

/***************************************************************************
 *	tiffEnvSelectFinish: ե롦쥯򤷤ǥ쥯ȥ̾
 *	
 *		void tiffEnvSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̤̾ѡ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void tiffEnvSelectFinish(const char *dirName, const char *fileName)
/*ARGSUSED*/
{
#ifdef	XAW_BUG
	XtVaSetValues(tiffFileEnviroment, XtNstring, XtNewString(dirName), NULL);
#else
	XtVaSetValues(tiffFileEnviroment, XtNstring, dirName, NULL);
#endif	/*XAW_BUG*/
}

/***************************************************************************
 *	tiffEnvSelector: ե롦쥯ƤӽФ
 *	
 *		void tiffEnvSelector(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void tiffEnvSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	String filepath;
	extern selectorPanes filePickupPaneInfo[];
	extern selectorPanes fileSortPaneInfo[];
	static selectorPanes *defPickup = &filePickupPaneInfo[3];
	static selectorPanes *defSort = &fileSortPaneInfo[1];

	XtVaGetValues(tiffFileEnviroment, XtNstring, &filepath, NULL);
	dirName[0] = '\0';
	fileName[0] = '\0';
	fileCheck(filepath, sizeof(dirName), dirName, sizeof(fileName), fileName);
	fileSelectorCall(w, dirName, defPickup, defSort, tiffEnvSelectFinish);
}

/***************************************************************************
 *	wrdEnvSelectFinish: ե롦쥯򤷤ǥ쥯ȥ̾
 *	
 *		void wrdEnvSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̤̾ѡ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void wrdEnvSelectFinish(const char *dirName, const char *fileName)
{
#ifdef	XAW_BUG
	XtVaSetValues(wrdFileEnviroment, XtNstring, XtNewString(dirName), NULL);
#else
	XtVaSetValues(wrdFileEnviroment, XtNstring, dirName, NULL);
#endif	/*XAW_BUG*/
}

/***************************************************************************
 *	wrdEnvSelector: ե롦쥯ƤӽФ
 *	
 *		void wrdEnvSelector(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void wrdEnvSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	String filepath;
	extern selectorPanes filePickupPaneInfo[];
	extern selectorPanes fileSortPaneInfo[];
	static selectorPanes *defPickup = &filePickupPaneInfo[2];
	static selectorPanes *defSort = &fileSortPaneInfo[1];

	XtVaGetValues(wrdFileEnviroment, XtNstring, &filepath, NULL);
	dirName[0] = '\0';
	fileName[0] = '\0';
	fileCheck(filepath, sizeof(dirName), dirName, sizeof(fileName), fileName);
	fileSelectorCall(w, dirName, defPickup, defSort, wrdEnvSelectFinish);
}

/***************************************************************************
 *	isPlaneFile: 
 *	
 *		int isPlaneFile(const char *filename);
 *	
 *		const char *filename;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int isPlaneFile(const char *filename)
{
	int status = False;
	int result;
	struct stat sbuf;

	result = stat(filename, &sbuf);
	if(result == 0) {
		status = sbuf.st_mode & S_IFMT;
	} else {
		status = (strlen(filename) == 0) || (errno != ENOENT);
	}
	return(status);
}

/***************************************************************************
 *	moveBackup: ꤵ줿եХååץեˤ
 *	
 *		static int moveBackup(const char *filename);
 *	
 *		const char *filename;	
 *	֤
 *					顼ʤ
 *		ʳ		顼ֹ
 *	
 *		ꤵ줿ե͡षƥХååץեˤ롣
 ***************************************************************************/
static int moveBackup(const char *filename)
{
	int result = 0, status;
	String backupName;

	backupName = backupNameAlloc(filename);
	
	if(backupName != NULL) {
		result = status = isPlaneFile(backupName);
		switch(status) {
		case 0:			/* Normal End */
		case S_IFREG:
			if(isPlaneFile(filename) == S_IFREG) {
				/* printf("rename  %s -> %s\n", filename, backupName); */
				if(rename(filename, backupName)) {
					result = errno;
				}
			}
			break;
		default:
			break;
		}
	}
#ifdef	DEBUG
	printf("backup filename = \"%s\"\n", 
				((backupName != NULL)?(backupName):("NULL Pointer")));
#endif	 /*DEBUG*/
	free(backupName);
	return(result);
}

/***************************************************************************
 *	regexLineFinder: 
 *	
 *		LineLink *regexLineFinder(const char *regex, LineLink *lines);
 *	
 *		const char *regex;
 *		LineLink *lines;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
const LineLink *regexLineFinder(const char *regex, const LineLink *lines)
{
	regex_t regExPattern;

	(void)regcomp(&regExPattern, regex, REG_EXTENDED | REG_NOSUB);
	while(lines != NULL) {
		/* printf("%s\n", lines->string); */
		if(!regexec(&regExPattern, lines->string, 0, NULL, 0)) {
			break;
		}
		lines = lines->next_ptr;
	}
	regfree(&regExPattern);

	return(lines);
}

/***************************************************************************
 *	enviromentLoad: ꥽եĶΤ˸ƤӽФ
 *	
 *		void enviromentLoad(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;					̤
 *		XtPointer client_data;		ե̾˳Ƥ줿å
 *		XtPointer call_data;		̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void enviromentLoad(Widget w, XtPointer client_data, XtPointer call_data)
{
	FILE *stream;
	String filename;
	char buffer[1024];
	const LineLink *line_ptr;
	Widget filenameEnviroment = (Widget)client_data;

	XtVaGetValues(filenameEnviroment, XtNstring, &filename, NULL);
	if(filename != NULL) {
		stream = fopen(filename, "r");
		if(stream != NULL) {
			ResorceFileTop = file2lines(stream);
			fclose(stream);
		}
	}
#ifdef	DEBUG
	printf("filename = %s\n", filename);
#endif	 /*DEBUG*/
	/* config_enable = regexLineFinder("^[.*0-9A-Za-z_]*selfConfig:True\n", ResorceFileTop); */
	discDataFile_line_ptr = regexLineFinder("^[.*0-9A-Za-z_]*discDataFile", ResorceFileTop);
	tiffDirpath_line_ptr  = regexLineFinder("^[.*0-9A-Za-z_]*tiffDirpath", ResorceFileTop);
	wordsDirpath_line_ptr = regexLineFinder("^[.*0-9A-Za-z_]*wordsDirpath", ResorceFileTop);
#ifdef	DEBUG
	if(discDataFile_line_ptr != NULL && discDataFile_line_ptr->string != NULL) {
		printf("discDataFile_line_ptr = %s\n", discDataFile_line_ptr->string);
	}
#endif	 /*DEBUG*/
	if(ResorceFileTop == NULL) {
		ResorceFileTop = string2lines(app_data.configString);
	}
	if(discDataFile_line_ptr == NULL) {
		sprintf(buffer, "%s\n", keyword2mes("cdlfile-remark"));
		line_ptr = lineAlloc(buffer);
		(void)linesConnect(ResorceFileTop, (LineLink*)line_ptr);
		sprintf(buffer, "*discDataFile:%s\n", app_data.tiffDirpath);
		discDataFile_line_ptr = lineAlloc(buffer);
		(void)linesConnect(ResorceFileTop, (LineLink*)discDataFile_line_ptr);
	}
#ifdef	DEBUG
	if(tiffDirpath_line_ptr != NULL && tiffDirpath_line_ptr->string != NULL) {
		printf("tiffDirpath_line_ptr  = %s\n", tiffDirpath_line_ptr->string);
	}
#endif	 /*DEBUG*/
	if(tiffDirpath_line_ptr == NULL) {
		sprintf(buffer, "%s\n", keyword2mes("tifffile-remark"));
		line_ptr = lineAlloc(buffer);
		(void)linesConnect(ResorceFileTop, (LineLink*)line_ptr);
		sprintf(buffer, "*tiffDirpath:%s\n", app_data.tiffDirpath);
		tiffDirpath_line_ptr  = lineAlloc(buffer);
		(void)linesConnect(ResorceFileTop, (LineLink*)tiffDirpath_line_ptr);
	}
#ifdef	DEBUG
	if(wordsDirpath_line_ptr != NULL && wordsDirpath_line_ptr->string != NULL) {
		printf("wordsDirpath_line_ptr = %s\n", wordsDirpath_line_ptr->string);
	}
#endif	 /*DEBUG*/
	if(wordsDirpath_line_ptr == NULL) {
		sprintf(buffer, "%s\n", keyword2mes("wrdfile-remark"));
		line_ptr = lineAlloc(buffer);
		(void)linesConnect(ResorceFileTop, (LineLink*)line_ptr);
		sprintf(buffer, "*wordsDirpath:%s\n", app_data.wordsDirpath);
		wordsDirpath_line_ptr = lineAlloc(buffer);
		(void)linesConnect(ResorceFileTop, (LineLink*)wordsDirpath_line_ptr);
	}
}

/***************************************************************************
 *	editResourceLine: 
 *	
 *		LineLink *editResourceLine(Widget tw, LineLink *line_ptr);
 *	
 *		Widget tw;
 *		LineLink *line_ptr;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
LineLink *editResourceLine(Widget tw, LineLink *line_ptr)
{
	char buffer[PATH_MAX+256]; 
	char *componentEnd;
	int componentLength;
	String newResource;

	if(tw != NULL) {
		XtVaGetValues(tw, XtNstring, &newResource, NULL);
	} else {
		return(NULL);
	}
	if(line_ptr == NULL) {
	}
	componentEnd = strchr(line_ptr->string, ':');
	if(componentEnd != NULL) {
		componentLength = componentEnd - line_ptr->string;
	} else {
		componentLength = strlen(line_ptr->string);
	}
	sprintf(buffer, "%.*s:%s\n", componentLength, line_ptr->string, newResource);
	XtFree(line_ptr->string);
	line_ptr->string = (char*)XtNewString(buffer);

	return(line_ptr);
}

/***************************************************************************
 *	l10nMessageArray: åϰ貽
 *	
 *		void l10nMessageArray(char *messageL10n[2], 
 *								const char *messagePattern[]);
 *	
 *		char *messageL10n[2];			ϰ貽å
 *		const char *messagePattern[];	å򸡺뤿Υѥ
 *	֤
 *		ʤ
 *	
 *		messagePattern[] 򸵤ϰ貽å messageL10n[] ֤
 *		ޤåϡmessageL10n[] NULL ݥ󥿤ˤʤ
 *		ǡ³ޤ
 *	Х
 *		 messagePattern[] ϡNULL ݥ󥿤üȤưޤ
 *		üޤϰ貽å뤿ᡢmessageL10n[] ϡ
 *		üʬޤǡɬפǤ­ʤ硢˲ƥХˤʤ
 *		ޤ
 *		δؿξ塢ޤ¿ϰ貽åȤϡ
 *		ʤ⤷̵ȻפޤΤȤ顢#define DEBUG 
 *		Ƥ硢32 İʾϰ貽åμΤȤˡǰΤ
 *		դ¥åФޤ
 *		ǥХåκݤѤƤ
 *		
 ***************************************************************************/
void l10nMessageArray(const char *messageL10n[], const char *messagePattern[])
{
	int counter;

	for(counter = 0;messagePattern[counter] != NULL;++counter) {
		messageL10n[counter] = keyword2mes(messagePattern[counter]);
#ifdef	DEBUG
		if(counter >= 32 && (counter & 31) == 0) {
			printf("Debug message from l10nMessageArray(): "
					"receive array is ready?  messageL10n[%d]\n", counter);
		}
#endif	/*DEBUG*/
	}
	messageL10n[counter] = NULL;
}

/***************************************************************************
 *	enviromentSave: 
 *	
 *		void enviromentSave(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void enviromentSave(Widget w, XtPointer client_data, XtPointer call_data)
{
	FILE *fp;
	String filename = NULL;
	PointorsLink *infomations = (PointorsLink*)client_data;
	Widget filenameEnviroment;
	Widget cdlFileEnviroment, tiffFileEnviroment, wrdFileEnviroment;
	const char *appdefSavedMessage;
	const char *buttonMessageArray[2];
	const char *buttonMessages[] = {"OK", NULL};

	if(infomations != NULL) {
		VaGetPointorsLink(infomations, &filenameEnviroment, &cdlFileEnviroment, 
							&tiffFileEnviroment, &wrdFileEnviroment, NULL);
		if(filenameEnviroment != NULL) {
			/* ХåեˤǤեƤԽ */
			XtVaGetValues(filenameEnviroment, XtNstring, &filename, NULL);
			(void)editResourceLine(cdlFileEnviroment, (LineLink*)discDataFile_line_ptr);
			(void)editResourceLine(tiffFileEnviroment, (LineLink*)tiffDirpath_line_ptr);
			(void)editResourceLine(wrdFileEnviroment, (LineLink*)wordsDirpath_line_ptr);
		}
	}
	if(filename != NULL) {
		moveBackup(filename);					/* Хååפ */
		fp = fopen(filename, "w");
		if(fp != NULL) {
			lines2file(ResorceFileTop, fp);		/* ե񤭽Ф */
			fclose(fp);
			/* եȤγǧåФ */
			buttonMessageArray[0] = keyword2mes(buttonMessages[0]);
			buttonMessageArray[1] = NULL;
			appdefSavedMessage = keyword2mes("appdefSavedMessage");
			messengerPrintf(w, NULL, NULL, NULL, 
				buttonMessageArray, appdefSavedMessage, filename);
		}
	}
}

/***************************************************************************
 *	firstPopup: ܤΥݥåץåפǥ꥽եɤ߹ߤԤ
 *	
 *		void firstPopup(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void firstPopup(Widget w, XtPointer client_data, XtPointer call_data)
{
	static Boolean firstPopupFlag = TRUE;

	if(firstPopupFlag == TRUE) {
		enviromentLoad(w, client_data, call_data);
		firstPopupFlag = FALSE;
	}
}

/***************************************************************************
 *	EnviromentSetData: 
 *	
 *		void EnviromentSetData(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void EnviromentSetData(Widget w, XtPointer client_data, XtPointer call_data)
{
	String filename;
	PointorsLink *infomations = (PointorsLink*)client_data;
	Widget cdlFileEnviroment, tiffFileEnviroment, wrdFileEnviroment;

	if(infomations != NULL) {
		VaGetPointorsLink(infomations, &cdlFileEnviroment, 
							&tiffFileEnviroment, &wrdFileEnviroment, NULL);
		if(cdlFileEnviroment != NULL) {
			XtVaGetValues(cdlFileEnviroment, XtNstring, &filename, NULL);
			app_data.cdl_file = filename;
		}
		if(tiffFileEnviroment != NULL) {
			XtVaGetValues(tiffFileEnviroment, XtNstring, &filename, NULL);
			app_data.tiffDirpath = filename;
		}
		if(wrdFileEnviroment != NULL) {
			XtVaGetValues(wrdFileEnviroment, XtNstring, &filename, NULL);
			app_data.wordsDirpath = filename;
		}
	}
}

/***************************************************************************
 *	Enviroment_init: ޥɡ˥塼ץࡦꥹȤνԤ
 *	
 *		void Enviroment_init(Widget topLevel, 
 *								Widget cd_panel, Widget popupButton);
 *	
 *		Widget topLevel;
 *		Widget cd_panel;
 *		Widget popupButton;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void Enviroment_init(Widget topLevel, Widget cd_panel, Widget popupButton)
{
	Widget enviromentShell, envBlock, appEnviroment, popdownEnv;
	Widget envInitialize, envSet, saveEnviroment, loadEnviroment;
	Widget filenameEnviroment, EnviromentSelect, EnviromentArea;
	Widget cdlArea, cdlLabel, cdlEnviroment, envCdlEnviroment, envCdlSelect;
	Widget tiffArea, tiffLabel, tiffEnviromentArea, envTiff, envTiffSelect;
	Widget wordsArea, wordsLabel, wordsEnviromentArea, envWords, envWordsSelect;
	static PopdownInfo popdownInfo;
	static char EnviromentFilename[1024];
	static char cdlEnviromentFilename[1024];
	static char wrdEnviromentFilename[1024];
	static char tiffEnviromentFilename[1024];
	PointorsLink *infomationBuffer;
	PointorsLink *infomationBuffer2;
	struct passwd *pw_data;

	XtGetApplicationNameAndClass(XtDisplay(topLevel), 
				&ApplicationName, &ApplicationClass);
	/***************************************
	 *	ãģ̥ǡδϢå
	 ***************************************/
	enviromentShell = XtVaCreatePopupShell(
			"enviromentShell",
			transientShellWidgetClass,
			topLevel,
			NULL
			);

	envBlock = XtVaCreateManagedWidget(
			"envBlock", 				/* widget name   */
			panedWidgetClass, 			/* widget class */
			enviromentShell, 			/* parent widget*/
			NULL 						/* argument list*/
			);

	appEnviroment = XtVaCreateManagedWidget(
			"appEnviroment", 			/* widget name   */
			panedWidgetClass,	 		/* widget class */
			envBlock, 					/* parent widget */
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list */
			);
	
	popdownEnv = XtVaCreateManagedWidget(
			"popdownEnv", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			appEnviroment, 				/* parent widget */
			NULL 						/* argument list */
			);

	envInitialize = XtVaCreateManagedWidget(
			"envInitialize", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			appEnviroment, 				/* parent widget */
			NULL 						/* argument list */
			);
	
	envSet = XtVaCreateManagedWidget(
			"envSet", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			appEnviroment, 				/* parent widget */
			NULL 						/* argument list */
			);
	
	saveEnviroment = XtVaCreateManagedWidget(
			"saveEnviroment", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			appEnviroment, 				/* parent widget */
			NULL 						/* argument list */
			);
	
	loadEnviroment = XtVaCreateManagedWidget(
			"loadEnviroment", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			appEnviroment, 				/* parent widget */
			NULL 						/* argument list */
			);
	
	pw_data = getpwuid(getuid());
/*
	home_dir = getenv("HOME");
	sprintf(EnviromentFilename, "%s/%s", home_dir, ApplicationClass);
 */
	sprintf(EnviromentFilename, "%s/%s", pw_data->pw_dir, ApplicationClass);

	filenameEnviroment = XtVaCreateManagedWidget(
			"filenameEnviroment", 		/* widget name   */
			asciiTextWidgetClass, 		/* widget class */
			appEnviroment, 				/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype, XawAsciiString,	
			XtNlength, sizeof(EnviromentFilename) - 1,
			XtNstring, EnviromentFilename, 
			NULL 						/* argument list */
			);
	
	EnviromentSelect = XtVaCreateManagedWidget(
			"EnviromentSelect", 		/* widget name   */
			commandWidgetClass, 		/* widget class */
			appEnviroment, 				/* parent widget */
			XtNbitmap, diskMark,
			NULL 						/* argument list */
			);
	
	EnviromentArea = XtVaCreateManagedWidget(
			"EnviromentArea", 			/* widget name   */
			/*panedWidgetClass,*/ 			/* widget class */
			formWidgetClass, 			/* widget class */
			envBlock,		 			/* parent widget*/
			NULL 						/* argument list*/
			);

	cdlArea = XtVaCreateManagedWidget(
			"cdlArea", 				/* widget name   */
			formWidgetClass, 			/* widget class */
			EnviromentArea, 			/* parent widget*/
			NULL 						/* argument list*/
			);

	cdlLabel = XtVaCreateManagedWidget(
			"cdlLabel", 			/* widget name   */
			labelWidgetClass,	 		/* widget class */
			cdlArea, 					/* parent widget */
			NULL 						/* argument list */
			);
	
	cdlEnviroment = XtVaCreateManagedWidget(
			"cdlEnviroment", 			/* widget name   */
			panedWidgetClass, 			/* widget class */
			cdlArea, 					/* parent widget */
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list */
			);
	
	envCdlEnviroment = XtVaCreateManagedWidget(
			"envCdlEnviroment", 			/* widget name   */
			labelWidgetClass,	 		/* widget class */
			cdlEnviroment, 				/* parent widget */
			NULL 						/* argument list */
			);
	
	sprintf(cdlEnviromentFilename, "%.*s", 
			(int)sizeof(cdlEnviromentFilename) - 1, app_data.cdl_file);

	cdlFileEnviroment = XtVaCreateManagedWidget(
			"cdlFileEnviroment", 		/* widget name   */
			asciiTextWidgetClass, 		/* widget class */
			cdlEnviroment, 				/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype, XawAsciiString,	
			XtNlength, sizeof(cdlEnviromentFilename) - 1,
			XtNstring, cdlEnviromentFilename, 
			NULL 						/* argument list */
			);
	
	envCdlSelect = XtVaCreateManagedWidget(
			"envCdlSelect", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			cdlEnviroment, 				/* parent widget */
			XtNbitmap, diskMark,
			NULL 						/* argument list */
			);
	
	tiffArea = XtVaCreateManagedWidget(
			"tiffArea", 				/* widget name   */
			formWidgetClass, 			/* widget class */
			EnviromentArea, 			/* parent widget*/
			NULL 						/* argument list*/
			);

	tiffLabel = XtVaCreateManagedWidget(
			"tiffLabel", 			/* widget name   */
			labelWidgetClass,	 		/* widget class */
			tiffArea, 					/* parent widget */
			NULL 						/* argument list */
			);
	
	tiffEnviromentArea = XtVaCreateManagedWidget(
			"tiffEnviromentArea", 		/* widget name   */
			panedWidgetClass, 			/* widget class */
			tiffArea, 			/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list*/
			);

	envTiff = XtVaCreateManagedWidget(
			"envTiff", 					/* widget name   */
			labelWidgetClass,	 		/* widget class */
			tiffEnviromentArea, 		/* parent widget */
			NULL 						/* argument list*/
			);

	sprintf(tiffEnviromentFilename, "%.*s", 
			(int)sizeof(tiffEnviromentFilename) - 1, app_data.tiffDirpath);

	tiffFileEnviroment = XtVaCreateManagedWidget(
			"tiffFileEnviroment", 		/* widget name   */
			asciiTextWidgetClass, 		/* widget class */
			tiffEnviromentArea, 		/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype, XawAsciiString,	
			XtNlength, sizeof(tiffEnviromentFilename) - 1,
			XtNstring, tiffEnviromentFilename, 
			NULL 						/* argument list */
			);
	
	envTiffSelect = XtVaCreateManagedWidget(
			"envTiffSelect", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			tiffEnviromentArea, 		/* parent widget */
			XtNbitmap, diskMark,
			NULL 						/* argument list*/
			);

	wordsArea = XtVaCreateManagedWidget(
			"wordsArea", 				/* widget name   */
			formWidgetClass, 			/* widget class */
			EnviromentArea, 			/* parent widget*/
			NULL 						/* argument list*/
			);

	wordsLabel = XtVaCreateManagedWidget(
			"wordsLabel", 			/* widget name   */
			labelWidgetClass,	 		/* widget class */
			wordsArea, 					/* parent widget */
			NULL 						/* argument list */
			);
	
	wordsEnviromentArea = XtVaCreateManagedWidget(
			"wordsEnviromentArea", 				/* widget name   */
			panedWidgetClass, 			/* widget class */
			wordsArea, 				/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 						/* argument list*/
			);
	envWords = XtVaCreateManagedWidget(
			"envWords", 				/* widget name */
			labelWidgetClass,	 		/* widget class */
			wordsEnviromentArea, 		/* parent widget */
			NULL 						/* argument list */
			);

	sprintf(wrdEnviromentFilename, "%.*s", 
			(int)sizeof(wrdEnviromentFilename) - 1, app_data.wordsDirpath);
			
	wrdFileEnviroment = XtVaCreateManagedWidget(
			"wrdFileEnviroment", 		/* widget name   */
			asciiTextWidgetClass, 		/* widget class */
			wordsEnviromentArea, 		/* parent widget */
			XtNeditType, XawtextEdit,
			XtNtype, XawAsciiString,	
			XtNlength, sizeof(wrdEnviromentFilename) - 1,
			XtNstring, wrdEnviromentFilename, 
			NULL 						/* argument list */
			);
	
	envWordsSelect = XtVaCreateManagedWidget(
			"envWordsSelect", 			/* widget name */
			commandWidgetClass, 		/* widget class */
			wordsEnviromentArea, 		/* parent widget */
			XtNbitmap, diskMark,
			NULL 						/* argument list */
			);

	VaCreatePointorsLink(&infomationBuffer, cdlFileEnviroment, 
							tiffFileEnviroment, wrdFileEnviroment, NULL);
	VaCreatePointorsLink(&infomationBuffer2, filenameEnviroment, 
				cdlFileEnviroment, tiffFileEnviroment, wrdFileEnviroment, NULL);
	XtAddCallback(popupButton, XtNcallback, firstPopup, filenameEnviroment);
	XtAddCallback(popupButton, XtNcallback, XtCallbackNone, enviromentShell);
	popdownInfo.popupWidget = popupButton;
	popdownInfo.popdownShell = enviromentShell ;
	popdownInfo.client_data = NULL;
	XtAddCallback(popdownEnv, XtNcallback, EnviromentSetData, infomationBuffer);
	XtAddCallback(envSet, XtNcallback, EnviromentSetData, infomationBuffer);
	XtAddCallback(popdownEnv, XtNcallback, PopdownTargetShell, &popdownInfo);

	XtAddCallback(loadEnviroment, XtNcallback, enviromentLoad, filenameEnviroment);
	XtAddCallback(saveEnviroment, XtNcallback, enviromentSave, infomationBuffer2);
	XtSetSensitive(saveEnviroment, ((app_data.read_only)?(False):(True)));
	/*
	XtAddCallback(envTiff, XtNcallback, TiffViewer, NULL);
	XtAddCallback(EnviromentSelect, XtNcallback, cdlEnvSelector, NULL);
	*/
	XtAddCallback(envCdlSelect, XtNcallback, cdlEnvSelector, NULL);
	XtAddCallback(envTiffSelect , XtNcallback, tiffEnvSelector, NULL);
	XtAddCallback(envWordsSelect , XtNcallback, wrdEnvSelector, NULL);
}

