/***************************************************************************
 *	memory_play.c - ꡼ǽ
 *
 *				1994/7/24 --
 *
 *					Programmed by Nobuyuki Maruichi
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

/***********************************************
 *	ԣϣףΣѤΥ󥯥롼ɡե
 ***********************************************/
#ifdef	TOWNS
# include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

/*****************************************
 * Atena Widget Υ󥯥롼ɡե
 *****************************************/
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#ifdef	X11R5
# include <X11/Xaw/Xawi18n.h>
# include <X11/Xaw/XawIm.h>
#endif	/*X11R5*/

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "cdda_ioc.h"
#include "cdda_ext.h"
#include "cd_word.h"
#include "mwxcd.h"
#include "file_sel.h"

/***************************************************************************
 *	Хѿ
 *
 ***************************************************************************/
extern AppData app_data;
extern struct cdda_play Cdda_info;
extern struct cd_toc CddaToc;
extern Cd_Order *CdOrder_ptr;
extern CddaDataForm *CurrentDisc_ptr;
extern int CurrentDiscFlag;
extern int OrderMode;
extern Pixmap vup_pixmap, vdown_pixmap;
extern Pixmap trackDecPixmap, trackIncPixmap;
Widget pMemoryShell;
Widget memoryList;
Widget wordsMemory; 
extern DiscWord *CurrentWords_ptr;

typedef struct timingInfo {
	Widget timeLabel;
	struct cd_subq *time_ptr;
} TimingInfo;

static TimingInfo startTimeInfo, endTimeInfo;

static struct cd_subq start_time = {0, 0, 0, 0, {0, 0, 0}, 0, {0, 0, 0}};
static struct cd_subq end_time   = {0, 0, 0, 0, {0, 0, 0}, 0, {0, 0, 0}};

static Cd_Order *memoryOrderLink = NULL;
String *memoryLists = NULL;

long MinuteFrames = 60 * 75;
long SecondFrames = 75;
long deltaFrames = 1;
int mtimeChangeCounter;

void SetTimeLabel(Widget w, struct cd_time *time_ptr);
Cd_Order *MemoryListShowCurrent(int def_index);

/***************************************************************************
 *	PopupMemoryShell: ץࡦꥹȤΥݥåץå׺ɸȤ
 *	
 *		void PopupMemoryShell(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;		topLevel ˥㥹Ȥ
 *		XtPointer call_data;
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopupMemoryShell(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget topLevel = (Widget) client_data;
	Position x, y;
	Dimension width, height;

	/**************************************
	 *	topLevel widget 礭롣
	 **************************************/
	XtVaGetValues(topLevel, 
			XtNwidth, &width,
			XtNheight, &height,
			NULL);
	
	/***************************************************************
	 *	topLevel widget Υ롼ȡɥΰ֤
	 ***************************************************************/
	XtTranslateCoords(topLevel, 	/* Widget */
			(Position) width/2, 	/* x */
			(Position) height/2,	/* y */
			&x, &y); 				/* coords on root window */

	/******************************************************
	 *	ץࡦꥹȡݥåץåפΰ֤ꤹ롣
	 *	ʤޤԲĻξ֡
	 ******************************************************/
	XtVaSetValues(pMemoryShell, 
			XtNx, x,
			XtNy, y,
			NULL);
}

/***************************************************************************
 *	PopdownTargetShell: ꤵ줿ɥݥåץ󤹤
 *	
 *		void PopdownTargetShell(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ץࡦꥹȤΥɥݥåץ󤷤ޤ
 ***************************************************************************/
/*ARGSUSED*/
void PopdownTargetShell(Widget w, XtPointer client_data, XtPointer call_data)
{
	PopdownInfo *popdownInfo = (PopdownInfo*) client_data;

	XtPopdown(popdownInfo->popdownShell);

	XtSetSensitive(popdownInfo->popupWidget, TRUE);
}

/***************************************************************************
 *	SetTimeLabel: ջ֤ɽ
 *	
 *		void SetTimeLabel(Widget w, struct cd_time *time_ptr);
 *	
 *		Widget w;
 *		struct cd_time *time_ptr;
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void SetTimeLabel(Widget w, struct cd_time *time_ptr)
{
	char time_string[20];

	sprintf(time_string, "%2d'%02d.%02d", 
			time_ptr->minute, time_ptr->second, time_ptr->frame);
	XtVaSetValues(w, XtNlabel, time_string, NULL);
}

/***************************************************************************
 *	SetMemoryTime: Ѥλ֤ɽ
 *	
 *		void SetMemoryTime(TimingInfo *timeInfo, long frames);
 *	
 *		TimingInfo *timeInfo;
 *		long frames;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void SetMemoryTime(TimingInfo *timeInfo, long frames)
{
	if(mtimeChangeCounter >= 0) {
		++mtimeChangeCounter;
		if(mtimeChangeCounter == 20) {
			deltaFrames *= 15;
		}
		if(mtimeChangeCounter == 200) {
			mtimeChangeCounter = -1;
			deltaFrames *= 5;
		}
	}
	frame2time(frames, &timeInfo->time_ptr->time);
	SetTimeLabel(timeInfo->timeLabel, &timeInfo->time_ptr->time);
}

/***************************************************************************
 *	IncrementTime: ֤򥤥󥯥Ȥ
 *	
 *		void IncrementTime(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void IncrementTime(Widget w, XtPointer client_data, XtPointer call_data)
{
	int frames;
	TimingInfo *timeInfo = (TimingInfo*)client_data;
	
	frames = time2frame(&timeInfo->time_ptr->time);
	SetMemoryTime(timeInfo, frames + deltaFrames);
}

/***************************************************************************
 *	DecrmentTime: ֤ǥȤ
 *	
 *		void DecrmentTime(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void DecrmentTime(Widget w, XtPointer client_data, XtPointer call_data)
{
	int frames;
	TimingInfo *timeInfo = (TimingInfo*)client_data;
	
	frames = time2frame(&timeInfo->time_ptr->time);
	if(frames > 0) {
		if(frames > deltaFrames) {
			SetMemoryTime(timeInfo, frames - deltaFrames);
		} else {
			SetMemoryTime(timeInfo, 0);
		}
	}
}

/***************************************************************************
 *	DecrementTrackTop: ʰΡ˥ȥåƬ֤ˤޤ
 *	
 *		void DecrementTrackTop(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void DecrementTrackTop(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status;
	int track;
	TimingInfo *timeInfo = (TimingInfo*)client_data;
	
	status = CmpDiscTime(&timeInfo->time_ptr->time, &CddaToc);
	switch(status) {
	case -1:
		memcpy(&timeInfo->time_ptr->time, 
					&CddaToc.track[0], 
					sizeof(timeInfo->time_ptr->time));
		break;
	case 0:
		track = get_track_no(&timeInfo->time_ptr->time, &CddaToc);
		if(track >= CddaToc.s_track) {
			if(SubCdTime(&timeInfo->time_ptr->time, 
						&CddaToc.track[track - CddaToc.s_track]) == 0) {
				if(track > CddaToc.s_track) {
					memcpy(&timeInfo->time_ptr->time, 
							TrackStartTime(track - 1, &CddaToc), 
							sizeof(timeInfo->time_ptr->time));
				}
			} else {
				memcpy(&timeInfo->time_ptr->time, 
							TrackStartTime(track, &CddaToc),
							sizeof(timeInfo->time_ptr->time));
			}
		} else {
			timeInfo->time_ptr->time = CddaToc.track[0];
		}
		break;
	case 1:
		memcpy(&timeInfo->time_ptr->time, 
				TrackStartTime(NumberOfTrack(&CddaToc) - 1, &CddaToc), 
				sizeof(timeInfo->time_ptr->time));
		break;
	}
	timeInfo->time_ptr->time.minute &= 0x7f;
	SetTimeLabel(timeInfo->timeLabel, &timeInfo->time_ptr->time);
}

/***************************************************************************
 *	IncrementTrackTop: ĸΥȥåƬ֤ˤޤ
 *	
 *		void IncrementTrackTop(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void IncrementTrackTop(Widget w, XtPointer client_data, XtPointer call_data)
{
	int track;
	int status;
	TimingInfo *timeInfo = (TimingInfo*)client_data;
	
	status = CmpDiscTime(&timeInfo->time_ptr->time, &CddaToc);
	switch(status) {
	case -1:
		memcpy(&timeInfo->time_ptr->time, 
					&CddaToc.track[0], 
					sizeof(timeInfo->time_ptr->time));
		break;
	case 0:
		track = get_track_no(&timeInfo->time_ptr->time, &CddaToc);
		if(track >= CddaToc.s_track && track < CddaToc.e_track) {
			memcpy(&timeInfo->time_ptr->time, 
						TrackStartTime(track + 1, &CddaToc), 
							sizeof(timeInfo->time_ptr->time));
		}
		break;
	case 1:
		memcpy(&timeInfo->time_ptr->time, 
				TrackStartTime(CddaToc.e_track, &CddaToc), 
				sizeof(timeInfo->time_ptr->time));
		break;
	}
	timeInfo->time_ptr->time.minute &= 0x7f;
	SetTimeLabel(timeInfo->timeLabel, &timeInfo->time_ptr->time);
}

/***************************************************************************
 *	DecrementTrackEnd: ʰΡ˥ȥåλ֤ˤޤ
 *	
 *		void DecrementTrackEnd(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void DecrementTrackEnd(Widget w, XtPointer client_data, XtPointer call_data)
{
	int track;
	int status;
	TimingInfo *timeInfo = (TimingInfo*)client_data;
	
	status = CmpDiscTime(&timeInfo->time_ptr->time, &CddaToc);
	switch(status) {
	case -1:
		getTrackEndTime(&timeInfo->time_ptr->time, CddaToc.s_track, &CddaToc);
		break;
	case 0:
		track = get_track_no(&timeInfo->time_ptr->time, &CddaToc);
		if(track > CddaToc.s_track) {
			getTrackEndTime(&timeInfo->time_ptr->time, track - 1, &CddaToc);
		}
		break;
	case 1:
		getTrackEndTime(&timeInfo->time_ptr->time, CddaToc.e_track, &CddaToc);
		break;
	}
	timeInfo->time_ptr->time.minute &= 0x7f;
	SetTimeLabel(timeInfo->timeLabel, &timeInfo->time_ptr->time);
}

/***************************************************************************
 *	IncrementTrackEnd: ĸΥȥåλ֤ˤޤ
 *	
 *		void IncrementTrackEnd(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void IncrementTrackEnd(Widget w, XtPointer client_data, XtPointer call_data)
{
	int track;
	int status;
	TimingInfo *timeInfo = (TimingInfo*)client_data;
	
	status = CmpDiscTime(&timeInfo->time_ptr->time, &CddaToc);
	switch(status) {
	case -1:
		getTrackEndTime(&timeInfo->time_ptr->time, CddaToc.s_track, &CddaToc);
		break;
	case 0:
		track = get_track_no(&timeInfo->time_ptr->time, &CddaToc);
		if(track >= CddaToc.s_track && track <= CddaToc.e_track) {
			if(SubCdTime(TrackEndTime(track, &CddaToc), 
							&timeInfo->time_ptr->time) > 1) {
				getTrackEndTime(&timeInfo->time_ptr->time, track, &CddaToc);
			} else {
				getTrackEndTime(&timeInfo->time_ptr->time, 
							track + (track < CddaToc.e_track), &CddaToc);
			}
		} else {
			frame2time(time2frame(&CddaToc.total) - 1, 
											&timeInfo->time_ptr->time);
		}
		break;
	case 1:
		getTrackEndTime(&timeInfo->time_ptr->time, CddaToc.e_track, &CddaToc);
		break;
	}
	timeInfo->time_ptr->time.minute &= 0x7f;
	SetTimeLabel(timeInfo->timeLabel, &timeInfo->time_ptr->time);
}

/***************************************************************************
 *	NowTiming: ߤΣãıջ֤
 *	
 *		void NowTiming(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	ɽLabelɥå
 *		XtPointer call_data;	̤
 *	
 *		ץࡦꥹȤΥɥݥåץ󤷤ޤ
 ***************************************************************************/
/*ARGSUSED*/
void NowTiming(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean wordTimeMode;
	TimingInfo *timeInfo = (TimingInfo*)client_data;
	XawListReturnStruct *list_ptr;
	TrackWord *currentWords = NULL, *currentWordsTop;
	extern int CurrentWordsTrack;
	extern Widget wordsList;

	XtVaGetValues(wordsMemory, XtNstate, &wordTimeMode, NULL);
	if(wordTimeMode != False) {
		if(CurrentWords_ptr != NULL && CurrentWordsTrack > 0) {
			currentWordsTop = 
				*(CurrentWords_ptr->trackWords+CurrentWordsTrack-1);
			list_ptr = XawListShowCurrent(wordsList);
			if(list_ptr->list_index == XAW_LIST_NONE) {
				if(cd_status2(timeInfo->time_ptr) == 0) {
					currentWords = wordCountSearch(currentWordsTop,
									wordsTimeSearch(currentWordsTop, 
												&timeInfo->time_ptr->time));
				}
			} else {
				currentWords = 
					wordCountSearch(currentWordsTop, list_ptr->list_index);
			}
			if(currentWords != NULL) {
				timeInfo->time_ptr->time = currentWords->wordTime;
				SetTimeLabel(timeInfo->timeLabel, &timeInfo->time_ptr->time);
			}
		}
		if(currentWords == NULL) {
			XtVaSetValues(wordsMemory, XtNstate, False, NULL);
		}
	} else {
		if(cd_status2(timeInfo->time_ptr) == 0) {
			SetTimeLabel(timeInfo->timeLabel, &timeInfo->time_ptr->time);
		}
	}
}

/***************************************************************************
 *	makeMemoryList: ꡦꥹʸ󥯥ȥꥹȤ
 *	
 *		String *makeMemoryList(void);
 *	֤
 *		ꡦꥹʸΥݥ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
String *makeMemoryList(void)
{
	int counter;
	int counter2;
	int numOfMemory;
	char memoryNameBuffer[80];
	String *memory_list = NULL;
	static const char *emptyMessage = "Empty";
	Cd_Order *memory_order;
	struct cd_time memoryTime;

	numOfMemory =  NumberOfLink(memoryOrderLink, Cd_Order_Next);
	if(numOfMemory > 0) {
		memory_list = (String*)malloc(sizeof(String) * (numOfMemory + 1));
		if(memory_list != NULL) {
			for(counter = 0, memory_order = memoryOrderLink;
				counter < numOfMemory && memory_order != NULL;
				++counter, memory_order = memory_order->next_order_ptr) {
				frame2time(SubCdTime(&memory_order->play_info.end, 
							&memory_order->play_info.start), &memoryTime);
				sprintf(memoryNameBuffer, "Memory %d: %2d:%02d.%02d"
						"(%2d:%02d.%02d -- %2d:%02d.%02d)", 
						counter, memoryTime.minute, 
						memoryTime.second, memoryTime.frame, 
						memory_order->play_info.start.minute, 
						memory_order->play_info.start.second, 
						memory_order->play_info.start.frame, 
						memory_order->play_info.end.minute, 
						memory_order->play_info.end.second, 
						memory_order->play_info.end.frame);
				*(memory_list + counter) = 
							(String)malloc(strlen(memoryNameBuffer) + 1);
				if(*(memory_list + counter) != NULL) {
					strcpy(*(memory_list + counter), memoryNameBuffer);
				} else {
					for(counter2 = 0;counter2 < counter;++counter2) {
						free(*(memory_list + counter2));
					}
					free(memory_list);
					memory_list = NULL;
					break;
				}
			}
			if(memory_list != NULL) {
				*(memory_list + numOfMemory) = NULL;
			}
		}
	} else {
		memory_list = (String*)malloc(sizeof(String) * 2);
		if(memory_list != NULL) {
			*memory_list = (String)malloc(strlen(emptyMessage));
			strcpy(*memory_list, emptyMessage);
			*(memory_list + 1) = NULL;
		} else {
			free(memory_list);
			memory_list = NULL;
		}
	}
	return(memory_list);
}

/***************************************************************************
 *	numOfMemoryList: ꥹȤιܿ
 *	
 *		int numOfMemoryList(const String *memory_list);
 *	
 *		const String *memory_list;	
 *	֤
 *		ꥹȤιܿ
 *	
 *		
 ***************************************************************************/
int numOfMemoryList(const String *memory_list)
{
	int counter = 0;

	if(memory_list != NULL) {
		while(*memory_list != NULL) {
			++counter;
			++memory_list;
		}
	}
	return(counter);
}

/***************************************************************************
 *	freeMemoryList: ꥹȤιܡʸˤΥ
 *	
 *		void freeMemoryList(String *memory_list);
 *	
 *		String *memory_list;
 *	
 *		
 ***************************************************************************/
void freeMemoryList(String *memory_list)
{
	String *memoryListItem = memory_list;

	if(memory_list != NULL) {
		while(*memoryListItem != NULL) {
			free(*memoryListItem);
			++memoryListItem;
		}
		free(memory_list);
	}
}

/***************************************************************************
 *	memoryClear: ꥹȤ򥯥ꥢ
 *	
 *		void memoryClear(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	̤
 *		XtPointer call_data;	̤
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void memoryClear(Widget w, XtPointer client_data, XtPointer call_data)
{
	Cd_Order *releaseCdOrder, *nextCdOrder;
	
	for(releaseCdOrder = memoryOrderLink;
					releaseCdOrder != NULL;releaseCdOrder = nextCdOrder) {
		nextCdOrder = releaseCdOrder->next_order_ptr;
		release_order(releaseCdOrder);
	}
	freeMemoryList(memoryLists);
	memoryOrderLink = NULL;
	memoryLists = makeMemoryList();
	resize_check(XtParent(memoryList), 
				numOfMemoryList(memoryLists), app_data.memoryListResize);
	XawListChange(memoryList, memoryLists, 
								numOfMemoryList(memoryLists), 0, True);
}

/***************************************************************************
 *	memoryEdit: ꥹȤγϡλ֤ǽˤ
 *	
 *		void memoryEdit(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	̤
 *		XtPointer call_data;	̤
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
void memoryEdit(Widget w, XtPointer client_data, XtPointer call_data)
{
	Cd_Order *memory_order;

	memory_order = MemoryListShowCurrent(EOF);
	if(memory_order != NULL) {
		start_time.time = memory_order->play_info.start;
		end_time.time = memory_order->play_info.end;
		SetTimeLabel(startTimeInfo.timeLabel, &startTimeInfo.time_ptr->time);
		SetTimeLabel(endTimeInfo.timeLabel, &endTimeInfo.time_ptr->time);
		XawListUnhighlight(memoryList);
	}
}

/***************************************************************************
 *	memoryNew: ꥹȤϿ
 *	
 *		void memoryNew(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	̤
 *		XtPointer call_data;	̤
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
void memoryNew(Widget w, XtPointer client_data, XtPointer call_data)
{
	Cd_Order *cd_order_ptr;
	Cd_Order *memory_order, *next_order;
	
	cd_order_ptr = (Cd_Order *)LinkLast(memoryOrderLink, Cd_Order_Next);
	memory_order = Cd_Order_alloc();
	if(memory_order != NULL) {
		memory_order->start_track = memory_order->end_track = EOF;
		memory_order->play_info.start = start_time.time;
		memory_order->play_info.end = end_time.time;
		memory_order->play_info.count = 1;
		if(SubCdTime(&start_time.time, &end_time.time) < 0) {
			next_order = ((cd_order_ptr == NULL)?
						(cd_order_ptr):(cd_order_ptr->next_order_ptr));
			insert_order(memory_order, cd_order_ptr, next_order);
			if(memoryOrderLink == NULL) {
				memoryOrderLink = memory_order;
			}
			freeMemoryList(memoryLists);
			memoryLists = makeMemoryList();
			resize_check(XtParent(memoryList), 
					numOfMemoryList(memoryLists), app_data.memoryListResize);
			XawListChange(memoryList, memoryLists, 
										numOfMemoryList(memoryLists), 0, True);
		} else {
			free(memory_order);
			memory_order = NULL;
		}
	}
}

/***************************************************************************
 *	isTimePlayable: ǽƥȤ
 *	
 *		int isTimePlayable(struct cd_time *start_time_ptr, 
 *								struct cd_time *end_time_ptr);
 *	
 *		struct cd_time *start_time_ptr;		ϻ
 *		struct cd_time *end_time_ptr;		λ
 *	֤
 *		ʣ:			Բ
 *		ʣʳ:		ǽ
 *	
 *		
 ***************************************************************************/
int isTimePlayable(struct cd_time *start_time_ptr, 
						struct cd_time *end_time_ptr)
{
	int status = 0;
	int start_track, end_track;
	
	start_track = get_track_no(start_time_ptr, &CddaToc);
	end_track   = get_track_no(end_time_ptr, &CddaToc);
	if(start_track != EOF && end_track != EOF) {
		status = isPlayable(start_track, end_track, &CddaToc);
	}
	return(status);
}

/***************************************************************************
 *	memoryAdd: ץ˥ܤϿ
 *	
 *		void memoryAdd(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	̤
 *		XtPointer call_data;	̤
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
void memoryAdd(Widget w, XtPointer client_data, XtPointer call_data)
{
	Cd_Order *cd_order_ptr, *memoryListCurrent;
	Cd_Order *memory_order, *next_order;
	struct cd_time *start_ptr, *end_ptr;
	extern Cd_Order *ProgramConnect;
	
	cd_order_ptr = ProgramConnect;
	memoryListCurrent = MemoryListShowCurrent(0);
	if(memoryListCurrent != NULL) {
		start_ptr = &memoryListCurrent->play_info.start;
		end_ptr   = &memoryListCurrent->play_info.end;
	} else {
		start_ptr = &start_time.time;
		end_ptr   = &end_time.time;
	}
	if(OrderMode == ProgramOrder && isTimePlayable(start_ptr, end_ptr)
							&& SubCdTime(start_ptr, end_ptr) < 0) {
		memory_order = Cd_Order_alloc();
		if(memory_order != NULL) {
			memory_order->start_track = memory_order->end_track = EOF;
			memory_order->play_info.start = *start_ptr;
			memory_order->play_info.end   = *end_ptr;
			memory_order->play_info.count = 1;
			next_order = ((cd_order_ptr == NULL)?
						(cd_order_ptr):(cd_order_ptr->next_order_ptr));
			insert_order(memory_order, cd_order_ptr, next_order);
			NewOrderProgram(memory_order);
		}
	}
}

/***************************************************************************
 *	MemoryListIndex: Ƭꤵ줿֤Υ
 *	
 *		Cd_Order *MemoryListIndex(int index);
 *	
 *		int index;		ΰ֡EOF ʤ顢ꥹȤ
 *	֤
 *		ؤݥ
 *	
 *		
 ***************************************************************************/
Cd_Order *MemoryListIndex(int index)
{
	int counter = 0;
	Cd_Order *cdplayOrder = NULL;

	for(cdplayOrder = memoryOrderLink, counter = 0;cdplayOrder != NULL && 
		((index == EOF)?
			(cdplayOrder->next_order_ptr != NULL):(counter < index));
				++counter, cdplayOrder = cdplayOrder->next_order_ptr)
		;		/*  */
	
	return(cdplayOrder);
}

/***************************************************************************
 *	MemoryListShowCurrent: ꥹȤܤΥ
 *	
 *		Cd_Order *MemoryListShowCurrent(int def_index);
 *	
 *		int def_index;		ꥹȤǤʤȤεư
 *	֤
 *		ܤΥޤϡǥեȤΥ
 *	
 *		δؿǤϡꥹȤܤΥ֤ޤ
 *		ꥹιܤ򤵤ƤʤȤϡdef_index
 *		ˤäơʲεưʬޤ
 *		def_index
 *			EOF:		ꥹȤ
 *			0:			NULL ݥ󥿤֤
 *			ʳ:	ꥹȤ def_index ܡdef_index 
 *						ΤȤꥹȤƬ
 *		
 ***************************************************************************/
Cd_Order *MemoryListShowCurrent(int def_index)
{
	Cd_Order *cdplayOrder = NULL;
	XawListReturnStruct *memory_point;

	memory_point = XawListShowCurrent(memoryList);
#ifdef	XAW_LIST_LOCALE_NONE
	if(memory_point->list_index != XAW_LIST_LOCALE_NONE)
#else
	if(memory_point->list_index != XAW_LIST_NONE)
#endif	/*XAW_LIST_LOCALE_NONE*/
		cdplayOrder = MemoryListIndex(memory_point->list_index);
	else
		switch(def_index) {
		case EOF:
			cdplayOrder = MemoryListIndex(def_index);
			break;
		case 0:
			break;
		default:
			cdplayOrder = MemoryListIndex(def_index - 1);
			break;
		}
	return(cdplayOrder);
}

/***************************************************************************
 *	memoryDelete: ܤޤϡꥹ˥ꥹȤ
 *	
 *		void memoryDelete(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	̤
 *		XtPointer call_data;	̤
 *	
 *		ꥹȤܤ򤵤Ƥϡιܤ
 *		ʳξϡꥹȤ
 ***************************************************************************/
/*ARGSUSED*/
void memoryDelete(Widget w, XtPointer client_data, XtPointer call_data)
{
	Cd_Order *releaseCdOrder;
	
	releaseCdOrder = MemoryListShowCurrent(EOF);
	if(releaseCdOrder != NULL) {
		if(releaseCdOrder->prev_order_ptr == NULL) {
			/* 륪ƬΤȤ */
			memoryOrderLink = releaseCdOrder->next_order_ptr;
		}
		release_order(releaseCdOrder);
		freeMemoryList(memoryLists);
		memoryLists = makeMemoryList();
		resize_check(XtParent(memoryList), 
					numOfMemoryList(memoryLists), app_data.memoryListResize);
		XawListChange(memoryList, memoryLists, 
									numOfMemoryList(memoryLists), 0, True);
	}
}

/***************************************************************************
 *	initTimeChange: ե졼ñ󥿤ν
 *	
 *		void initTimeChange(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	̤
 *		XtPointer call_data;	̤
 ***************************************************************************/
void initTimeChange(Widget w, XtPointer client_data, XtPointer call_data)
{
	mtimeChangeCounter = 0;
	deltaFrames = 1;
}

/***************************************************************************
 *	memory_block_init: ե졼ñʬΥå
 *	
 *		void memory_block_init(Widget parent, 
 *							const char *org_name, TimingInfo *timeInfo);
 *	
 *		Widget parent;			ƥå
 *		const char *org_name;	ƥå̾θȤʤ̾
 *		TimingInfo *timeInfo;	ե졼ñΤξ
 ***************************************************************************/
void memory_block_init(Widget parent, 
			const char *org_name, TimingInfo *timeInfo)
{
	Widget decrmentTime;
	Widget incrementTime;
	char widgetName[30];

	sprintf(widgetName, "%s""DecrmentTime", org_name);
	decrmentTime = XtVaCreateManagedWidget(
			widgetName, 					/* widget name   */
			repeaterWidgetClass, 			/* widget class */
			parent, 						/* parent widget */
			XtNbitmap, vdown_pixmap, 		/* Set Bitmap */
			NULL 							/* argument list */
			);
	
	sprintf(widgetName, "%s""IncrementTime", org_name);
	incrementTime = XtVaCreateManagedWidget(
			widgetName, 					/* widget name   */
			repeaterWidgetClass, 			/* widget class */
			parent, 						/* parent widget */
			XtNbitmap, vup_pixmap, 			/* Set Bitmap */
			NULL 							/* argument list*/
			);
	XtAddCallback(incrementTime, XtNcallback, IncrementTime, timeInfo);
	XtAddCallback(decrmentTime, XtNcallback, DecrmentTime, timeInfo);
	XtAddCallback(incrementTime, XtNstartCallback, initTimeChange, 0);
	XtAddCallback(decrmentTime, XtNstartCallback, initTimeChange, 0);
}

/***************************************************************************
 *	memory_init: ޥɡ˥塼ץࡦꥹȤνԤ
 *	
 *		void memory_init(XtAppContext app_context, Widget parent);
 *	
 *		XtAppContext app_context;
 *		Widget parent;
 *	
 *		
 ***************************************************************************/
void memory_init(XtAppContext app_context, Widget popupButton, Widget parent)
{
	Widget memoryPlayBlock, memoryControlBlock;
	Widget popdownMemoryArea, clearMemory, newMemory;
	Widget editMemory, deleteMemory, enterMemory;
	Widget startBlock, startTiming, startTime;
	Widget endBlock, endTiming, endTime;
	Widget trackDecTop, trackIncTop, trackDecEnd, trackIncEnd;
	Widget memoryView;
	static PopdownInfo popdownInfo;

	pMemoryShell = XtCreatePopupShell(
			"pMemoryShell",
			topLevelShellWidgetClass,
			parent,
			NULL,
			0
			);

	memoryPlayBlock = XtVaCreateManagedWidget(
			"memoryPlayBlock", 				/* widget name   */
			panedWidgetClass, 				/* widget class */
			pMemoryShell, 					/* parent widget*/
			NULL 							/* argument list*/
			);

	memoryControlBlock = XtVaCreateManagedWidget(
			"memoryControlBlock", 			/* widget name   */
			panedWidgetClass,	 			/* widget class */
			memoryPlayBlock, 				/* parent widget */
			XtNorientation, XtorientHorizontal,
			NULL 							/* argument list */
			);
	
	popdownMemoryArea = XtVaCreateManagedWidget(
			"popdownMemoryArea", 			/* widget name   */
			commandWidgetClass, 		/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	clearMemory = XtVaCreateManagedWidget(
			"clearMemory", 					/* widget name   */
			commandWidgetClass,		/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	newMemory = XtVaCreateManagedWidget(
			"newMemory", 					/* widget name   */
			commandWidgetClass, 		/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	editMemory = XtVaCreateManagedWidget(
			"editMemory", 					/* widget name   */
			commandWidgetClass, 		/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	wordsMemory = XtVaCreateManagedWidget(
			"wordsMemory", 					/* widget name   */
			toggleWidgetClass, 			/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	deleteMemory = XtVaCreateManagedWidget(
			"deleteMemory", 				/* widget name   */
			commandWidgetClass,		/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	enterMemory = XtVaCreateManagedWidget(
			"enterMemory", 					/* widget name   */
			commandWidgetClass, 		/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	startBlock = XtVaCreateManagedWidget(
			"startBlock", 					/* widget name   */
			panedWidgetClass, 				/* widget class */
			memoryPlayBlock, 				/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 							/* argument list*/
			);

	startTiming = XtVaCreateManagedWidget(
			"startTiming", 					/* widget name   */
			commandWidgetClass, 		/* widget class */
			startBlock, 					/* parent widget */
			NULL 							/* argument list */
			);
	
	startTime = XtVaCreateManagedWidget(
			"startTime", 					/* widget name   */
			labelWidgetClass, 		/* widget class */
			startBlock, 					/* parent widget */
			NULL 							/* argument list */
			);
	
	endBlock = XtVaCreateManagedWidget(
			"endBlock", 					/* widget name   */
			panedWidgetClass, 				/* widget class */
			memoryPlayBlock, 				/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 							/* argument list*/
			);

	endTiming = XtVaCreateManagedWidget(
			"endTiming", 					/* widget name   */
			commandWidgetClass, 		/* widget class */
			endBlock, 						/* parent widget */
			NULL 							/* argument list*/
			);

	endTime = XtVaCreateManagedWidget(
			"endTime", 						/* widget name */
			labelWidgetClass, 		/* widget class */
			endBlock, 						/* parent widget */
			NULL 							/* argument list */
			);

	memoryView = XtVaCreateManagedWidget(
			"memoryView", 					/* widget name   */
			viewportWidgetClass, 			/* widget class */
			memoryPlayBlock, 				/* parent widget */
			NULL 							/* argument list */
			);
	
	memoryList = XtVaCreateManagedWidget(
			"memoryList", 					/* widget name   */
			listWidgetClass, 			/* widget class */
			memoryView, 					/* parent widget */
			NULL 							/* argument list */
			);

	XtAddCallback(popupButton, XtNcallback, PopupMemoryShell, parent);
	XtAddCallback(popupButton, XtNcallback, XtCallbackNone, pMemoryShell);
	popdownInfo.popupWidget = popupButton;
	popdownInfo.popdownShell = pMemoryShell;
	popdownInfo.client_data = NULL;
	XtAddCallback(popdownMemoryArea, 
					XtNcallback, PopdownTargetShell, &popdownInfo);
	startTimeInfo.timeLabel = startTime;
	startTimeInfo.time_ptr = &start_time;
	memory_block_init(startBlock, "start", &startTimeInfo);
	SetTimeLabel(startTimeInfo.timeLabel, &startTimeInfo.time_ptr->time);
	XtAddCallback(startTiming, XtNcallback, NowTiming, &startTimeInfo);

	trackDecTop = XtVaCreateManagedWidget(
			"trackDecTop", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			startBlock, 					/* parent widget */
			XtNbitmap, trackDecPixmap, 		/* Set Bitmap */
			NULL 							/* argument list */
			);
	trackIncTop = XtVaCreateManagedWidget(
			"trackIncTop", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			startBlock, 					/* parent widget */
			XtNbitmap, trackIncPixmap, 		/* Set Bitmap */
			NULL 							/* argument list */
			);
	XtAddCallback(trackDecTop, XtNcallback, DecrementTrackTop, &startTimeInfo);
	XtAddCallback(trackIncTop, XtNcallback, IncrementTrackTop, &startTimeInfo);

	endTimeInfo.timeLabel = endTime;
	endTimeInfo.time_ptr = &end_time;
	memory_block_init(endBlock, "end", &endTimeInfo);
	SetTimeLabel(endTimeInfo.timeLabel, &endTimeInfo.time_ptr->time);

	trackDecEnd = XtVaCreateManagedWidget(
			"trackDecEnd", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			endBlock, 						/* parent widget */
			XtNbitmap, trackDecPixmap, 		/* Set Bitmap */
			NULL 							/* argument list*/
			);
	trackIncEnd = XtVaCreateManagedWidget(
			"trackIncEnd", 				/* widget name   */
			commandWidgetClass, 		/* widget class */
			endBlock, 						/* parent widget */
			XtNbitmap, trackIncPixmap, 		/* Set Bitmap */
			NULL 							/* argument list*/
			);
	XtAddCallback(trackDecEnd, XtNcallback, DecrementTrackEnd, &endTimeInfo);
	XtAddCallback(trackIncEnd, XtNcallback, IncrementTrackEnd, &endTimeInfo);

	XtAddCallback(clearMemory, XtNcallback, memoryClear, NULL);
	XtAddCallback(endTiming, XtNcallback, NowTiming, &endTimeInfo);
	XtAddCallback(newMemory, XtNcallback, memoryNew, NULL);
	XtAddCallback(editMemory, XtNcallback, memoryEdit, NULL);
	XtAddCallback(deleteMemory, XtNcallback, memoryDelete, NULL);
	XtAddCallback(enterMemory, XtNcallback, memoryAdd, NULL);

	memoryLists = makeMemoryList();
	resize_check(XtParent(memoryList), 
				numOfMemoryList(memoryLists), app_data.memoryListResize);
	XawListChange(memoryList, memoryLists, 
								numOfMemoryList(memoryLists), 0, True);
}

