/***************************************************************************
 *	mwxcd.c - X11R6 CD player
 *	
 *					Programmed by Nobuyuki Maruichi
 *	Note.
 *			ܸ EUC
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>

/***************************************************
 *	X11/X Toolkit δŪʥ󥯥롼ɡե
 ***************************************************/
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */
#include <X11/Core.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

/*****************************************
 * Atena Widget Υ󥯥롼ɡե
 *****************************************/
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#ifdef	X11R5
# include <X11/Xaw/Xawi18n.h>
# include <X11/Xaw/XawIm.h>
#endif	/*X11R5*/

/*********************************
 * CDDA Υ󥯥롼ɡե
 *********************************/
#include <fcntl.h>
#ifdef	TOWNS
# include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */

/**********************************
 *	CD ѥܥΥӥåȥޥå
 **********************************/
#include <X11/bitmaps/xlogo11>
#include "bitmaps/cd_case.xbm"		/*  */
#include "bitmaps/eject.xbm"	
#include "bitmaps/ejectDisable.xbm"	
#include "bitmaps/rew.xbm"			/* |: Υȥåذư */
#include "bitmaps/ff.xbm"			/* |: ĸΥȥåذư */
#include "bitmaps/play.xbm"			/*  | : ܥ */
#include "bitmaps/stop.xbm"			/*    : ߥܥ */
#include "bitmaps/pause.xbm"		/*  ||  : ߥܥ */
#include "bitmaps/vup.xbm"			/*  | : ܥ塼ࡦåסܥ */
#include "bitmaps/vdown.xbm"		/* |  : ܥ塼ࡦ󡦥ܥ */
#include "bitmaps/vupDisable.xbm"	/*  | : åסܥ */
#include "bitmaps/vdwDisable.xbm"	/* |  : 󡦥ܥ */
#include "bitmaps/trackDec.xbm"		
#include "bitmaps/trackInc.xbm"		
#include "bitmaps/floppy.xbm"	
#include "bitmaps/floppy_m.xbm"	
#include "bitmaps/no_marked.xbm"	
#include "bitmaps/marked.xbm"	
#include "bitmaps/rectsiz.xbm"	
#include "bitmaps/maxLock.xbm"	

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "mwxcd.h"
#include "cdda_ioc.h"
#include "cdda_iox.h"
#include "cdda_ext.h"
#include "cd_data.h"
#include "file_sel.h"
#include "luty.h"
#include "message.h"

#define PROGRAM_MODE
#define SkipIntervalTime	200

static int counter_reduce(Widget w, const char *title);
static void counter_disp2(Widget w, const char *title_ptr,
				const struct cd_subq *subq_ptr, int counter_mode);
static void IntervalCounterControl(XtPointer client_data, XtIntervalId *id);
void popdownErrorShell(Widget w, XtPointer client_data, XtPointer call_data);

#ifdef	GENERAL
static void trayManager(XtPointer client_data, XtIntervalId *id);
void trayManagerOn(void);
void trayManagerOff(void);
#endif	/*GENERAL*/

/* #define DEBUG */

/***************************************************************************
 *	Хѿ
 *		CdTrack:		
 *		PlayingMode:	CD PLAYER ư⡼
 *		Interval:		CD Υ󥿤Υ󥿡ХʽͤΤá
 *		track_string:	
 *		cd_volume:		
 *		track:			ȥåɽѤΥ
 *		counter:		ɽѤΥ
 *		Cdda_info:		
 *		FF_SearchId:	ꥵѤΥ󥿡Х
 *		REW_SearchId:	ᤷѤΥ󥿡Х
 ***************************************************************************/
extern ioType currentIoType;
extern cdDigitalAudio *currentCDDA;
extern cdDigitalAudio *CddaIoTypes[];
int CdTrack = 1;
int PlayingMode = STOP;
long int Interval = 1;
char track_string[12];
struct cdda_play Cdda_info;
Widget topLevel;
Widget track;
Widget counter, OrderControl;
Widget pErrorShell;
Widget versionShell, versionArea, versionMessage, versionPopdown;
Widget errorMessage, errorArea, errorPopdown;
Widget eject, pauseButton, play;
Widget vol;
Widget repeatModeBox, repeatoff, repeatall;
Widget cdTitle;
Pixmap vup_pixmap, vdown_pixmap, vupDisablePixmap, vdwDisablePixmap;
Pixmap trackDecPixmap, trackIncPixmap, eject_pixmap, ejectDisable_pixmap;
Pixmap mark, diskMark, diskDisable, marked, no_marked;
Pixmap rew_pixmap, ff_pixmap, play_pixmap;
Pixmap stop_pixmap, pause_pixmap;
Pixmap cd_case_pixmap;
Pixmap getSize, maxLock;

IntervalData CounterCtrl = {FALSE, 0, NULL};
IntervalData SkipCtrl = {FALSE, 0, NULL};
IntervalData TrayCtrl = {FALSE, 0, NULL};

int CounterFlag = CounterStop;
int CounterMode = TotalTime;
struct cd_toc CddaToc;
struct cd_toc BackCddaToc;
int RepeatModeFlag = RepeatOff;
Tray TrayStatus = TrayUnknown;
Tray FixedTrayStatus = TrayUnknown;

#define SearchCount(searchCounter)	(4 * (searchCounter >= 10) + 1)
int OrderMode = NormalOrder;
int VolumeDevice = 0;
Boolean volmue_enable_flag = False;

Cd_Order *NormalPlayOrder_ptr = NULL;	/* ̾ν */
Cd_Order *ProgramOrder_ptr = NULL;		/* ץν */
Cd_Order *ProgramConnect = NULL;		/* ץɲð */
Cd_Order *ProgramList_ptr = NULL;		/* Υץ */
Cd_Order *CdOrder_ptr = NULL;			/* ߤΥץ */

enum _RepeatMode RepeatModeOff = RepeatOff, RepeatModeOn = RepeatOn;
const char *OrderModeStrings[] = {"Normal Mode", "Program Mode"};
const char *CounterTitle[] = {"Stop", "Total Time", "Track Time"};
String ProgramStrings[100];
int ProgramMaxNum = ProgramMax;
int TrackNumbers[100];
extern int cdlFileEncode;
 
CddaDataForm *DiscData_ptr = NULL;
CddaDataForm *CurrentDisc_ptr = NULL;
int CurrentDiscFlag = FALSE;
int ProgramSongTitle = TRUE;
struct cd_subq CurrentSubq;
struct cd_subq PauseSubq;
static Atom wm_delete_window;
char **TiffSuffixList;
String TiffViewerCall = 
#ifndef	VIWER
				NULL;			/* ӥ奢Ѥˤ */
#else
				VIWER;			/* ӥ奢ꤹ */
#endif	/*VIWER*/
volatile int ViwerPid = 0;

AppData app_data;

/* Resources:

 Name                Class              RepType         Default Value
 ----                -----              -------         -------------
 menuBlockPanes		 MenuBlockPanes		int				20
 menuSongTitle		 MenuSongTitle		Boolean			TRUE
 programSongTitle	 ProgramSongTitle	Boolean			TRUE
 discDataFile		 DiscDataFile		String			""
 cdlReadOnly		 CdlReadOnly		Boolean			FALSE
 spaceDelete		 SpaceDelete		Boolean			TRUE
 dataTrackTitle		 DataTrackTitle		String			
 						"<<  DATA TRACK  >>                        "
 backupSuffix		 DataTrackTitle		String			".bak"
 cdDevice			 CdDevice			String			"/dev/cdrom"
 cdDataListResize	 CdListResize		int				15
 programListResize	 CdListResize		int				15
 memoryListResize	 CdListResize		int				15
 tiffDisplayable	 TiffDisplayable	Boolean			FALSE
 tiffDirpath		 TiffDirpath		String			""
 tiffViewer			 TiffViewer			String			""
 tiffSuffix			 TiffSuffix			String			""
 wordsDisplayable	 WordsDisplayable	Boolean			FALSE
 wordsDirpath		 WordsDirpath		String			""
 wordsCoLimit		 WordsCoLimit		int				80
 unitMessage		 UnitMessage		String			NULL
 messages			 Messages			String			NULL
 mixerDevice		 MixerDevice		String			"/dev/mixer"
 labelWidth			 LabelWidth			int				140
 refresh			 Refresh			int				5
 verticalMargin		 VerticalMargin		Int				28
 cdlAutoHeight	 	 AutoHeight			Boolean			TRUE
 wrdAutoHeight		 AutoHeight			Boolean			TRUE
 towns				 Towns				Boolean			TRUE
 help				 Help				Boolean			FALSE
 jencoding			 Jencoding			String			ENCODING_DIR
*/

/* resource list */
static XtResource resources[] = {
	{
		XtNmenuBlockPanes,
		XtCMenuBlockPanes,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, menu_panes),
		XtRImmediate,
		(XtPointer) 20
	},
	{
		XtNmenuSongTitle,
		XtCMenuSongTitle,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, menu_song_title),
		XtRImmediate,
		(XtPointer) TRUE,
	},
	{
		XtNprogramSongTitle,
		XtCProgramSongTitle,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, program_song_title),
		XtRImmediate,
		(XtPointer) TRUE,
	},
	{
		XtNdiscDataFile,
		XtCDiscDataFile,
		XtRString,
		sizeof(XtPointer),
		XtOffsetOf(AppData, cdl_file),
		XtRImmediate,
		(XtPointer) "",
	},
	{
		XtNcdlReadOnly,
		XtCCdlReadOnly,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, read_only),
		XtRImmediate,
		(XtPointer) FALSE,
	},
	{
		XtNspaceDelete,
		XtCSpaceDelete,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, space_delete),
		XtRImmediate,
		(XtPointer) TRUE,
	},
	{
		XtNdataTrackTitle,
		XtCDataTrackTitle,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, data_track_title),
		XtRImmediate,
		(XtPointer) "<<  DATA TRACK  >>                        ",
	},
	{
		XtNbackupSuffix,
		XtNbackupSuffix,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, backup_suffix),
		XtRImmediate,
		(XtPointer) ".bak",
	},
	{
		XtNcdDevice,
		XtCCdDevice,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, cdDevice),
		XtRImmediate,
		(XtPointer) "/dev/cdrom",
	},
	{
		XtNcdIoctl,
		XtCCdIoctl,
		XtRCdIoctl,
		sizeof(ioType),
		XtOffsetOf(AppData, cdIoctl),
		XtRImmediate,
		(XtPointer) CDDA_IO_TYPE,
	},
	{
		XtNcdDataListResize,
		XtCCdListResize,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, cdDataListResize),
		XtRImmediate,
		(XtPointer) 15,
	},
	{
		XtNprogramListResize,
		XtCCdListResize,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, programListResize),
		XtRImmediate,
		(XtPointer) 15,
	},
	{
		XtNmemoryListResize,
		XtCCdListResize,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, memoryListResize),
		XtRImmediate,
		(XtPointer) 15,
	},
	{
		XtNtiffDisplayable,
		XtCTiffDisplayable,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, tiffDisplayable),
		XtRImmediate,
		(XtPointer) FALSE,
	},
	{
		XtNtiffDirpath,
		XtCTiffDirpath,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, tiffDirpath),
		XtRImmediate,
		(XtPointer) "",
	},
	{
		XtNtiffViewer,
		XtCTiffViewer,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, tiffViewer),
		XtRImmediate,
		(XtPointer) "",
	},
	{
		XtNtiffSuffix,
		XtCTiffSuffix,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, tiffSuffix),
		XtRImmediate,
		(XtPointer) "",
	},
	{
		XtNwordsDisplayable,
		XtCWordsDisplayable,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, wordsDisplayable),
		XtRImmediate,
		(XtPointer) FALSE,
	},
	{
		XtNwordsDirpath,
		XtCWordsDirpath,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, wordsDirpath),
		XtRImmediate,
		(XtPointer) "",
	},
	{
		XtNwordsCoLimit,
		XtCWordsCoLimit,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, wordsCoLimit),
		XtRImmediate,
		(XtPointer) 80,
	},
	{
		XtNunitMessage,
		XtCUnitMessage,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, unitMessage),
		XtRImmediate,
		(XtPointer) NULL
	},
	{
		XtNmessages,
		XtCMessages,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, messages),
		XtRImmediate,
		(XtPointer) NULL
	}, 
	{
		XtNmixerDevice,
		XtCMixerDevice,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, mixerDevice),
		XtRImmediate,
		(XtPointer) "/dev/mixer",
	}, 
	{
		XtNlabelWidth,
		XtCLabelWidth,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, labelWidth),
		XtRImmediate,
		(XtPointer) 140
	},
	{
		XtNrefresh,
		XtCRefresh,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, refresh),
		XtRImmediate,
		(XtPointer) 5
	},
	{
		XtNverticalMargin,
		XtCVerticalMargin,
		XtRInt, 
		sizeof(Dimension),
		XtOffsetOf(AppData, verticalMargin),
		XtRImmediate,
		(XtPointer) 28,
	},
	{
		XtNcdlAutoHeight,
		XtCAutoHeight,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, cdlAutoHeight),
		XtRImmediate,
		(XtPointer) TRUE
	},
	{
		XtNwrdAutoHeight,
		XtCAutoHeight,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, wrdAutoHeight),
		XtRImmediate,
		(XtPointer) TRUE
	},
#ifdef TOWNS
	{
		XtNtowns,
		XtCTowns,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, towns),
		XtRImmediate,
		(XtPointer) TRUE,
	},
#endif /*TOWNS*/
	{
		XtNhelp,
		XtCHelp,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, help),
		XtRImmediate,
		(XtPointer) FALSE,
	},
	{
		XtNjencoding,
		XtCJencoding,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, jencoding),
		XtRImmediate,
		(XtPointer) ENCODING_DIR,
	},
	{
		XtNconfigString,
		XtCConfigString,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, configString),
		XtRImmediate,
		(XtPointer) "! mwxcd self-config file.\n",
	},
};

/* Command-line options table */
static XrmOptionDescRec options[] = {
	{"-dev", 		"*cdDevice", 			XrmoptionSepArg, NULL},
	{"-cdio", 		"*cdIoctl", 			XrmoptionSepArg, NULL},
	{"-mixer", 		"*mixerDevice", 		XrmoptionSepArg, NULL},
	{"-cdl", 		"*discDataFile", 		XrmoptionSepArg, NULL},
	{"-trackmenu", 	"*menuBlockPanes", 		XrmoptionSepArg, NULL},
	{"+menu_title", "*menuSongTitle",		XrmoptionNoArg, "True"},
	{"-menu_title", "*menuSongTitle",		XrmoptionNoArg, "False"},
	{"+prog_title", "*programSongTitle",	XrmoptionNoArg, "True"},
	{"-prog_title", "*programSongTitle",	XrmoptionNoArg, "False"},
	{"-readonly", 	"*cdlReadOnly", 		XrmoptionNoArg, "True"},
	{"-read_write", "*cdlReadOnly", 		XrmoptionNoArg, "False"},
	{"+spdel", 		"*spaceDelete", 		XrmoptionNoArg, "True"},
	{"-spdel", 		"*spaceDelete", 		XrmoptionNoArg, "False"},
#ifdef TOWNS
	{"-towns", 		"*towns", 				XrmoptionNoArg, "True"},
	{"-notowns", 	"*towns", 				XrmoptionNoArg, "False"},
#endif /*TOWNS*/
	{"-h", 			"*help", 				XrmoptionNoArg, "True"},
	{"--help", 		"*help", 				XrmoptionNoArg, "True"},
};

/***************************************************************************
 *	Quit: λܥ
 *	
 *		void Quit(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
void Quit(Widget w, XtPointer client_data, XtPointer call_data)
{
	CdDriveClose();				/* CDDA/dev/cdromˤ򥯥 */
	exit(0);
}

/***************************************************************************
 *	normal_play: Ρޥ롦⡼ɤǻȥåդʿǡ
 *	
 *		int normal_play(struct cdda_play *play_info, 
 *				int track_no, Cd_Order *order_ptr, struct cd_toc *toc);
 *	
 *		struct cdda_play *play_info;	ȥåȺǽȥåջ
 *		int track_no;					ȥå
 *		Cd_Order *order_ptr;			Ρޥ롦⡼ɡƬ
 *		struct cd_toc *toc;				ãľTable of contents
 *	֤
 *		NULL: 		顼ȥå
 *		NULLʳ: 	ȥåޤ४ؤΥݥ
 *	
 *		ꥹȤƬ顢ȥåޤ४õơ
 *		СȥåƬ饪αսλ֤ޤǤդ롣
 *		αսλ֤ϡϢ³륪ǥȥåνλ֤
 *		ȤǤꡢ̾ãĤαսλ֤ΤȤǤ롣
 *		
 ***************************************************************************/
Cd_Order *normal_play(struct cdda_play *play_info, 
					int track_no, Cd_Order *order_ptr, struct cd_toc *toc)
{
	Cd_Order *result_order_ptr;
	
	result_order_ptr = track_order_search(track_no, order_ptr);
	if(result_order_ptr == NULL) {
		result_order_ptr = track_order_search(toc->s_track, order_ptr);
	}
	if(result_order_ptr != NULL) {
		play_info->start = toc->track[track_no - toc->s_track];
		play_info->end   = result_order_ptr->play_info.end;
		play_info->count = 1;
		if(cd_play2(play_info) == 0) {
			PlayingMode = PLAY;
			CounterControl(CounterMode, NULL);
			CdTrack = get_track_no(&play_info->start, toc);
			track_set(CdTrack);
		} else {
			result_order_ptr = NULL;
		}
	}
	return(result_order_ptr);
}

/***************************************************************************
 *	normal_play2: Ρޥ롦⡼ɤǻȥåʤˤդ
 *	
 *		int normal_play2(struct cdda_play *play_info, 
 *				int track_no, Cd_Order *order_ptr, struct cd_toc *toc);
 *	
 *		struct cdda_play *play_info;	ȥåȺǽȥåջ
 *		int track_no;					ȥå
 *		Cd_Order *order_ptr;			Ρޥ롦⡼ɡƬ
 *		struct cd_toc *toc;				ãľTable of contents
 *	֤
 *		NULL: 		顼ȥå
 *		NULLʳ: 	ȥåޤ४ؤΥݥ
 *	
 *		ꥹȤƬ顢ȥåޤ४õơ
 *		СȥåƬ饪αսλ֤ޤǤդ롣
 *		αսλ֤ϡϢ³륪ǥȥåνλ֤
 *		ȤǤꡢ̾ãĤαսλ֤ΤȤǤ롣
 *		
 ***************************************************************************/
Cd_Order *normal_play2(struct cdda_play *play_info, 
					int track_no, Cd_Order *order_ptr, struct cd_toc *toc)
{
	Cd_Order *result_order_ptr;
	
	if(track_no >= toc->s_track && track_no <= toc->e_track) {
		result_order_ptr = normal_play(play_info, track_no, order_ptr, toc);
		if(result_order_ptr == NULL) {
			result_order_ptr = nearest_track_order_search(track_no, order_ptr);
			if(result_order_ptr != NULL) {
				if(result_order_ptr->end_track < track_no) {
					track_no = result_order_ptr->end_track;
				} else {
					track_no = result_order_ptr->start_track;
				}
				result_order_ptr = normal_play(play_info, 
												track_no, order_ptr, toc);
			}
		}
	} else {
		track_no = search_audio_track(0, NULL, toc) + toc->s_track;
		result_order_ptr = normal_play(play_info, track_no, order_ptr, toc);
	}
	return(result_order_ptr);
}

/***************************************************************************
 *	program_play: ץࡦ⡼ɤǱդ
 *	
 *		int program_play(struct cd_toc *toc, 
 *						struct cdda_play *play_info, int track_no);
 *	
 *		struct cd_toc *toc;				ãľTable of contents
 *		struct cdda_play *play_info;	ȥåȺǽȥåջ
 *		int track_no;					ȥå
 *	֤
 *		EOF: 		顼
 *		ʾ: 	ǽΥǥȥåֹƬȥåֹ
 *	
 *		Хѿκѥ򼨤ݥ󥿤Σգ̣̥ݥ󥿰ʳ
 *		ʤ顢ץ򳫻Ϥ롣
 *		ư⡼ɤȣУ̣١ɡɽϡϿ
 *		ϥȥåֹ򻻽Сȥåֹɽ
 *		
 ***************************************************************************/
int program_play(struct cd_toc *toc)
{
	int status = EOF;
	
	if(CdOrder_ptr != NULL) {
		PlayingMode = PLAY;					/* ư⡼ɤȣУ̣١ */
		CounterControl(CounterMode, NULL);	/* ɽ */
		Cdda_info = CdOrder_ptr->play_info;	/* Ͽ */
		CdTrack = get_track_no(&Cdda_info.start, &CddaToc);
		status = cd_play2(&Cdda_info);		/*  */
		if(status == 0) {
			status = CdTrack;
		}
		track_set(CdTrack);
	}
	return(status);
}

/***************************************************************************
 *	MediaChange: ǥѹν롼
 *	
 *		int MediaChange(void);
 *	֤
 *		TOC ΤȤ֤͡ʤ饨顼
 *	
 *		ǥѹνԤʤޤƤϰʲΤȤ
 *		  TOC(Table of Contents) 
 *		  CDL 򸡺
 *		  ȥå˥塼򹹿
 *		   CD ̾Τκ˴
 *		  촹 CD ̾Τκ
 *		  λɤ߹
 *		  촹ä硢ץ򥯥ꥢ롣
 *	
 ***************************************************************************/
/* ARGSUSED */
int MediaChange(void)
{
	int status;
	/* struct cd_subq subq; */
	Boolean eject_flag;		/* eject Toggle Widget ξּ */
	void make_cd_menu(struct cd_toc *toc);

	 /* TOC(Table of Contents)  */
	BackCddaToc = CddaToc;
	status = get_toc(&CddaToc);
	XtVaGetValues(eject, XtNstate, &eject_flag, NULL);
	if(eject_flag == True) {
		XtVaSetValues(eject, XtNstate, False, NULL);
	}
	if(status < 0) {
		/***************************
		 *	ǥμ˼
		 ***************************/
		compactDiscDataError();
		PopupCddaerrMessage("");
	} else {
		/***************************
		 *	ǥμ
		 ***************************/
		/* CDL 򸡺 */
		CurrentDisc_ptr = SearchDiscData(EOF, DiscData_ptr, &CddaToc);
		if(CurrentDisc_ptr != NULL) {
			/* CDL 򹹿 */
			MakeDiscInfomation(CurrentDisc_ptr, &CddaToc);
			CurrentDiscFlag = TRUE;
		} else {
			/* ̤ϿǥѤΰŪ CDL  */
			CurrentDisc_ptr = 
						MakeNewDiscData(&CddaToc, app_data.space_delete);
			MakeDiscInfomation(CurrentDisc_ptr, &CddaToc);
			CurrentDiscFlag = FALSE;
		}
		make_cd_menu(&CddaToc);	/* ȥå˥塼򹹿 */
		XtVaSetValues(cdTitle, XtNlabel, cdljc(CurrentDisc_ptr->cdTitle), NULL);
		if(OrderMode == NormalOrder) {
			CdOrder_ptr = NULL;
		}
		release_order_list(NormalPlayOrder_ptr);	/* κ˴ */
		/* 촹 CD ̾Τκ */
		NormalPlayOrder_ptr = MakeNormalPlayOrders(0, &CddaToc);
		if(OrderMode == NormalOrder) {
			CdOrder_ptr = NormalPlayOrder_ptr;
		}
		compactDiscIn();
		makeDiscWords();
		if(cmp_toc(&CddaToc, &BackCddaToc) == 1) {
			/*************************
			 *	ǥ򴹤줿
			 *************************/
			if(OrderMode == ProgramOrder) {
				/*********************************************************
				 *	ץࡦꥹȤǽȥåΤߤǺƹ
				 *********************************************************/
				CdOrder_ptr = ProgramOrder_ptr =
							remakeProgram(ProgramOrder_ptr, &CddaToc);
				ProgramConnect = LinkLast(ProgramOrder_ptr, Cd_Order_Next);
				MakeProgramOrderList();
			} else {
				ProgramClear(NULL, NULL, NULL);	/* ץ */
			}
		}
	}
	return(status);
}

/***************************************************************************
 *	Play: ܥΥХåؿ
 *	
 *		void Play(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				ܥΥ
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
void Play(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status = 1;
	struct cd_subq subq;
	/* Boolean eject_flag; */		/* eject Toggle Widget ξּ */
	void make_cd_menu(struct cd_toc *toc);

	if(cddaStatus2(&subq) >= 0) {
		if(subq.playing == CS_EJECTED) {
			status = FALSE;
			cd_door_cntrl(CDIOCDOOR_CLOSE);
		}
	} else {
		status = FALSE;
		cd_door_cntrl(CDIOCDOOR_CLOSE);
	}
	switch(PlayingMode) {
	case STOP:
		if(status == FALSE)
			status = MediaChange();
		if(status < 0) {
			XtVaSetValues(w, XtNstate, False, NULL);
#ifdef	GENERAL
			trayManagerOn();
#endif	/*GENERAL*/
		} else {
			trayManagerOff();
		}
		error_control((status >= 0)?(True):(False));
		switch(OrderMode) {
		case NormalOrder:
			if(status > 0) {
				if(NormalPlayOrder_ptr != NULL) {
					CdOrder_ptr = normal_play2(&Cdda_info, CdTrack, 
										NormalPlayOrder_ptr, &CddaToc);
				}
			}
			XtSetSensitive(OrderControl, False);
			break;
		case ProgramOrder:
			if(status > 0) {
				if(program_play(&CddaToc) >= 0) {
					XtSetSensitive(OrderControl, 
							((CdOrder_ptr != NULL)?(False):(True)));
				} else {
					XtVaSetValues(play, XtNstate, False, NULL);
				}
			}
			break;
		}
		track_set(CdTrack);
		break;
	case PAUSE:
		XtVaSetValues(pauseButton, XtNstate, False, NULL);
		CounterControl(CounterMode, NULL);
		PlayingMode = PLAY;
		cd_resume();			/* CDդƳ */
		break;
	}
	track_set(CdTrack);
}

/***************************************************************************
 *	Pause: ߥܥΥХåؿ
 *	
 *		void Pause(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ʤߤ롣
 *		ʤդƳ
 *		
 ***************************************************************************/
/* ARGSUSED */
void Pause(Widget w, XtPointer client_data, XtPointer call_data)
{
	switch(PlayingMode) {
	case PLAY:					/*  */
		CounterControl(CounterStop, NULL);
		if(cd_status2(&PauseSubq) != EOF) {
			counter_disp2(counter, "Pause", &PauseSubq, CounterMode);
		}
		PlayingMode = PAUSE;
		cd_pause();				/* CDߤˤ */
		break;
	case PAUSE:					/*  */
		cd_resume();			/* CDդƳ */
		PlayingMode = PLAY;
		if(cd_status2(&PauseSubq) != EOF) {
			counter_disp2(counter, 
						CounterTitle[CounterMode], &PauseSubq, CounterMode);
		}
		CounterControl(CounterMode, NULL);
		break;
	default:
		XtVaSetValues(w, XtNstate, False, NULL);
		break;
	}
}

/***************************************************************************
 *	Stop: ߥܥΥХåؿ
 *	
 *		void Stop(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ãĤߤ롣
 *		ɽStopɡãĤߡ⡼ѹǽˤ
 *		
 ***************************************************************************/
/* ARGSUSED */
void Stop(Widget w, XtPointer client_data, XtPointer call_data)
{
	CounterControl(CounterStop, "Stop");
	XtVaSetValues(cdTitle, XtNlabel, cdljc(CurrentDisc_ptr->cdTitle), NULL);
	XtVaSetValues(pauseButton, XtNstate, False, NULL);
	XtVaSetValues(play, XtNstate, False, NULL);
	cd_stop();
	PlayingMode = STOP;
	XtSetSensitive(OrderControl, True);
	playFinished();
#ifdef	GENERAL
	trayManagerOn();
#endif	/*GENERAL*/
}

/***************************************************************************
 *	Eject: ãĥɥ饤֤Υ
 *	
 *		void Eject(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ãĤߤơǽʤ饤Ȥ
 *		ޤȥå˥塼ԲĤˤ
 *		
 ***************************************************************************/
void Eject(Widget w, XtPointer client_data, XtPointer call_data)
{
#ifndef	GENERAL
	int status;
#endif	/*GENERAL*/
	Boolean eject_flag;		/* Toggle Widget ξּ */
	Dimension height1, height2;
	extern Widget DiscView, DiscTrackList;

	XtVaGetValues(w, XtNstate, &eject_flag, NULL);
	CounterControl(CounterStop, "Stop");
	XtVaSetValues(play, XtNstate, False, NULL);

	switch(eject_flag) {
	case True:				/* ȥ쥤ץ󤵤 */
		if(PlayingMode != STOP) {
			cd_stop();
			XtVaSetValues(pauseButton, XtNstate, False, NULL);
			PlayingMode = STOP;
			XtSetSensitive(OrderControl, True);
			playFinished();
#ifdef	GENERAL
			trayManagerOn();
#endif	/*GENERAL*/
		}
#ifdef	CDIOCDOOR
		cd_door_cntrl(CDIOCDOOR_OPEN);
#endif	/*CDIOCDOOR*/
		error_control(False);
		compactDiscOut();
		break;
	case False:				/* ȥ쥤 */
#ifdef	CDIOCDOOR
		cd_door_cntrl(CDIOCDOOR_CLOSE);
#endif	/*CDIOCDOOR*/
		if(PlayingMode == STOP) {
#ifdef	GENERAL
/*
			do {
				trayStatus = cdTrayStatus();
			} while(trayStatus != TrayClosed);
 */
#endif	/*GENERAL*/
#ifndef	GENERAL
			status = MediaChange();
			error_control((status >= 0)?(True):(False));
#endif	/*GENERAL*/
			if(!app_data.cdlAutoHeight) {
				XtVaGetValues(DiscView, XtNheight, &height1, NULL);
				XtVaGetValues(DiscTrackList, XtNheight, &height2, NULL);
			}
			/*printf("DiscView:Height=%d/DiscTrackList:Height=%d\n", height1, height2);*/
			playFinished();
#ifdef	GENERAL
			trayManagerOn();
#endif	/*GENERAL*/
		}
		break;
	}
}

/***************************************************************************
 *	track_set: ȥåֹɽꤹ
 *	
 *		void track_set(int track_no);
 *	
 *		int track_no;		ȥåֹ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void track_set(int track_no)
{
	if(track_no >= 0) {
		sprintf(track_string, "Track %2d", track_no);
		XtVaSetValues(track, XtNlabel, track_string, NULL);
		track_no = track_no - (track_no > 0);
	}
	if(PlayingMode == PLAY && track_no >= 0) {
		XtVaSetValues(cdTitle, XtNlabel, 
			cdljc((CurrentDisc_ptr->track_ptr+track_no)->trackTitle), NULL);
	} else {
		XtVaSetValues(cdTitle, XtNlabel, cdljc(CurrentDisc_ptr->cdTitle), NULL);
	}
}

/***************************************************************************
 *	Counter: 󥿤ɽ⡼ɤѤCounter ΥХåؿ
 *	
 *		void Counter(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		󥿤ɽ⡼ɤѤ
 *		
 ***************************************************************************/
/* ARGSUSED */
void Counter(Widget w, XtPointer client_data, XtPointer call_data)
{
	switch(CounterFlag) {
	case CounterStop:
		switch(CounterMode) {
		case TotalTime:
			CounterMode = TrackTime; 
			break;
		case TrackTime:
			CounterMode = TotalTime; 
			break;
		}
		if(PlayingMode == PAUSE) {
			counter_disp2(counter, "Pause", &PauseSubq, CounterMode);
		}
		break;
	case TotalTime:
		CounterFlag =  CounterMode = TrackTime; 
		break;
	case TrackTime:
		CounterFlag =  CounterMode = TotalTime; 
		break;
	}
}

/***************************************************************************
 *	intervalRemoveTimeOut: ϿƤԤθƤӽФؿä
 *	
 *		void intervalRemoveTimeOut(IntervalData *interval_data);
 *	
 *		IntervalData *interval_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void intervalRemoveTimeOut(IntervalData *interval_data)
{
	if(interval_data->flag == TRUE) {
		/*******************************************
		 *	ԤƤӽФؿϿƤȤ
		 *******************************************/
		XtRemoveTimeOut(interval_data->intervalId);
		interval_data->flag = FALSE;
	}
}

/***************************************************************************
 *	intervalAddTimeOut: ַв˸ƤӽФؿϿ
 *	
 *		void intervalAddTimeOut(XtAppContext app_context, 
 *					unsigned long interval, XtTimerCallbackProc proc, 
 *					IntervalData *interval_data, XtPointer client_data);
 *	
 *		XtAppContext app_context;		ץꥱ󥳥ƥ
 *		unsigned long interval;			ֳִ֡msec.
 *		XtTimerCallbackProc proc;		ַв˸ƤӽФؿ
 *		IntervalData *interval_data;	ָƤӽФѤι¤ΤΥݥ
 *		XtPointer client_data;			ͽΥǡؤݥ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void intervalAddTimeOut(XtAppContext app_context, 
				unsigned long interval, XtTimerCallbackProc proc, 
					IntervalData *interval_data, XtPointer client_data)
{
	interval_data->client_data = client_data;
	
	if(interval_data->flag == FALSE) {
		/*********************************************
		 *	ؿŤϿʤ褦˥å
		 *********************************************/
		interval_data->intervalId = 
				XtAppAddTimeOut(app_context, interval, proc, interval_data);
		interval_data->flag = TRUE;
	}
}

/***************************************************************************
 *	CounterControl: 󥿤椹
 *	
 *		void CounterControl(int counter_type, char *counter_buffer);
 *	
 *		int counter_type;
 *		char *counter_buffer;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void CounterControl(int counter_type, char *counter_buffer)
{
	if(counter_type == CounterStop) {
		intervalRemoveTimeOut(&CounterCtrl);
		if(counter_buffer != NULL) {
			XtVaSetValues(counter, XtNlabel, counter_buffer, NULL);
		}
	}
	if(CounterFlag == CounterStop) {
		if(counter_type != CounterStop) {
			intervalAddTimeOut(XtWidgetToApplicationContext(counter), 
					Interval, IntervalCounterControl, &CounterCtrl, counter);
		}
	}
	CounterFlag = counter_type;			/* ɽƳ */
}

#define	NEXT

/***************************************************************************
 *	DelayedSkip: ꤵ줿ȥå
 *	
 *		static void DelayedSkip(XtPointer client_data, XtIntervalId *id);
 *	
 *		XtPointer client_data;
 *		XtIntervalId *id;
 *	֤
 *		
 *	
 *		δؿϡ̾ƸƤӽФ褦˥ॢȴؿ
 *		ƤӽФ롣
 *	Ϣ
 *		
 ***************************************************************************/
/* ARGSUSED */
static void DelayedSkip(XtPointer client_data, XtIntervalId *id)
{
	IntervalData *skip_ctrl_ptr = (IntervalData*)client_data;
	SkippingData *skip_info_ptr;
	struct cdda_play *skip_play_ptr;

	skip_ctrl_ptr->flag = FALSE;	/* å״λ򼨤 */
	skip_info_ptr = (SkippingData *)skip_ctrl_ptr->client_data;
	skip_play_ptr = (struct cdda_play*)skip_info_ptr->skipping_play_ptr;
	
	CounterControl(CounterMode, NULL);	/* ɽƳ */
	(void)cd_play2(skip_play_ptr);		/*  */
}

/***************************************************************************
 *	SetDelayedSkip: ꤵ줿ȥå
 *	
 *		static void SetDelayedSkip(XtAppContext app_context, 
 *					struct cdda_play *skipPlay_ptr, int *skip_counter);
 *	
 *		XtAppContext app_context;
 *		struct cdda_play *skipPlay_ptr;
 *		int *skip_counter;
 *	֤
 *		
 *	
 *		ٱ䥹åפΤϿԤ
 *	Ϣ
 *		
 ***************************************************************************/
/* ARGSUSED */
static void SetDelayedSkip(XtAppContext app_context, 
						struct cdda_play *skipPlay_ptr, int *skip_counter)
{
	int track_no;
	static SkippingData skip_info;

	/*******************************************
	 *	ճϻ֤ȥåɽ
	 *******************************************/
	track_no = get_track_no(&skipPlay_ptr->start, &CddaToc);
	track_set(track_no);
	CounterControl(CounterStop, "Skipping...");

	skip_info.skipping_play_ptr = skipPlay_ptr;
	skip_info.search_counter = skip_counter;
	intervalAddTimeOut(app_context, SkipIntervalTime, 
						DelayedSkip, &SkipCtrl, &skip_info);
}

/***************************************************************************
 *	NowSkip: ꤵ줿ȥå
 *	
 *		static void NowSkip(struct cdda_play *skipPlay_ptr);
 *	
 *		struct cdda_play *skipPlay_ptr;
 *	֤
 *		
 *	
 *		ٱʤǥåפ
 *	Ϣ
 *		
 ***************************************************************************/
/* ARGSUSED */
static void NowSkip(struct cdda_play *skipPlay_ptr)
{
	int track_no;
	static SkippingData skip_info;

	track_no = get_track_no(&skipPlay_ptr->start, &CddaToc);
	track_set(track_no);
	CounterControl(CounterStop, "Skipping...");
	skip_info.skipping_play_ptr = (XtPointer) skipPlay_ptr;
	SkipCtrl.client_data = (XtPointer) &skip_info;
	DelayedSkip(&SkipCtrl, NULL);
}

/***************************************************************************
 *	SearchInitiaize: 󥿤νؿ
 *	
 *		static void SearchInitiaize(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	ХåϢ³ƤӽФؤΥݥ
 *		XtPointer call_data;	̤ѡRepeater Widget Ǥϡ̤ѡ
 *	֤
 *		
 *	
 *		󥿤νԤâϢ³åפξ֤Ǥ
 *		ϡ󥿤˥å׾֤Ǥ뤳Ȥ򼨤
 *		롣
 *		for Repeater Widget/XtNstartCallBack
 *	Ϣ
 *		SearchBackward();
 *		Rew();
 *		RewStop();
 *		
 ***************************************************************************/
/* ARGSUSED */
static void SearchInitiaize(Widget w, XtPointer client_data, XtPointer call_data)
{
	int *search_counter = (int*)client_data;

	*search_counter = SearchInit;
	if(SkipCtrl.flag != FALSE) {
		intervalRemoveTimeOut(&SkipCtrl);	/* ٱ䥹åפâ */
		*search_counter = Skipping;			/* Ϣ³åפ򼨤 */
	}
}

/***************************************************************************
 *	SearchBackward: ᤷؿfor Repeater Widget/XtNCallBack
 *	
 *		static void SearchBackward(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	ХåϢ³ƤӽФؤΥݥ
 *		XtPointer call_data;	̤ѡRepeater Widget Ǥϡ̤ѡ
 *	֤
 *		
 *	
 *		δؿǤϡ󥿤ξ֤ˤäơ狼ޤ
 *		󥿤 SearchInit ΤȤʽ֡
 *			󥿤Υ󥯥
 *			åפδˤʤ롢ߤαջ֤μ
 *			ջ郎Ǥ̵ʤϢ³åװˤ
 *		󥿤 Skipping ΤȤ
 *			ʤˤʤ
 *		󥿤 SearchError ΤȤ
 *			ʤˤʤ
 *		󥿤嵭ʳΤȤʥ֡
 *			֤ȥꥹȤ顢̤Ȥƥ֤
 *			줬°륪롣
 *			Ǥ̵ϡθ³ȸȤʤΤǡλǡ
 *			ߤ롣
 *			Ǥϡ֤롣
 *	Ϣ
 *		Rew();					
 *		RewStop();
 *		
 ***************************************************************************/
/* ARGSUSED */
static void SearchBackward(Widget w, XtPointer client_data, XtPointer call_data)
{
	static struct cd_subq search_subq;
	Cd_Order *cd_order_ptr;
	int *search_counter = (int*)client_data;

	switch(*search_counter) {
	case SearchInit:			/*  */
		++*search_counter;		/*  */
		if(cd_status2(&search_subq) == EOF) {
			*search_counter = Skipping;	/* ʳϥԲ */
		}
		break;
	default:					/*  */
		++*search_counter;		/*  */
		cd_order_ptr = searching(CdOrder_ptr, &Cdda_info, &search_subq.time, 
										-SearchCount(*search_counter) * 75);
		if(cd_order_ptr == NULL) {
			*search_counter = SearchError;		/* ³ʤΤǥ */
		} else {
			if(cd_play2(&Cdda_info) == EOF) {
				*search_counter = SearchError;	/* 顼ǥ */
			} else {
				search_subq.time = Cdda_info.start;
				CdOrder_ptr = cd_order_ptr;
			}
		}
		break;
	case Skipping:				/* Ǥʤ */
		break;
	case SearchError:			/*  */
		break;
	}
}

/***************************************************************************
 *	SkipBackward: Υȥåإåפ
 *	
 *		int SkipBackward(Widget w, 
 *					XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		FALSE:	
 *		TRUE:	
 *	
 *		
 *	Ϣ
 *		SearchBackward();
 *		Rew();
 *		RewStop();
 ***************************************************************************/
int SkipBackward(Widget w, XtPointer client_data, XtPointer call_data)
{
	int status = FALSE;
	int *search_counter = (int*)client_data;
	int track_no;
	static struct cd_subq subq;
	static struct cdda_play skip_play = {{0,0,0}, {0,0,0}, 1};
	Cd_Order *cd_order_ptr;

	switch(PlayingMode) {
	case PLAY:
		if(*search_counter != Skipping) {
			if(cd_status2(&subq) == 0) {
				skip_play.end = CdOrder_ptr->play_info.end;
				if(SkipTop(&skip_play, 
							CdOrder_ptr, &CddaToc, &subq) != FALSE) {
					SetDelayedSkip(XtWidgetToApplicationContext(w), 
										&skip_play, search_counter);
					break;		/* 顼 */
				} else {
					skip_play.start = subq.time;
				}
			} else {
				break;		/* 顼 */
			}
		}
		track_no = get_track_no(&skip_play.start, &CddaToc);
		cd_order_ptr = PreviousSkip(&skip_play, track_no, 
									CdOrder_ptr, &CddaToc);
		if(cd_order_ptr != NULL) {
			CdOrder_ptr = cd_order_ptr;
			SetDelayedSkip(XtWidgetToApplicationContext(w), 
							&skip_play, search_counter);
		} else {
			NowSkip(&skip_play);
		}
		break;
	case STOP:
		if(OrderMode == ProgramOrder) {
			cd_order_ptr = PreviousSkip(&Cdda_info, CdTrack, 
										CdOrder_ptr, &CddaToc);
			if(cd_order_ptr != NULL) {
				CdOrder_ptr = cd_order_ptr;
			
				CdTrack = get_track_no(&Cdda_info.start, &CddaToc);
			}
		} else {
			if(CdTrack > 1) {
				--CdTrack;
			}
		}
		track_set(CdTrack);
		break;
	}
	return(status);
}

/***************************************************************************
 *	Rew: ңţץܥʡ|ˤΥ줿Ȥν򤹤ʥХåؿ
 *	
 *		void Rew(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ңţףɣΣưϡʲΣ̤Τɤ餫Ǥ
 *		ᤷ
 *		ȥåذư
 *	Ϣ
 *		SearchBackward();
 *		RewStop();
 *		
 ***************************************************************************/
/* ARGSUSED */
void Rew(Widget w, XtPointer client_data, XtPointer call_data)
{
	int *search_counter = (int*)client_data;
	
	track_set(CdTrack);
	
	switch(*search_counter) {
	case SearchError:			/*  */
		/* to be continue */
	default:					/* ưԤä */
		*search_counter = 0;
		break;
	case Skipping:				/* åưʥԲġ */
	case SearchWaiting:			/* åư */
		SkipBackward(w, client_data, call_data);
		*search_counter = 0;
		break;
	}
}

/***************************************************************************
 *	SearchForward: ꥵؿ
 *	
 *		static void SearchForward(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	ХåϢ³ƤӽФؤΥݥ
 *		XtPointer call_data;	̤ѡRepeater Widget Ǥϡ̤ѡ
 *	֤
 *		
 *	
 *		δؿǤϡ󥿤ξ֤ˤäơ狼ޤ
 *		󥿤 SearchInit ΤȤʽ֡
 *			󥿤Υ󥯥
 *			åפδˤʤ롢ߤαջ֤μ
 *			ջ郎Ǥ̵ʤϢ³åװˤ
 *		󥿤 Skipping ΤȤ
 *			ʤˤʤ
 *		󥿤 SearchError ΤȤ
 *			ʤˤʤ
 *		󥿤嵭ʳΤȤʥ֡
 *			֤ȥꥹȤ顢̤Ȥƥ֤
 *			줬°륪롣
 *			Ǥ̵ϡθ³ȸȤʤΤǡλǡ
 *			ߤ롣
 *			Ǥϡ֤롣
 *	Ϣ
 *		SearchBackward();
 *		Ff();
 *		FfStop();
 *		
 ***************************************************************************/
/* ARGSUSED */
static void SearchForward(Widget w, XtPointer client_data, XtPointer call_data)
{
	static struct cd_subq search_subq;
	Cd_Order *cd_order_ptr;
	int *search_counter = (int*)client_data;

	switch(*search_counter) {
	case SearchInit:			/*  */
		++*search_counter;		/*  */
		if(cd_status2(&search_subq) == EOF) {
			*search_counter = Skipping;		/* ʳϥԲ */
		}
		break;
	default:					/*  */
		++*search_counter;		/*  */
		cd_order_ptr = searching(CdOrder_ptr, &Cdda_info, &search_subq.time, 
										SearchCount(*search_counter) * 75);
		if(cd_order_ptr == NULL) {
			*search_counter = SearchError;		/* ³ʤΤǥ */
		} else {
			if(cd_play2(&Cdda_info) == EOF) {
				*search_counter = SearchError;	/* 顼ǥ */
			} else {
				search_subq.time = Cdda_info.start;
				CdOrder_ptr = cd_order_ptr;
			}
		}
		break;
	case Skipping:				/* Բ */
		break;
	case SearchError:			/*  */
		break;
	}
}

/***************************************************************************
 *	SkipForward: | Υȥåå
 *	
 *		void SkipForward(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	ХåϢ³ƤӽФؤΥݥ
 *		XtPointer call_data;	̤ѡRepeater Widget Ǥϡ̤ѡ
 *	֤
 *		
 *	
 *		ꥵؿSearchForward()ˤϿؿ
 *	Ϣ
 *		SearchForward();
 *		SearchForwardAction();
 *		Ff();
 *		FfStop();
 *		
 ***************************************************************************/
void SkipForward(Widget w, XtPointer client_data, XtPointer call_data)
{
	int track_no;
	int *search_counter = (int*)client_data;
	static struct cd_subq subq;
	static struct cdda_play skip_play = {{0,0,0}, {0,0,0}, 1};
	Cd_Order *cd_order_ptr;

	switch(PlayingMode) {
	case PLAY:
		if(*search_counter != Skipping) {
			if(cd_status2(&subq) == EOF) {
				break;
			}
			skip_play.start = subq.time;
			skip_play.end = CdOrder_ptr->play_info.end;
		}
		track_no = get_track_no(&skip_play.start, &CddaToc);
		cd_order_ptr = NextSkip(&skip_play, track_no, 
										CdOrder_ptr, &CddaToc);
		if(cd_order_ptr != NULL) {
			CdOrder_ptr = cd_order_ptr;
			SetDelayedSkip(XtWidgetToApplicationContext(w), 
								&skip_play, search_counter);
		} else {
			NowSkip(&skip_play);
		}
		break;
	case STOP:
		if(OrderMode == ProgramOrder) {
			cd_order_ptr = NextSkip(&Cdda_info, CdTrack, 
										CdOrder_ptr, &CddaToc);
			if(cd_order_ptr != NULL) {
				CdOrder_ptr = cd_order_ptr;
				
				CdTrack = get_track_no(&Cdda_info.start, &CddaToc);
			}
		} else {
			if(CdTrack < 99) {
				++CdTrack;
			}
		}
		track_set(CdTrack);
		break;
	}
}

/***************************************************************************
 *	Ff: ƣƥܥ|ˤΥ줿Ȥν򤹤ʥХåؿ
 *	
 *		void Ff(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		ƣưϡʲΣ̤Τɤ餫Ǥ
 *		ꥵ
 *		ȥåذư
 *	Ϣ
 *		SearchForward();
 *		SearchForwardAction();
 *		FfStop();
 *		
 ***************************************************************************/
/* ARGSUSED */
void Ff(Widget w, XtPointer client_data, XtPointer call_data)
{
	int *search_counter = (int*)client_data;
	
	track_set(CdTrack);
	
	switch(*search_counter) {
	case SearchError:			/*  */
		/* to be continue */
	default:					/* ưԤä */
		*search_counter = 0;
		break;
	case Skipping:			/* åסʥԲġ */
	case SearchWaiting:			/* åư */
		SkipForward(w, client_data, call_data);
		*search_counter = 0;
		break;
	}
}

/***************************************************************************
 *	RepeatMode: ԡȥ⡼ɤꤹ
 *	
 *		static void RepeatMode(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
static void RepeatMode(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean flag;

	XtVaGetValues(w, XtNstate, &flag, NULL);
	if(flag != False) {
		RepeatModeFlag = *((int*)client_data);
		if(RepeatModeFlag != False) {
			XtVaSetValues(repeatoff, XtNleftBitmap, no_marked, NULL);
			XtVaSetValues(repeatall, XtNleftBitmap, marked, NULL);
		} else {
			XtVaSetValues(repeatoff, XtNleftBitmap, marked, NULL);
			XtVaSetValues(repeatall, XtNleftBitmap, no_marked, NULL);
		}
	}
}

/***************************************************************************
 *	playFinished: λν
 *	
 *		void playFinished(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void playFinished(void)
{
	CdOrder_ptr = (Cd_Order *)LinkLast(CdOrder_ptr, Cd_Order_Prev);
	if(CdOrder_ptr != NULL) {
		CdTrack = get_track_no(&CdOrder_ptr->play_info.start, &CddaToc);
		if(CdTrack == EOF) {
			CdTrack = 1;
		}
		track_set(CdTrack);
	}
}

/***************************************************************************
 *	ControlMode: ⡼ɤꤹ
 *	
 *		static void ControlMode(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
static void ControlMode(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean flag;
	Dimension width;
	
	XtVaGetValues(w, XtNstate, &flag, XtNwidth, &width, NULL);
	XtVaSetValues(w, 
			XtNlabel, OrderModeStrings[flag != FALSE], 
			XtNwidth, width,
			NULL);
	OrderMode = ((flag != FALSE)?(ProgramOrder):(NormalOrder));
	switch(OrderMode) {
	case NormalOrder:
		CdOrder_ptr = NormalPlayOrder_ptr;
		break;
	case ProgramOrder:
		CdOrder_ptr = ProgramOrder_ptr;
		break;
	}
}

/***************************************************************************
 *	counter_disp: 󥿤ɽ
 *	
 *		static void counter_disp(Widget w, const char *title_ptr, 
 *						int frameOffset, const struct cd_time *time_ptr);
 *	
 *		Widget w;						󥿤ɽ٥륦å
 *		const char *title_ptr;			󥿤ʸ
 *		int frameOffset;
 *		const struct cd_time *time_ptr;	ջ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
static void counter_disp(Widget w, const char *title_ptr, int frameOffset, const struct cd_time *time_ptr)
{
	static char minString[4];
	static char counterBuffer[30];

	sprintf(minString, "%s%d", 
				((frameOffset < 0)?("-"):("")), time_ptr->minute);
	sprintf(counterBuffer, "%s %.3s:%02d", 
				title_ptr, minString, time_ptr->second);
	XtVaSetValues(w, XtNlabel, counterBuffer, NULL);
}

/***************************************************************************
 *	counter_disp2: 󥿤ɽ
 *	
 *		static void counter_disp2(Widget w, const char *title_ptr, 
 *						const struct cd_subq *subq_ptr, int counter_mode);
 *	
 *		Widget w;						󥿤ɽ٥륦å
 *		const char *title_ptr;			󥿤ʸ
 *		const struct cd_subq *subq_ptr;	ջ
 *		int counter_mode;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
static void counter_disp2(Widget w, const char *title_ptr, 
						const struct cd_subq *subq_ptr, int counter_mode)
{
	int track;
	int frameOffset;

	switch(counter_mode) {
	case TotalTime:
		counter_disp(w, title_ptr, 
							time2frame(&subq_ptr->time), &subq_ptr->time);
		break;
	case TrackTime:
		track = subq_ptr->track - (subq_ptr->track > 0); 
		frameOffset = 
			time2frame(&subq_ptr->time) - time2frame(&CddaToc.track[track]);
		counter_disp(w, title_ptr, frameOffset, &subq_ptr->offset);
		break;
	}
}

/***************************************************************************
 *	counter_reduce: ߤαվ˥󥿤碌
 *	
 *		static int counter_reduce(widget w, const char *title);
 *	
 *		widget w;			ɽΥ٥롦å
 *		const char *title;	󥿤κ¦ʸ
 *	֤
 *		EOF: 				顼ʸߤαվμ˼ԡ
 *		ʾ0100: 	󥿾μ˥ե졼ब 00 ˤʤ
 *							Ǥλ֡ms.ñ̡
 *	
 *		
 ***************************************************************************/
static int counter_reduce(Widget w, const char *title)
{
	int status = FALSE;
	int interval_dif = 0;

	if(cd_status(&CurrentSubq) == 0) {
		if(CurrentSubq.playing) {
			counter_disp2(w, title, &CurrentSubq, CounterFlag);
			status = TRUE;
			if(CurrentSubq.track != CdTrack) {
				CdTrack = CurrentSubq.track ;
				track_set(CdTrack);
			}
			interval_dif = 100 * CurrentSubq.time.frame / 75;
		}
	}
	return((status)?(interval_dif):(EOF));
}

/***************************************************************************
 *	IntervalCounterControl: ä˥󥿤ɽ
 *	
 *		static void IntervalCounterControl(XtPointer client_data, XtIntervalId *id);
 *	
 *		XtPointer client_data;
 *		XtIntervalId *id;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
static void IntervalCounterControl(XtPointer client_data, XtIntervalId *id)
{
	int interval_dif = 0;
	IntervalData *interval_data = (IntervalData *)client_data;
	Widget w;
	struct cdda_play cdda_info;
	Cd_Order *new_order;

	CounterCtrl.flag = FALSE;
	w = (Widget)interval_data->client_data;
	
	interval_dif = counter_reduce(w, CounterTitle[CounterFlag]); 
	
	if(interval_dif == EOF) {
		/**********************
		 *	Repeat 
		 **********************/
		new_order = PlayContinue(RepeatModeFlag, CdOrder_ptr);
		if(new_order != NULL) {
			CdOrder_ptr = new_order;
			cdda_info = CdOrder_ptr->play_info;		/* BUG??? */
			cd_play2(&cdda_info);
			interval_dif = counter_reduce(w, CounterTitle[CounterFlag]);
		}
	}
	
	if(interval_dif != EOF) {
		intervalAddTimeOut(XtWidgetToApplicationContext(w),
				Interval - interval_dif, 
				IntervalCounterControl, &CounterCtrl, w);
		FlashingProgram();
		FlashingDiscData();
		WordsFlashing();
	} else {
		CounterFlag = CounterStop;
		XtVaSetValues(cdTitle, XtNlabel, CurrentDisc_ptr->cdTitle, NULL);
		XtVaSetValues(w, XtNlabel, "Stop", NULL);
		XtVaSetValues(play, XtNstate, False, NULL);
		if(PlayingMode == PLAY) {
			PlayingMode = STOP;
			XtSetSensitive(OrderControl, True);
			playFinished();
#ifdef	GENERAL
			trayManagerOn();
#endif	/*GENERAL*/
		}
	}
}

#ifdef	GENERAL
/***************************************************************************
 *	cdTrayStatus: CD ȥ쥤ξ
 *	
 *		Tray cdTrayStatus(void);
 *	
 *		ʤ
 *	֤
 *		TrayClosed:		
 *		TrayOpened:		
 *		TrayError:		
 *	
 *		
 ***************************************************************************/
Tray cdTrayStatus(void)
{
	struct cd_subq subq;
	Tray newTrayStatus = TrayUnknown;

	if(cddaStatus2(&subq) < 0) {
		return(newTrayStatus);
	}
	switch(subq.playing) {
	case CS_STOP:
	case CS_PLAYING:
	case CS_PAUSE:
		newTrayStatus = TrayClosed;
		break;
	case CS_EJECTED:
		newTrayStatus = TrayOpened;
		break;
	default:
	case CS_WAITING:
	case CS_UNKNOWN:
	case CS_ERROR:
		newTrayStatus = TrayError;
		break;
	}
	return(newTrayStatus);
}

/***************************************************************************
 *	trayManager: ãĥȥ쥤ξִƻ
 *	
 *		static void trayManager(XtPointer client_data, XtIntervalId *id);
 *	
 *		XtPointer client_data;
 *		XtIntervalId *id;
 *	֤
 *		
 *	
 *		δؿϡ֤ CD ȥ쥤ξ֤ƻΤ˸ƤӽФ
 *		ޤ
 *	
 *		δؿϡPC/ATʸߴ ΥƥॳɬפȤޤ
 *		TOWNS ¢ CD-ROM ɥ饤֤Ǥϡ1.3.84 ȯɽ줿
 *		饤ФɬפǤĤޤꡢ1.3.84 㤤СǤϡݡ
 *		ޤ
 *		TrayError   = 0x00,
 *		TrayClosed  = 0x01,
 *		TrayOpened  = 0x02,
 *		TrayUnknown = 0x03
 ***************************************************************************/
static void trayManager(XtPointer client_data, XtIntervalId *id)
{
	int status;
	Tray newTrayStatus = TrayUnknown;
#ifdef	DEBUG
	char mwxcdTitle[256];
	static int checkValue = EOF;
	struct cd_subq subq;
	Boolean recall;
	static const char *trayStatus[] = 
					{"TrayError", "TrayClosed", "TrayOpened", "TrayUnknown"};
#endif	/*DEBUG*/

#ifdef	DEBUG2
	if(id != NULL) {
		printf("##%d -- ", *id);	fflush(stdout);
	} else {
		printf("##NULL -- ");	fflush(stdout);
	}
#endif	/*DEBUG*/
#ifdef	DEBUG
	if(id != NULL && checkValue != *id) {
		printf("ERROR: %d -- %d\n", checkValue, *id);
	}
#endif	/*DEBUG*/

	TrayCtrl.flag = FALSE;
	newTrayStatus = cdTrayStatus();
	switch(newTrayStatus) {
	case TrayClosed:
		if(FixedTrayStatus != newTrayStatus) {
			FixedTrayStatus = newTrayStatus;
			XtVaSetValues(eject, XtNstate, False, NULL);
			status = MediaChange();
			error_control((status >= 0)?(True):(False));
		}
		break;
	case TrayOpened:
		if(FixedTrayStatus != newTrayStatus) {
			FixedTrayStatus = newTrayStatus;
			XtVaSetValues(eject, XtNstate, True, NULL);
			XtVaSetValues(pauseButton, XtNstate, False, NULL);
			PlayingMode = STOP;
			XtSetSensitive(OrderControl, True);
			playFinished();
			compactDiscOut();
			error_control(False);
		}
		break;
	default:
		break;
	}
	TrayStatus = newTrayStatus;

#ifdef	DEBUG
	sprintf(mwxcdTitle, "mwxcd-"VERSION_NO" --[%s]", trayStatus[TrayStatus]);
	XtVaSetValues(topLevel, XtNtitle, mwxcdTitle, NULL);
#endif	/*DEBUG*/

	if(TrayCtrl.flag == FALSE) {
		/*********************************************
		 *	ؿŤϿʤ褦˥å
		 *********************************************/
		TrayCtrl.intervalId = 
				XtAppAddTimeOut(XtWidgetToApplicationContext(counter), 
								1000, trayManager, NULL);
#ifdef	DEBUG2
		printf("%d", TrayCtrl.intervalId);	fflush(stdout);
#endif	/*DEBUG*/
#ifdef	DEBUG
		checkValue = TrayCtrl.intervalId;
#endif	/*DEBUG*/
		TrayCtrl.flag = TRUE;
	}
#ifdef	DEBUG2
	printf("\n");
#endif	/*DEBUG*/
}

/***************************************************************************
 *	trayManagerOn: ãĥȥ쥤ξִƻγ
 *	
 *		void trayManagerOn(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 *	
 *		δؿϡPC/ATʸߴ ΥƥॳɬפȤޤ
 *		TOWNS ¢ CD-ROM ɥ饤֤Ǥϡ1.3.84 ȯɽ줿
 *		饤ФɬפǤĤޤꡢ1.3.84 㤤СǤϡݡ
 *		ޤ
 *		PC/AT  SCSI CD-ROM ɥ饤֤ؤбϡС 
 *		mwxcdVersion 1.22-1996/8/3ˤǤϡݡȤƤޤ
 ***************************************************************************/
void trayManagerOn(void)
{
	if(TrayCtrl.flag == FALSE) {
#ifdef	DEBUG
		XtVaSetValues(topLevel, XtNtitle, "mwxcd-"VERSION_NO" --[Tray Manager:ON]", NULL);
#endif	/*DEBUG*/
		trayManager(NULL, NULL);
	}
}

/***************************************************************************
 *	trayManagerOff: ãĥȥ쥤ξִƻβ
 *	
 *		void trayManagerOff(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 *	
 *		δؿϡPC/ATʸߴ ΥƥॳɬפȤޤ
 *		TOWNS ¢ CD-ROM ɥ饤֤Ǥϡ1.3.84 ȯɽ줿
 *		饤ФɬפǤĤޤꡢ1.3.84 㤤СǤϡݡ
 *		ޤ
 *		PC/AT  SCSI CD-ROM ɥ饤֤ؤбϡС 
 *		mwxcdVersion 1.22-1996/8/3ˤǤϡݡȤƤޤ
 ***************************************************************************/
void trayManagerOff(void)
{
#ifdef	DEBUG
	XtVaSetValues(topLevel, XtNtitle, "mwxcd-"VERSION_NO" --[Tray Manager:OFF]", NULL);
#endif	/*DEBUG*/
	intervalRemoveTimeOut(&TrayCtrl);
}
#endif	/*GENERAL*/

/***************************************************************************
 *	ProgramList: ǥХåѤΥץꥹȤ
 *	
 *		void ProgramList(void);
 *	
 *		
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ProgramList(void)
{
	Cd_Order *order;

	printf("\n");
	for(order = ProgramOrder_ptr;order != NULL;
				order = order->next_order_ptr) {
		printf("Track %d - %d: (%2d:%02d -- %2d:%02d) x %d.\n",
			order->start_track, order->end_track,
			order->play_info.start.minute, 
			order->play_info.start.second, 
			order->play_info.end.minute, 
			order->play_info.end.second, order->play_info.count) ;
	}
}

/***************************************************************************
 *	NewOrderProgram: ꤵ줿ץɲä
 *	
 *		void NewOrderProgram(Cd_Order *new_order);
 *	
 *		Cd_Order *new_order;		ץɲäվ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void NewOrderProgram(Cd_Order *new_order)
{
	if(new_order != NULL) {
		if(ProgramOrder_ptr == NULL && CdOrder_ptr == NULL) {
			CdOrder_ptr = ProgramOrder_ptr = new_order;
		}
		ProgramConnect = new_order;
		MakeProgramOrderList();
	}
	ProgramList_ptr = NULL;
}

/***************************************************************************
 *	TrackAddProgram: ꤵ줿ȥåץɲä
 *	
 *		void TrackAddProgram(int track);
 *	
 *		int track;		ץɲäȥåֹ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void TrackAddProgram(int track)
{
	Cd_Order *new_order;
	
	new_order = add_program(track, ProgramConnect, &CddaToc);
	NewOrderProgram(new_order);
}

/***************************************************************************
 *	TrackMenuSelect: ȥåΤȤ˸ƤӽФ륳Хåؿ
 *	
 *		void TrackMenuSelect(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	򤵤줿ȥåֹ
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void TrackMenuSelect(Widget w, XtPointer client_data, XtPointer call_data)
{ 
	int track_no;
	int *pane_number = (int*) client_data;
	Cd_Order *new_order;
	
	track_no = *pane_number + CddaToc.s_track;
	if(isAudioTrack(&CddaToc.track[*pane_number])) {
		switch(OrderMode) {
		case NormalOrder:
			new_order = normal_play(&Cdda_info, track_no, 
											NormalPlayOrder_ptr, &CddaToc);
#ifdef	GENERAL
			if(new_order != NULL) {
				trayManagerOff();
			}
#endif	/*GENERAL*/
			XtVaSetValues(play, XtNstate, True, NULL);
			if(new_order != NULL) {
				CdOrder_ptr = new_order;
				CdTrack = track_no;
				XtSetSensitive(OrderControl, False);
			}
			break;
		case ProgramOrder:
			TrackAddProgram(track_no);
			break;
		}
	}
	popdownTrackMenus(0);
}

/***************************************************************************
 *	ProgrampPoint: ץƤ򥵡
 *	
 *		void ProgramPoint(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ProgramPoint(Widget w, XtPointer client_data, XtPointer call_data)
{
	Cd_Order *ppoint;
	XawListReturnStruct *list_ptr = (XawListReturnStruct*)call_data;
	
#ifdef	DEBUG
	printf("Program %d --- \"%s\"\n", list_ptr->list_index, list_ptr->string);
#endif	/*DEBUG*/
	
	ppoint = (Cd_Order *)LinkSearch(list_ptr->list_index, 
									ProgramOrder_ptr, Cd_Order_Next);
	ProgramList_ptr = ppoint;
	if(ppoint != NULL) {
#ifdef	DEBUG
		printf(" Track %d - %d: (%2d:%02d -- %2d:%02d) x %d.\n",
			ppoint->start_track, ppoint->end_track,
			ppoint->play_info.start.minute, 
			ppoint->play_info.start.second, 
			ppoint->play_info.end.minute, 
			ppoint->play_info.end.second, ppoint->play_info.count);
#endif	/*DEBUG*/
	}
}

/***************************************************************************
 *	MakeProgramOrderList: ץƤ򹹿
 *	
 *		void MakeProgramOrderList(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void MakeProgramOrderList(void)
{
	int num;
	extern Cd_Order *ProgramOrder_ptr;	/* ץѥƬ */
	extern Widget programList;

	num = ProgramOrderList(ProgramOrder_ptr, 
			ProgramStrings, ProgramStrlen, ProgramMaxNum);
	if(num == 0) {
		sprintf(*ProgramStrings, "Empty");
		++num;
	}
	resize_check(XtParent(programList), num, app_data.programListResize);
	XawListChange(programList, ProgramStrings, num, 0, True);
}

/***************************************************************************
 *	ProgramClear: ץƤ򥯥ꥢ
 *	
 *		void ProgramClear(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ProgramClear(Widget w, XtPointer client_data, XtPointer call_data)
{
	Cd_Order *release_ptr = NULL;	/* ץѥѥݥ */
	Cd_Order *remain_order = NULL;	/* Τ˲Ǥʤ */
	extern Cd_Order *ProgramOrder_ptr;	/* ץѥƬ */
	
	release_ptr = ProgramOrder_ptr;
	if(PlayingMode == PLAY && OrderMode == ProgramOrder) {
		remain_order = CdOrder_ptr;
		if(CdOrder_ptr == release_ptr && release_ptr != NULL) {
			/* 뤿ΥΤȤ */
			release_ptr = release_ptr->next_order_ptr;
		}
		(void)delete_order(remain_order);
	}
	release_order_list(release_ptr);
	ProgramOrder_ptr = ProgramConnect = remain_order;
	if(OrderMode == ProgramOrder) {
		CdOrder_ptr = remain_order;
	}
	MakeProgramOrderList();
}

/***************************************************************************
 *	ProgramJump: ꤵ줿ץ˥פ
 *	
 *		void ProgramJump(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ProgramJump(Widget w, XtPointer client_data, XtPointer call_data)
{
#ifdef	DEBUG
	if(ProgramList_ptr == NULL) {
		printf("ProgramJump: NULL End.\n");
	} else {
		printf("ProgramJump: Track %d - %d: (%2d:%02d -- %2d:%02d) x %d.\n",
			ProgramList_ptr->start_track, ProgramList_ptr->end_track,
			ProgramList_ptr->play_info.start.minute, 
			ProgramList_ptr->play_info.start.second, 
			ProgramList_ptr->play_info.end.minute, 
			ProgramList_ptr->play_info.end.second, ProgramList_ptr->play_info.count);
	}
#endif	/*DEBUG*/
	if(ProgramList_ptr != NULL) {
		if(OrderMode == ProgramOrder) {
			CdOrder_ptr = ProgramList_ptr;
			Cdda_info = CdOrder_ptr->play_info;
			if(PlayingMode == PLAY) {
				cd_play2(&Cdda_info);
			}
		}
	}
}

/***************************************************************************
 *	ProgramDelete: ꤵ줿ץƤ
 *	
 *		void ProgramDelete(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ProgramDelete(Widget w, XtPointer client_data, XtPointer call_data)
{
	int newIndex;
	Cd_Order *release_ptr = NULL;	/* ץѥѥݥ */
	extern Cd_Order *ProgramOrder_ptr;	/* ץѥƬ */
	extern Widget programUnmark, programList, programFlashing;
	
#ifdef	DEBUG
	if(ProgramList_ptr == NULL) {
		printf("ProgramDelete: NULL End.\n");
	} else {
		printf("ProgramDelete: Track %d - %d: (%2d:%02d -- %2d:%02d) x %d.\n",
			ProgramList_ptr->start_track, ProgramList_ptr->end_track,
			ProgramList_ptr->play_info.start.minute, 
			ProgramList_ptr->play_info.start.second, 
			ProgramList_ptr->play_info.end.minute, 
			ProgramList_ptr->play_info.end.second, ProgramList_ptr->play_info.count);
	}
#endif	/*DEBUG*/
	release_ptr = ProgramList_ptr;
	if(PlayingMode == PLAY && OrderMode == ProgramOrder) {
		if(CdOrder_ptr == release_ptr && release_ptr != NULL) {
			/* 뤿ΥΤȤ */
			release_ptr = NULL;
		}
	}
	if(release_ptr != NULL) {
		newIndex = NumberOfLink(release_ptr, Cd_Order_Prev);
		newIndex -= (newIndex > 0);
		if(CdOrder_ptr == release_ptr) {
			CdOrder_ptr = NeighborOrder(CdOrder_ptr);
		}
		if(ProgramOrder_ptr == release_ptr) {
			ProgramOrder_ptr = NeighborOrder(ProgramOrder_ptr);
		}
		if(ProgramConnect == release_ptr) {
			ProgramConnect = NeighborOrder(ProgramConnect);
		}
		(void)release_order(release_ptr);
	
		MakeProgramOrderList();
		do {
			ProgramList_ptr = (Cd_Order*)LinkSearch(
								newIndex, ProgramOrder_ptr, Cd_Order_Next);
		} while(ProgramList_ptr == NULL && --newIndex >= 0);
		/* printf("ProgramList_ptr != %p\n", ProgramList_ptr); */
		if(ProgramList_ptr != NULL) {
			XawListHighlight(programList, newIndex);
			XtSetSensitive(programFlashing, False);
			XtSetSensitive(programUnmark, True);
			XtVaSetValues(programUnmark, XtNstate, True, NULL);
		} else {
			XawListUnhighlight(programList);
			XtSetSensitive(programFlashing, True);
			XtVaSetValues(programUnmark, XtNstate, False, NULL);
			XtSetSensitive(programUnmark, False);
		}
	}
}

/***************************************************************************
 *	resize_check: 
 *	
 *		void resize_check(Widget w, int panes, int limit);
 *	
 *		Widget w;
 *		int panes;
 *		int limit;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void resize_check(Widget w, int panes, int limit)
{
	if(limit >= 0) {
		if(panes <= limit) {
			XtVaSetValues(w, XtNallowVert, False, NULL);
		} else {
			XtVaSetValues(w, XtNallowVert, True, NULL);
		}
	}
}

/***************************************************************************
 *	error_control: ãĤΥ顼ؿ
 *	
 *		void error_control(Boolean status);
 *	
 *		Boolean status;		False ΤȤ顼
 *	֤
 *		
 *	
 *		ߤϡȥå˥塼
 *		
 ***************************************************************************/
void error_control(Boolean status)
{
	extern Widget pressme;
	
	XtSetSensitive(pressme, status);
}

/***************************************************************************
 *	alloc_program_list: ץࡦꥹѤΥݤ롣
 *	
 *		int alloc_program_list(char **program_string_ptr, 
 *									int length, int max_num);
 *	
 *		char **program_string_ptr;	ץࡦꥹȤؤΥݥ
 *		int length;					ĤΥꥹȤʸĹ
 *		int max_num;				ꥹȤκĿ
 *	֤
 *		ݤθĿ
 *	
 *		
 ***************************************************************************/
int alloc_program_list(char **program_string_ptr, int length, int max_num)
{
	int counter;
	void *alloc_ptr;
	
	for(counter = 0;counter < max_num;++counter, ++program_string_ptr) {
		alloc_ptr = malloc(length + 1);
		if(alloc_ptr != NULL) {
			*program_string_ptr = (char *)alloc_ptr;
			**program_string_ptr = '\0';
		} else {
			break;
		}
	}
	return(counter);
}

/***************************************************************************
 *	make_dummy_toc: ƥѤΣãľTOCˤؿ
 *	
 *		void make_dummy_toc(struct cd_toc *toc_ptr);
 *	
 *		struct cd_toc *toc_ptr;		ƥѤTOC 뤿ΥХåե
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void make_dummy_toc(struct cd_toc *toc_ptr)
{
	int i;
	struct cd_time time_data = {0, 0, 0};

	toc_ptr->type = 0x03;
	toc_ptr->s_track = 1;
	toc_ptr->e_track = 99;
	for(i = 0;i < 99;++i) {
		time_data.minute = ((i / 4) | ((i & 1)?(0x80):(0x00)));
		time_data.second = ((i & 3) * 15);
		toc_ptr->track[i] = time_data;
	}
	time_data.second = 59;
	time_data.minute &= 0x7f;
	toc_ptr->total = time_data;
}

/***************************************************************************
 *	ErrorPopUp: 顼åΥݥåסåסɥɽ
 *	
 *		void ErrorPopUp(Widget pShell, Widget mess_w, 
 *					Widget area, Widget popdown, const char *message_ptr);
 *	
 *		Widget pShell;			ݥåץåפ륷롦å
 *		Widget mess_w;			åɽ٥롦å
 *		Widget area;
 *		Widget popdown;
 *		const char *message_ptr;	å
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ErrorPopUp(Widget pShell, Widget mess_w, 
					Widget area, Widget popdown, const char *message_ptr)
{
	Widget parent_w;
	Position x = 0, y = 0;
	Dimension width, height;
	void XtMoveWidget(Widget , Position, Position);
	Dimension popupButtonWidth, errorAreaWidth;

	/*******************************************************************
	 *	顼åݥåסåסɥΰ֤
	 *		ƥåȤ礭̴˺ɸѴ
	 *		ʤΤȤݥåץåפԲĻ
	 *******************************************************************/
	parent_w = XtParent(pShell);
	if(parent_w != NULL) {
		XtVaGetValues(parent_w, XtNwidth, &width, XtNheight, &height, NULL);
		XtTranslateCoords(parent_w, 	/* Widget */
				(Position) width/2, 	/* x */
				(Position) height/2,	/* y */
				&x, &y); 				/* coords on root window */
	}
	XtVaSetValues(pShell, XtNx, x, XtNy, y,NULL);	/*  */
	/*****************************
	 *	顼å
	 *****************************/
	XtVaSetValues(mess_w, XtNlabel, message_ptr, NULL);
	/*************************************
	 *	ݥåץåסޥåפ
	 *************************************/
	XtMoveWidget(pShell, x, y);
	XtPopup(pShell, XtGrabExclusive);
	/***********************************************
	 *	顼åݥåסåס
	 *	ɥĤܥ򥻥󥿥󥰤
	 ***********************************************/
	XtVaGetValues(popdown, XtNwidth, &popupButtonWidth, NULL);
	XtVaGetValues(mess_w, XtNwidth, &errorAreaWidth, NULL);
	XtVaSetValues(mess_w, XtNinternalWidth, 4, NULL);
	XawFormDoLayout(area, False);
	XtVaSetValues(mess_w, XtNinternalWidth, 2, NULL);
	XtVaSetValues(popdown, 
		XtNhorizDistance, (errorAreaWidth - popupButtonWidth) / 2, NULL);
	XawFormDoLayout(area, True);
#ifdef	DEBUG
	printf("errorAreaWidth = %d, popdownButtonWidth = %d, NewPos = %d", 
				errorAreaWidth, popupButtonWidth, 
				(errorAreaWidth - popupButtonWidth) / 2);
#endif	/*DEBUG*/
#ifdef	DEBUG
	XtVaGetValues(popdown, XtNx, &popupButtonWidth, NULL);
	printf(" -> %d\n", popupButtonWidth);
#endif	/*DEBUG*/
}

/***************************************************************************
 *	PopupMessage: ꤵ줿åݥåץåסɥɽ
 *	
 *		void PopupMessage(const char *message);
 *	
 *		const char *message;	Ϥå
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void PopupMessage(const char *message)
{
	ErrorPopUp(pErrorShell, errorMessage, errorArea, errorPopdown, message);
}

/***************************************************************************
 *	PopupSyserrMessage: ꤵ줿ƥࡦ顼åɽ
 *	
 *		void PopupSyserrMessage(const char *left_message);
 *	
 *		const char *left_message;	¦ɲäå
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void PopupSyserrMessage(const char *left_message)
{
	char message_buffer[1024];

	sprintf(message_buffer, "%s:%s", left_message, strerror(errno));
	ErrorPopUp(pErrorShell, errorMessage, errorArea, errorPopdown, message_buffer);
}

#ifdef OLD_IMPREMENT
/***************************************************************************
 *	PopupCddaerrMessage: ꤵ줿ãĴطΥ顼åɽ
 *	
 *		void PopupCddaerrMessage(const char *left_message);
 *	
 *		const char *left_message;	¦ɲäå
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void PopupCddaerrMessage(const char *left_message)
{
	char message_buffer[1024];
	extern char *CddaErrorMessage;

	if(left_message == NULL) {
		left_message = "";
	}
	sprintf(message_buffer, "%s%s: %s", 
				left_message, CddaErrorMessage, strerror(errno));
	ErrorPopUp(pErrorShell, errorMessage, errorArea, errorPopdown, message_buffer);
}

#else

void PopupCddaerrMessage(const char *left_message)
{
	const char *buttonMessageArray[2];
	const char *buttonMessages[] = {"OK", NULL};
	extern char *CddaErrorMessage;

	buttonMessageArray[0] = keyword2mes(buttonMessages[0]);
	buttonMessageArray[1] = NULL;

	messengerPrintf(XtParent(pErrorShell), NULL, NULL, NULL, 
						buttonMessageArray, "%s%s: %s", 
						left_message, CddaErrorMessage, strerror(errno));
	return;
}
#endif /*OLD_IMPREMENT*/

/***************************************************************************
 *	popdownErrorShell: 顼ݥåץåפݥåץ󤹤
 *	
 *		void popdownErrorShell(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;	顼ݥåץåס롦å
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void popdownErrorShell(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget pErrorShell = (Widget)client_data;
	
	XtPopdown(pErrorShell);
}

/***************************************************************************
 *	VersionPopup: versionSehllݥåץåפ
 *	
 *		void VersionPopup(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;	顼ݥåץåס롦å
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void VersionPopup(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget parent_w;
	Position x = 0, y = 0;
	Dimension width, height;

	/*******************************************************************
	 *	顼åݥåסåסɥΰ֤
	 *		ƥåȤ礭̴˺ɸѴ
	 *		ʤΤȤݥåץåפԲĻ
	 *******************************************************************/
	parent_w = XtParent(versionShell);
	if(parent_w != NULL) {
		XtVaGetValues(parent_w, XtNwidth, &width, XtNheight, &height, NULL);
		XtTranslateCoords(parent_w, 	/* Widget */
				(Position) width/2, 	/* x */
				(Position) height/2,	/* y */
				&x, &y); 				/* coords on root window */
	}
	XtVaSetValues(versionShell, XtNx, x, XtNy, y,NULL);	/*  */
	XtPopup(versionShell, XtGrabExclusive);
}

/***************************************************************************
 *	version_init: 顼åݥåץåפ
 *	
 *		void version_init(XtAppContext app_context, Widget topLevel, Pixmap pixmap);
 *	
 *		XtAppContext app_context;	ץꥱ󡦥ƥ
 *		Widget topLevel;			Ǿ̤Υå
 *		Pixmap pixmap;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void version_init(XtAppContext app_context, Widget topLevel, Pixmap pixmap)
{
	Dimension popupButtonWidth, errorAreaWidth;
	
	versionShell = XtCreatePopupShell(
			"pVersionShell", 
			transientShellWidgetClass,
			topLevel,
			NULL,
			0
			);
	versionArea = XtVaCreateManagedWidget(
			"versionArea", 
			formWidgetClass,
			versionShell,
			NULL
			);
	versionMessage = XtVaCreateManagedWidget(
			"versionMessage", 
			labelWidgetClass,
			versionArea, 
			XtNleftBitmap, pixmap,
			XtNheight, 36,
			XtNlabel, "  mwxcd:  "MWXCD_VERSION"  1999/08/16", 
			NULL
			);
	versionPopdown = XtVaCreateManagedWidget(
			"versionPopdown", 
			commandWidgetClass,
			versionArea,
			NULL
			);

	XtVaGetValues(versionPopdown, XtNwidth, &popupButtonWidth, NULL);
	XtVaGetValues(versionMessage, XtNwidth, &errorAreaWidth, NULL);
	XtVaSetValues(versionPopdown, 
			XtNhorizDistance, (errorAreaWidth - popupButtonWidth) / 2, NULL);
	XtAddCallback(versionPopdown, XtNcallback, popdownErrorShell, versionShell);
}

/***************************************************************************
 *	cerror_init: 顼åݥåץåפ
 *	
 *		void cerror_init(XtAppContext app_context, Widget topLevel);
 *	
 *		XtAppContext app_context;	ץꥱ󡦥ƥ
 *		Widget topLevel;			Ǿ̤Υå
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void cerror_init(XtAppContext app_context, Widget topLevel)
{
	pErrorShell = XtCreatePopupShell(
			"pErrorShell", 
			transientShellWidgetClass,
			topLevel,
			NULL,
			0
			);
	errorArea = XtVaCreateManagedWidget(
			"errorArea", 
			/*panedWidgetClass,*/
			formWidgetClass,
			pErrorShell,
			NULL
			);
	errorMessage = XtVaCreateManagedWidget(
			"errorMessage", 
			labelWidgetClass,
			errorArea, 
			NULL
			);
	errorPopdown = XtVaCreateManagedWidget(
			"errorPopdown", 
			commandWidgetClass,
			errorArea,
			NULL
			);
	XtAddCallback(errorPopdown, XtNcallback, popdownErrorShell, pErrorShell);
}

/*#define	MAX_TRACKS_DEBUG*/
/***************************************************************************
 *	cdda_init: ãġģطν
 *	
 *		void cdda_init(void);
 *	
 *		
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void cdda_init(void)
{
	int status;
	int flag = FALSE;
	struct cd_subq subq;
	void make_cd_menu(struct cd_toc *toc);
	struct cdda_play my_play;

	if(app_data.cdl_file != NULL) {
		DiscData_ptr = MakeDiscsData(app_data.cdl_file, app_data.space_delete);
		cdlFileEncode = isCdlCodeset(DiscData_ptr);
	}
	ProgramMaxNum = 
		alloc_program_list(ProgramStrings, ProgramStrlen, ProgramMax);

	if(cd_status2(&subq) != EOF) {
		flag = TRUE;
		CdTrack = subq.track;
	} else {
		PlayingMode = STOP;
		CdTrack = 1;
		XtVaSetValues(cdTitle, XtNlabel, cdljc(CurrentDisc_ptr->cdTitle), NULL);
	}
	status = get_toc(&CddaToc);
#ifdef	MAX_TRACKS_DEBUG
	make_dummy_toc(&CddaToc);
#endif	/*MAX_TRACKS_DEBUG*/
	if(status >= 0) {
		CurrentDisc_ptr = SearchDiscData(EOF, DiscData_ptr, &CddaToc);
		if(CurrentDisc_ptr != NULL) {
			MakeDiscInfomation(CurrentDisc_ptr, &CddaToc);
			CurrentDiscFlag = TRUE;
		} else {
			CurrentDisc_ptr = 
					MakeNewDiscData(&CddaToc, app_data.space_delete);
			MakeDiscInfomation(CurrentDisc_ptr, &CddaToc);
			CurrentDiscFlag = FALSE;
		}
		make_cd_menu(&CddaToc);
		/**************************
		 *	track_list(&CddaToc);
		 **************************/
		NormalPlayOrder_ptr = MakeNormalPlayOrders(0, &CddaToc);
		CdOrder_ptr = track_order_search(CdTrack, NormalPlayOrder_ptr);

		if(flag != FALSE && CdOrder_ptr != NULL) {
			my_play = CdOrder_ptr->play_info;
			my_play.start = subq.time;
			my_play.count = 1;
			cd_play2(&my_play);
			XtVaSetValues(play, XtNstate, True, NULL);
			PlayingMode = PLAY;
			Cdda_info = my_play;
			XtVaSetValues(cdTitle, XtNlabel, 
				cdljc((CurrentDisc_ptr->track_ptr+CdTrack)->trackTitle), NULL);
		}
	}
	ProgramClear(NULL, NULL, NULL);		/* ץ */
	error_control((status >= 0)?(True):(False));

	track_set(CdTrack);
}

/***************************************************************************
 *	quit_child_pocess: ҥץexit()ˤ롢ߤwait()
 *	
 *		void quit_child_pocess(int sig);
 *	
 *		int sig;
 *	֤
 *		
 *	
 *		TIFF ʤɤβӥ奢ӥץˤʤΤɤ
 *		
 ***************************************************************************/
void quit_child_pocess(int sig)
{
	int pid;
	int status;

	pid = wait(&status);
#ifdef	TIFF_DEBUG
	printf(">>>> Wait: %3d.\n", pid);
#endif	/*TIFF_DEBUG*/
	ViwerPid = 0;
}

/***************************************************************************
 *	LabelPixmaps: ٥ѤΥԥޥåפޤ
 *	
 *		void LabelPixmaps(Display *display, Drawable drawable);
 *	
 *		Display *display;
 *		Drawable drawable;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void LabelPixmaps(Display *display, Drawable drawable)
{
	mark = XCreateBitmapFromData(display, drawable, 
			xlogo11_bits, xlogo11_width, xlogo11_height);

	no_marked = XCreateBitmapFromData(display, drawable, 
			no_marked_bits, no_marked_width, no_marked_height);

	marked = XCreateBitmapFromData(display, drawable, 
			marked_bits, marked_width, marked_height);

	eject_pixmap = XCreateBitmapFromData(display, drawable, 
			eject_bits, eject_width, eject_height);

	ejectDisable_pixmap = XCreateBitmapFromData(display, drawable, 
			ejectDisable_bits, ejectDisable_width, ejectDisable_height);

	rew_pixmap = XCreateBitmapFromData(display, drawable, 
			rew_bits, rew_width, rew_height);

	play_pixmap = XCreateBitmapFromData(display, drawable, 
			play_bits, play_width, play_height);

	ff_pixmap = XCreateBitmapFromData(display, drawable, 
			ff_bits, ff_width, ff_height);

	stop_pixmap = XCreateBitmapFromData(display, drawable, 
			stop_bits, stop_width, stop_height);

	pause_pixmap = XCreateBitmapFromData(display, drawable, 
			pause_bits, pause_width, pause_height);

	cd_case_pixmap = XCreateBitmapFromData(display, drawable, 
			cd_case_bits, cd_case_width, cd_case_height);

	diskMark = XCreateBitmapFromData(display, drawable, 
			floppy_bits, floppy_width, floppy_height);

	diskDisable = XCreateBitmapFromData(display, drawable, 
			floppy_m_bits, floppy_m_width, floppy_m_height);

	vdown_pixmap = XCreateBitmapFromData(display, drawable, 
			vdown_bits, vdown_width, vdown_height);

	vup_pixmap = XCreateBitmapFromData(display, drawable, 
			vup_bits, vup_width, vup_height);

	vdwDisablePixmap = XCreateBitmapFromData(display, drawable, 
			vdwDisable_bits, vdwDisable_width, vdwDisable_height);

	vupDisablePixmap = XCreateBitmapFromData(display, drawable, 
			vupDisable_bits, vupDisable_width, vupDisable_height);

	trackDecPixmap = XCreateBitmapFromData(display, drawable, 
			trackDec_bits, trackDec_width, trackDec_height);

	trackIncPixmap = XCreateBitmapFromData(display, drawable, 
			trackInc_bits, trackInc_width, trackInc_height);

	getSize = XCreateBitmapFromData(display, drawable, 
			rectsiz_bits, rectsiz_width, rectsiz_height);

	maxLock = XCreateBitmapFromData(display, drawable, 
			maxLock_bits, maxLock_width, maxLock_height);
}

/***************************************************************************
 *	mwxcd_usage: ˡɽ
 *	
 *		void mwxcd_usage(const char *program);
 *	
 *		const char *program;	裰ʥץ̾
 *	
 *		
 ***************************************************************************/
void mwxcd_usage(const char *program)
{
	fprintf(stderr,"\nmwxcd %s\n", MWXCD_VERSION);
	fprintf(stderr,"\n%s:%s\n", keyword2mes("USAGE"), program);
	fprintf(stderr,"       %s [%s] [%s]\n", 
			program, keyword2mes("OPTION"), keyword2mes("TKOPTION"));
	fprintf(stderr,"%s\n", keyword2mes("MOPTION"));
	fprintf(stderr,"\t[-dev %s] : %s\n", 
			keyword2mes("DEVICE"), keyword2mes("SET_USE_CDROM"));
			/* SET_USE_CDROM:CD-ROM ɥ饤֤ΥǥХեꤷޤ */
	fprintf(stderr,"\t[-cdio %s] : %s\n", 
			keyword2mes("CD_IO_TYPE"), keyword2mes("SET_CD_IO_TYPE"));
			/* SET_CD_IO_TYPE:CD-ROM ɥ饤֤I/O μ̤TownsOld/TownsExt/GENERAL椫ꤷޤ */
	fprintf(stderr,"\t[-mixer %s] : %s\n", 
			keyword2mes("DEVICE"), keyword2mes("SET_USE_MIXER"));
			/* SET_USE_MIXER:ߥΥǥХեꤷޤ */
	fprintf(stderr,"\t[-cdl %s] : %s\n", 
			keyword2mes("CDLFILE"), keyword2mes("SET_CDLFILE"));
			/* SET_CDLFILE:CDL եꤷޤ */
#ifdef	TOWNS
	fprintf(stderr,"\t[-towns] [%s]\n", keyword2mes("TOWNSOPT"));
			/* TOWNSOPT:TOWNS ѵǽѤ롣 */
	fprintf(stderr,"\t[-notowns] [%s]\n", keyword2mes("NOTOWNSOPT"));
			/* NOTOWNSOPT:TOWNS ѵǽѤʤ */
#endif	/*TOWNS*/
	fprintf(stderr,"\t[-h or --help] : %s\n", 
			keyword2mes("PRINT_HELP"));
			/* PRINT_HELP: Υإפɽޤ */
	fprintf(stderr,"\n%s\n\n", keyword2mes("OTHEROPT"));
			/* OTHEROPT: 嵭ʳεǽϡ饤ޥ˥奢ʤɤ򻲾ȤƤ */
}

/***************************************************************************
 *	main: ᥤؿ
 *	
 *		int main(int argc, char **argv);
 *	
 *		int argc;
 *		char **argv;
 *	֤
 *		
 *	
 *		mwxcd [-Toolkit Option]
 *		
 ***************************************************************************/
int main(int argc, char **argv)
{
	XtAppContext app_context;
	Widget area, menuArea, cBlock, dBlock, displays;
	Widget volumeArea, volumeUp, volumeDown;
	Widget cd_panel, stop, rew, ff;
	int RewSearchCounter;
	int FfSearchCounter;
	int trackmenu_counter;
	void make_cd_menu(struct cd_toc *toc);
	void cdmenu_init(XtAppContext app_context, Widget area);
	void cmenu_init(XtAppContext app_context, 
					Widget topLevel, Widget cd_panel, Widget box);
	extern char *CdDevice;
	/*struct lconv *localeInfo;*/
	char mwxcdTitle[256];
	char program[40];

	sprintf(program, "%.*s", (int)sizeof(program) - 1, *argv);
	XtSetLanguageProc(NULL, NULL, NULL);
	/*localeInfo = localeconv();*/

	topLevel = XtVaAppInitialize(
		&app_context, 				/* Application context */
		"Mwxcd", 					/* Application class */
		options, XtNumber(options), /* command line */
		&argc, argv,				/* command line args */
		NULL, 						/* for missing app-defaults file */
		NULL);						/* terminate varargs list */

	/*printf("Locale = %s\n", setlocale(LC_ALL, NULL));*/
	/*printf("Locale = %s\n", setlocale(LC_CTYPE, NULL));*/

	/* CDDA ioctl() Υפʸ󤫤Ѵ륳СϿ */
	XtAppSetTypeConverter(app_context, XtRString, 
				XtRCdIoctl, CddaIoTypeConverter, NULL, 0, XtCacheNone, NULL);

	XtGetApplicationResources(topLevel, 
		&app_data, 
		resources, 
		XtNumber(resources), 
		NULL, 
		0);

	LabelPixmaps(XtDisplay(topLevel), RootWindowOfScreen(XtScreen(topLevel)));
	
	CdDevice = app_data.cdDevice;	/* CD-ROM ɥ饤֤ΥǥХ̾ */
	ProgramSongTitle = app_data.program_song_title;
									/* ץζ̾ɽˤĤ */
	
#ifdef	OLD_VOLUME
	set_volume( CDDA_Left,  get_volume(CDDA_Left));
	volmue_enable_flag = 
		((set_volume(CDDA_Right, get_volume(CDDA_Right)) == EOF)?(False):(True));
#endif	/*OLD_VOLUME*/

	area = XtVaCreateManagedWidget(
		"area", 			/* arbitrary widget name */
		panedWidgetClass,	/* widget class from Form.h */
		topLevel,	 		/* parent widget */
		NULL);				/* tarminate varargs list */

	menuArea = XtVaCreateManagedWidget(
		"menuArea", 		/* arbitrary widget name */
		formWidgetClass,	/* widget class from Form.h */
		area,		 		/* parent widget */
		NULL);				/* tarminate varargs list */

	cdmenu_init(app_context, menuArea);

	cdTitle = XtVaCreateManagedWidget(
		"cdTitle", 			/* arbitrary widget name */
		labelWidgetClass,	/* widget class from Label.h */
		area,		 		/* parent widget */
		XtNlabel, "CD Title", 
		NULL);				/* tarminate varargs list */

	cBlock = XtVaCreateManagedWidget(
		"cBlock", 			/* arbitrary widget name */
		panedWidgetClass,	/* widget class from Form.h */
		area,		 		/* parent widget */
		NULL);				/* tarminate varargs list */

	dBlock = XtVaCreateManagedWidget(
		"dBlock", 			/* arbitrary widget name */
		panedWidgetClass,	/* widget class from Form.h */
		cBlock,	 			/* parent widget */
		NULL);				/* tarminate varargs list */

	displays = XtVaCreateManagedWidget(
		"displays", 		/* arbitrary widget name */
		panedWidgetClass,	/* widget class from Form.h */
		dBlock,	 			/* parent widget */
		NULL);				/* tarminate varargs list */

	track = XtVaCreateManagedWidget(
		"track", 			/* arbitrary widget name */
		labelWidgetClass,	/* widget class from Label.h */
		displays,	 		/* parent widget */
		NULL);				/* tarminate varargs list */

	counter = XtVaCreateManagedWidget(
		"counter", 			/* arbitrary widget name */
		commandWidgetClass,	/* widget class from Command.h */
		displays,	 		/* parent widget */
		XtNlabel, "Stop",
		NULL);				/* tarminate varargs list */

	volumeArea = XtVaCreateManagedWidget(
		"volumeArea", 		/* arbitrary widget name */
		/*formWidgetClass,*/	/* widget class from Form.h */
		panedWidgetClass,		/* widget class from Box.h */
		dBlock,		 		/* parent widget */
		NULL);				/* tarminate varargs list */

	vol = XtVaCreateManagedWidget(
		"volume",		 	/* arbitrary widget name */
		commandWidgetClass,	/* widget class from Command.h */
		volumeArea,		 	/* parent widget */
		NULL);				/* tarminate varargs list */

	volumeDown = XtVaCreateManagedWidget(
		"volumeDown",	 	/* arbitrary widget name */
		repeaterWidgetClass,	/* widget class from Repeater.h */
		volumeArea,	 		/* parent widget */
		NULL);				/* tarminate varargs list */

	volumeUp = XtVaCreateManagedWidget(
		"volumeUp",	 		/* arbitrary widget name */
		repeaterWidgetClass,	/* widget class from Repeater.h */
		volumeArea,		 	/* parent widget */
		NULL);				/* tarminate varargs list */

	cd_panel = XtVaCreateManagedWidget(
		"panel", 			/* arbitrary widget name */
		formWidgetClass,	/* widget class from Form.h */
		area,		 		/* parent widget */
		NULL);				/* tarminate varargs list */

	cmenu_init(app_context, topLevel, cd_panel, menuArea);

	eject = XtVaCreateManagedWidget(
		"eject", 			/* widget name */
		toggleWidgetClass,	/* widget class from Toggle.h */
		cd_panel, 			/* parent widget */
		NULL);				/* tarminate varargs list */

	rew = XtVaCreateManagedWidget(
		"rew", 				/* arbitrary widget name */
		repeaterWidgetClass,	/* widget class from Command.h */
		cd_panel,	 		/* parent widget */
		NULL);				/* tarminate varargs list */

	play = XtVaCreateManagedWidget(
		"play", 			/* arbitrary widget name */
		toggleWidgetClass,	/* widget class from Command.h */
		cd_panel,	 		/* parent widget */
		NULL);				/* tarminate varargs list */

	ff = XtVaCreateManagedWidget(
		"ff", 				/* arbitrary widget name */
		repeaterWidgetClass,	/* widget class from Command.h */
		cd_panel,		 	/* parent widget */
		NULL);				/* tarminate varargs list */

	stop = XtVaCreateManagedWidget(
		"stop", 			/* arbitrary widget name */
		commandWidgetClass,	/* widget class from Command.h */
		cd_panel,		 	/* parent widget */
		NULL);				/* tarminate varargs list */

	pauseButton = XtVaCreateManagedWidget(
		"pause", 			/* arbitrary widget name */
		toggleWidgetClass,	/* widget class from Toggle.h */
		cd_panel,		 	/* parent widget */
		NULL);				/* tarminate varargs list */

	repeatModeBox = XtVaCreateManagedWidget(
		"repeatModeBox",	/* arbitrary widget name */
		panedWidgetClass,	/* widget class from Box.h */
		cBlock,				/* parent widget */
		NULL);				/* tarminate varargs list */

	repeatoff = XtVaCreateManagedWidget(
		"repeatoff",		/* arbitrary widget name */
		toggleWidgetClass,	/* widget class from Toggle.h */
		repeatModeBox,		/* parent widget */
		NULL);				/* tarminate varargs list */

	repeatall = XtVaCreateManagedWidget(
		"repeatall", 		/* arbitrary widget name */
		toggleWidgetClass,	/* widget class from Toggle.h */
		repeatModeBox,	 	/* parent widget */
		NULL);				/* tarminate varargs list */

	OrderControl = XtVaCreateManagedWidget(
		"orderControl", 	/* arbitrary widget name */
		toggleWidgetClass,	/* widget class from Toggle.h */
		menuArea,		 	/* parent widget */
		NULL);				/* tarminate varargs list */

	fileDialogInit(topLevel);
	cerror_init(app_context, topLevel);

	XtAddCallback(counter, XtNcallback,  Counter, 0);
	XtAddCallback(volumeDown, XtNcallback, MainVolumeDown, vol);
	XtAddCallback(volumeUp, XtNcallback, MainVolumeUp, vol);
	XtAddCallback(vol, XtNcallback, ChangeVolumeDev, 0);
	XtAddCallback(eject, XtNcallback, Eject, 0);
	XtAddCallback( play, XtNcallback,  Play, 0);
	XtAddCallback(  rew, XtNcallback,  SearchBackward, &RewSearchCounter);
	XtAddCallback(  rew, XtNstopCallback,   Rew, &RewSearchCounter);
	XtAddCallback(  rew, XtNstartCallback, SearchInitiaize, &RewSearchCounter);
	XtAddCallback(   ff, XtNcallback,   SearchForward, &FfSearchCounter);
	XtAddCallback(   ff, XtNstartCallback, SearchInitiaize, &FfSearchCounter);
	XtAddCallback(   ff, XtNstopCallback,    Ff, &FfSearchCounter);

	XtAddCallback( stop, XtNcallback,  Stop, 0);
	XtAddCallback(pauseButton, XtNcallback, Pause, 0);
	XtAddCallback(repeatoff, XtNcallback, RepeatMode, &RepeatModeOff);
	XtAddCallback(repeatall, XtNcallback, RepeatMode, &RepeatModeOn);
	XtAddCallback(OrderControl, XtNcallback, ControlMode, 0);
	ControlMode(OrderControl, NULL, NULL);

	/*XtVaSetValues(topLevel, XtNwidth, 320, NULL);*/
	/*XtVaSetValues(cd_panel, XtNwidth, 252, NULL);*/
	XawToggleChangeRadioGroup(repeatall, repeatoff);
#ifdef	TEST
#endif	/*TEST*/

	for(trackmenu_counter = 0;
			trackmenu_counter < 100;++trackmenu_counter) {
		TrackNumbers[trackmenu_counter] = trackmenu_counter;
	}

	jaEncodeType();
	cdda_init();
	makeDiscWords();
#ifdef	TEST
	{
		int counter;
		extern String printableWordList[];
		extern String printableWordArray[];
		int limit = arrayCount((XtPointer)printableWordList);

		for(counter = 0;counter <= limit;++counter) {
			printf("#%d:[%p]:%s\n", counter, 
				printableWordArray[counter], printableWordArray[counter]);
		}
	}
#endif	/*TEST*/
	version_init(app_context, topLevel, cd_case_pixmap);
#ifndef	VIWER
	TiffViewerCall = app_data.tiffViewer;
#endif	/*VIWER*/
	TiffSuffixList = strings_make(app_data.tiffSuffix);
#ifdef	TEST
	{
		int counter;
		extern String printableWordList[];
		extern String printableWordArray[];
		int limit = arrayCount((XtPointer)printableWordList);

		for(counter = 0;counter <= limit;++counter) {
			printf("#%d:[%p]:%s\n", counter, 
				printableWordArray[counter], printableWordArray[counter]);
		}
	}
#endif	/*TEST*/

	XtVaSetValues(repeatoff, XtNleftBitmap, no_marked, NULL);
	XtVaSetValues(repeatall, XtNleftBitmap, marked, NULL);

	XtVaSetValues(topLevel, XtNiconPixmap, cd_case_pixmap, NULL);
	XtVaSetValues(eject, XtNbitmap, eject_pixmap, NULL);
	XtVaSetValues(rew, XtNbitmap, rew_pixmap, NULL);
	XtVaSetValues(play, XtNbitmap, play_pixmap, NULL);
	XtVaSetValues(ff, XtNbitmap, ff_pixmap, NULL);
	XtVaSetValues(stop, XtNbitmap, stop_pixmap, NULL);
	XtVaSetValues(pauseButton, XtNbitmap, pause_pixmap, NULL);
	XtVaSetValues(volumeDown, XtNbitmap, vdown_pixmap, NULL);
	XtVaSetValues(volumeUp, XtNbitmap, vup_pixmap, NULL);
	/*XtVaSetValues(topLevel, XtNiconPixmap, rew_pixmap, NULL);*/
	XtSetSensitive(vol, volmue_enable_flag);
	XtSetSensitive(volumeDown, volmue_enable_flag);
	XtSetSensitive(volumeUp, volmue_enable_flag);
	if(volmue_enable_flag == False) {
		XtVaSetValues(volumeDown, XtNbitmap, vdwDisablePixmap, NULL);
		XtVaSetValues(volumeUp, XtNbitmap, vupDisablePixmap, NULL);
	}
	ChangeVolumeLabel();
#ifdef	TEST
	{
		int counter;
		extern String printableWordList[];
		extern String printableWordArray[];
		int limit = arrayCount((XtPointer)printableWordList);

		for(counter = 0;counter <= limit;++counter) {
			printf("#%d:[%p]:%s\n", counter, 
				printableWordArray[counter], printableWordArray[counter]);
		}
	}
#endif	/*TEST*/

	if(app_data.help) {
		/* -help ץ󤬻ꤵ줿Ȥ */
		mwxcd_usage(program);
		exit(0);
	}
	if(Interval > 0) {
		Interval *= 1000;
		if(PlayingMode == PLAY) {
			CounterControl(CounterMode, NULL);
			XtSetSensitive(OrderControl, False);
		}
	}
	XtRealizeWidget(topLevel);
#ifdef	TEST
	{
		int counter;
		extern String printableWordList[];
		extern String printableWordArray[];
		int limit = arrayCount((XtPointer)printableWordList);

		for(counter = 0;counter <= limit;++counter) {
			printf("#%d:[%p]:%s\n", counter, 
				printableWordArray[counter], printableWordArray[counter]);
		}
	}
#endif	/*TEST*/
	sprintf(mwxcdTitle, "mwxcd "MWXCD_VERSION" --[%s]", setlocale(LC_CTYPE, NULL));
	XtVaSetValues(topLevel, XtNtitle, mwxcdTitle, NULL);

	currentCDDA = CddaIoTypes[app_data.cdIoctl];
#ifdef	GENERAL
	if(PlayingMode != PLAY) {
		trayManagerOn();
	}
#endif	/*GENERAL*/
	if(RepeatModeFlag == RepeatOff) {
		XtVaSetValues(repeatoff, XtNstate, True, NULL);
		RepeatMode(repeatoff, &RepeatModeOff, NULL);
	} else {
		XtVaSetValues(repeatall, XtNstate, True, NULL);
		RepeatMode(repeatall, &RepeatModeOn, NULL);
	}
#ifdef	NEXT
	wm_delete_window = XInternAtom(XtDisplay(topLevel), 
							"WM_DELETE_WINDOW", False);
	(void) XSetWMProtocols(XtDisplay(topLevel), XtWindow(topLevel), 
							&wm_delete_window, 1);
#endif	/*NEXT*/

#ifdef	NEW_IMPREMENT
	if((fcntl(ConnectionNumber(XtDisplay(topLevel)), F_SETFD, 1)) == -1) {
		fprintf(stderr, "mwxcd: Tiff Viwer is unsable.\n");
		TiffViewerCall = NULL;
	}
#endif	/*NEW_IMPREMENT*/

	if(currentCDDA == NULL) {
		printf("%s\n", keyword2mes("CdIoFatalErr"));
		exit(0);
	}
	XtAppMainLoop(app_context);

	return(0);
}

