/***************************************************************************
 *  mwxcd.h - miner CD Player
 *  
 *          Version 0.8  :   1994/07/16 -- 
 *          Version 1.24 :   1998/10/20 -- 
 *
 *                  Programmed by Nobuyuki Maruichi
 *		Extention:
 *			ץꥱ󡦥꥽ղä
 ***************************************************************************/

#include <stdio.h>
#include <stddef.h>

#include <sys/types.h>

#ifdef	TOWNS
# include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */

#include <X11/Intrinsic.h>  /* Intrinsics Definitions */
#include <X11/StringDefs.h> /* Standard Name-String definitions */
#include <X11/Core.h>		/*  */
#include <X11/Shell.h>

#include "cdda_ext.h"

#ifndef _MXCD_DEFINED
# define _MXCD_DEFINED
# define VERSION_NO		"1.31"
# define MWXCD_VERSION	"Version 1.31"

/* Resources:

 Name                Class              RepType         Default Value
 ----                -----              -------         -------------
 menuBlockPanes		 MenuBlockPanes		int				20
 menuSongTitle		 MenuSongTitle		Boolean			TRUE
 programSongTitle	 ProgramSongTitle	Boolean			TRUE
 discDataFile		 DiscDataFile		String			""
 cdlReadOnly		 CdlReadOnly		Boolean			FALSE
 spaceDelete		 SpaceDelete		Boolean			TRUE
 dataTrackTitle		 DataTrackTitle		String			
 						"<<  DATA TRACK  >>                        "
 backupSuffix		 DataTrackTitle		String			".bak"
 cdDevice			 CdDevice			String			"/dev/cdrom"
 cdDataListResize	 CdListResize		int				15
 programListResize	 CdListResize		int				15
 memoryListResize	 CdListResize		int				15
 tiffDisplayable	 TiffDisplayable	Boolean			FALSE
 tiffDirpath		 TiffDirpath		String			""
 tiffViewer			 TiffViewer			String			""
 tiffSuffix			 TiffSuffix			String			""
 wordsDisplayable	 WordsDisplayable	Boolean			FALSE
 wordsDirpath		 WordsDirpath		String			""
 wordsCoLimit		 WordsCoLimit		int				80
 unitMessage		 UnitMessage		String			NULL
 messages			 Messages			String			NULL
 mixerDevice		 MixerDevice		String			"/dev/mixer"
 labelWidth			 LabelWidth			int				140
 refresh			 Refresh			int				5
 verticalMargin		 VerticalMargin		Int				28
 cdlAutoHeight	 	 AutoHeight			Boolean			TRUE
 wrdAutoHeight		 AutoHeight			Boolean			TRUE
 towns				 Towns				Boolean			TRUE
 help				 Help				Boolean			FALSE
 jencoding			 Jencoding			String			ENCODING_DIR
*/

/*****************************************************
 *	ץꥱ󡦥꥽Υ꥽̾饹̾
 *****************************************************/
#define XtNmenuBlockPanes	"menuBlockPanes"
#define XtCMenuBlockPanes	"MenuBlockPanes"
#define XtNmenuSongTitle	"menuSongTitle"
#define XtCMenuSongTitle	"MenuSongTitle"
#define XtNprogramSongTitle	"programSongTitle"
#define XtCProgramSongTitle	"ProgramSongTitle"
#define XtNdiscDataFile		"discDataFile"
#define XtCDiscDataFile		"DiscDataFile"
#define XtNcdlReadOnly		"cdlReadOnly"
#define XtCCdlReadOnly		"CdlReadOnly"
#define XtNspaceDelete		"spaceDelete"
#define XtCSpaceDelete		"SpaceDelete"
#define XtNdataTrackTitle	"dataTrackTitle"
#define XtCDataTrackTitle	"DataTrackTitle"
#define XtNbackupSuffix		"backupSuffix"
#define XtCBackupSuffix		"BackupSuffix"
#define XtNcdDevice			"cdDevice"
#define XtCCdDevice			"CdDevice"
#define XtNcdIoctl			"cdIoctl"
#define XtCCdIoctl			"CdIoctl"
#define XtRCdIoctl			"CdIoctl"
#define XtNcdlAutoHeight	"cdlAutoHeight"
#define XtNwrdAutoHeight	"wrdAutoHeight"
#define XtCAutoHeight		"AutoHeight"
#define XtNcdDataListResize	"cdDataListResize"
#define XtNprogramListResize	"programListResize"
#define XtNmemoryListResize	"memoryListResize"
#define XtCCdListResize		"CdListResize"
#define XtNtiffDisplayable	"tiffDisplayable"
#define XtCTiffDisplayable	"TiffDisplayable"
#define XtNtiffViewer		"tiffViewer"
#define XtCTiffViewer		"TiffViewer"
#define XtNtiffDirpath		"tiffDirpath"
#define XtCTiffDirpath		"TiffDirpath"
#define XtNtiffSuffix		"tiffSuffix"
#define XtCTiffSuffix		"TiffSuffix"
#define XtNwordsDisplayable	"wordsDisplayable"
#define XtCWordsDisplayable	"WordsDisplayable"
#define XtNwordsDirpath		"wordsDirpath"
#define XtCWordsDirpath		"WordsDirpath"
#define XtNwordsCoLimit		"wordsCoLimit"
#define XtCWordsCoLimit		"WordsCoLimit"
#define XtNverticalMargin	"verticalMargin"
#define XtCVerticalMargin	"VerticalMargin"

#define XtNunitMessage		"unitMessage"
#define XtCUnitMessage		"UnitMessage"
#define XtNmessages			"messages"
#define XtCMessages			"Messages"
#define	XtNmixerDevice		"mixerDevice"
#define	XtCMixerDevice		"MixerDevice"
#define	XtNtowns			"towns"
#define	XtCTowns			"Towns"
#define	XtNhelp				"help"
#define	XtCHelp				"Help"
#define	XtNlabelWidth		"labelWidth"
#define	XtCLabelWidth		"LabelWidth"
#define	XtNrefresh			"refresh"
#define	XtCRefresh			"Refresh"
#define	XtNjencoding		"jencoding"
#define	XtCJencoding		"Jencoding"
#define XtNconfigString		"configString"
#define XtCConfigString		"ConfigString"

#define ENCODING_DIR		"ja:ja_JP.eucJP\n\
	ja_JP:ja_JP.eucJP\n\
	ja_JP.ujis:ja_JP.eucJP\n\
	ja_JP.eucJP:ja_JP.eucJP\n\
	Jp_JP:ja_JP.eucJP\n\
	ja_JP.AJEC:ja_JP.eucJP\n\
	ja_JP.EUC:ja_JP.eucJP\n\
	ja_JP.ISO-2022-JP:ja_JP.JIS7\n\
	ja_JP.JIS:ja_JP.JIS7\n\
	ja_JP.jis7:ja_JP.JIS7\n\
	ja_JP.JIS7:ja_JP.JIS7\n\
	ja_JP.mscode:ja_JP.SJIS\n\
	ja_JP.SJIS:ja_JP.SJIS\n\
	japanese:ja_JP.eucJP\n\
	japan:ja_JP.eucJP\n\
	Japanese-EUC:ja_JP.eucJP"

/* data structure for application resources */
typedef struct {
	int menu_panes;
	Boolean menu_song_title;
	Boolean program_song_title;
	String cdl_file;
	Boolean read_only;
	Boolean space_delete;
	String data_track_title;
	String backup_suffix;
	String cdDevice;
	ioType cdIoctl;
	int cdDataListResize;
	int programListResize;
	int memoryListResize;
	Boolean tiffDisplayable;
	String tiffViewer;
	String tiffDirpath;
	String tiffSuffix;
	Boolean wordsDisplayable;
	String wordsDirpath;
	int wordsCoLimit;
#ifndef	TMIXER_NOT_SUPPORT
	String unitMessage;
	String messages;
	String mixerDevice;
	int labelWidth;
	int refresh;
	Dimension verticalMargin;
	Boolean cdlAutoHeight;
	Boolean wrdAutoHeight;
#ifdef TOWNS
	Boolean towns;
#endif /*TOWNS*/
	Boolean help;
#endif	/*TMIXER_NOT_SUPPORT*/
	String jencoding;
	String configString;
} AppData, *AppDataPtr;

/*************
 *	
 *************/
enum CD_PlayingMode {STOP = 0, PLAY, PAUSE};
enum CD_SearchingMode {
	Ready = EOF,		/* åפǤʤ */
	SearchWait=0,		/* ǽΥԤ֤ξ */
	Searching,			/* ξ */
	Skip				/* åԤξ */
};
enum CounterMode {CounterStop, TotalTime, TrackTime};

enum CD_RepeatMode {
	NoRepeat, 
	TotalRepeat,		/* ãΤΥԡ */
	TrackRepeat,		/* ȥåΥԡ */
	ProgramRepeat,		/* ץΥԡ */
};

typedef enum _TrayStatusValues {
	TrayError   = 0x00,
	TrayClosed  = 0x01,
	TrayOpened  = 0x02,
	TrayUnknown = 0x03
} Tray;

#define isTrayClosed(status)	\
					((status == TrayClosed)?(1):-(status==TrayUnknown))
#define isTrayOpened(status)	\
					((status == TrayOpened)?(1):-(status==TrayUnknown))

/***************************************************************************
 *	å
 *		Skipping:	åפϲǽǤʤ֡Stopʤɡ
 *		SearchError:	ư˥顼ȯʥåפʤ
 *		SearchInit:		󥿤ν
 *		SearchWaiting:	Ԥ֡å׾
 ***************************************************************************/
enum _SearchMode2 {
	SkipWaiting = -3, 		/* ³åפǤʤ */
	Skipping = -2, 			/* ưǤʤ֡Stop/Pause */
	SearchError = -1, 		/* ư˥顼ȯ */
	SearchInit = 0, 		/* 󥿤ν */
	SearchWaiting = 1,		/* Ԥ֡å׾ */
};

/***************************************************************************
 *	IntervalData: ԤθƤӽФؿѹ¤
 *	С
 *		int flag;					ॢȸƤӽФؿϿե饰
 *		XtIntervalId intarvalId;	Ͽä
 *		XtPointer client_data;		ؿˤ錄 client_data 
 ***************************************************************************/
typedef struct _IntervalData {
	int flag;
	XtIntervalId intervalId;
	XtPointer client_data;
} IntervalData;

typedef struct _SkippingData {
	struct cdda_play *skipping_play_ptr;
	int *search_counter;
} SkippingData;

extern int JaLoacle;
extern int cdlFileEncode;
extern int (*jcodesets[])(unsigned const char **src_ptr, int old, int *type);
extern int (*jencodes[])(unsigned char *dest_ptr, int code, int old, int type);

#define FALSE 0
#define TRUE 1
#define ProgramMax 100
#define ProgramStrlen 60

#include "cd_data.h"

#ifdef TOWNS
# ifdef GENERAL 
#  define CDDA_IO_TYPE	TownsExtIO
# else
#  define CDDA_IO_TYPE	TownsIO
# endif /* GENERAL*/
#else
# ifdef GENERAL 
#  define CDDA_IO_TYPE	GeneralIO
# endif /*GENERAL*/
#endif /*TOWNS*/

/***************
 *	Prototype
 ***************/
void Quit(Widget w, XtPointer client_data, XtPointer call_data);
void Play(Widget w, XtPointer client_data, XtPointer call_data);
void Pause(Widget w, XtPointer client_data, XtPointer call_data);
void Stop(Widget w, XtPointer client_data, XtPointer call_data);
void CounterControl(int counter_type, char *counter_buffer);
#ifdef OLD
static void SearchBackward(XtPointer client_data, XtIntervalId *id);
static void SearchBackwardAction(Widget w, XEvent *event,
				String *params, Cardinal *num_params);
#endif	/*OLD*/
int SkipBackward(Widget w, XtPointer client_data, XtPointer call_data);
void Rew(Widget w, XtPointer client_data, XtPointer call_data);
#ifdef OLD
void RewStop(Widget w, XEvent *event,
				String *params, Cardinal *num_params);
#endif	/*OLD*/
#ifdef OLD
void RewStop(Widget w, XEvent *event,
static void SearchForward(XtPointer client_data, XtIntervalId *id);
void SearchForwardAction(Widget w, XEvent *event,
				String *params, Cardinal *num_params);
#endif	/*OLD*/
void SkipForward(Widget w, XtPointer client_data, XtPointer call_data);
void Ff(Widget w, XtPointer client_data, XtPointer call_data);
#ifdef OLD
void RewStop(Widget w, XEvent *event,
void FfStop(Widget w, XEvent *event,
				String *params, Cardinal *num_params);
#endif	/*OLD*/
void abnormal_exception(void);
void TrackMenuSelect(Widget w, XtPointer client_data, XtPointer call_data);
void CD_Volume(Widget w, XtPointer client_data, XtPointer call_data);
void VolumeUp(Widget w, XtPointer client_data, XtPointer call_data);
void VolumeDown(Widget w, XtPointer client_data, XtPointer call_data);
void playFinished(void);
void MakeProgramOrderList(void);
void ProgramPoint(Widget w, XtPointer client_data, XtPointer call_data);
void ProgramClear(Widget w, XtPointer client_data, XtPointer call_data);
void ProgramJump(Widget w, XtPointer client_data, XtPointer call_data);
void ProgramDelete(Widget w, XtPointer client_data, XtPointer call_data);
void resize_check(Widget w, int panes, int limit);
void error_control(Boolean status);
void ErrorPopUp(Widget pErrorShell, Widget mess_w, 
				Widget area, Widget popdown, const char *message_ptr);
void PopupMessage(const char *message);
void PopupSyserrMessage(const char *left_message);
void PopupCddaerrMessage(const char *left_message);

void track_set(int track_no);

void make_cd_menu(struct cd_toc *toc);
void popdownTrackMenus(int menu_no);
void FlashControl(Widget w, XEvent *event,
							String *params, Cardinal *num_params);
void MakeDiscInfomation(CddaDataForm *disc_data, struct cd_toc *toc);
void releaseDiscData(CddaDataForm *disc_info);
void NewOrderProgram(Cd_Order *new_order);
void DiscData_init(Widget topLevel, Widget cd_panel, Widget popupButton);
void FlashingProgram(void);
void PopdownTargetShell(Widget w, XtPointer client_data, XtPointer call_data);
void MainVolumeUp(Widget w, XtPointer client_data, XtPointer call_data);
void MainVolumeDown(Widget w, XtPointer client_data, XtPointer call_data);
void volume_init(Widget topLevel, Widget popupButton);
void ChangeVolumeLabel(void);
void FlashingDiscData(void);
int isPlayable(int start_track, int end_track, const struct cd_toc *toc);
void compactDiscDataError(void);
void compactDiscOut(void);
void compactDiscIn(void);
void strings_free(char **strings);
char *searchFileName0(const char *dirName, const char *fileName);
char *searchFileName(const char *dirName, 
						const char *fileName, const char **suffixList);
char **strings_make(const char *arg_string);
String backupNameAlloc(const char *filename);
void makeDiscWords(void);
void WordsFlashing(void);
void WordsInit(Widget topLevel, Widget cd_panel, Widget popupButton);
void wordsCompactDiscOut(void);
void wordsCompactDiscIn(void);
void VersionPopup(Widget w, XtPointer client_data, XtPointer call_data);
void LabelPixmaps(Display *display, Drawable drawable);
void quit_child_pocess(int sig);

void ResizeConfig(Widget w, XEvent *event,
							String *params, Cardinal *num_params);
# ifdef	GENERAL
Tray cdTrayStatus(void);
void trayManagerOn(void);
void trayManagerOff(void);
# endif	/*GENERAL*/

int jaEncodeType(void);

int cnv2strlen(const char *src, int srcEncode);
char *jcodecnv(char *dest, size_t length, char *src, int srcEncode);
char **strArray2jcnvAndNew(const char **src_ptr, int srcEncode, int destEncode);

void ChangeVolumeDev(Widget w, XtPointer client_data, XtPointer call_data);

void XmwGetWindowInfo(Widget w, 
					XWindowAttributes *winAttr, XWindowAttributes *rootAttr);
void autoMaxHeight(Widget vWidget);
void XmwCallbackAutoHeight(Widget w, XtPointer client_data, XtPointer call_data);
void XmwCallbackNoneAutoHeight(Widget w, XtPointer client_data, XtPointer call_data);

#define cdljc(string)	jcodecnv(NULL, 0, string, cdlFileEncode)

#endif	/*_MXCD_DEFINED*/

