/***************************************************************************
 *	volueme.c: {[
 *	
 *			Reprogramed by Nobuyuki Maruichi
 *	⑫
 *		͖  Nm(HCB01504)TOWNS PCM [eBeB[̓dq{[
 *		ݒvOɍ쐬܂B
 ***************************************************************************/
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>

#include "vol_ioc.h"

#define NR_CHAN	       6
#define VOL1_CHAN      0x4e1
#define VOL1_DATA      0x4e0
#define VOL2_CHAN      0x4e3
#define VOL2_DATA      0x4e2

#define	FALSE		0
#define	TRUE		1

static const struct {
	int creg;
	int dreg;
	int chan;
	int creg_mask;
	int dreg_mask;
} chan_data[NR_CHAN] = {
	{ VOL1_CHAN, VOL1_DATA, 0, 0x1d, 0x3f},		/* Line in (Left) */
	{ VOL1_CHAN, VOL1_DATA, 1, 0x1d, 0x3f},		/* Line in (Right) */
	{ VOL2_CHAN, VOL2_DATA, 0, 0x1f, 0x3f},		/* CD-DA (Left) */
	{ VOL2_CHAN, VOL2_DATA, 1, 0x1f, 0x3f},		/* CD-DA (Right) */
	{ VOL2_CHAN, VOL2_DATA, 2, 0x1f, 0x3f},		/* Mic */
	{ VOL2_CHAN, VOL2_DATA, 3, 0x1f, 0x3f},		/* Modem */
};

struct volume_info {
	int	flag;
	unsigned char data_reg;
	unsigned char com_reg;
} volume_data[NR_CHAN] = {
	{FALSE, 0, 0},					/* Line in (Left) */
	{FALSE, 0, 0},					/* Line in (Right) */
	{FALSE, 0, 0},					/* CD-DA (Left) */
	{FALSE, 0, 0},					/* CD-DA (Right) */
	{FALSE, 0, 0},					/* Mic */
	{FALSE, 0, 0},					/* Modem */
};

/***************************************************************************
 *	volume_buffering: ANZXdq{[EWX^L^
 *	`
 *		int volume_buffering(int indx, int chan, int vol);
 *	
 *		int indx;		ANZX{[̎
 *		int chan;		{[c`s`WX^
 *		int vol;		{[bnlWX^
 *	
 *		
 ***************************************************************************/
void volume_buffering(int indx, int chan, int vol)
{
	volume_data[indx].flag = TRUE;
	volume_data[indx].data_reg = vol & 0x3f;
	volume_data[indx].com_reg = chan & chan_data[indx].creg_mask;
}

/***************************************************************************
 *	set_volume: {[ݒ肷
 *	`
 *		int set_volume(int indx, int volume_level);
 *	
 *		int indx;				{[ݒ肷Ώ
 *		int volume_level;		|PF~[g
 *								O`URF{[xiʁj
 *								ÔƂA@|RPDTa
 *								UR̂ƂA@@@@Oa
 *								ODTaɐݒ
 *	Ԃl
 *		dneF	G[
 *		OF		I
 *	
 *		@index ɂ́AE_VolumrType 񋓌^̒萔gp
 *		
 *		enum E_VolumrType {
 *			LineIn_Left = 0, LineIn_Right, 
 *			CDDA_Left, CDDA_Right, 
 *			MicIn, ModemOut	
 *		};
 *	QƎ
 *		get_volume();
 ***************************************************************************/
int set_volume(int indx, int volume_level)
#ifdef	TOWNS
{
	int fd;
	char vol;
	char chan;

	if (volume_level >= 0) {
		chan = chan_data[indx].chan | 0x04;
		vol = volume_level;
	} else if (volume_level == -1) {
		chan = chan_data[indx].chan & ~0x04;
		vol = 0;
	}

	if ((fd=open("/dev/port",O_RDWR))<0) {
		return(EOF);
	}

	lseek(fd,chan_data[indx].creg,0);
	write(fd,&chan,1);

	lseek(fd,chan_data[indx].dreg,0);
	write(fd,&vol,1);

	volume_buffering(indx, chan, vol);

	close(fd);

	return(0);
}
#else
{
	return(EOF);
}
#endif	/* TOWNS */

/***************************************************************************
 *	volume_port_status: 擾\ȃ{[E|[g󂯎
 *	`
 *		void volume_port_status(int fd);
 *	
 *		int fd;			g/dev/porth̃t@CEfBXNv^
 *	
 *		@݂̃{[P^{[Q̏擾
 ***************************************************************************/
void volume_port_status(int fd)
{
	unsigned char vol;
	unsigned char chan;

	lseek(fd, VOL1_CHAN, 0);
	read(fd, &chan, 1);
	lseek(fd, VOL1_DATA, 0);
	read(fd, &vol, 1);
	volume_buffering((chan & 0x01) + LineIn_Left, chan, vol);
	lseek(fd, VOL2_CHAN, 0);
	read(fd, &chan, 1);
	lseek(fd, VOL2_DATA, 0);
	read(fd, &vol, 1);
	volume_buffering((chan & 0x03) + CDDA_Left, chan, vol);
}

/***************************************************************************
 *	get_volume_io: {[ǂݎ
 *	`
 *		void get_volume_io(int fd, int indx, 
 *						unsigned char *chan, unsigned char *vol);
 *	
 *		int fd;					g/dev/porth̃t@CEfBXNv^
 *		int indx;				{[ݒ肷Ώ
 *		unsigned char *chan;	{[c`s`WX^
 *		unsigned char *vol;		{[bnlWX^
 *	Ԃl
 *		|QF 			G[
 *		|PF 			~[g
 *		O`URF		{[x
 *								O`URF{[xiʁj
 *								ÔƂA@|RPDTa
 *								UR̂ƂA@@@@Oa
 *								ODTaɐݒ
 *	
 *		@index ɂ́AE_VolumrType 񋓌^̒萔gp
 *	QƎ
 *		set_volume();
 ***************************************************************************/
void get_volume_io(int fd, int indx, unsigned char *chan, unsigned char *vol)
{
	char select_chan;

	lseek(fd,chan_data[indx].creg,0);
	select_chan = chan_data[indx].chan;
	write(fd, &select_chan, 1);

	lseek(fd,chan_data[indx].creg,0);
	read(fd, chan, 1);
	lseek(fd,chan_data[indx].dreg,0);
	read(fd, vol, 1);
	
	if((*vol & 0x3f) == 0x00) {
		select_chan |= 0x04;
		write(fd, &select_chan, 1);
	}
	volume_buffering(indx, *chan, *vol);
}

/***************************************************************************
 *	check_volume_io: {[mF
 *	`
 *		void check_volume_io(int fd, int indx, 
 *						unsigned char *chan, unsigned char *vol);
 *	
 *		int fd;					g/dev/porth̃t@CEfBXNv^
 *		int indx;				{[ݒ肷Ώ
 *		unsigned char chan;		{[c`s`WX^
 *		unsigned char vol;		{[bnlWX^
 *	
 *		@index ɂ́AE_VolumrType 񋓌^̒萔gp
 *	QƎ
 *		set_volume();
 ***************************************************************************/
void check_volume_io(int fd, int indx, 
						unsigned char *chan, unsigned char *vol)
{
	unsigned char chan_work, volume_status;
	
	chan_work = *chan | 0x04;			/* |a */
	lseek(fd, chan_data[indx].creg, 0);
	write(fd, &chan_work, 1);

	lseek(fd, chan_data[indx].creg, 0);
	read(fd, &chan_work, 1);
	lseek(fd, chan_data[indx].dreg, 0);
	read(fd, &volume_status, 1);
	if((volume_status & 0x3f) != 0 && (*chan & 0x04) == 0) {
		lseek(fd, chan_data[indx].creg, 0);
		write(fd, chan, 1);			/* {[bnlWX^߂ */
	}
	volume_buffering(indx, *chan, *vol);
}

#ifdef	BUG_PROGRAM
/***************************************************************************
 *	get_volume: {[ǂݎ
 *	`
 *		int get_volume(int indx);
 *	
 *		int indx;		{[ݒ肷Ώ
 *	Ԃl
 *		|QF 			G[
 *		|PF 			~[g
 *		O`URF		{[x
 *								O`URF{[xiʁj
 *								ÔƂA@|RPDTa
 *								UR̂ƂA@@@@Oa
 *								ODTaɐݒ
 *	
 *		@index ɂ́AE_VolumrType 񋓌^̒萔gp
 *	QƎ
 *		set_volume();
 ***************************************************************************/
int get_volume(int indx)
{
	int fd;
	char vol;
	char chan;

	if ((fd=open("/dev/port", O_RDONLY))<0) {
		return(-2);
	}

	lseek(fd,chan_data[indx].creg,0);
	read(fd,&chan,1);

	lseek(fd,chan_data[indx].dreg,0);
	read(fd,&vol,1);

	if(chan & 0x04) {
		vol &= 0x3f;
	} else {
		vol = -1;
	}
	close(fd);

	return(vol);
}
#endif	/*BUG_PROGRAM*/

/***************************************************************************
 *	get_volume2: {[ǂݎigp^FmFj
 *	`
 *		int get_volume2(int indx);
 *	
 *		int indx;		{[ݒ肷Ώ
 *	Ԃl
 *		dneF 		G[
 *		PQF	|RQatOiPȂ|RQaj
 *		PPF	@OatO@iPȂOaj
 *		POF	~[gEtOiOȂ~[gj
 *		T`OF 		
 *			O`URF		{[x
 *								O`URF{[xiʁj
 *								ÔƂA@|RPDTa
 *								UR̂ƂA@@@@Oa
 *								ODTaɐݒ
 *	
 *		@index ɂ́AE_VolumrType 񋓌^̒萔gp
 *	QƎ
 *		set_volume();
 ***************************************************************************/
int get_volume2(int indx)
#ifdef	TOWNS
{
	int fd;
	char vol;
	char chan;

	if ((fd=open("/dev/port", O_RDWR))<0) {
		return(EOF);
	}
	volume_port_status(fd);
	if(volume_data[indx].flag) {
		vol = volume_data[indx].data_reg & 0x3f;
		chan = volume_data[indx].com_reg & 0x1f;
		check_volume_io(fd, indx, &chan, &vol);
	} else {
		get_volume_io(fd, indx, &chan, &vol);
		vol = volume_data[indx].data_reg & 0x3f;
		chan = volume_data[indx].com_reg & 0x1f;
	}
	volume_buffering(indx, chan, vol);

	close(fd);

	return((vol & 0x3f) | ((chan & 0x1c) << 8));
}
#else
{
	return(EOF);
}
#endif	/* TOWNS */

/***************************************************************************
 *	get_volume: {[ǂݎ
 *	`
 *		int get_volume(int indx);
 *	
 *		int indx;		{[ݒ肷Ώ
 *	Ԃl
 *		|QF 			G[
 *		|PF 			~[g
 *		O`URF		{[x
 *								O`URF{[xiʁj
 *								ÔƂA@|RPDTa
 *								UR̂ƂA@@@@Oa
 *								ODTaɐݒ
 *	
 *		@index ɂ́AE_VolumrType 񋓌^̒萔gp
 *	QƎ
 *		set_volume();
 ***************************************************************************/
int get_volume(int indx)
{
	int volume;
	int volume_status;

	volume_status = get_volume2(indx);
	if((volume_status & MAX_VOLUME) != 0x00) {
		volume = 63;
	} else {
		if((volume_status & MIN_LEVEL) != 0x00) {
			volume = 0;
		} else {
			if((volume_status & MUTE_FLAG) == 0x00) {
				volume = -1;
			} else {
				volume = volume_status & 0x3f;
			}
		}
	}
	return(volume);
}

