/***************************************************************************
 *	tmixer.c: X ΥߥǥХˤܥ塼ޥ
 *	
 *		Date. 1997/03/27 -- 1997/08/16
 *			Programed by Nobuyuki Maruichi
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <endian.h>

/***********************************************
 *	Linux Υɴط󥯥롼ɡե
 ***********************************************/
#include <linux/soundcard.h>
#ifdef TOWNS
# include <linux/townsvol.h>
#endif /*TOWNS*/

/***********************************************
 *	X11R5/6.x δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Xlocale.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

/*****************************************
 * Atena Widget Υ󥯥롼ɡե
 *****************************************/
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/SmeBSB.h>

/*******************************************
 *	ܥ塼ࡦ٥ɽѤΥå
 *******************************************/
#include "Level.h"
#include "luty.h"
#ifndef TMIXER_ONLY
#include "mwxcd.h"
#include "file_sel.h"
#endif /*TMIXER_ONLY*/

/***************************
 *	ӥåȥޥåסե
 ***************************/
#include "bitmaps/vup.xbm"				/*  |: ܥ塼ࡦå */
#include "bitmaps/vdown.xbm"			/* | : ܥ塼ࡦ */
#include "bitmaps/vupDisable.xbm"		/*  |: ܥ塼ࡦå */
#include "bitmaps/vdwDisable.xbm"		/* | : ܥ塼ࡦ */

/***************************************************************************
 *	ǡ
 *		MixerLevel:		ܥ塼٥ѤζΤ
 *		VolumeType:		ܥ塼򼨤
 *		MonauralInfo:	Υܥ塼 GUIѡ
 *		StereoInfo:		ƥ쥪ܥ塼 GUIѡ
 *		MixerChannel:		ܥ塼ѡ֥
 *		MixerUnitInfoProc
 ***************************************************************************/

/*****************************************
 *	ܥ塼٥ѤζΤ
 *****************************************/
#if __BYTE_ORDER == __LITTLE_ENDIAN
typedef union {
	int value;
	struct {
		unsigned char l;
		unsigned char r;
		unsigned short dummy;
	} s;
	unsigned bytes[4];
} MixerLevel;
#else
# error  Sorry. This __BYTE_ORDER is not supported.
#endif /*__BYTE_ORDER == __LITTLE_ENDIAN*/

/***********************************
 *	ܥ塼򼨤
 ***********************************/
typedef enum _volumeType {
	VolumeUndefined = 0, Monaural = 1, Stereo
} VolumeType;

/***************************************
 *	Υܥ塼 GUIѡ
 ***************************************/
typedef struct volume_widgets {
	Widget volumeArea;
	Widget volumeLabel;
	Widget volumeMeter;
	Widget volumeMin;
	Widget volumeMax;
	Widget volumeDown;
	Widget volumeUp;
	const char *levelForm;
} MonauralInfo;

/***************************************
 *	ƥ쥪ܥ塼 GUIѡ
 ***************************************/
typedef struct stereo_volume_widgets {
	Widget volumeArea;
	Widget volumeLeftLabel;
	Widget volumeRightLabel;
	Widget volumeArea1;
	Widget volumeArea2;
	Widget volumeLeftMeter;
	Widget volumeRightMeter;
	Widget volumeSlider;
	Widget volumeMin;
	Widget volumeMax;
	Widget volumeSeparate;
	Widget volumeMute;
	Widget volumeDown;
	Widget volumeUp;
	const char *lLevelForm;
	const char *rLevelForm;
} StereoInfo;

/***********************************
 *	ܥ塼ѡ֥
 ***********************************/
typedef struct MixerParts {
	int volumeType;		
	MonauralInfo *monauralMixer;
	StereoInfo *stereoMixer;		
	int fd;
	int channelNo;
	int ussLevel;
	int min;
	int max;
	int muteLevel;
	const char *baseName;
	void (*create)(struct MixerParts *mixer);
	int (*levelDown)(struct MixerParts *mixer);
	int (*levelUp)(struct MixerParts *mixer);
	int (*refreshLevel)(struct MixerParts *mixer);
	int (*mute)(struct MixerParts *mixer);
	int (*levelSet)(struct MixerParts *mixer, int newLevel);
	void (*labelSet)(struct MixerParts *mixer);
} MixerChannel;

typedef void (*MixerUnitInfoProc)(MixerChannel *mixerUnit);

typedef struct {
	int limit;
	const char **names;
} DeviceNamesInfo;

/***************************************************************************
 *	Хѿ
 *		MixerUnits:			ߥؤΥݥ󥿤Υݥ
 *		vup_pixmap:			ܥ塼ࡦåפΥԥޥå
 *		vdown_pixmap:		ܥ塼ࡦΥԥޥå
 *		vupDisablePixmap:	ܥ塼ࡦåפΥԥޥåסԲġ
 *		vdwDisablePixmap:	ܥ塼ࡦΥԥޥåסԲġ
 *		DeviceNames:		إå줿ǥХ̾
 ***************************************************************************/
MixerChannel **MixerUnits;
Pixmap vup_pixmap, vdown_pixmap, vupDisablePixmap, vdwDisablePixmap;

#define NumberOfArray(array) (sizeof(array)/sizeof(array[0]))

const char *SoundDeviceNames[]   = SOUND_DEVICE_NAMES;
const char *SoundDeviceLabels[]  = SOUND_DEVICE_LABELS;
#ifdef TOWNS
const char *TSoundDeviceNames[]  = TSOUND_DEVICE_NAMES;
const char *TSoundDeviceLabels[] = TSOUND_DEVICE_LABELS;
#endif /*TOWNS*/

#ifdef TOWNS
DeviceNamesInfo DevicesNames[] = {
	{NumberOfArray(TSoundDeviceNames),  TSoundDeviceNames}, 
	{NumberOfArray(TSoundDeviceLabels), TSoundDeviceLabels}, 
	{NumberOfArray(SoundDeviceNames),   SoundDeviceNames}, 
	{NumberOfArray(SoundDeviceLabels),  SoundDeviceLabels}, 
	{0, NULL} 
};
#else
DeviceNamesInfo DevicesNames[] = {
	{NumberOfArray(SoundDeviceNames),  SoundDeviceNames}, 
	{NumberOfArray(SoundDeviceLabels), SoundDeviceLabels}, 
	{0, NULL} 
};
#endif /*TOWNS*/

DeviceNamesInfo *CurrentDevicesNames = DevicesNames;	/* main() ǽ */

void mixerRefresh(MixerChannel *mixerUnit);
#ifdef TOWNS
void unitInfoTowns(MixerChannel *mixerUnit);
#endif /*TOWNS*/
void unitInfo(MixerChannel *mixerUnit);
void unitInfoUSS(MixerChannel *mixerUnit);

typedef struct {
	const char *unitName;
	void (*levelUnit)(MixerChannel *mixerUnit);
} UnitType;

UnitType MixerLevels[] = {
#ifdef TOWNS
	"DECIBEL", unitInfoTowns, 
#endif /*TOWNS*/
	"DECILE", unitInfo, 
	"PERCENTAGE", unitInfoUSS, 
	NULL, NULL
};

#ifndef TMIXER_ONLY
void unitLabel(char *buffer, MixerChannel *mixerUnit);
void unitLabelUSS(char *buffer, MixerChannel *mixerUnit);
#ifdef TOWNS
void unitLabelTowns(char *buffer, MixerChannel *mixerUnit);
#endif /*TOWNS*/

typedef void (*UnitLabelProc)(char *buffer, MixerChannel *mixerUnit);

UnitLabelProc UnitLabels[] = {
#ifdef TOWNS
	unitLabelTowns, 
#endif /*TOWNS*/
	unitLabel, 
	unitLabelUSS, 
	NULL
};

UnitLabelProc CurrentUnitLabel = 
# ifdef TOWNS
	unitLabelTowns;
# else
	unitLabel;
# endif /*TOWNS*/
#endif /*TMIXER_ONLY*/

MessageNode *FallbackDict;
MessageNode *LocaleDict;

#define SOUND_MASK_EFFECT (SOUND_MASK_BASS | SOUND_MASK_TREBLE)
#define	lrVolume(volume)	(((volume) << 8) | (volume))
#define MIN_LEVEL 0
#define MAX_LEVEL 100
#define MEDIUM_LEVEL 50

#define XtNunitMessage	"unitMessage"
#define XtCUnitMessage	"UnitMessage"
#define XtNmessages		"messages"
#define XtCMessages		"Messages"
#define	XtNmixerDevice	"mixerDevice"
#define	XtCMixerDevice	"MixerDevice"
#define	XtNtowns		"towns"
#define	XtCTowns		"Towns"
#define	XtNhelp			"help"
#define	XtCHelp			"Help"
#define	XtNlabelWidth	"labelWidth"
#define	XtCLabelWidth	"LabelWidth"
#define	XtNrefresh		"refresh"
#define	XtCRefresh		"Refresh"

const char *DefaultMessages = 
	"DECIBEL:Display by decibel. [dB]\n"
	"DECILE:Display by decile. [1/10]\n"
	"PERCENTAGE:Display by percentage. [%]";

const char *DefaultLabel = 
	"MIN:Min\n"
	"MAX:Max\n"
	"MUTE:Mute\n"
	"SEPARATE:Separate\n"
	"OFFLINE:[off-line]\n" 
	"ONLINE:[on-line]\n"
	"LEFT:(L) \n"
	"RIGHT:(R) \n"
	"ON:on\n"
	"OFF:off\n"
	"USAGE:Usage\n"
	"DEVICE:device\n"
	"TKOPTION:Toolkit option\n"
	"MIXERERR:Can't use %s.";

#ifdef TMIXER_ONLY
/* data structure for application resources */
typedef struct {
	String unitMessage;
	String messages;
	String mixerDevice;
	int labelWidth;
	int refresh;
#ifdef TOWNS
	Boolean towns;
#endif /*TOWNS*/
	Boolean help;
} AppData, *AppDataPtr;

AppData app_data;

/* resource list */
static XtResource resources[] = {
	{
		XtNunitMessage,
		XtCUnitMessage,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, unitMessage),
		XtRImmediate,
		(XtPointer) NULL
	},
	{
		XtNmessages,
		XtCMessages,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, messages),
		XtRImmediate,
		(XtPointer) NULL
	}, 
	{
		XtNmixerDevice,
		XtCMixerDevice,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, mixerDevice),
		XtRImmediate,
		(XtPointer) "/dev/mixer",
	}, 
	{
		XtNlabelWidth,
		XtCLabelWidth,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, labelWidth),
		XtRImmediate,
		(XtPointer) 140
	},
	{
		XtNrefresh,
		XtCRefresh,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, refresh),
		XtRImmediate,
		(XtPointer) 5
	},
#ifdef TOWNS
	{
		XtNtowns,
		XtCTowns,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, towns),
		XtRImmediate,
		(XtPointer) TRUE,
	},
#endif /*TOWNS*/
	{
		XtNhelp,
		XtCHelp,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, help),
		XtRImmediate,
		(XtPointer) FALSE,
	},
};

/* Command-line options table */
static XrmOptionDescRec options[] = {
	{"-mixer", 		"*mixerDevice", 		XrmoptionSepArg, NULL},
#ifdef TOWNS
	{"-towns", 		"*towns", 				XrmoptionNoArg, "True"},
	{"-notowns", 	"*towns", 				XrmoptionNoArg, "False"},
#endif /*TOWNS*/
	{"-h", 			"*help", 				XrmoptionNoArg, "True"},
	{"--help", 		"*help", 				XrmoptionNoArg, "True"},
};
#else
/***************************************************************************
 *	mwxcd ۻΤ߻
 ***************************************************************************/
AppData app_data;
Widget popdownVolume;

#endif /*TMIXER_ONLY*/

#ifdef TMIXER_ONLY
/***************************************************************************
 *	keyword2mes: ɤϰ貽줿å
 *	
 *		const char *keyword2mes(const char *keyword);
 *	
 *		const char *keyword;
 *	֤
 *		ϰ貽줿å / ǥեȤΥå / 
 *	
 *		ɤϰ貽줿å롣˼Ԥȡ
 *		ǥեȤΥåޤϥɼȤ롣
 ***************************************************************************/
const char *keyword2mes(const char *keyword)
{
	const MessageNode *result = NULL;

	result = messageSearch(LocaleDict, keyword);
	if(result == NULL) {
		result = messageSearch(FallbackDict, keyword);
	}
	if(result == NULL) {
		fprintf(stderr, "Keyword \"%s\" is not found.\n", keyword);
	}
	return((result != NULL)?(result->message):(keyword));
}
#endif /*TMIXER_ONLY*/

#ifdef TOWNS
/***************************************************************************
 *	gainForTowns: TOWNS ȼθΨɽԤʤ
 *	
 *		void gainForTowns(char *string, int volume);
 *	
 *		char *string;	ɽѤʸХåե
 *		int volume;		TOWNS ȼΥܥ塼٥0-65
 *	
 *		TOWNS Υܥ塼˻ȤƤϡɥλͤ TOWNS
 *		ǤϡºǽʤΤϡ66ʳΥܥ塼ࡦ٥Ȥʤޤ
 *		TOWNS ˸¤ä硢Υ٥б븺(dB)狼Τǡ
 *		бǥ٥ͤɽ뤿δؿǤʤߥ塼ȡ̵
 *		ΤȤϡ-[dB] 뤬ɽϡoffɤȤ롣
 ***************************************************************************/
void gainForTowns(char *string, int volume)
{
	if(volume > 0) {
		sprintf(string, "%4.1fdB", (volume - 65) / 2.0);
	} else {
		sprintf(string, "  %s", keyword2mes("OFF"));
	}
}

/***************************************************************************
 *	unitInfoTowns: ġΥǥХβɽTOWNS Τͭ
 *	
 *		void unitInfoTowns(MixerChannel *mixerUnit);
 *	
 *		MixerChannel *mixerUnit;
 *	֤
 *		ʤ
 *	
 *		TOWNS Υܥ塼˻ȤƤϡɥλͤ TOWNS
 *		ǤϡºǽʤΤϡ66ʳΥܥ塼ࡦ٥Ȥʤޤ
 *		TOWNS ˸¤ä硢Υ٥б븺(dB)狼Τǡ
 *		бǥ٥ͤɽ뤿δؿǤʤߥ塼ȡ̵
 *		ΤȤϡ-[dB] 뤬ɽϡoffɤȤ롣
 ***************************************************************************/
void unitInfoTowns(MixerChannel *mixerUnit)
{
	MixerLevel volume;
	int  bitCounter;
	int muteOnly = TOWNS_MUTE_DEVICES;
	char numBuffer[40];
	char levelBuffer[40];
	const char *flag[] = {"OFF", "ON"};

	bitCounter = (0x0001 << mixerUnit->channelNo);
	volume.value = mixerUnit->ussLevel;
	switch(mixerUnit->volumeType) {
	case Monaural:
		if(muteOnly & bitCounter || volume.s.l == 0) {
			sprintf(levelBuffer, mixerUnit->monauralMixer->levelForm, 
						keyword2mes(flag[volume.s.l != mixerUnit->min]));
		} else {
			gainForTowns(numBuffer, USStoTowns66(volume.s.l));
			sprintf(levelBuffer, 
						mixerUnit->monauralMixer->levelForm, numBuffer);
		}
		XtVaSetValues(mixerUnit->monauralMixer->volumeLabel, 
												XtNlabel, levelBuffer, NULL);
		break;
	case Stereo:
		gainForTowns(numBuffer, USStoTowns66(volume.s.l));
		sprintf(levelBuffer, mixerUnit->stereoMixer->lLevelForm, numBuffer);
		XtVaSetValues(mixerUnit->stereoMixer->volumeLeftLabel, 
												XtNlabel, levelBuffer, NULL);
		gainForTowns(numBuffer, USStoTowns66(volume.s.r));
		sprintf(levelBuffer, mixerUnit->stereoMixer->rLevelForm, numBuffer);
		XtVaSetValues(mixerUnit->stereoMixer->volumeRightLabel, 
												XtNlabel, levelBuffer, NULL);
		break;
	}
}
#endif /*TOWNS*/

/***************************************************************************
 *	unitInfo: ġΥǥХβɽ
 *	
 *		void unitInfo(MixerChannel *mixerUnit);
 *	
 *		MixerChannel *mixerUnit;
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void unitInfo(MixerChannel *mixerUnit)
{
	MixerLevel volume;
	char numBuffer[40];
	char levelBuffer[40];

	volume.value = mixerUnit->ussLevel;
	switch(mixerUnit->volumeType) {
	case Monaural:
		sprintf(numBuffer, "%4.1f", volume.s.l / 10.0);
		sprintf(levelBuffer, mixerUnit->monauralMixer->levelForm, numBuffer);
		XtVaSetValues(mixerUnit->monauralMixer->volumeLabel, 
												XtNlabel, levelBuffer, NULL);
		break;
	case Stereo:
		sprintf(numBuffer, "%4.1f", volume.s.l / 10.0);
		sprintf(levelBuffer, mixerUnit->stereoMixer->lLevelForm, numBuffer);
		XtVaSetValues(mixerUnit->stereoMixer->volumeLeftLabel, 
												XtNlabel, levelBuffer, NULL);
		sprintf(numBuffer, "%4.1f", volume.s.r / 10.0);
		sprintf(levelBuffer, mixerUnit->stereoMixer->rLevelForm, numBuffer);
		XtVaSetValues(mixerUnit->stereoMixer->volumeRightLabel, 
												XtNlabel, levelBuffer, NULL);
		break;
	}
}

/***************************************************************************
 *	unitInfoUSS: ġΥǥХβɽ
 *	
 *		void unitInfoUSS(MixerChannel *mixerUnit);
 *	
 *		MixerChannel *mixerUnit;
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void unitInfoUSS(MixerChannel *mixerUnit)
{
	MixerLevel volume;
	char numBuffer[40];
	char levelBuffer[40];

	volume.value = mixerUnit->ussLevel;
	switch(mixerUnit->volumeType) {
	case Monaural:
		sprintf(numBuffer, "%3d %%", volume.s.l);
		sprintf(levelBuffer, mixerUnit->monauralMixer->levelForm, numBuffer);
		XtVaSetValues(mixerUnit->monauralMixer->volumeLabel, 
												XtNlabel, levelBuffer, NULL);
		break;
	case Stereo:
		sprintf(numBuffer, "%3d %%", volume.s.l);
		sprintf(levelBuffer, mixerUnit->stereoMixer->lLevelForm, numBuffer);
		XtVaSetValues(mixerUnit->stereoMixer->volumeLeftLabel, 
												XtNlabel, levelBuffer, NULL);
		sprintf(numBuffer, "%3d %%", volume.s.r);
		sprintf(levelBuffer, mixerUnit->stereoMixer->rLevelForm, numBuffer);
		XtVaSetValues(mixerUnit->stereoMixer->volumeRightLabel, 
												XtNlabel, levelBuffer, NULL);
		break;
	}
}

#ifndef TMIXER_ONLY

/***************************************************************************
 *	unitLabel: ᥤ󡦥ɥβɽѡʸʣʬΣɽ
 *	
 *		void unitLabel(char *buffer, MixerChannel *mixerUnit);
 *	
 *		char *buffer;
 *		MixerChannel *mixerUnit;
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void unitLabel(char *buffer, MixerChannel *mixerUnit)
{
	MixerLevel volume;
	const char *unitName = keyword2mes(mixerUnit->baseName);

	volume.value = mixerUnit->ussLevel;
	switch(mixerUnit->volumeType) {
	case Monaural:
		sprintf(buffer, "%s %4.1f", unitName, volume.s.l / 10.0);
		break;
	case Stereo:
		if(volume.s.l == volume.s.r) {
			sprintf(buffer, "%s %4.1f", unitName, volume.s.l / 10.0);
		} else {
			sprintf(buffer, "%s L.R Separate", unitName);
		}
		break;
	}
}

/***************************************************************************
 *	unitLabelUSS: ᥤ󡦥ɥβɽѡʸɴʬΨɽ
 *	
 *		void unitLabelUSS(char *buffer, MixerChannel *mixerUnit);
 *	
 *		char *buffer;
 *		MixerChannel *mixerUnit;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void unitLabelUSS(char *buffer, MixerChannel *mixerUnit)
{
	MixerLevel volume;
	const char *unitName = keyword2mes(mixerUnit->baseName);

	volume.value = mixerUnit->ussLevel;
	switch(mixerUnit->volumeType) {
	case Monaural:
		sprintf(buffer, "%s %3d %%", unitName, volume.s.l);
		break;
	case Stereo:
		if(volume.s.l == volume.s.r) {
			sprintf(buffer, "%s %3d %%", unitName, volume.s.l);
		} else {
			sprintf(buffer, "%s L.R Separate", unitName);
		}
		break;
	}
}

#ifdef	TOWNS
/***************************************************************************
 *	unitLabelTowns: ᥤ󡦥ɥβɽѡʸʥǥ٥
 *	
 *		void unitLabelTowns(char *buffer, MixerChannel *mixerUnit);
 *	
 *		char *buffer;
 *		MixerChannel *mixerUnit;
 *	֤
 *		
 *	
 *		TOWNS Υܥ塼˻ȤƤϡɥλͤ TOWNS
 *		ǤϡºǽʤΤϡ66ʳΥܥ塼ࡦ٥Ȥʤޤ
 *		TOWNS ˸¤ä硢Υ٥б븺(dB)狼Τǡ
 *		бǥ٥ͤɽ뤿δؿǤʤߥ塼ȡ̵
 *		ΤȤϡ-[dB] 뤬ɽϡoffɤȤ롣
 *		
 ***************************************************************************/
void unitLabelTowns(char *buffer, MixerChannel *mixerUnit)
{
	int  bitCounter;
	int muteOnly = TOWNS_MUTE_DEVICES;
	MixerLevel volume;
	char numBuffer[40];
	const char *unitName = keyword2mes(mixerUnit->baseName);

	const char *flag[] = {"OFF", "ON"};

	bitCounter = (0x0001 << mixerUnit->channelNo);
	volume.value = mixerUnit->ussLevel;
	switch(mixerUnit->volumeType) {
	case Monaural:
		if(muteOnly & bitCounter || volume.s.l == 0) {
			sprintf(buffer, mixerUnit->monauralMixer->levelForm, 
						keyword2mes(flag[volume.s.l != mixerUnit->min]));
		} else {
			gainForTowns(numBuffer, USStoTowns66(volume.s.l));
			sprintf(buffer, 
						mixerUnit->monauralMixer->levelForm, numBuffer);
		}
		break;
	case Stereo:
		gainForTowns(numBuffer, USStoTowns66(volume.s.l));
		if(volume.s.l == volume.s.r) {
			sprintf(buffer, "%s %s", unitName, numBuffer);
		} else {
			sprintf(buffer, "%s L.R Separate", unitName);
		}
		break;
	}
}
#endif	/*TOWNS*/

/***************************************************************************
 *	ChangeVolumeLabel: ᥤ󡦥ɥΥܥ塼ࡦ٥ɽ
 *	
 *		void ChangeVolumeLabel(void);
 *	
 *		
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void ChangeVolumeLabel(void)
{
	MixerChannel *currentUnit;
	extern int VolumeDevice;
	extern Boolean volmue_enable_flag;

	if(volmue_enable_flag) {
		currentUnit = MixerUnits[VolumeDevice];
		mixerRefresh(currentUnit);
	}
}

/***************************************************************************
 *	ChangeVolumeDev: ѹǽϰϤǥܥ塼ڤؤ򤹤
 *	
 *		void ChangeVolumeDev(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
void ChangeVolumeDev(Widget w, XtPointer client_data, XtPointer call_data)
{
	extern int VolumeDevice;

	++VolumeDevice;
	if(MixerUnits[VolumeDevice] == NULL) {
		VolumeDevice = 0;
	}
	ChangeVolumeLabel();
}

/***************************************************************************
 *	mainLevelUnitSelector: ᥤ󡦥ɥΥ٥ɽñ̤򤹤
 *	
 *		void mainLevelUnitSelector(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void mainLevelUnitSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	CurrentUnitLabel = (UnitLabelProc)client_data;
	ChangeVolumeLabel();
}

/***************************************************************************
 *	unitSearch: ߥμ̻ҤǥХ˴ؤ򸡺
 *	
 *		int unitSearch(int channel);
 *	
 *		int channel;		ߥμ̻ҡID
 *	֤
 *		EOF		ꤵ줿ǥХ¸ߤʤ̵
 *		0ʾ塧		ͭʥߥؤΥݥź
 *	
 *		
 ***************************************************************************/
int unitSearch(int channel)
{
	int counter;
	int unitNo = EOF;

	for(counter = 0;MixerUnits[counter] != NULL && unitNo == EOF;++counter) {
		if(MixerUnits[counter]->channelNo == channel) {
			unitNo = counter;
		}
	}
	return(unitNo);
}

#endif /*TMIXER_ONLY*/

/***************************************************************************
 *	level_up: ܥ塼٥򣱤ľ夲
 *	
 *		int level_up(MixerChannel *mixerUnit);
 *	
 *		MixerChannel *mixerUnit;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int level_up(MixerChannel *mixerUnit)
{
	MixerLevel volume, nowVolume;

	(void)ioctl(mixerUnit->fd, MIXER_READ(mixerUnit->channelNo), &mixerUnit->ussLevel);

	for(volume.value = nowVolume.value = mixerUnit->ussLevel, 
				volume.s.l += (nowVolume.s.l <= nowVolume.s.r),
				volume.s.r += (nowVolume.s.r <= nowVolume.s.l);
				nowVolume.s.l <= 100 && volume.s.r <= 100 && 
				nowVolume.value == mixerUnit->ussLevel;
				volume.s.l += (volume.s.l <= volume.s.r),
				volume.s.r += (volume.s.r <= volume.s.l)) {
		nowVolume = volume;
		if(mixerUnit->volumeType == Monaural) {
			volume.s.r = volume.s.l;
			volume.s.r = nowVolume.s.l;
		}
		ioctl(mixerUnit->fd, MIXER_WRITE(mixerUnit->channelNo), &nowVolume);
	}
	return(nowVolume.value);
}

/***************************************************************************
 *	level_down: ܥ塼٥򣱤Ĳ
 *	
 *		int level_down(MixerChannel *mixerUnit);
 *	
 *		MixerChannel *mixerUnit;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int level_down(MixerChannel *mixerUnit)
{
	int level;
	MixerLevel volume, nowVolume;
#define  max(a,b)        (a > b ? a : b)

	(void)ioctl(mixerUnit->fd, MIXER_READ(mixerUnit->channelNo), &mixerUnit->ussLevel);

	for(volume.value = nowVolume.value = mixerUnit->ussLevel, 
			volume.s.l -= (nowVolume.s.l >= nowVolume.s.r),
			volume.s.r -= (nowVolume.s.r >= nowVolume.s.l),
			level = max(nowVolume.s.l, nowVolume.s.r);
				level > 0 && nowVolume.value == mixerUnit->ussLevel;
					volume.s.l -= (volume.s.l >= volume.s.r),
					volume.s.r -= (volume.s.r >= volume.s.l), --level) {
		nowVolume = volume;
		if(mixerUnit->volumeType == Monaural) {
			volume.s.r = volume.s.l;
			nowVolume.s.r = nowVolume.s.l;
		}
		ioctl(mixerUnit->fd, MIXER_WRITE(mixerUnit->channelNo), &nowVolume);
	}
	return(nowVolume.value);
}

#ifndef TMIXER_ONLY

/***************************************************************************
 *	MainVolumeUp: ᥤ󡦥ɥΥܥ塼ࡦ٥ 0.5 dB 夲
 *	
 *		void MainVolumeUp(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void MainVolumeUp(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerChannel *currentUnit;
	extern int VolumeDevice;

	currentUnit = MixerUnits[VolumeDevice];
	level_up(currentUnit);
	mixerRefresh(currentUnit);
}

/***************************************************************************
 *	MainVolumeDown: ᥤ󡦥ɥΥܥ塼ࡦ٥ 0.5 dB 
 *	
 *		void MainVolumeDown(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void MainVolumeDown(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerChannel *currentUnit;
	extern int VolumeDevice;

	currentUnit = MixerUnits[VolumeDevice];
	level_down(currentUnit);
	mixerRefresh(currentUnit);
}

#endif /*TMIXER_ONLY*/

/***************************************************************************
 *	level_set: ܥ塼٥ꤹ
 *	
 *		int level_set(struct MixerParts *mixerUnit, int newLevel);
 *	
 *		struct MixerParts *mixerUnit;
 *		int newLevel;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int level_set(MixerChannel *mixerUnit, int newLevel)
{
	MixerLevel volume;

	(void)ioctl(mixerUnit->fd, MIXER_READ(mixerUnit->channelNo), &mixerUnit->ussLevel);
	volume.value = newLevel;
	if(mixerUnit->volumeType == Monaural) {
		volume.s.r = volume.s.l;
	}
	ioctl(mixerUnit->fd, MIXER_WRITE(mixerUnit->channelNo), &volume);
	return(volume.value);
}

/***************************************************************************
 *	monauralRefresh: ܥ塼٥ɽ򹹿
 *	
 *		int monauralRefresh(MixerChannel *mixerUnit);
 *	
 *		MixerChannel *mixerUnit;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int monauralRefresh(MixerChannel *mixerUnit)
{
	int status;
	Dimension iwidth, width;
	MixerLevel volume, oldVolume;

	(void)ioctl(mixerUnit->fd, 
				MIXER_READ(mixerUnit->channelNo), &volume.value);
	status = (volume.s.l != (mixerUnit->ussLevel & 0x0000007f));
	/* ɽι */
	oldVolume.value = mixerUnit->ussLevel;
	mixerUnit->ussLevel = volume.value;
	if(status) {
		mixerUnit->labelSet(mixerUnit);
		if(volume.s.l == mixerUnit->min || oldVolume.s.l == mixerUnit->min) {
			XtVaSetValues(mixerUnit->monauralMixer->volumeMin, 
							XtNstate, (volume.s.l == mixerUnit->min), NULL);
		}
		if(volume.s.l == mixerUnit->max || oldVolume.s.l == mixerUnit->max) {
			XtVaSetValues(mixerUnit->monauralMixer->volumeMax, 
							XtNstate, (volume.s.l == mixerUnit->max), NULL);
		}
	}
	XtVaGetValues(mixerUnit->monauralMixer->volumeMeter, 
			XtNinternalWidth, &iwidth, XtNwidth, &width, NULL);
	XtVaSetValues(mixerUnit->monauralMixer->volumeMeter, 
			XtNlevelValue, volume.s.l * (width - 2 * iwidth) / 100, NULL);
	return(status);
}

/***************************************************************************
 *	stereoRefresh: ܥ塼٥ɽ򹹿
 *	
 *		int stereoRefresh(MixerChannel *mixerUnit);
 *	
 *		MixerChannel *mixerUnit;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int stereoRefresh(MixerChannel *mixerUnit)
{
	int status;
	Dimension iwidth, width;
	MixerLevel volume, oldVolume;

	(void)ioctl(mixerUnit->fd, 
					MIXER_READ(mixerUnit->channelNo), &volume.value);
	volume.value &= 0x00007f7f;
	status = (volume.value != mixerUnit->ussLevel);
	if(mixerUnit->muteLevel != -1) {
		return(status);
	}
	/* ɽι */
	oldVolume.value = mixerUnit->ussLevel;
	mixerUnit->ussLevel = volume.value;
	if(status) {
		mixerUnit->labelSet(mixerUnit);
		if(volume.value == mixerUnit->min || 
						oldVolume.value == mixerUnit->min) {
			XtVaSetValues(mixerUnit->stereoMixer->volumeMin, 
						XtNstate, (volume.value == mixerUnit->min), NULL);
		}
		if(volume.value == mixerUnit->max || 
						oldVolume.value == mixerUnit->max) {
			XtVaSetValues(mixerUnit->stereoMixer->volumeMax, 
						XtNstate, (volume.value == mixerUnit->max), NULL);
		}
		if(((volume.s.r == volume.s.l) != (oldVolume.s.r == oldVolume.s.l))
											&& volume.s.r != volume.s.l) {
			XtVaSetValues(mixerUnit->stereoMixer->volumeSeparate, 
												XtNstate, True, NULL);
		}
	}
	XtVaGetValues(mixerUnit->stereoMixer->volumeLeftMeter, 
			XtNinternalWidth, &iwidth, XtNwidth, &width, NULL);
	XtVaSetValues(mixerUnit->stereoMixer->volumeLeftMeter, 
			XtNlevelValue, volume.s.l * (width - 2 * iwidth) / 100, NULL);
	XtVaGetValues(mixerUnit->stereoMixer->volumeRightMeter, 
			XtNinternalWidth, &iwidth, XtNwidth, &width, NULL);
	XtVaSetValues(mixerUnit->stereoMixer->volumeRightMeter, 
			XtNlevelValue, volume.s.r * (width - 2 * iwidth) / 100, NULL);
	return(status);
}

/***************************************************************************
 *	mixerRefresh: ٥ɽ򹹿
 *	
 *		void mixerRefresh(MixerChannel *mixerUnit);
 *	
 *		MixerChannel *mixerUnit;
 *	֤
 *		
 *	
 *		٥ɽʸɽ/Сɽ/Min/Max/Separateˤ򹹿
 *		
 ***************************************************************************/
void mixerRefresh(MixerChannel *mixerUnit)
{
#ifndef TMIXER_ONLY
	static char volume_string[40];
	MixerChannel *currentUnit;
	extern Widget vol;
	extern int VolumeDevice;

	currentUnit = MixerUnits[VolumeDevice];
#endif /*TMIXER_ONLY*/
	switch(mixerUnit->volumeType) {
	case Monaural:
		monauralRefresh(mixerUnit);
		break;
	case Stereo:
		stereoRefresh(mixerUnit);
		break;
	}
#ifndef TMIXER_ONLY
	if(mixerUnit == currentUnit) {
		CurrentUnitLabel(volume_string, currentUnit);
		XtVaSetValues(vol, XtNlabel, volume_string, NULL);
	}
#endif /*TMIXER_ONLY*/
}

/***************************************************************************
 *	mixerAdjust: ä˥٥ɽ򹹿
 *	
 *		void mixerAdjust(XtPointer client_data, XtIntervalId *id);
 *	
 *		XtPointer client_data;
 *		XtIntervalId *id;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void mixerAdjust(XtPointer client_data, XtIntervalId *id)
{
	MixerChannel **mixerUnit_ptr;

	for(mixerUnit_ptr = MixerUnits;
			mixerUnit_ptr != NULL && *mixerUnit_ptr != NULL;++mixerUnit_ptr) {
		mixerRefresh(*mixerUnit_ptr);
	}
	(void)XtAppAddTimeOut((XtAppContext)client_data, 
						app_data.refresh * 1000, mixerAdjust, client_data);
}

/***************************************************************************
 *	volumeMin: ꤵ줿ܥ塼Ǿ̵ˤˤ
 *	
 *		void volumeMin(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	ܥ塼༱̻
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void volumeMin(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerChannel *mixerUnit = (MixerChannel*)client_data;
	Boolean muteFlag = FALSE;

	if(mixerUnit->stereoMixer != NULL) {
		XtVaGetValues(mixerUnit->stereoMixer->volumeMute,
											XtNstate, &muteFlag, NULL);
	}
	level_set(mixerUnit, mixerUnit->min);
	mixerUnit->muteLevel = -1;
	mixerRefresh(client_data);
	if(muteFlag != False && mixerUnit->stereoMixer != NULL) {
		XtVaSetValues(mixerUnit->stereoMixer->volumeMute,
											XtNstate, False, NULL);
	}
}

/***************************************************************************
 *	volumeMax: ꤵ줿ܥ塼ˤ
 *	
 *		void volumeMax(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	ܥ塼༱̻
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void volumeMax(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerChannel *mixerUnit = (MixerChannel*)client_data;
	Boolean muteFlag = FALSE;

	if(mixerUnit->stereoMixer != NULL) {
		XtVaGetValues(mixerUnit->stereoMixer->volumeMute,
											XtNstate, &muteFlag, NULL);
	}
	mixerUnit->max = level_set(mixerUnit, mixerUnit->max);
	if(mixerUnit->volumeType == Monaural) {
		mixerUnit->max &= 0x0000007f;
	}
	mixerUnit->muteLevel = -1;
	mixerRefresh(client_data);
	if(muteFlag != False && mixerUnit->stereoMixer != NULL) {
		XtVaSetValues(mixerUnit->stereoMixer->volumeMute,
											XtNstate, False, NULL);
	}
}

/***************************************************************************
 *	effectMedium: ⲹ㲻ΥȥǸ̤Ūˤ
 *	
 *		void effectMedium(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	ܥ塼༱̻
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void effectMedium(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerChannel *mixerUnit = (MixerChannel*)client_data;

	level_set(mixerUnit, lrVolume(50));
	mixerRefresh(client_data);
}

/***************************************************************************
 *	onOffCheck: ꤵ줿ܥ塼 ON/OFF åɽ򹹿
 *	
 *		int onOffCheck(Widget w, MixerChannel *mixerUnit);
 *	
 *		Widget w;				˥塼ܤΥ֥
 *		MixerChannel *mixerUnit;	ߥ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
int onOffCheck(Widget w, MixerChannel *mixerUnit)
{
	int flag;
	MixerLevel volume;
	char levelLabel[40];
	static const char *onOff[2] = {"OFFLINE", "ONLINE"};

	(void)ioctl(mixerUnit->fd, 
					MIXER_READ(mixerUnit->channelNo), &volume.value);
	flag = (volume.value != mixerUnit->min);
	sprintf(levelLabel, "%s  %s", 
				keyword2mes(mixerUnit->baseName), keyword2mes(onOff[flag]));
	XtVaSetValues(w, XtNlabel, levelLabel, NULL);
	return(flag);
}

/***************************************************************************
 *	volumeOnOff: ꤵ줿ܥ塼 ON/OFF 
 *	
 *		void volumeOnOff(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	ܥ塼༱̻
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void volumeOnOff(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerLevel volume;
	MixerChannel *mixerUnit = (MixerChannel*)client_data;

	(void)ioctl(mixerUnit->fd, 
					MIXER_READ(mixerUnit->channelNo), &volume.value);

	if(volume.value == mixerUnit->min) {
		level_set(mixerUnit, mixerUnit->max);
	} else {
		level_set(mixerUnit, mixerUnit->min);
	}
	onOffCheck(w, mixerUnit);
	if(mixerUnit->monauralMixer != NULL || mixerUnit->stereoMixer != NULL) {
		mixerRefresh(mixerUnit);
	}
}

/***************************************************************************
 *	VolumeDown: ꤵ줿ƥ쥪ܥ塼Ǿͥ󤵤
 *	
 *		void VolumeDown(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	ܥ塼༱̻
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void VolumeDown(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerChannel *mixerUnit = (MixerChannel*)client_data;
	
	mixerUnit->levelDown(mixerUnit);
	mixerRefresh(client_data);
}

/***************************************************************************
 *	VolumeUp: ꤵ줿ƥ쥪ܥ塼Ǿͥåפ
 *	
 *		void VolumeUp(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	ܥ塼༱̻
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void VolumeUp(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerChannel *mixerUnit = (MixerChannel*)client_data;
	
	mixerUnit->levelUp(mixerUnit);
	mixerRefresh(client_data);
}

/***************************************************************************
 *	VolumeMute: ꤵ줿ܥ塼ΰŪʺǾʥߥ塼ȡˤ ON/OFF 
 *	
 *		void VolumeMute(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void VolumeMute(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean muteFlag = FALSE;
	MixerChannel *mixerUnit = (MixerChannel*)client_data;
	
	XtVaGetValues(w, XtNstate, &muteFlag, NULL);
	if(muteFlag == True) {
		/* Ūʥߥ塼Ȥ OFF  ON */
		(void)ioctl(mixerUnit->fd, 
				MIXER_READ(mixerUnit->channelNo), &mixerUnit->muteLevel);
		level_set(mixerUnit, mixerUnit->min);
		if(mixerUnit->muteLevel == mixerUnit->min) {
			/* Ǥ˺Ǿ٥ΤȤ */
			XtVaSetValues(w, XtNstate, False, NULL);
			mixerUnit->muteLevel = -1;
		}
	} else {
		level_set(mixerUnit, mixerUnit->muteLevel);
		mixerUnit->muteLevel = -1;
		mixerRefresh(client_data);
	}
}

/***************************************************************************
 *	muteStereoCancel: ꤵ줿ƥ쥪ܥ塼Υߥ塼Ȥ˴
 *	
 *		void muteStereoCancel(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	ܥ塼ɣġʣɣΣԷ˥㥹ȡ
 *		XtPointer call_data;	̤
 *	
 *		ꤵ줿ƥ쥪ܥ塼बߥ塼Ⱦ֤ǤȤΥߥ
 *		Ȥ˴롣
 *		ϡ̡Ω椫ǤʤˤäưѤƤ
 *		ΥСʹߤǤϡطʤξ֤᤹
 *		
 ***************************************************************************/
/*ARGSUSED*/
void muteStereoCancel(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerChannel *mixerUnit = (MixerChannel*)client_data;
	Boolean muteFlag = FALSE;

	XtVaGetValues(mixerUnit->stereoMixer->volumeMute,
											XtNstate, &muteFlag, NULL);
	if(muteFlag != False && mixerUnit->muteLevel != -1) {
		XtVaSetValues(mixerUnit->stereoMixer->volumeMute,
											XtNstate, False, NULL);
		level_set(mixerUnit, mixerUnit->muteLevel);
		mixerUnit->muteLevel = -1;
		mixerRefresh(client_data);
	}
}

/***************************************************************************
 *	monoLevelSet: ܥ塼ꤹlevel åȤΥХå
 *	
 *		void monoLevelSet(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				level å
 *		XtPointer client_data;	ܥ塼༱̻
 *		XtPointer call_data;	٥
 *	
 *
 ***************************************************************************/
void monoLevelSet(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerLevel volume;
	XawLevelReturnStruct *levelData = (XawLevelReturnStruct*) call_data;
	MixerChannel *mixerUnit = (MixerChannel*)client_data;

	volume.value = levelData->levelValue;
	volume.s.r = volume.s.l;
	levelData->levelValue = level_set(mixerUnit, volume.value);
	mixerRefresh(client_data);
}

/***************************************************************************
 *	leftLevelSet: ܥ塼ꤹlevel åȤΥХå
 *	
 *		void leftLevelSet(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				level å
 *		XtPointer client_data;	ܥ塼༱̻
 *		XtPointer call_data;	٥
 *	
 *
 ***************************************************************************/
void leftLevelSet(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerLevel volume, newLevel;
	Boolean separateFlag = FALSE;
	XawLevelReturnStruct *levelData = (XawLevelReturnStruct*) call_data;
	MixerChannel *mixerUnit = (MixerChannel*)client_data;

	XtVaGetValues(mixerUnit->stereoMixer->volumeSeparate,
											XtNstate, &separateFlag, NULL);
	if(separateFlag != False) {
		volume.value = mixerUnit->ussLevel;
		volume.s.l   = levelData->levelValue;
		newLevel.value = level_set(mixerUnit, volume.value);
		levelData->levelValue = volume.s.l;
		mixerRefresh(client_data);
	} else {
		monoLevelSet(w, client_data, call_data);
	}
}

/***************************************************************************
 *	rightLevelSet: ܥ塼ꤹlevel åȤΥХå
 *	
 *		void rightLevelSet(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				level å
 *		XtPointer client_data;	ܥ塼༱̻
 *		XtPointer call_data;	٥
 *	
 *
 ***************************************************************************/
void rightLevelSet(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerLevel volume, newLevel;
	Boolean separateFlag = FALSE;
	XawLevelReturnStruct *levelData = (XawLevelReturnStruct*) call_data;
	MixerChannel *mixerUnit = (MixerChannel*)client_data;

	XtVaGetValues(mixerUnit->stereoMixer->volumeSeparate,
											XtNstate, &separateFlag, NULL);
	if(separateFlag != False) {
		volume.value = mixerUnit->ussLevel;
		volume.s.r   = levelData->levelValue;
		newLevel.value = level_set(mixerUnit, volume.value);
		levelData->levelValue = volume.s.l;
		mixerRefresh(client_data);
	} else {
		monoLevelSet(w, client_data, call_data);
	}
}

/***************************************************************************
 *	levelUnitSelector: ٥ɽñ̤򤹤
 *	
 *		void levelUnitSelector(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void levelUnitSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	MixerChannel **mixerUnit_ptr;
	UnitType *levelUnit_ptr = (UnitType*)client_data;

	for(mixerUnit_ptr = MixerUnits;mixerUnit_ptr != NULL && 
							*mixerUnit_ptr != NULL;++mixerUnit_ptr) {
		(*mixerUnit_ptr)->labelSet = levelUnit_ptr->levelUnit;
		(*mixerUnit_ptr)->labelSet(*mixerUnit_ptr);
	}
}

/***************************************************************************
 *	stereo_volume: ƥ쥪ܥ塼νԤ
 *	
 *		void stereo_volume(Widget parent, Widget box);
 *	
 *		Widget parent;
 *	
 *
 ***************************************************************************/
StereoInfo *stereo_volume(Widget parent, const char *baseName)
{
	char widgetName[80];
	char deviceLabel[80];
	char *formBuffer;
	StereoInfo *stereo_pointer;

	stereo_pointer = (StereoInfo*)malloc(sizeof(StereoInfo));
	if(stereo_pointer != NULL) {
		sprintf(widgetName, "%sVolArea", baseName);
		stereo_pointer->volumeArea = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				panedWidgetClass,				/* widget class */
				parent,							/* parent widget */
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolArea1", baseName);
		stereo_pointer->volumeArea1 = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				panedWidgetClass,				/* widget class */
				stereo_pointer->volumeArea,		/* parent widget */
				XtNorientation, XtorientHorizontal, 
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolArea2", baseName);
		stereo_pointer->volumeArea2 = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				panedWidgetClass,				/* widget class */
				stereo_pointer->volumeArea,		/* parent widget */
				XtNorientation, XtorientHorizontal, 
				NULL							/* argument list */
				);
		sprintf(widgetName,  "%sVolLeftLabel", baseName);
		sprintf(deviceLabel, "%s%s%%s", 
						keyword2mes(baseName), keyword2mes("LEFT"));
		formBuffer = (char*)XtMalloc(strlen(deviceLabel)+1);
		strcpy(formBuffer, deviceLabel);
		stereo_pointer->lLevelForm = (const char *)formBuffer;
		stereo_pointer->volumeLeftLabel = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				labelWidgetClass,				/* widget class */
				stereo_pointer->volumeArea1,	/* parent widget */
				XtNlabel, deviceLabel,
				XtNmin, app_data.labelWidth, 
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolRightLabel", baseName);
		sprintf(deviceLabel, "%s%s%%s", 
						keyword2mes(baseName), keyword2mes("RIGHT"));
		formBuffer = (char*)XtMalloc(strlen(deviceLabel)+1);
		strcpy(formBuffer, deviceLabel);
		stereo_pointer->rLevelForm = (const char *)formBuffer;
		stereo_pointer->volumeRightLabel = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				labelWidgetClass,				/* widget class */
				stereo_pointer->volumeArea2,	/* parent widget */
				XtNmin, app_data.labelWidth, 
				XtNlabel, deviceLabel,
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolLeftMeter", baseName);
		stereo_pointer->volumeLeftMeter = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				levelWidgetClass,				/* widget class */
				stereo_pointer->volumeArea1,	/* parent widget */
				XtNlevelMaxValue, 100, 
				XtNwidth, 110, 					/* Set width */
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolRightMeter", baseName);
		stereo_pointer->volumeRightMeter = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				levelWidgetClass,				/* widget class */
				stereo_pointer->volumeArea2,	/* parent widget */
				XtNlevelMaxValue, 100, 
				XtNwidth, 110, 					/* Set width */
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolMin", baseName);
		stereo_pointer->volumeMin = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				toggleWidgetClass,				/* widget class */
				stereo_pointer->volumeArea1,	/* parent widget */
				XtNlabel, keyword2mes("MIN"),				
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolMax", baseName);
		stereo_pointer->volumeMax = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				toggleWidgetClass,				/* widget class */
				stereo_pointer->volumeArea1,	/* parent widget */
				XtNlabel, keyword2mes("MAX"),				
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolDown", baseName);
		stereo_pointer->volumeDown = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				repeaterWidgetClass,			/* widget class */
				stereo_pointer->volumeArea2,	/* parent widget */
				XtNskipAdjust, True, 
#define	BITMAP_SET
#ifdef	BITMAP_SET
				XtNbitmap, vdown_pixmap,	
#endif	/*BITMAP_SET*/
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolUp", baseName);
		stereo_pointer->volumeUp = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				repeaterWidgetClass,			/* widget class */
				stereo_pointer->volumeArea2,	/* parent widget */
				XtNskipAdjust, True, 
#ifdef	BITMAP_SET
				XtNbitmap, vup_pixmap,	
#endif	/*BITMAP_SET*/
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolMute", baseName);
		stereo_pointer->volumeMute = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				toggleWidgetClass,				/* widget class */
				stereo_pointer->volumeArea1,	/* parent widget */
				XtNlabel, keyword2mes("MUTE"),				
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolLevel", baseName);
		stereo_pointer->volumeSeparate = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				toggleWidgetClass,				/* widget class */
				stereo_pointer->volumeArea2,	/* parent widget */
				XtNlabel, keyword2mes("SEPARATE"),				
				NULL							/* argument list */
				);
	}
	return(stereo_pointer);
}

/***************************************************************************
 *	mono_volume: Υ롦ܥ塼νԤ
 *	
 *		void mono_volume(Widget parent, Widget box);
 *	
 *		Widget parent;
 *	
 *
 ***************************************************************************/
MonauralInfo *mono_volume(Widget parent, const char *baseName)
{
	char widgetName[80];
	char deviceLabel[80];
	char *formBuffer;
	/*char *widgetName_ptr;*/
	MonauralInfo *monaural_pointer;

	monaural_pointer = (MonauralInfo*)malloc(sizeof(MonauralInfo));
	if(monaural_pointer != NULL) {
		sprintf(widgetName, "%sVolArea", baseName);
		monaural_pointer->volumeArea = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				panedWidgetClass,				/* widget class */
				parent,							/* parent widget */
				XtNorientation, XtorientHorizontal, 
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolLabel", baseName);
		sprintf(deviceLabel, "%s %%s", keyword2mes(baseName));
		formBuffer = (char*)XtMalloc(strlen(deviceLabel)+1);
		strcpy(formBuffer, deviceLabel);
		monaural_pointer->levelForm = (const char *)formBuffer;
		monaural_pointer->volumeLabel = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				labelWidgetClass,				/* widget class */
				monaural_pointer->volumeArea,		/* parent widget */
				XtNlabel, deviceLabel,
				XtNmin, app_data.labelWidth, 
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolMeter", baseName);
		monaural_pointer->volumeMeter = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				levelWidgetClass,				/* widget class */
				monaural_pointer->volumeArea,	/* parent widget */
				XtNlevelMaxValue, 100, 
				XtNwidth, 110, 					/* Set width */
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolDown", baseName);
		monaural_pointer->volumeDown = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				repeaterWidgetClass,			/* widget class */
				monaural_pointer->volumeArea,	/* parent widget */
				XtNskipAdjust, True, 
#ifdef	BITMAP_SET
				XtNbitmap, vdown_pixmap,	
#endif	/*BITMAP_SET*/
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolUp", baseName);
		monaural_pointer->volumeUp = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				repeaterWidgetClass,			/* widget class */
				monaural_pointer->volumeArea,	/* parent widget */
				XtNskipAdjust, True, 
#ifdef	BITMAP_SET
				XtNbitmap, vup_pixmap,	
#endif	/*BITMAP_SET*/
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolMin", baseName);
		monaural_pointer->volumeMin = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				toggleWidgetClass,				/* widget class */
				monaural_pointer->volumeArea,	/* parent widget */
				XtNlabel, keyword2mes("MIN"),				
				NULL							/* argument list */
				);
		sprintf(widgetName, "%sVolMax", baseName);
		monaural_pointer->volumeMax = XtVaCreateManagedWidget(
				widgetName,						/* Widget Name */
				toggleWidgetClass,				/* widget class */
				monaural_pointer->volumeArea,	/* parent widget */
				XtNlabel, keyword2mes("MAX"),				
				NULL							/* argument list */
				);
	}
	return(monaural_pointer);
}

/***************************************************************************
 *	volumeMake: ġΥܥ塼ࡦǥХѤΥѡĽԤ
 *	
 *		MixerChannel *volumeMake(int mixer, int type, int channel, 
 *									Widget parent, const char *baseName);
 *	
 *		int mixer;				ߥǥХΥե뵭һ
 *		int type;				Υ/ƥ쥪
 *		int channel;			ֹͥ
 *		Widget parent;			ƥå
 *		const char *baseName;	ġΥܥ塼ࡦǥХ̾
 *	֤
 *		NULL			­
 *		NULLʳ		ߥ
 *	
 *		
 ***************************************************************************/
MixerChannel *volumeMake(int mixer, int type, int channel, 
									Widget parent, const char *baseName)
{
	int unitTypeDefault = 0;
	MixerChannel *newMixer;
	const MixerChannel defaultMixer = {
		VolumeUndefined, 		/* ̤ܥ塼ॿ */
		NULL, 					/* Υ롦ܥ塼ࡦ֥å */
		NULL, 					/* ƥ쥪ܥ塼ࡦ֥å */
		EOF,					/* ǥХΥեǥץ */
		EOF, 					/* ֹͥ */
		0,						/* ܥ塼ࡦ٥롦Хåե */
		0,						/* MIN ܥ塼ࡦ٥ */
		lrVolume(MAX_LEVEL),	/* MAX ܥ塼ࡦ٥ */
		-1,
		NULL, 
	};
	static char effectCutString[] = "#override\n"
								"<EnterWindow>:	highlight()	\n"
								"<LeaveWindow>:	reset()		\n"
								"<Btn1Down>:	set()		\n"
								"<Btn1Up>:		notify() unset()";
	XtTranslations effectCutTranslations;
#ifdef	TOWNS
	unitTypeDefault = !app_data.towns;
#endif	/*TOWNS*/
	newMixer = (MixerChannel*)malloc(sizeof(MixerChannel));
	if(newMixer != NULL) {
		memcpy(newMixer, &defaultMixer, sizeof(defaultMixer));
		newMixer->volumeType = type;
		newMixer->fd         = mixer;
		newMixer->channelNo  = channel;
		newMixer->ussLevel   = -1;
		newMixer->min        = 0;
		newMixer->max        = 100 * 0x100 + 100;
		newMixer->baseName   = baseName;
		newMixer->labelSet   = MixerLevels[unitTypeDefault].levelUnit;
		newMixer->levelDown  = level_down;
		newMixer->levelUp    = level_up;
		switch(type) {
		case Monaural:
			newMixer->monauralMixer = mono_volume(parent, baseName);
			newMixer->max &= 0x000000ff;
			if(newMixer->monauralMixer != NULL) {
				/* ܥ塼ɽºݤΥ٥ǽ */
				monauralRefresh(newMixer);
				/* Хåؿ */
				XtAddCallback(newMixer->monauralMixer->volumeMeter, 
						XtNcallback, monoLevelSet, (XtPointer)newMixer);
				XtAddCallback(newMixer->monauralMixer->volumeMin, 
						XtNcallback, volumeMin, (XtPointer)newMixer);
				XtAddCallback(newMixer->monauralMixer->volumeMax, 
						XtNcallback, volumeMax, (XtPointer)newMixer);
				XtAddCallback(newMixer->monauralMixer->volumeUp, 
						XtNcallback, VolumeUp, (XtPointer)newMixer);
				XtAddCallback(newMixer->monauralMixer->volumeDown, 
						XtNcallback, VolumeDown, (XtPointer)newMixer);
			}
			break;
		case Stereo:
			newMixer->stereoMixer   = stereo_volume(parent, baseName);
			if(newMixer->stereoMixer != NULL) {
				/* ܥ塼ɽºݤΥ٥ǽ */
				stereoRefresh(newMixer);
				XtAddCallback(newMixer->stereoMixer->volumeLeftMeter, 
						XtNcallback, muteStereoCancel, (XtPointer)newMixer);
				XtAddCallback(newMixer->stereoMixer->volumeLeftMeter, 
						XtNcallback, leftLevelSet, (XtPointer)newMixer);
				XtAddCallback(newMixer->stereoMixer->volumeRightMeter, 
						XtNcallback, muteStereoCancel, (XtPointer)newMixer);
				XtAddCallback(newMixer->stereoMixer->volumeRightMeter, 
						XtNcallback, rightLevelSet, (XtPointer)newMixer);
				XtAddCallback(newMixer->stereoMixer->volumeMin, 
						XtNcallback, volumeMin, (XtPointer)newMixer);
				XtAddCallback(newMixer->stereoMixer->volumeMax, 
						XtNcallback, volumeMax, (XtPointer)newMixer);
				if((1 << channel) & SOUND_MASK_EFFECT) {
					XtVaSetValues(newMixer->stereoMixer->volumeMute, 
							XtNlabel, "Cut", NULL);
					XtAddCallback(newMixer->stereoMixer->volumeMute, 
							XtNcallback, effectMedium, (XtPointer)newMixer);
					effectCutTranslations = 
								XtParseTranslationTable(effectCutString);
					XtOverrideTranslations(
							newMixer->stereoMixer->volumeMute,
											effectCutTranslations);
				} else {
					XtAddCallback(newMixer->stereoMixer->volumeMute, 
							XtNcallback, VolumeMute, (XtPointer)newMixer);
				}
				XtAddCallback(newMixer->stereoMixer->volumeUp, 
						XtNcallback, VolumeUp, (XtPointer)newMixer);
				XtAddCallback(newMixer->stereoMixer->volumeDown, 
						XtNcallback, VolumeDown, (XtPointer)newMixer);
			}
			break;
		}
	}
	return(newMixer);
}

/***************************************************************************
 *	deviceInfo: ġΥǥХβʬ
 *	
 *		int deviceInfo(int mixer, const char *target,
 *						int devices, int streo, int counter, int co)
 *	
 *		int mixer;				/dev/mixer Υե롦ǥץ
 *		int devices;			Ѳǽʥܥ塼Υӥåȥޥ
 *		int streo;				ƥ쥪ܥ塼Υӥåȥޥ
 *		int counter;			ܥ塼ǥХֹ
 *	֤
 *		ߥΣͥʬξʹʡߥI/O
 *	
 *		
 ***************************************************************************/
MixerChannel *deviceInfo(int mixer, int devices, int streo, int counter, Widget parent)
{
	int  bitCounter;
	int volumeType;
	MixerChannel *mixerUnit = NULL;
	char buffer[256];

	bitCounter = (0x0001 << counter);

	volumeType = ((devices & bitCounter) >> counter) +
								((streo & bitCounter) >> counter);
#ifdef TOWNS_MUTE_DEVICES
	if(app_data.towns) {
		volumeType = ((~TOWNS_MUTE_DEVICES & bitCounter)?(volumeType):(0));
	}
#endif /*TOWNS_MUTE_DEVICES*/

	sprintf(buffer, "%s:%s", CurrentDevicesNames->names[counter], 
								CurrentDevicesNames->names[counter]);
	FallbackDict = makeMessages(FallbackDict , buffer);

	if(volumeType > 0) {
		mixerUnit = volumeMake(mixer, volumeType, counter, 
							parent, CurrentDevicesNames->names[counter]);
	}

	return(mixerUnit);
}

/***************************************************************************
 *	deviceList: ǥХβʬǥХΥꥹȤ
 *	
 *		MixerChannel **deviceList(int mixer, Widget parent, 
 *				MixerChannel *(*print)(int mixer, 
 *					int devices, int streo, int counter, Widget parent));
 *	
 *		int mixer;				mixer Υե롦ǥץ
 *		Widget parent;
 *		MixerChannel *(*interfaceCreate)(int mixer, int devices, 
 *								int streo, int counter, Widget parent));
 *	֤
 *		NULL		۾ｪλ
 *		NULLʳ	ǥХΥꥹ
 *	
 *		
 ***************************************************************************/
MixerChannel **deviceList(int mixer, Widget parent, 
			MixerChannel *(*interfaceCreate)(int mixer, 
						int devices, int streo, int counter, Widget parent))
{
	int devices;
	int streoDevices;
	int counter, bitCounter;
	int deviceCounter = 0, mixerBlockSize;
	MixerChannel *mixerUnits[SOUND_MIXER_NRDEVICES + 1];
	MixerChannel **mixerUnits_ptr;

	if(ioctl(mixer, SOUND_MIXER_READ_DEVMASK, &devices) >= 0 &&
			ioctl(mixer, SOUND_MIXER_READ_STEREODEVS, &streoDevices) >= 0) {
		for(counter = 0, deviceCounter = 0, bitCounter = 0x001;
				counter < SOUND_MIXER_NRDEVICES; ++counter, bitCounter <<= 1, 
					deviceCounter += (mixerUnits[deviceCounter] != NULL)) {
			mixerUnits[deviceCounter] = 
				interfaceCreate(mixer, devices, streoDevices, counter, parent);
		}
	}
	mixerUnits[deviceCounter] = NULL;
	if(deviceCounter > 0) {
		++deviceCounter;
		mixerBlockSize = sizeof(MixerChannel*) * (deviceCounter + 1);
		mixerUnits_ptr = (MixerChannel**)XtMalloc(mixerBlockSize);
		memcpy(mixerUnits_ptr, mixerUnits, mixerBlockSize);
	} else {
		mixerUnits_ptr = NULL;
	}

	return(mixerUnits_ptr);
}

#ifdef TMIXER_ONLY
/***************************************************************************
 *	LabelPixmaps: ٥ѥӥåȥޥåפκ
 *	
 *		void LabelPixmaps(Display *display, Drawable drawable);
 *	
 *		Display *display;
 *		Drawable drawable;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void LabelPixmaps(Display *display, Drawable drawable)
{
	vdown_pixmap = XCreateBitmapFromData(display, drawable, 
			vdown_bits, vdown_width, vdown_height);

	vup_pixmap = XCreateBitmapFromData(display, drawable, 
			vup_bits, vup_width, vup_height);

	vdwDisablePixmap = XCreateBitmapFromData(display, drawable, 
			vdwDisable_bits, vdwDisable_width, vdwDisable_height);

	vupDisablePixmap = XCreateBitmapFromData(display, drawable, 
			vupDisable_bits, vupDisable_width, vupDisable_height);
}
#endif /*TMIXER_ONLY*/

#ifndef TMIXER_ONLY
/***************************************************************************
 *	PopupVolume: ܥ塼楦ɥΥݥåץå
 *	
 *		void PopupVolume(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopupVolume(Widget w, XtPointer client_data, XtPointer call_data)
{
	PopdownInfo *popdownInfo = (PopdownInfo*)client_data;
    Widget popupButton = popdownInfo->popupWidget;
    Position x, y;
    Dimension width, height;

	/*********************************************************
	 *	ݥåץåפεˤʤääȤ礭
	 *********************************************************/
	XtVaGetValues(popupButton, 
			XtNwidth, &width,
			XtNheight, &height,
			NULL);
	
	/***********************************
	 *	Root Window κɸϤѴ
	 ***********************************/
	XtTranslateCoords(popupButton,		/* Widget */
			(Position) 0,				/* x */
			(Position) height/2,		/* y */
			&x, &y);					/* coords on root window */
	/*******************************************************************
	 *	ݥåץåץΰ֤ꤹʤޤвƤʤ
	 *******************************************************************/
	XtVaSetValues(popdownInfo->popdownShell, 
			XtNx, x,
			XtNy, y,
			NULL);
}
#endif /*TMIXER_ONLY*/

/***************************************************************************
 *	quit: λԤʤХåؿ
 *	
 *		void quit_proc(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	/dev/mixer Υե뵭һҤؤΥݥ
 *		XtPointer call_data;	̤
 *	֤
 *		
 *		
 *	
 *		
 ***************************************************************************/
void quit_proc(Widget w, XtPointer client_data, XtPointer call_data)
{
	int *mixer_ptr;

	mixer_ptr = (int*)client_data;	
	close(*mixer_ptr);
	exit(0);
}

/***************************************************************************
 *	searchUnit: ߥֹͥ椫鸡
 *	
 *		void searchUnit(MixerChannel **MixerUnits, int channel);
 *	
 *		MixerChannel **MixerUnits;	
 *		int channel;				
 *	֤
 *		NULL			Ĥʤä
 *		NULLʳ		Фߥ
 *	
 *		
 ***************************************************************************/
MixerChannel *searchUnit(MixerChannel **MixerUnits, int channel)
{
	MixerChannel **mixerUnit_ptr;

	for(mixerUnit_ptr = MixerUnits;*mixerUnit_ptr != NULL && 
				(*mixerUnit_ptr)->channelNo != channel;++mixerUnit_ptr) 
		;			/* ԡ⤷ʤ */

	return((*mixerUnit_ptr != NULL && 
		(*mixerUnit_ptr)->channelNo == channel)?(*mixerUnit_ptr):(NULL));
}

/***************************************************************************
 *	makeVolumeUnitMenu: ܥ塼٥ɽؤѤΥ˥塼
 *	
 *		void makeVolumeUnitMenu(Widget menu);
 *	
 *		Widget menu;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void makeVolumeUnitMenu(Widget menu)
{
	int unitTypeDefault = 0;
	int counter;
	Widget levelUnit;
	Widget separator1;

#ifdef	TOWNS
	unitTypeDefault = !app_data.towns;
#endif	/*TOWNS*/
	if(NumberOfArray(MixerLevels) - unitTypeDefault > 0) {
		for(counter = unitTypeDefault;counter < NumberOfArray(MixerLevels) &&
					MixerLevels[counter].unitName != NULL;++counter) {
			levelUnit = 
					XtVaCreateManagedWidget(
						(MixerLevels[counter].unitName),
						smeBSBObjectClass,
						menu,
						XtNlabel, keyword2mes(MixerLevels[counter].unitName), 
						NULL);
			XtAddCallback(levelUnit, XtNcallback, 
							levelUnitSelector, &MixerLevels[counter]);
#ifndef TMIXER_ONLY
			XtAddCallback(levelUnit, XtNcallback, 
							mainLevelUnitSelector, UnitLabels[counter]);
#endif /*TMIXER_ONLY*/
		}
		separator1 = XtVaCreateManagedWidget(
					"separator1",
					smeLineObjectClass,
					menu,
					NULL);
	}
}

/***************************************************************************
 *	makeMixerMenu: ߥΥ˥塼
 *	
 *		void makeMixerMenu(Widget parent);
 *	
 *		Widget parent;		ƥå
 *	֤
 *		
 *		
 *	
 *	
 ***************************************************************************/
void makeMixerMenu(int mixer, Widget parent, MixerChannel **MixerUnits)
{
	Widget mixerMenuButton, mixerMenu;
	Widget topLine;
#ifdef TMIXER_ONLY
	Widget mixerQuit;
#endif /*TMIXER_ONLY*/
#ifdef TOWNS_MUTE_DEVICES
	int counter, bitCounter;
	int devices, streoDevices;
	char widgetName[40];
	MixerChannel *mixerUnit;
	Widget muteUnit, levelUnit, separator0, separator1;
	const MessageNode *targetName;
	static const MixerChannel defaultMixer = {
		VolumeUndefined, 		/* ̤ܥ塼ॿ */
		NULL, 					/* Υ롦ܥ塼ࡦ֥å */
		NULL, 					/* ƥ쥪ܥ塼ࡦ֥å */
		EOF,					/* ǥХΥեǥץ */
		EOF, 					/* ֹͥ */
		0,						/* ܥ塼ࡦ٥롦Хåե */
		0,						/* MIN ܥ塼ࡦ٥ */
		lrVolume(MAX_LEVEL),	/* MAX ܥ塼ࡦ٥ */
		-1,
		NULL, 
	};
#endif /*TOWNS_MUTE_DEVICES*/

	mixerMenuButton = XtVaCreateManagedWidget(
				"mixerMenuButton",
				menuButtonWidgetClass,
				parent,
				NULL);

	mixerMenu = XtVaCreatePopupShell(
				"mixerMenu",
				simpleMenuWidgetClass,
				mixerMenuButton,
				NULL);

	topLine = XtVaCreateManagedWidget(
				"topLine",
				smeLineObjectClass,
				mixerMenu,
				NULL);

#ifdef TOWNS_MUTE_DEVICES
	if(ioctl(mixer, SOUND_MIXER_READ_DEVMASK, &devices) >= 0 && app_data.towns &&
			ioctl(mixer, SOUND_MIXER_READ_STEREODEVS, &streoDevices) >= 0) {
		for(counter = 0, bitCounter = 0x001;
				counter < SOUND_MIXER_NRDEVICES; ++counter, bitCounter <<= 1) {
			if(bitCounter & devices & ~streoDevices & TOWNS_MUTE_DEVICES) {
				/* ߥ塼ȥǥХʤ */
				sprintf(widgetName, "%sMute", CurrentDevicesNames->names[counter]);
				muteUnit = XtVaCreateManagedWidget(
							widgetName,
							smeBSBObjectClass,
							mixerMenu,
							NULL);
				mixerUnit = searchUnit(MixerUnits, counter);
				if(mixerUnit == NULL) {
					mixerUnit = (MixerChannel*)XtMalloc(sizeof(*mixerUnit));
					memcpy(mixerUnit, &defaultMixer, sizeof(defaultMixer));
					mixerUnit->volumeType = 
									((devices & bitCounter) >> counter) +
									((streoDevices & bitCounter) >> counter);
					mixerUnit->fd        = mixer;
					mixerUnit->channelNo = counter;
					mixerUnit->min       = 0;
					mixerUnit->max       = 100 * 0x100 + 100;
					mixerUnit->baseName  = CurrentDevicesNames->names[counter];
				}
				onOffCheck(muteUnit, mixerUnit);
				XtAddCallback(muteUnit, XtNcallback, volumeOnOff, mixerUnit);
			}
		}
		separator0 = XtVaCreateManagedWidget(
					"separator0",
					smeLineObjectClass,
					mixerMenu,
					NULL);
	}
#endif /*TOWNS_MUTE_DEVICES*/
	makeVolumeUnitMenu(mixerMenu);

#ifndef TMIXER_ONLY
	popdownVolume = XtVaCreateManagedWidget(
				"popdown",
				smeBSBObjectClass,
				mixerMenu,
				NULL);
#else
	mixerQuit = XtVaCreateManagedWidget(
				"quit",
				smeBSBObjectClass,
				mixerMenu,
				NULL);

	XtAddCallback(mixerQuit, XtNcallback, quit_proc, (void*)&mixer);
#endif /*TMIXER_ONLY*/
}

/***************************************************************************
 *	usage: ˡɽ
 *	
 *		void usage(int mixer, const char *program);
 *	
 *		int mixer;				/dev/mixer Υե롦ǥץ
 *		const char *program;	裰ʥץ̾
 *	
 *		
 ***************************************************************************/
void usage(int mixer, const char *program)
{
	int streoDevices;

	if(ioctl(mixer, SOUND_MIXER_READ_STEREODEVS, &streoDevices) >= 0) {
		fprintf(stderr,"%s:%s[Version 1.03]\n", keyword2mes("USAGE"), program);
#ifdef	TOWNS
		fprintf(stderr,"       %s [-mixer %s] [-towns] [-notowns] [%s]\n", 
				program, keyword2mes("DEVICE"), keyword2mes("TKOPTION"));
#else
		fprintf(stderr,"       %s [-mixer %s] [%s]\n", 
				program, keyword2mes("DEVICE"), keyword2mes("TKOPTION"));
#endif	/*TOWNS*/
	} else {
		fprintf(stderr, keyword2mes("MIXERERR"), app_data.mixerDevice);
		fprintf(stderr, "\n");
	}
}

#ifndef TMIXER_ONLY

/***************************************************************************
 *	volume_init: ܥ塼ॷκ
 *	
 *		void volume_init(Widget topLevel, Widget popupButton);
 *	
 *		Widget topLevel;		ƾ̥å
 *		Widget popupButton;		ݥåץåפ륦å
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void volume_init(Widget topLevel, Widget popupButton)
{
	int mixer;
	XtAppContext app_context;
	Widget tmixer, mixerBlock, mixerMenuBlock, mixerMainBlock;
	static PopdownInfo popdownInfo;
	extern Boolean volmue_enable_flag;
	extern int VolumeDevice;

	app_context = XtWidgetToApplicationContext(topLevel);
	tmixer = XtVaCreatePopupShell(
				"mixerShell", 
				topLevelShellWidgetClass,	/* widget class */
				topLevel, 
				NULL);

	mixerBlock = XtVaCreateManagedWidget(
				"mixerBlock",
				panedWidgetClass,
				tmixer,
				NULL);

	mixerMenuBlock = XtVaCreateManagedWidget(
				"mixerMenuBlock",
				boxWidgetClass,
				mixerBlock,
				NULL);

	mixerMainBlock = XtVaCreateManagedWidget(
				"mixerMainBlock",
				boxWidgetClass,
				mixerBlock,
				NULL);

#ifdef	TOWNS
	if(app_data.towns) {
		CurrentDevicesNames = DevicesNames;
	} else {
		CurrentDevicesNames = &DevicesNames[2];
	}
#else
	CurrentDevicesNames = DevicesNames;
#endif	/*TOWNS*/

	FallbackDict = makeMessages(NULL, DefaultMessages);
	FallbackDict = makeMessages(FallbackDict , DefaultLabel);
	LocaleDict   = makeMessages(NULL, app_data.unitMessage);
	LocaleDict   = makeMessages(LocaleDict, app_data.messages);

	mixer = open(app_data.mixerDevice, O_RDWR);
	volmue_enable_flag = (mixer >= 0);
	LabelPixmaps(XtDisplay(tmixer), RootWindowOfScreen(XtScreen(tmixer)));
	MixerUnits = deviceList(mixer, mixerMainBlock, deviceInfo);
	makeMixerMenu(mixer, mixerMenuBlock, MixerUnits);

	popdownInfo.popupWidget  = popupButton;
	popdownInfo.popdownShell = tmixer;
	popdownInfo.client_data = NULL;
	XtAddCallback(popupButton, XtNcallback, PopupVolume, &popdownInfo);
	XtAddCallback(popupButton, XtNcallback, XtCallbackNone, tmixer);

	XtAddCallback(popdownVolume, 
					XtNcallback, PopdownTargetShell, &popdownInfo);

	XtSetSensitive(popupButton, volmue_enable_flag);

	if(volmue_enable_flag) {
		VolumeDevice = unitSearch(SOUND_MIXER_CD);
		if(VolumeDevice == EOF) {
			VolumeDevice = unitSearch(SOUND_MIXER_VOLUME);
		}
		if(VolumeDevice == EOF) {
			VolumeDevice = unitSearch(SOUND_MIXER_LINE);
		}
		if(VolumeDevice == EOF) {
			VolumeDevice = 0;
		}
	}

	(void)XtAppAddTimeOut(app_context, 
				app_data.refresh * 1000, mixerAdjust, (XtPointer)app_context);

}

#else

/***************************************************************************
 *	main: tmixer Υᥤؿ
 *	
 *		void main(int argc, char **argv);
 *	
 *		int argc;		θĿ
 *		char **argv;	ʸؤΥݥ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void main(int argc, char **argv)
{
	int mixer;
	XtAppContext app_context;
	Widget tmixer, mixerBlock, mixerMenuBlock, mixerMainBlock;
	static String fallback_resources[] = {
		"*fontSet: -adobe-helvetica-medium-r-*--14-*, -misc-fixed-*-*-*--14-*", 
		"*font: -adobe-helvetica-medium-r-*--12-*", 
		"*Paned*showGrip: False", 
		"*Level.translations: #override "
		"	<Btn1Down>:   levelControl() notify() \n"
		"	<Btn1Motion>: levelControl() notify()", 
		"*mixerMenuButton.menuName: mixerMenu", 
		"*MenuButton.label: Mixer commands", 
		"*MenuButton.shapeStyle: Oval", 
		"*MenuButton.leftBitmap: menu10", 
		"*mixerMenuButton.leftBitmap: menu10", 
		"*SimpleMenu.label: Mixer commands", 
		"*SimpleMenu.background: SkyBlue", 
		"*SimpleMenu.menuLabel.foreground: maroon", 
		"*SimpleMenu.menuLabel.font: " 
			"-adobe-new century schoolbook-bold-i-normal--12-*-*-*-*-*-*-*", 
		"*quit.label: Quit", NULL
	};
	char tmixerTitle[80];
	char program[40];

	sprintf(program, "%.*s", sizeof(program) - 1, *argv);

	XtSetLanguageProc(NULL, NULL, NULL);
	tmixer = XtVaAppInitialize(
				&app_context,
				"Tmixer",
				options, XtNumber(options), /* command line */
				&argc, argv,
				fallback_resources, 
				NULL);

	XtGetApplicationResources(tmixer,
				&app_data,
				resources, 
				XtNumber(resources), 
				NULL, 
				0);

	mixerBlock = XtVaCreateManagedWidget(
				"mixerBlock",
				panedWidgetClass,
				tmixer,
				NULL);

	mixerMenuBlock = XtVaCreateManagedWidget(
				"mixerMenuBlock",
				boxWidgetClass,
				mixerBlock,
				NULL);

	mixerMainBlock = XtVaCreateManagedWidget(
				"mixerMainBlock",
				boxWidgetClass,
				mixerBlock,
				NULL);

#ifdef	TOWNS
	if(app_data.towns) {
		CurrentDevicesNames = DevicesNames;
	} else {
		CurrentDevicesNames = &DevicesNames[2];
	}
#else
	CurrentDevicesNames = DevicesNames;
#endif	/*TOWNS*/

	FallbackDict = makeMessages(NULL, DefaultMessages);
	FallbackDict = makeMessages(FallbackDict , DefaultLabel);
	LocaleDict   = makeMessages(NULL, app_data.unitMessage);
	LocaleDict   = makeMessages(LocaleDict, app_data.messages);

	mixer = open(app_data.mixerDevice, O_RDWR);
	LabelPixmaps(XtDisplay(tmixer), RootWindowOfScreen(XtScreen(tmixer)));
	MixerUnits = deviceList(mixer, mixerMainBlock, deviceInfo);
	makeMixerMenu(mixer, mixerMenuBlock, MixerUnits);

	if(app_data.help) {
		usage(mixer, program);
		exit(0);
	}
#ifdef	TOWNS
	sprintf(tmixerTitle, "Tmixer Version1.03(%s%s)--[%s]", 
		"TOWNS", ((app_data.towns != False)?(""):("-OFF")), setlocale(LC_CTYPE, NULL));
#else
	sprintf(tmixerTitle, "Tmixer Version1.03--[%s]", setlocale(LC_CTYPE, NULL));
#endif	/*TOWNS*/
	XtVaSetValues(tmixer, XtNtitle, tmixerTitle, NULL);

	(void)XtAppAddTimeOut(app_context, 
				app_data.refresh * 1000, mixerAdjust, (XtPointer)app_context);

	XtRealizeWidget(tmixer);
	XtAppMainLoop(app_context);
}

#endif /*TMIXER_ONLY*/
