/***************************************************************************
 *		Level.c: mwxcd Υ٥᡼ɽѥå
 *		
 *		
 *		
 *			Last update. 1998/10/18 [ Xaw3d ѻɽ̲Хк]
 *		
 ***************************************************************************/

/*
 * Level.c - Level button widget
 */

#include <stdio.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Xmu/Misc.h>
#include <X11/Xmu/Converters.h>
#include <X11/extensions/shape.h>

#ifdef	USE_Xaw3d
# include <X11/Xaw3d/XawInit.h>
#endif	/*USE_Xaw3d*/
#ifdef	USE_neXtaw
# include <X11/neXtaw/XawInit.h>
#endif	/*USE_neXtaw*/
#ifdef	USE_Xaw95
# include <X11/Xaw95/XawInit.h>
#endif	/*USE_Xaw95*/
#if !(defined(USE_Xaw3d) || defined(USE_Xaw95) || defined(USE_neXtaw))
# include <X11/Xaw/XawInit.h>
#endif /* !(defined(USE_Xaw3d) || defined(USE_Xaw95) || defined(USE_neXtaw)) */

#include "LevelP.h"

#define DEFAULT_HIGHLIGHT_THICKNESS 2
#define DEFAULT_SHAPE_HIGHLIGHT 32767

/****************************************************************
 *
 *	Full class record constant
 *
 ****************************************************************/

/* Private Data */

/*****************************
 *	ǥեȤѴơ֥
 *****************************/
static char defaultTranslations[] =
	"<Btn1Down>:	levelControl() notify()	\n"
	"<Btn1Motion>:	levelControl() notify()	";

/*
 *	"<EnterWindow>:	highlight()		\n"
 *	"<LeaveWindow>:	reset()			\n"
 */

#define offset(field) XtOffsetOf(LevelRec, field)

/*************
 *	꥽
 *************/
static XtResource resources[] =
{
	{
		XtNcallback, 
		XtCCallback, 
		XtRCallback, 
		sizeof(XtPointer),
	 	offset(level.callbacks), 
	 	XtRCallback, 
	 	(XtPointer) NULL
	 },
	{
		XtNhighlightThickness, 
		XtCThickness, 
		XtRDimension, 
		sizeof(Dimension),
		offset(level.highlight_thickness), 
		XtRImmediate,
	 	(XtPointer) DEFAULT_SHAPE_HIGHLIGHT
	 },
	{
		XtNshapeStyle, 
		XtCShapeStyle, 
		XtRShapeStyle, 
		sizeof(int),
		offset(level.shape_style), 
		XtRImmediate, 
		(XtPointer) XawShapeRectangle
	},
	{
		XtNcornerRoundPercent, 
		XtCCornerRoundPercent,
		XtRDimension, 
		sizeof(Dimension),
		offset(level.corner_round), 
		XtRImmediate, 
		(XtPointer) 25
	},
	/* ɲå꥽ */
	{
		XtNlevelValue, 
		XtCLevelValue,
		XtRInt, 
		sizeof(int),
		offset(level.levelValue), 
		XtRImmediate, 
		(XtPointer) 0
	},
	{
		XtNlevelMaxValue, 
		XtCLevelMaxValue,
		XtRInt, 
		sizeof(int),
		offset(level.maxValue), 
		XtRImmediate, 
		(XtPointer) 100
	},
};
#undef offset

static Boolean SetValues();
static void Initialize(), Redisplay(), Set(), Reset(), Notify(), Unset();
static void Highlight(), Unhighlight(), Destroy();
static void LevelControl(Widget w, XEvent *event,
							String *params, Cardinal *num_params);
static void PaintLevelWidget(Widget w, Region region, Boolean change);
static void paintLevel(Widget w);
static void ClassInitialize();
static Boolean ShapeButton(LevelWidget cbw, Boolean checkRectangular);
static void Realize(), Resize();
static XtGeometryResult QueryGeometry(Widget w, 
					XtWidgetGeometry *intended, XtWidgetGeometry *preferred);

static XtActionsRec actionsList[] =
{
	{"set", Set},
	{"notify", Notify},
	{"highlight", Highlight},
	{"reset", Reset},
	{"unset", Unset},
	{"unhighlight", Unhighlight}, 
	{"levelControl", LevelControl}		/* ɲʬ */
};

#define SuperClass ((LabelWidgetClass)&labelClassRec)

LevelClassRec levelClassRec =
{
	{
		(WidgetClass) SuperClass,		/* superclass			  */
		"Level",						/* class_name			  */
		sizeof(LevelRec),				/* size					  */
		ClassInitialize,				/* class_initialize		  */
		NULL,							/* class_part_initialize  */
		FALSE,							/* class_inited			  */
		Initialize,						/* initialize			  */
		NULL,							/* initialize_hook		  */
		Realize,						/* realize				  */
		actionsList,					/* actions				  */
		XtNumber(actionsList),			/* num_actions			  */
		resources,						/* resources			  */
		XtNumber(resources),			/* resource_count		  */
		NULLQUARK,						/* xrm_class			  */
		FALSE,							/* compress_motion		  */
		TRUE,							/* compress_exposure	  */
		TRUE,							/* compress_enterleave    */
		FALSE,							/* visible_interest		  */
		Destroy,						/* destroy				  */
		Resize,							/* resize				  */
		Redisplay,						/* expose				  */
		SetValues,						/* set_values			  */
		NULL,							/* set_values_hook		  */
		XtInheritSetValuesAlmost,		/* set_values_almost	  */
		NULL,							/* get_values_hook		  */
		NULL,							/* accept_focus			  */
		XtVersion,						/* version				  */
		NULL,							/* callback_private		  */
		defaultTranslations,			/* tm_table				  */
		QueryGeometry,					/* query_geometry		  */
		XtInheritDisplayAccelerator,	/* display_accelerator	  */
		NULL							/* extension			  */
	},			/* CoreClass fields initialization */
	{
		XtInheritChangeSensitive		/* change_sensitive	*/
	},			/* SimpleClass fields initialization */
	{
		0,								/* field not used    */
	},			/* LabelClass fields initialization */
	{
		0,								/* field not used    */
	},			/* LevelClass fields initialization */
};

 /* for public consumption */
WidgetClass levelWidgetClass = (WidgetClass) & levelClassRec;

/****************************************************************
 *
 * Private Procedures
 *
 ****************************************************************/

/***************************************************************************
 *	Get_GC: եåƥȡʣǣáˤ
 *	
 *		static GC Get_GC(LevelWidget cbw, Pixel fg, Pixel bg);
 *	
 *		LevelWidget cbw;	
 *		Pixel fg;			ʿΥԥ
 *		Pixel bg;			طʿΥԥ
 *	֤
 *		եåƥȡʣǣá
 *	
 *		ʿطʿեȡĺǤ°ꤷޤ
 *		ʿ			
 *		طʿ			
 *		եȡ			ΡLabel åʬΡ˥եID
 *		ĺǤ°	Cap Projecting
 *					highlight ɽǤ
 ***************************************************************************/
static GC Get_GC(LevelWidget cbw, Pixel fg, Pixel bg)
{
	XtGCMask value_mask = GCForeground | GCBackground | GCLineWidth | GCCapStyle;
	XGCValues values;

	values.foreground = fg;		/* ʿΥԥ */
	values.background = bg;		/* طʿΥԥ */
	values.cap_style = CapProjecting;

#ifdef	Xaw3D_BUG
	if(cbw != NULL && cbw->label.font) {
		values.font = cbw->label.font->fid;	/* FONT id */
		value_mask |= GCFont;
	}
#endif	/*Xaw3D_BUG*/

	if (cbw->level.highlight_thickness > 1)
		values.line_width = cbw->level.highlight_thickness;
	else
		values.line_width = 0;

	return XtGetGC((Widget) cbw, value_mask, &values);
}

/***************************************************************************
 *	Initialize: Level åȤ initialize ᥽å
 *	
 *		static void Initialize(Widget request, Widget new,
 *									ArgList args, Cardinal num_args)
 *	
 *		Widget request;
 *		Widget new;
 *		ArgList args;		̤
 *		Cardinal num_args;	̤
 *	
 *		ץ饤١ȥ󥹥ѿν
 *		ѥ֥å󥹥ѿͭΥå
 *		
 *		
 *			XtNshapeStyleshape_style
 *					åȤγ
 *			XtNhighlightThicknesshighlight_thickness
 *					hightlight 褹
 *			ץ饤١ȡnormal_GC
 *					̾ѤΥեåƥ
 *			ץ饤١ȡinverse_GC
 *					ȿžѤΥեåƥ
 *			ץ饤١ȡset
 *					֤򼨤С
 *			ץ饤١ȡhighlighted
 *					highlight ɽ˴ؤ֤򼨤С
 ***************************************************************************/
/* ARGSUSED */
static void Initialize(Widget request, Widget new,
					   ArgList args, Cardinal num_args)
{
	LevelWidget cbw = (LevelWidget) new;
	int shape_event_base, shape_error_base;

	if (cbw->level.shape_style != XawShapeRectangle
		&& !XShapeQueryExtension(XtDisplay(new), &shape_event_base,
								 &shape_error_base))
		cbw->level.shape_style = XawShapeRectangle;
	if (cbw->level.highlight_thickness == DEFAULT_SHAPE_HIGHLIGHT) {
		if (cbw->level.shape_style != XawShapeRectangle)
			cbw->level.highlight_thickness = 0;
		else
			cbw->level.highlight_thickness = DEFAULT_HIGHLIGHT_THICKNESS;
	}
	cbw->level.normal_GC = Get_GC(cbw, cbw->label.foreground,
									cbw->core.background_pixel);
	cbw->level.inverse_GC = Get_GC(cbw, cbw->core.background_pixel,
									 cbw->label.foreground);
	XtReleaseGC(new, cbw->label.normal_GC);
	cbw->label.normal_GC = cbw->level.normal_GC;

	cbw->level.set = FALSE;
	cbw->level.highlighted = HighlightNone;
}

/***************************************************************************
 *	QueryGeometry: Level åȤ query_geometry ᥽å
 *	
 *		static XtGeometryResult QueryGeometry(Widget w, 
 *				XtWidgetGeometry *intended, XtWidgetGeometry *preferred);
 *	
 *		ϡ
 *		Widget w;				䤤碌륦åȤ֥
 *		XtWidgetGeometry *intended;		ƤԤȤƤ른ȥѹ
 *		ʽϡ
 *		XtWidgetGeometry *preferred;	åȤ䥪֥ȤŬڤ
 *										ȥ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
static XtGeometryResult QueryGeometry(Widget w, 
					XtWidgetGeometry *intended, XtWidgetGeometry *preferred)
{
	register LevelWidget lw = (LevelWidget) w;

	/*printf("%s:%d:%s:%d\n", __FILE__, __LINE__, "lw->level.maxValue", lw->level.maxValue);*/
	/*lw->level.maxValue = 100;*/
	preferred->request_mode = CWWidth | CWHeight;
	preferred->width = (lw->level.maxValue + 2 * lw->label.internal_width +
						LEFT_OFFSET(lw));
	preferred->height = lw->label.label_height + 2 * lw->label.internal_height;
	if (((intended->request_mode & (CWWidth | CWHeight))
		 == (CWWidth | CWHeight)) &&
		intended->width == preferred->width &&
		intended->height == preferred->height)
		return XtGeometryYes;
	else if (preferred->width == w->core.width &&
			 preferred->height == w->core.height)
		return XtGeometryNo;
	else
		return XtGeometryAlmost;
}

/***************************************************************************
 *	HighlightRegion: highlight ΰ
 *	
 *		static Region HighlightRegion(LevelWidget cbw);
 *	
 *		LevelWidget cbw;
 *	֤
 *		highlight ΰ򼨤꡼
 *	
 *		åȤ礭 highlight Ȥ顢¦ΰȳ
 *		¦ΰơκ顢highlight ΰ
 ***************************************************************************/
static Region HighlightRegion(LevelWidget cbw)
{
	static Region outerRegion = NULL, innerRegion, emptyRegion;
	XRectangle rect;

	if (cbw->level.highlight_thickness == 0 ||
		cbw->level.highlight_thickness >
	(Dimension) ((Dimension) Min(cbw->core.width, cbw->core.height) / 2))
		return (NULL);

	if (outerRegion == NULL) {
		/* save time by allocating scratch regions only once. */
		outerRegion = XCreateRegion();
		innerRegion = XCreateRegion();
		emptyRegion = XCreateRegion();
	}
	rect.x = rect.y = 0;
	rect.width = cbw->core.width;
	rect.height = cbw->core.height;
	XUnionRectWithRegion(&rect, emptyRegion, outerRegion);
	rect.x = rect.y = cbw->level.highlight_thickness;
	rect.width -= cbw->level.highlight_thickness * 2;
	rect.height -= cbw->level.highlight_thickness * 2;
	XUnionRectWithRegion(&rect, emptyRegion, innerRegion);
	XSubtractRegion(outerRegion, innerRegion, outerRegion);
	return outerRegion;
}

static int point(int x, int width, int iwidth)
{
	switch((x >= iwidth) + (x >= (width - iwidth))) {
	case 0:
		x = 0;
		break;
	case 1:
		x -= iwidth;
		break;
	case 2:
		x = width - 2 * iwidth;
		break;
	}
	return(x);
}

/***************************
 *
 *	Action Procedures
 *
 ***************************/

/***************************************************************************
 *	LevelControl: 
 *	
 *		void LevelControl(Widget w, XEvent *event,
 *							String *params, Cardinal *num_params);
 *	
 *		Widget w;					
 *		XEvent *event;				
 *		String *params;				
 *		Cardinal *num_params;		
 *	
 *		
 *	ѷ
 *		levelControl();		
 ***************************************************************************/
static void LevelControl(Widget w, XEvent *event,
							String *params, Cardinal *num_params)
{
	LevelWidget lw = (LevelWidget) w;

	switch((int)*num_params) {
	default:		/* ΰ¿Ȥ */
		XtWarning("Too many parameter passed to flashControl action table.");
		break;
	case 0:			/* ΰꤵƤʤȤ */
		switch(event->type) {
		case ButtonPress:
			lw->level.levelValue = point(event->xbutton.x, 
								lw->core.width, lw->label.internal_width);
			paintLevel(w);
			break;
		case MotionNotify:
			lw->level.levelValue = point(event->xmotion.x, 
								lw->core.width, lw->label.internal_width);
			paintLevel(w);
			break;
		default:
			break;
		}
		break;
	}
}

/***************************************************************************
 *	Set: ֤ˤ륢set() 
 *	
 *		static void Set(Widget w, XEvent *event,
 *							String *params, Cardinal *num_params);
 *	
 *		Widget w;
 *		XEvent *event;
 *		String *params;			̤
 *		Cardinal * num_params;		̤
 *	
 *		֤ޤǤϡnotify λ꤬ǽǡʿȤ
 *		ܡȿžɽʤɡܥɽԤޤ٥طʿ
 *		Ȥäɽޤ
 ***************************************************************************/
/* ARGSUSED */
static void Set(Widget w, XEvent * event,
				String * params, Cardinal * num_params)
{
	LevelWidget cbw = (LevelWidget) w;

	if (cbw->level.set)
		return;					/* ֤ʤ顢⤷ʤ */

	cbw->level.set = TRUE;	/* ֤ˤ */
	if (XtIsRealized(w))		/* åȤ¸Ƥʤ */
		PaintLevelWidget(w, (Region) NULL, TRUE);
}

/***************************************************************************
 *	Unset: ֤äunset() 
 *	
 *		static void Unset(Widget w, XEvent *event,
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;
 *		XEvent *event;
 *		String *params;			̤
 *		Cardinal * num_params;
 *	
 *		֤äܡȿžɽޤܥطʿ
 *		äɽޤ٥ʿȤäɽޤ
 ***************************************************************************/
/* ARGSUSED */
static void Unset(Widget w, XEvent * event,
				  String * params, Cardinal * num_params)
{
	LevelWidget cbw = (LevelWidget) w;

	if (!cbw->level.set)
		return;					/* ֤ʤ顢⤷ʤ */

	cbw->level.set = FALSE;	/* ֤ä */
	if (XtIsRealized(w)) {		/* åȤ¸Ƥʤ */
		XClearWindow(XtDisplay(w), XtWindow(w));
		PaintLevelWidget(w, (Region) NULL, TRUE);
	}
}

/***************************************************************************
 *	Reset: set ޤ highlight äreset() 
 *	
 *		static void Reset(Widget w, XEvent *event,
 *							String *params, Cardinal *num_params);
 *	
 *		Widget w;
 *		XEvent *event;
 *		String *params;			̤
 *		Cardinal * num_params;	̤
 *	
 *		set ޤ highlight äܥطʿɽޤ
 *		٥ʿɽޤ
 ***************************************************************************/
/* ARGSUSED */
static void Reset(Widget w, XEvent * event,
				  String * params, Cardinal * num_params)
{
	LevelWidget cbw = (LevelWidget) w;

	if (cbw->level.set) {		/* ֤ */
		cbw->level.highlighted = HighlightNone;
		Unset(w, event, params, num_params);
	} else
		Unhighlight(w, event, params, num_params);
}

/***************************************************************************
 *	Highlight: ܡȿžɽԤޤhighlight() 
 *	
 *		static void Highlight(Widget w, XEvent *event,
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;
 *		XEvent *event;
 *		String *params;
 *		Cardinal *num_params;
 *	
 *		Level åȤοȥȥ饹Ȥ뿧XtNforeground
 *		 XtNbackgroundˤǡܡȿžɽԤޤΥ
 *		ǤϡWhenUnset  Always Ȥäƾꤹ뤳ȤǤޤ
 *		ꤵʤäˤϡWhenUnset ꤵ줿ΤȤߤʤ
 *		ޤ
 ***************************************************************************/
/* ARGSUSED */
static void Highlight(Widget w, XEvent * event,
					  String * params, Cardinal * num_params)
{
	LevelWidget cbw = (LevelWidget) w;

	if (*num_params == (Cardinal) 0)	/* ˰ʤȤ */
		cbw->level.highlighted = HighlightWhenUnset;
	else {
		if (*num_params != (Cardinal) 1)	/* ۾ʤȤ */
			XtWarning("Too many parameters ""passed to highlight action table.");
		else
			switch (params[0][0]) {
			case 'A':				/* Always */
			case 'a':				/*                */
				cbw->level.highlighted = HighlightAlways;
				break;
			default:				/* WhenUnset */
				cbw->level.highlighted = HighlightWhenUnset;
				break;
			}
	}

	if (XtIsRealized(w))		/* åȤ¸Ƥʤ */
		PaintLevelWidget(w, HighlightRegion(cbw), TRUE);
}

/***************************************************************************
 *	Unhighlight: ܡȿžɽäunhighlight() 
 *	
 *		static void Unhighlight(Widget w, XEvent *event,
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;
 *		XEvent *event;
 *		String *params;			̤
 *		Cardinal * num_params;	̤
 *	
 *		Level åȤο˰פ뿧XtNforeground  
 *		XtNbackgroundˤܡȿžɽäޤ
 ***************************************************************************/
/* ARGSUSED */
static void Unhighlight(Widget w, XEvent * event,
						String * params, Cardinal * num_params)
{
	LevelWidget cbw = (LevelWidget) w;

	cbw->level.highlighted = HighlightNone;
	if (XtIsRealized(w))		/* åȤ¸Ƥʤ */
		PaintLevelWidget(w, HighlightRegion(cbw), TRUE);
}

/***************************************************************************
 *	Notify: ХåꥹȤ¹ԡnotify() 
 *	
 *		static void Notify(Widget w, XEvent *event,
 *							String *params, Cardinal *num_params);
 *	
 *		Widget w;
 *		XEvent *event;
 *		String *params;			̤
 *		Cardinal * num_params;	̤
 *	
 *		set ֤Ǽ¹Ԥ줿硢XtNcallback ˤäƻꤵ줿
 *		åꥹȤ¹Ԥޤ call_data ͤƤޤ
 ***************************************************************************/
/* ARGSUSED */
static void Notify(Widget w, XEvent * event,
				   String * params, Cardinal * num_params)
{
	LevelWidget cbw = (LevelWidget) w;
	XawLevelReturnStruct level_data;

	/*
	 *	check to be sure state is still Set so that user can cancel
     *	the action (e.g. by moving outside the window, in the default
     *	bindings.
  	 */
	/*if(cbw->level.set)*/			/* ֤ */
	level_data.levelValue = cbw->level.levelValue;
	/*printf("%s:%d:%s:%d\n", __FILE__, __LINE__, "cbw->level.maxValue", cbw->level.maxValue);*/
	level_data.maxValue = cbw->level.maxValue;
	XtCallCallbackList(w, cbw->level.callbacks, (XtPointer)&level_data);
}

/*
 * Repaint the widget window
 */

/************************
*
*  REDISPLAY (DRAW)
*
************************/

/***************************************************************************
 *	Redisplay: Level åȤ expose ᥽å
 *	
 *		static void Redisplay(Widget w, XEvent *event, Region region);
 *	
 *		Widget w;
 *		XEvent *event;
 *		Region region;
 *	
 ***************************************************************************/
/* ARGSUSED */
static void Redisplay(Widget w, XEvent *event, Region region)
{
	/*PaintLevelWidget(w, region, FALSE);*/
	paintLevel(w);
}

static void paintLevel(Widget w)
{
	int levelValue;
	LevelWidget lw = (LevelWidget) w;
	
	levelValue = lw->level.levelValue;
	/*printf("%s:%d:%s:%d\n", __FILE__, __LINE__, "lw->level.maxValue", lw->level.maxValue);*/
	if(lw->level.levelValue > lw->level.maxValue) {
		levelValue = lw->level.maxValue;
	}

	XFillRectangle(XtDisplay(w), XtWindow(w), lw->level.normal_GC,  
			lw->label.internal_width, lw->label.internal_height,
			levelValue, 
			lw->core.height - 2 * lw->label.internal_height);
	XFillRectangle(XtDisplay(w), XtWindow(w), lw->level.inverse_GC,  
			lw->label.internal_width + levelValue, 
			lw->label.internal_height,
			lw->level.maxValue - lw->level.levelValue, 
			lw->core.height - 2 * lw->label.internal_height);
}

/***************************************************************************
 *	PaintLevelWidget: Level åȤ褹
 *	
 *		static void PaintLevelWidget(Widget w, 
 *										Region region, Boolean change);
 *	
 *		Widget w;			Level å
 *		Region region;		褹ΰʥ꡼(superclass)
 *		Boolean change;		did it change either set or highlight state?
 *	
 *
 *
 ***************************************************************************/
static void PaintLevelWidget(Widget w, Region region, Boolean change)
{
	LevelWidget cbw = (LevelWidget) w;
	Boolean very_thick;
	GC norm_gc, rev_gc;

	very_thick = cbw->level.highlight_thickness >
		(Dimension) ((Dimension) Min(cbw->core.width, cbw->core.height) / 2);

	if (cbw->level.set) {
		cbw->label.normal_GC = cbw->level.inverse_GC;
		XFillRectangle(XtDisplay(w), XtWindow(w), cbw->level.normal_GC,
					   0, 0, cbw->core.width, cbw->core.height);
		region = NULL;			/* Force label to repaint text. */
	} else
		cbw->label.normal_GC = cbw->level.normal_GC;

	if (cbw->level.highlight_thickness <= 0) {
		(*SuperClass->core_class.expose) (w, (XEvent *) NULL, region);
		return;
	}
/*
 * If we are set then use the same colors as if we are not highlighted.
 */

	if (cbw->level.set == (cbw->level.highlighted == HighlightNone)) {
		norm_gc = cbw->level.inverse_GC;
		rev_gc = cbw->level.normal_GC;
	} else {
		norm_gc = cbw->level.normal_GC;
		rev_gc = cbw->level.inverse_GC;
	}

	if (!((!change && (cbw->level.highlighted == HighlightNone)) ||
		  ((cbw->level.highlighted == HighlightWhenUnset) &&
		   (cbw->level.set)))) {
		if (very_thick) {
			cbw->label.normal_GC = norm_gc;	/* Give the label the right GC. */
			XFillRectangle(XtDisplay(w), XtWindow(w), rev_gc,
						   0, 0, cbw->core.width, cbw->core.height);
		} else {
			/* wide lines are centered on the path, so indent it */
			int offset = cbw->level.highlight_thickness / 2;
			XDrawRectangle(XtDisplay(w), XtWindow(w), rev_gc, offset, offset,
					  cbw->core.width - cbw->level.highlight_thickness,
					cbw->core.height - cbw->level.highlight_thickness);
		}
	}
	(*SuperClass->core_class.expose) (w, (XEvent *) NULL, region);
}

/***************************************************************************
 *	Destroy: Level åȤ Destroy ᥽å
 *	
 *		static void Destroy(Widget w);
 *	
 *		Widget w;
 *	
 *		եåƥȤ
 *		
 ***************************************************************************/
static void Destroy(Widget w)
{
	LevelWidget cbw = (LevelWidget) w;

	/* so Label can release it */
	if (cbw->label.normal_GC == cbw->level.normal_GC)
		XtReleaseGC(w, cbw->level.inverse_GC);
	else
		XtReleaseGC(w, cbw->level.normal_GC);
}

/*
 * Set specified arguments into widget
 */

/***************************************************************************
 *	SetValues: Level åȤ set_values ᥽å
 *	
 *		static Boolean SetValues(Widget current, Widget request, 
 *					Widget new, ArgList args, Cardinal *num_args);
 *	
 *		Widget current;		XtSetValues() ƤӽФξ֤ΥåȤ
 *							ԡ
 *		Widget request;		XtSetValues() ƤӽФͤѹ줿
 *							Υ饹 set_values() ؿƤӽФƤ
 *							֤ΥåȤΥԡ
 *		Widget new;			ǤꤵƤ set_values() ƤӽФǽ
 *							줿å
 *		ArgList args;		XtSetValues() ƤӽФϤ줿ꥹ
 *							̤ѡ
 *		Cardinal *num_args;	ꥹΰο̤ѡ
 *	֤
 *		Falseʵ: 	åȤ褹
 *		True ʿ: 	åȤ褷ʤ
 *	
 *		
 *	Ȼ
 *		See. X Toolkit Intrinsics Reference Manual		XtSetValuesFunc
 *														set_values ᥽å
 *			 X Toolkit Intrinsics Programing Manual		set_values ᥽å
 ***************************************************************************/
/* ARGSUSED */
static Boolean SetValues(Widget current, Widget request, Widget new, 
									ArgList args, Cardinal *num_args)
{
	LevelWidget oldcbw = (LevelWidget) current;
	LevelWidget cbw = (LevelWidget) new;
	Boolean redisplay = False;	/* ؿ֤͡ʺե饰 */

	/*printf("%s:%d:%s:%d\n", __FILE__, __LINE__, "cbw->level.maxValue", cbw->level.maxValue);*/
	if(cbw->level.levelValue > cbw->level.maxValue) {
		cbw->level.levelValue = cbw->level.maxValue;
	}

	if (oldcbw->core.sensitive != cbw->core.sensitive && 
						!cbw->core.sensitive) {
		/*
		 *	󥻥󥷥ƥ֡⡼ɡʴβǽˤˤʤä
		 */
		cbw->level.set = FALSE;
		cbw->level.highlighted = HighlightNone;
		redisplay = TRUE;
	}
	if ((oldcbw->label.foreground != cbw->label.foreground) ||
		(oldcbw->core.background_pixel != cbw->core.background_pixel) ||
		(oldcbw->level.highlight_thickness !=
		 cbw->level.highlight_thickness) ||
		(oldcbw->label.font != cbw->label.font)) {
		if (oldcbw->label.normal_GC == oldcbw->level.normal_GC)
			/* Label has release one of these */
			XtReleaseGC(new, cbw->level.inverse_GC);
		else
			XtReleaseGC(new, cbw->level.normal_GC);

		cbw->level.normal_GC = Get_GC(cbw, cbw->label.foreground,
										cbw->core.background_pixel);
		cbw->level.inverse_GC = Get_GC(cbw, cbw->core.background_pixel,
										 cbw->label.foreground);
		XtReleaseGC(new, cbw->label.normal_GC);
		cbw->label.normal_GC = (cbw->level.set
								? cbw->level.inverse_GC
								: cbw->level.normal_GC);

		redisplay = True;
	}
	if (XtIsRealized(new)
		&& oldcbw->level.shape_style != cbw->level.shape_style
		&& !ShapeButton(cbw, TRUE)) {
		cbw->level.shape_style = oldcbw->level.shape_style;
	}
	if (XtIsRealized(new) && 
				oldcbw->level.levelValue != cbw->level.levelValue) {
		redisplay = True;
	}
	return (redisplay);
}

/***************************************************************************
 *	ClassInitialize: Level åȤ class_initialize ᥽å
 *	
 *		static void ClassInitialize(void);
 *	
 *		ʸ󢪷ηСϿޤ
 *	Ȼ
 *		X Toolkit Intrinsics Reference Manual   XtProc
 *												  class_initialize ᥽å
 *		X Toolkit Intrinsics Programing Manual  class_initialize ᥽å
 ***************************************************************************/
static void ClassInitialize(void)
{
	XawInitializeWidgetSet();
	XtSetTypeConverter(XtRString, XtRShapeStyle, XmuCvtStringToShapeStyle,
					   NULL, 0, XtCacheNone, NULL);
}


/***************************************************************************
 *	ShapeButton: 
 *	
 *		static Boolean ShapeButton(LevelWidget cbw, 
 *										Boolean checkRectangular);
 *	
 *		LevelWidget cbw;
 *		Boolean checkRectangular;
 *	֤
 *		
 *	
 *		
 *		
 ***************************************************************************/
static Boolean ShapeButton(LevelWidget cbw, Boolean checkRectangular)
{
	Dimension corner_size = 1;			/* WARNING ɻ */

	if ((cbw->level.shape_style == XawShapeRoundedRectangle)) {
		corner_size = (cbw->core.width < cbw->core.height) ? cbw->core.width
			: cbw->core.height;
		corner_size = (int) (corner_size * cbw->level.corner_round) / 100;
	}
	if (checkRectangular || cbw->level.shape_style != XawShapeRectangle) {
		if (!XmuReshapeWidget((Widget) cbw, cbw->level.shape_style,
							  corner_size, corner_size)) {
			cbw->level.shape_style = XawShapeRectangle;
			return (False);
		}
	}
	return (TRUE);
}

/***************************************************************************
 *	Realize: Level åȤ realize ᥽å
 *	
 *		static void Realize(Widget w, 
 *					Mask *valueMask, XSetWindowAttributes *attributes);
 *	
 *		Widget w;
 *		Mask *valueMask;
 *		XSetWindowAttributes *attributes;
 *	
 *
 *
 ***************************************************************************/
static void Realize(Widget w, 
					Mask *valueMask, XSetWindowAttributes *attributes)
{
	(*levelWidgetClass->core_class.superclass->core_class.realize)
		(w, valueMask, attributes);

	ShapeButton((LevelWidget) w, FALSE);
}

/***************************************************************************
 *	Resize: Level åȤ resize ᥽å
 *	
 *		static void Resize(Widget w);
 *	
 *		Widget w;
 *	
 *		
 *		
 ***************************************************************************/
static void Resize(Widget w)
{
	if (XtIsRealized(w))
		ShapeButton((LevelWidget) w, FALSE);

	(*levelWidgetClass->core_class.superclass->core_class.resize) (w);
}

